jQuery(document).ready(function ($) {
    $('[data-toggle="tooltip"]').tooltip();

    $('#ju-message-container .close').on('click', function () {
        $("#ju-message-container").animate({'height': 0}, 300);
        $("#ju-message-container .alert-message").animate({'height': 0}, 300);
        setTimeout(function () {
            $("#ju-message-container").hide();
        }, 300);
    });

    $('#drop_config_cancel_close').on('click', function (e) {
        e.preventDefault();
        if ($("#configuration-form").height() < 1 && $("#droptables-role-form").height() < 1 && task_action !== 'configuration.saveParams') {
            $.ajax({
                type: "POST",
                url: DroptableConfigUrl2,
                data: '',
                success: function (data) {
                    var result = $.parseJSON(data);
                    if (result.response == true && typeof result.datas.url !== 'undefined') {
                        location.href = result.datas.url;
                    }
                },
                error: function (jqxhr, textStatus, error) {
                }
            });
        }
    });

    $("#configuration-form" ).on( "submit", function(e) {
        e.preventDefault();

        if ($(this).height() > 0) {
            var dataString = $(this).serialize();
            $.ajax({
                type: "POST",
                url: DroptableConfigUrl,
                data: dataString,
                success: function (data) {
                    var result = $.parseJSON(data);
                    if (result.response == true && typeof result.datas.url !== 'undefined') {
                        location.href = result.datas.url;
                    } else {
                        alert('Error when saving');
                    }
                },
                error: function (jqxhr, textStatus, error) {
                    alert('Error when saving');
                }
            });
        }
    });

    $("#droptables-role-form" ).on( "submit", function(e) {
        e.preventDefault();

        if ($(this).height() > 0) {
            var dataString = $(this).serialize();
            $.ajax({
                type: "POST",
                url: DroptableConfigUrl,
                data: dataString,
                success: function (data) {
                    var result = $.parseJSON(data);
                    if (result.response == true && typeof result.datas.url !== 'undefined') {
                        location.href = result.datas.url;
                    } else {
                        alert('Error when saving');
                    }
                },
                error: function (jqxhr, textStatus, error) {
                    alert('Error when saving');
                }
            });
        }
    });

    $(window).on('resize scroll', function () {
        // Get position of subhead-fixed
        if ($(window).scrollTop() >= 53) {
            $('.ju-left-panel').addClass('ju-tab-position-fixed');
            $('.ju-left-panel').prop('style', false);
        } else {
            if ($(window).scrollTop() > 0 && $(window).scrollTop() <= 53) {
                $('.ju-left-panel').css('top', 140 - $(window).scrollTop());
            } else {
                $('.ju-left-panel').removeClass('ju-tab-position-fixed');
                $('.ju-left-panel').prop('style', false);
            }
        }
    });

    var $controlFormatStyle = $('#control_format_style');
    var $list_format_style  = $controlFormatStyle.find('#list_format_style');
    var $new_format_style   = $controlFormatStyle.find('#new_format_style');
    var $set_color          = $controlFormatStyle.find('#set_color');
    var $save_format_style  = $controlFormatStyle.find('#save_format_style');
    var active_format_color = '';


    // set value for an html input element from cellStyle object
    function updateParamFromStyleObjectSelectBox(that, defaultValue, callback, multiple_select) {
        that.data('value', defaultValue);
        var text = '';
        if (multiple_select) {
            $.each(defaultValue.split(','), function (i, v) {
                if (that.find('li[data-value="' + v + '"]').length > 0) {
                    if (text !== '') {
                        text += ',' + that.find('li[data-value="' + v + '"]').text();
                    } else {
                        text += that.find('li[data-value="' + v + '"]').text();
                    }
                }
            })
        } else if (that.find('li[data-value="' + defaultValue + '"]').length > 0) {
            text += that.find('li[data-value="' + defaultValue + '"]').text();
        }

        that.prev('.droptable_select_box_before').text(text === '' ? defaultValue : text).data('value', defaultValue);
        if (typeof callback !== 'undefined' && callback !== null) {
            callback.call(that);
        }
    }

    /**
     * Create custom select box
     *
     * @param $
     * @param select_function cell function when click select
     */
    function custom_select_box ($, select_function, multiple) {
        $(this).on('click', function (e) {
            var $that = $(this);
            var old_value;

            $('#mybootstrap').find('.droptable_select_box').each(function () {
                $(this).hide();
                $(this).siblings('.show').removeClass('show');
            });
            var position = $(this).position();

            if ($(this).hasClass('show')) {
                $(this).next().hide();
                $(this).removeClass('show');
                $(document).unbind('click.droptable_select_box');
                return;
            }

            $that.addClass('show');
            var $select = $(this).next().css({bottom: 40, left: position.left, 'min-width': $that.outerWidth()}).show();

            if (multiple) {
                $select.find('li input').prop("checked", false);
                old_value = $that.data('value').split(',');
                $.each(old_value, function (i, v) {
                    $select.find('li:not(.data-none)[data-value="' + v + '"]').find('input').prop("checked", true);
                })
            } else {
                old_value = $that.data('value');
            }


            $select.find('li').unbind('click').on('click', function (e) {
                var text = '', data = '';
                var li_tag = $(this);
                if (multiple) {
                    if ($(e.target).is('input')) {
                        li_tag = $(e.target).parent();
                    } else if(li_tag.find('input').length > 0) {
                        li_tag.find('input').prop("checked", !li_tag.find('input').is(":checked"));
                    }
                }


                if (!multiple || li_tag.hasClass('data-none')) {
                    text = li_tag.text();
                    data = li_tag.data('value');
                    $select.find('li:not(.data-none)').find('input:checked').prop("checked", false);
                } else {
                    if (li_tag.hasClass('data-none')) {
                        text = data = '';
                    } else {
                        $select.find('li:not(.data-none)').each(function (i, e) {
                            if ($(e).find('input').is(":checked")) {
                                if (data !== '') {
                                    text += ',' + $(e).text();
                                    data += ',' + $(e).data('value');
                                } else {
                                    text += $(e).text();
                                    data += $(e).data('value');
                                }
                            }
                        });
                    }
                }

                $select.data('value', data).change();
                $that.val(data).text(text).data('value', data).change();

                if (typeof select_function !== 'undefined' && select_function !== null) {
                    select_function.bind(li_tag.data('value'));
                }
                if (!multiple || li_tag.hasClass('data-none')) {
                    $('#mybootstrap').find('.droptable_select_box').hide();
                }
                $('#jform_include_editor_buttons2').val(data).trigger('change');
            });

            $(document).bind('click.droptable_select_box', (e) => {
                if (!$(e.target).is($(this)) && !(!!multiple && $(e.target).parents('.droptable_select_box').length > 0)) {
                    $select.hide();
                    $that.removeClass('show');
                    $(document).unbind('click.droptable_select_box');
                }
            });
        });
    }

    updateParamFromStyleObjectSelectBox($('#jform_include_editor_buttons').next('.droptable_select_box'), $('#jform_include_editor_buttons').data('value'), null, true);
    custom_select_box.call($('#jform_include_editor_buttons'), $, null, true);

    //create new .pane-color-tile
    $new_format_style.find('.create_format_style').on('click', function () {
        var number_format = $list_format_style.find('.pane-color-tile').length;
        var $html = $('<div class="pane-color-tile td_' + number_format + '">' +
            '<div class="pane-color-tile-header pane-color-tile-band" style="background-color:#ffffff" data-value="#ffffff"></div>' +
            '<div class="pane-color-tile-1 pane-color-tile-band" style="background-color:#ffffff" data-value="#ffffff"></div>' +
            '<div class="pane-color-tile-2 pane-color-tile-band" style="background-color:#ffffff" data-value="#ffffff"></div>' +
            '<div class="pane-color-tile-footer pane-color-tile-band" style="background-color:#ffffff" data-value="#ffffff"></div>' +
            '</div>');
        $html.appendTo($list_format_style);

        /*active new .pane-color-tile*/
        set_active_format_style();
        $list_format_style.find('.td_' + number_format).trigger('click');
    });

    //remove .pane-color-tile
    $new_format_style.find('.remove_format_style').on('click', function () {
        if ($new_format_style.find('.hide_set_format_style').hasClass('show')) {
            $new_format_style.find('.hide_set_format_style').trigger('click');
        }
        $controlFormatStyle.find('.pane-color-tile.active').remove();
        save_format_style();
    });

    var not_render_minicolors = false;
    //click active .pane-color-tile
    var set_active_format_style = function () {
        $controlFormatStyle.find('.pane-color-tile').on('click', function () {
            $(this).siblings('.active').removeClass('active');
            if (!$new_format_style.find('.hide_set_format_style').hasClass('show')) {
                $new_format_style.find('.hide_set_format_style').trigger('click');
            }
            $(this).addClass('active');
            reset_color_picket($(this));
        });
    };
    set_active_format_style();

    //set color picket when select format style
    var reset_color_picket = function (e) {
        not_render_minicolors = true;
        active_format_color = '';
        e.find('.pane-color-tile-band').each(function (i) {
            active_format_color += i === 0 ? '' : '|';
            active_format_color += $(this).data('value');

            $set_color.find('.control_value:eq(' + i + ')').find('.minicolors-input').minicolors('value', $(this).data('value'));
            $set_color.find('.control_value:eq(' + i + ')').find('.minicolors-swatch-color').css('color', $(this).data('value'));
            if (i === 3) {
                not_render_minicolors = false;
            }
        });
    };

    var get_color_picket = function (e, v, reset) {
        if (reset === '0' || e.hasClass('pane-set-color-header')) {
            $list_format_style.find('.active').find('.pane-color-tile-header').css('background-color', v).data('value', v);
        }
        if (reset === '1' || e.hasClass('pane-set-color-1')) {
            $list_format_style.find('.active').find('.pane-color-tile-1').css('background-color', v).data('value', v);
        }
        if (reset === '2' || e.hasClass('pane-set-color-2')) {
            $list_format_style.find('.active').find('.pane-color-tile-2').css('background-color', v).data('value', v);
        }
        if (reset === '3' || e.hasClass('pane-set-color-footer')) {
            $list_format_style.find('.active').find('.pane-color-tile-footer').css('background-color', v).data('value', v);
        }
    };

    //select color

    $('.minicolors-input').unbind('change').on('change', function (e) {
        e.preventDefault();
        if (!not_render_minicolors) {
            $(this).minicolors('value', $(this).val());
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', $(this).val());
            get_color_picket($(this), $(this).val(), '');
        }
    });

    /*save the change format style*/
    var save_format_style = function () {
        var dataFormatStyle = '';
        $list_format_style.find('.pane-color-tile').find('.pane-color-tile-band').each(function (i) {
            dataFormatStyle += (i !== 0 ? '|' : '') + $(this).data('value');
        }),
            $('#jform_alternate_color').val(dataFormatStyle).trigger('change');

        active_format_color = '';
    };

    $save_format_style.find('input:eq(0)').on('click', function () {
        $new_format_style.find('.hide_set_format_style').trigger('click');
        var html = '<span style="color: #ff8726; float: right;">Remember to save your alternate color change</span>';
        $controlFormatStyle.find('.label_text').append(html);
        setTimeout(function () {
            $controlFormatStyle.find('.label_text span').remove();
        }, 2000);
        save_format_style();
    });

    /*remove the change format style*/
    var cancel_format_style = function () {
        active_format_color.split('|').map(function (color, number) {
            get_color_picket($controlFormatStyle, color, number.toString());
        }),
            reset_color_picket($list_format_style.find('.active')),
            $controlFormatStyle.find('.pane-color-tile.active').removeClass('active');
    };
    $save_format_style.find('input:eq(1)').on('click', function () {
        if (active_format_color !== '') {
            $new_format_style.find('.hide_set_format_style').trigger('click');
            cancel_format_style();
        }
    });

    $new_format_style.find('.hide_set_format_style').on('click', function () {
        if ($(this).hasClass('show')) {
            $(this).removeClass('show');
        } else {
            $(this).addClass('show');
        }

        $set_color.toggle();
        $save_format_style.toggle();
    });
    $('.hide_set_format_style').trigger('click');
})