<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;

jimport('joomla.application.component.controllerlegacy');

/**
 * Class DroptablesController
 */
class DroptablesController extends JControllerLegacy
{

    /**
     * Default view for this controller
     *
     * @var string
     */
    protected $default_view = 'droptables';

    /**
     * Check the first get function
     *
     * @var integer
     */
    public static $Once = 1;

    /**
     * Method to display the view.
     *
     * @param boolean $cachable  The name of the template file to parse
     * @param boolean $urlparams The name of the template file to parse
     *
     * @return $this
     */
    public function display($cachable = false, $urlparams = false)
    {
        // Load the submenu.
        DroptablesHelper::addSubmenu(JFactory::getApplication()->input->getCmd('view', $this->default_view));

        $syn = false;
        $vName = JFactory::getApplication()->input->getCmd('view', $this->default_view);
        $layout = JFactory::getApplication()->input->getCmd('layout', 'default');
        if ($vName === 'droptables') {
            $syn = true;
            $view = $this->getView($vName, 'html');
            $modelCategory = $this->getModel('category');
            $view->setModel($modelCategory, false);
            $modelCategories = $this->getModel('categories');
            $view->setModel($modelCategories, false);
            $modelTables = $this->getModel('tables');
            $view->setModel($modelTables, false);
            $modelStyles = $this->getModel('styles');
            $view->setModel($modelStyles, false);
            $modelChartTyles = $this->getModel('chartTypes');
            $view->setModel($modelChartTyles, false);
        } elseif ($vName === 'category' && $layout === 'default') {
            $syn = true;
            $view = $this->getView($vName, 'raw');
            $model = $this->getModel('category');
            $view->setModel($model, false);
        } elseif ($vName === 'charttyle') {
            $view = $this->getView($vName, 'json');
            $model = $this->getModel('charttype');
            $view->setModel($model, true);
        } elseif ($vName === 'dbtable') {
            $view = $this->getView($vName, 'raw');
            $modelTable = $this->getModel('table');
            $view->setModel($modelTable, false);
        } elseif ($vName === 'tables') {
            $syn = true;
            $view = $this->getView($vName, 'html');
            $modelCategory = $this->getModel('category');
            $view->setModel($modelCategory, false);
            $modelCategories = $this->getModel('categories');
            $view->setModel($modelCategories, false);
            $modelTables = $this->getModel('tables');
        }
//        }
        /*
         * Sync page code use cUrl
         *
         * */
        $componentParams = JComponentHelper::getParams('com_droptables');
        $sync_periodicity = (int)$componentParams->get('sync_periodicity');
        if (!empty($sync_periodicity) && $syn) {
            $curSyncInterval = $this->curSyncInterval($componentParams);

//            if ($curSyncInterval >= 0.5 && self::$Once === 1) {
            if ($curSyncInterval >= $sync_periodicity && self::$Once === 1) {
                $doc = JFactory::getDocument();
                JHtml::_('jquery.framework');
                $script = "jQuery(document).ready(function(){
                        jQuery.ajax({
                            url: '" . JUri::root() . "index.php?option=com_droptables&task=frontexcel.syncSpreadsheet',
                            type: 'POST',
                            success: function (datas) {
                            },
                            error: function (jqxhr, textStatus, error) {
                            },
                        });
                    });";
                $doc->addScriptDeclaration($script);

                self::$Once = 0;
            }
        }
        parent::display($cachable, $urlparams);
        return $this;
    }

    /**
     * Function curSyncInterval
     *
     * @param object $params Component params
     *
     * @return integer
     */
    private function curSyncInterval($params)
    {
        //get last_log param
        if ($params->get('last_sync') !== null) {
            $last_log = $params->get('last_sync');
            $time_old = (int)$last_log;
        } else {
            $time_old = 0;
        }

        $time_new = (int)strtotime(date('Y-m-d H:i:s'));
        $timeInterval = $time_new - $time_old;
        $curtime = $timeInterval / 60;

        return $curtime;
    }

    /**
     * Get function edithtaccess in DroptablesBase
     *
     * @return void
     */
    public function htaccessdo()
    {
        DroptablesBase::edithtaccess();
    }
}
