<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

//no direct accees
defined('_JEXEC') || die('restricted aceess');

// phpcs:disable Squiz.Classes.ValidClassName.NotCamelCaps -- Default joomla core class name rule

/**
 * Droptables chart addon
 */
class SppagebuilderAddonDroptables_chart extends SppagebuilderAddons
{

    /**
     * Render chart addon
     *
     * @return string
     */
    public function render()
    {

        $class = (isset($this->addon->settings->class) && $this->addon->settings->class) ? ' ' . $this->addon->settings->class : '';
        $chartID = (isset($this->addon->settings->chartID) && $this->addon->settings->chartID) ? $this->addon->settings->chartID : '';

        $output = '';
        $styles = array();

        if ($chartID) {
            $output .= '<div class="sppb-addon sppb-addon-droptables-chart' . $class . '">';
            $html = '';

            JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_droptables/models/', 'DroptablesModel');
            $modelChart = JModelLegacy::getInstance('Chart', 'droptablesModel');
            $chart = $modelChart->getChart($chartID);
            //  var_dump($table);
            if ($chart) {
                $modelTable = JModelLegacy::getInstance('Table', 'droptablesModel');
                $table = $modelTable->getItem($chart->id_table, true, true, null, false);
               // $table->id = $chart->id_table;
                $text = '<img src="/components/com_droptables/assets/images/wptm_placeholder_chart.svg" data-droptablestable="'.$chart->id_table.'" data-droptables-chart="'.$chartID.'" />';
                $html = JHtml::_('content.prepare', $text);
            }

            if ($html) {
                if ($styles) {
                    foreach ($styles as $style) {
                        $output .= '<link rel="stylesheet" href="' . $style . '" />';
                    }
                }

                $output .= $html;
            } else {
                $output .= 'The chart doest not exist. Please check chart ID again';
            }

            $output .= '</div>';
        } else {
            $output .= '<div class="sppb-addon sppb-addon-droptables-chart' . $class . '">';
            $output .= '<img style="background-color: #ffffff; border: 2px solid #888888; height: 150px; border-radius: 10px; width: 99%;" src="'. JURI::root() . 'components/com_droptables/assets/images/wptm_placeholder_chart.svg" />';
            $output .= '<span style="font-size: 13px; text-align: center;">Please enter a Droptables chart ID</span>';
            $output .= '</div>';
        }

        return $output;
    }

    /**
     * Template for chart addon
     *
     * @return string
     */
    public static function getTemplate()
    {

        $output = '';
        $output .= '<div class="sppb-addon sppb-addon-droptables-chart edit-view" >';
        $output .= '<img style="background-color: #ffffff; border: 2px solid #888888; height: 150px; border-radius: 10px; width: 99%;" src="'. JURI::root() . 'components/com_droptables/assets/images/wptm_placeholder_chart.svg" />';
        $output .= '<span style="font-size: 13px; text-align: center;">Open preview to see the chart</span>';
        $output .= '</div>';

        return $output;
    }

    /**
     * Css for the addon
     *
     * @return string
     */
    public function css()
    {
        $addon_id = '#sppb-addon-' . $this->addon->id;

        $style = '';
        $style_sm = '';
        $style_xs = '';

        $style .= (isset($this->addon->settings->addon_text_transform) && $this->addon->settings->addon_text_transform) ? 'text-transform: ' . $this->addon->settings->addon_text_transform  . '; ' : '';

        if (isset($addon->settings->addon_font_style->italic) && $addon->settings->addon_font_style->italic) {
            $style .= 'font-style: italic;';
        }

        if (isset($addon->settings->addon_font_style->uppercase) && $addon->settings->addon_font_style->uppercase) {
            $style .= 'text-transform: uppercase;';
        }

        if (isset($addon->settings->addon_font_style->weight) && $addon->settings->addon_font_style->weight) {
            $style .= 'font-weight: ' . $addon->settings->addon_font_style->weight . ';';
        }

        $css = '';
        if ($style) {
            $css .= $addon_id . ' .sppb-addon-title {' . $style . '}';
        }

        if ($style_sm) {
            $css .= '@media (min-width: 768px) and (max-width: 991px) {';
                $css .= $addon_id . ' .sppb-addon-title {' . $style_sm . '}';
            $css .= '}';
        }

        if ($style_xs) {
            $css .= '@media (max-width: 767px) {';
                $css .= $addon_id . ' .sppb-addon-title {' . $style_xs . '}';
            $css .= '}';
        }

        return $css;
    }
}
