<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') || die('restricted aceess');

use Joomla\CMS\Language\Text;

JLoader::register('DroptablesHelper', JPATH_ADMINISTRATOR . '/components/com_droptables/helpers/droptables.php');
JLoader::register('DroptablesComponentHelper', JPATH_ADMINISTRATOR . '/components/com_droptables/helpers/component.php');
$spVersion = DroptablesComponentHelper::getVersion('com_sppagebuilder');
$icon  = JURI::root().'plugins/sppagebuilder/droptables/addons/droptables_table/assets/images/table_icon.svg';
if (version_compare($spVersion, '4.0') >= 0) {
    $icon = '<img src="'. JURI::root() . 'plugins/sppagebuilder/droptables/addons/droptables_table/assets/images/table_icon.svg" />';
}
SpAddonsConfig::addonConfig(
    array(
        'type'=>'content',
        'addon_name'=>'droptables_table',
        'title'=> 'Droptables Table',
        'icon'=> $icon,
        'category'=>'General',
        'attr'=>array(
            'general' => array(
                'tableID' => [
                    'type'     => 'select',
                    'title'    => 'Table',
                    'desc'     => 'Choose a table only. Do not select a category',
                    'values'   => DroptablesHelper::allTableList(),
                    'inline'  => true,
                ],
                'droptables_separator' => [
                    'type' => 'separator'
                ],
                'admin_label'=>array(
                    'type'=>'text',
                    'title'=>'Admin Label',
                    'desc'=>'Admin label description.',
                    'std'=> '',
                ),
                'class'=>array(
                    'type'=>'text',
                    'title'=>'CSS CLass',
                    'std'=> ''
                ),
            ),
        ),
    )
);
