<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;

jimport('joomla.application.component.helper');

/**
 * Class droptablesComponentHelper
 */
class DroptablesComponentHelper extends JComponentHelper
{
    /**
     * Method to set config parameters
     *
     * @param array $datas Params data
     *
     * @return boolean
     */
    public function setParams($datas)
    {
        $component = JComponentHelper::getComponent('com_droptables');
        $table = JTable::getInstance('extension');
        // Load the previous Data
        if (!$table->load($component->id, false)) {
            return false;
        }
        $d = json_decode($table->params);
        foreach ($datas as $key => $data) {
            $d->$key = $data;
        }
        $table->params = json_encode($d);
        // Bind the data.
        if (!$table->bind($datas)) {
            return false;
        }
        // Check the data.
        if (!$table->check()) {
            return false;
        }
        // Store the data.
        if (!$table->store()) {
            return false;
        }
        unset(self::$components['com_droptables']);
        return true;
    }

    /**
     * Method to get the version of a component
     *
     * @param null|string $option Component name
     *
     * @return null
     */
    public static function getVersion($option = 'com_droptables')
    {
        $manifest = self::getManifest($option);
        if (is_object($manifest) && property_exists($manifest, 'version')) {
            return $manifest->version;
        }
        return null;
    }

    /**
     * Method to get an object containing the manifest values
     *
     * @param string $option Component name
     *
     * @return object
     */
    public static function getManifest($option)
    {
        $component = self::getComponent($option);
        $table = JTable::getInstance('extension');
        // Load the previous Data
        if (!$table->load($component->id, false)) {
            return false;
        }
        return json_decode($table->manifest_cache);
    }
}
