<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access
defined('_JEXEC') || die;

/**
 * Class DroptablesTableConfig
 */
class DroptablesTableConfig extends JTable
{
    /**
     * Constructor
     *
     * @param JDatabase $db A database connector object
     *
     * @return void
     */
    public function __construct(&$db)
    {
        parent::__construct('#__droptables', 'id', $db);
    }

    /**
     * Overloaded bind function to pre-process the params.
     *
     * @param array  $array  Named array
     * @param string $ignore Ignore
     *
     * @return null|string null is operation was satisfactory, otherwise returns an error
     * @see    JTable:bind
     * @since  1.5
     */
    public function bind($array, $ignore = '')
    {
        if (isset($array['params']) && is_array($array['params'])) {
            $registry = new JRegistry();
            $registry->loadArray($array['params']);
            $array['params'] = (string) $registry;
        }

        return parent::bind($array, $ignore);
    }

    /**
     * Overload the store method for the Weblinks table.
     *
     * @param boolean $updateNulls Toggle whether null values should be updated.
     *
     * @return boolean True on success, false on failure.
     * @since  1.6
     */
    public function store($updateNulls = false)
    {
        $date = JFactory::getDate();
        // $user = JFactory::getUser();
        if ($this->id) {
            // Existing item
            $this->modified = $date->toSql();
            //$this->modified_by = $user->get('id');
        } else {
            // New weblink. A weblink created and created_by field can be set by the user,
            // so we don't touch either of these if they are set.
            if (!intval($this->created)) {
                $this->created = $date->toSql();
            }
            /*if (empty($this->created_by)) {
                $this->created_by = $user->get('id');
            }*/
        }

        // Attempt to store the user data.
        return parent::store($updateNulls);
    }
}
