<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') || die;

/**
 * Class DroptablesViewDroptables
 */
class DroptablesViewConfiguration extends JViewLegacy
{
    /**
     * Variable to hold params values
     *
     * @var array $params The data of params
     */
    protected $params;

    /**
     * Variable to hold form values
     *
     * @var array $form The data of form
     */
    protected $form;

    /**
     * Display the view
     *
     * @param string $tpl The name of the template file to parse
     *
     * @return void
     */
    public function display($tpl = null)
    {
        JHtml::_('jquery.framework');
        $document = JFactory::getDocument();

//        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/jquery-ui.js');

        $document->addStyleSheet(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/css/style.css');
        $document->addStyleSheet(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/css/waves.min.css');
        $document->addStyleSheet(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/css/jquery.qtip.css');
        $document->addStyleSheet(JURI::root() . 'components/com_droptables/assets/css/tooltipster.bundle.min.css');
        $document->addStyleSheet(JURI::root() . 'components/com_droptables/assets/css/tooltipster-sideTip-borderless.min.css');
        $document->addStyleSheet(JURI::root() . 'components/com_droptables/assets/css/config.css?v=' . time());

        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/tooltipster.bundle.min.js');
        $document->addScript(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/js/velocity.min.js');
        $document->addScript(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/js/tabs.js');
        $document->addScript(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/js/script.js');
        $document->addScript(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/js/waves.min.js');
        $document->addScript(JUri::base() . 'components/com_droptables/assets/joomla-css-framework/js/jquery.qtip.min.js');
        $document->addScript(JUri::base() . 'components/com_droptables/assets/js/configuration.js?v=' . time());

        $this->canDo = DroptablesHelper::getActions();
        $params = JComponentHelper::getParams('com_droptables');
        $this->paramsData = $params;
        $plugins = JPluginHelper::getPlugin('editors-xtd');
        $count = count($plugins);
        $this->plugins = array();
        for ($i = 0; $i < $count; $i++) {
            $this->plugins[] = $plugins[$i]->name;
        }
        $model = $this->getModel();
        $form = $model->getForm();

        // Bind data
        if ($form && $params) {
            $form->bind($params);
        }

        $this->form = &$form;

        $this->params = &$params;

        $this->addToolbar();
        parent::display($tpl);
    }

    /**
     * Add the page title and toolbar.
     *
     * @return void
     */
    protected function addToolbar()
    {
        JToolbarHelper::title(JText::_('COM_DROPTABLES_CONFIGURATION_TITLE'), 'ju_settings');

        // Generate html for toolbar button
        $html = array();
        $html[] = '<button onclick="Joomla.submitbutton(\'configuration.saveParams\');"  class="ju-button orange-button waves-effect waves-light">';
        $html[] = '<span class="icon-apply ju-icon orange-icon" aria-hidden="true"></span>' . JText::_('COM_DROPTABLES_JS_SAVE');
        $html[] = '</button>';
        $html[] = '<button onclick="Joomla.submitbutton(\'configuration.saveParamsAndClose\');"  class="ju-button orange-outline-button orange-border waves-effect waves-light">';
        $html[] = '<span class="icon-save ju-icon orange-outline-icon" aria-hidden="true"></span>' . JText::_('COM_DROPTABLES_JS_SAVE_AND_CLOSE');
        $html[] = '</button>';
        $html[] = '<button onclick="Joomla.submitbutton(\'configuration.closeConfiguration\');"  class="ju-button black-outline-button waves-effect waves-light">';
        $html[] = '<span class="icon-cancel ju-icon black-outline-icon" aria-hidden="true"></span>' . JText::_('COM_DROPTABLES_JS_CANCEL');
        $html[] = '</button>';
        $toolbar = JToolBar::getInstance('toolbar');
        $toolbar->appendButton('Custom', implode('', $html));
    }
}
