<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') || die;

/**
 * Class DroptablesViewDroptables
 */
class DroptablesViewDroptables extends JViewLegacy
{
    /**
     * State
     *
     * @var mixed
     */
    protected $state;

    /**
     * Display the view
     *
     * @param string $tpl The name of the template file to parse
     *
     * @return void
     */
    public function display($tpl = null)
    {
        $this->canDo = DroptablesHelper::getActions();
        $userManage = $this->canDo->get('core.manage');

        if (!isset($userManage) && $userManage !== true) {
            die();
        }

        $params = JComponentHelper::getParams('com_droptables');
        $this->params = $params;

        $this->editorHideButtons = false;
        if (isset($this->params['include_editor_buttons'])) {
            $loadEditorButtons = explode(',', $this->params['include_editor_buttons']);
            $excludeEditorButtons =  array();
            $plugins = JPluginHelper::getPlugin('editors-xtd');
            foreach ($plugins as $plugin) {
                if (!in_array($plugin->name, $loadEditorButtons)) {
                    $excludeEditorButtons[] = $plugin->name;
                }
            }
            if (!empty($excludeEditorButtons)) {
                $this->editorHideButtons = $excludeEditorButtons;
            }
        }

        $this->idTable = (int)JFactory::getApplication()->input->getInt('id_table');

        //check update old-tables
        require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'table.php');
        $modelTable1 = new DroptablesModelTable();
        $this->updateOldTable = $modelTable1->updateOldTable();
//        require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'install.php');
//        $droptablesInstallerScript = new com_droptablesInstallerScript();
//        $droptablesInstallerScript->droptables_update_styles(JFactory::getDbo());

        if ($this->idTable > 0) {
            //get table theme style
            $modelStyles = $this->getModel('styles');
            $this->styles = $modelStyles->getStyles();
            //get chart theme style
            $modelChartTypes = $this->getModel('chartTypes');
            $this->chartTypes = $modelChartTypes->getChartTypes();

            $this->setLayout(JFactory::getApplication()->input->getCmd('layout', 'default'));

            $this->firstData = $modelTable1->firstGetTable($this->idTable);

            if ($this->firstData->type === 'mysql') {
                $this->tableParams = array();
//                $this->tableParams = $modelTable1->getTableParams($this->idTable);
//                if (is_string($this->tableParams->params)) {
//                    $this->tableParams = json_decode($this->tableParams->params, true);
//                }
                require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'dbtable.php');
                $modelDbTable = new DroptablesModelDbtable();
                $query_option = $modelDbTable->getQueryOption($this->idTable);
                if (!empty($query_option->option_value) && is_string($query_option->option_value)) {
                    $query_option = json_decode($query_option->option_value, true);
                }
                $this->tableParams['query_option'] = $query_option;
            }
        } else {
            $model = $this->getModel('categories');
            JFactory::getApplication()->setUserState('list.limit', 100000);
            $this->categories = $model->getItems();
            $this->dbtable_cat = (int)$params->get('dbtable_cat', 0);

            $modelTables = $this->getModel('tables');
            $this->tables = $modelTables->getItems();
            $this->tables = DroptablesTablesHelper::categoryObject($this->tables);
        }

        $modelTable = $this->getModel('tables');
        $this->authors = $modelTable->getUsers();
        $this->user_roles = $modelTable->getUserRoles();
        $getUser = JFactory::getUser();
        $list_rolers_of_user = $getUser->groups;
        if (!empty($list_rolers_of_user) && is_array($list_rolers_of_user)) {
            $this->list_rolers_of_user = array_keys($list_rolers_of_user);
        } else {
            $this->list_rolers_of_user = array();
        }
        $this->user_roles1 = array();

        if ((int)JFactory::getApplication()->input->getInt('caninsert', 'GET', 'bool')) {
            $this->caninsert = true;
            //get charts
            require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'charts.php');
            $modelCharts = new DroptablesModelCharts();
            $this->listChart = $modelCharts->getCharts();
            $this->listChart = $this->sortChartsByTable($this->listChart);
            $this->back_to_list = JFactory::getApplication()->input->getInt('backtolist', 0);
        } else {
            $this->caninsert = false;
            $this->back_to_list = 0;
        }
        $this->id_charts = JFactory::getApplication()->input->getInt('chart', 'GET');

        parent::display($tpl);

        $app = JFactory::getApplication();
        if ($app->isClient('administrator')) {
            $this->addToolbar();
        }
    }

    /**
     * Group of chart by is table
     *
     * @param array $listChart List chart
     *
     * @return array|null
     */
    public function sortChartsByTable($listChart)
    {
        $data = null;
        if (is_array($listChart)) {
            $count = count($listChart);
            $data = array();
            for ($i = 0; $i < $count; $i ++) {
                if (!isset($data[$listChart[$i]->id_table])) {
                    $data[$listChart[$i]->id_table] = array();
                }
                $data[$listChart[$i]->id_table][] = $listChart[$i];
            }
        }
        return $data;
    }

    /**
     * Add the page title and toolbar.
     *
     * @return void
     */
    protected function addToolbar()
    {
        $canDo = DroptablesHelper::getActions();

        JToolBarHelper::title(JText::_('COM_DROPTABLES_MAIN_PAGE'), 'droptables.png');

        $toolbar = JToolBar::getInstance();

        if ($canDo->get('core.admin') && $this->idTable < 1) {
//        if ($canDo->get('core.admin')) {
//            $toolbar->appendButton('popup', 'support', JText::_('COM_DROPTABLES_VIEW_SUPPORT'), 'index.php?option=com_droptables&view=support&tmpl=component', 700, 600, 0, 0);
            JToolBarHelper::preferences('com_droptables');
            $toolbar->appendButton(
                'Link',
                'droptable-config-options',
                JText::_('COM_DROPTABLES_CONFIGURATION'),
                'index.php?option=com_droptables&amp;task=configuration.display'
            );
        }

        JToolBarHelper::divider();
    }
}
