<?php
/**
 * Droptables
 *
 * @package    Joomla.Administrator
 * @subpackage com_droptables
 *
 * @copyright Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') || die;

$app = JFactory::getApplication();

if ($app->isClient('site')) {
    JSession::checkToken('get') || die(JText::_('JINVALID_TOKEN'));
}

//JLoader::register('ContentHelperRoute', JPATH_ROOT . '/components/com_droptables/helpers/route.php');

// Include the component HTML helpers.
JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');

//JHtml::_('behavior.core');
JHtml::_('bootstrap.tooltip', '.hasTooltip', array('placement' => 'bottom'));
JHtml::_('formbehavior.chosen', 'select');

// Special case for the search field tooltip.
//$searchFilterDesc = $this->filterForm->getFieldAttribute('search', 'description', null, 'filter');
//JHtml::_('bootstrap.tooltip', '#filter_search', array('title' => JText::_($searchFilterDesc), 'placement' => 'bottom'));

$function = $app->input->getCmd('function', 'jSelectTable');
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));

$lang = '';
?>
<div class="container-popup">

    <form action="<?php echo JRoute::_('index.php?option=com_droptables&view=tables&layout=modal&tmpl=component&function=' . $function . '&' . JSession::getFormToken() . '=1'); ?>"
          method="post" name="adminForm" id="adminForm" class="form-inline">

        <div class="clearfix"></div>

        <?php if (empty($this->items)) : ?>
            <div class="alert alert-no-items">
                <?php echo JText::_('JGLOBAL_NO_MATCHING_RESULTS'); ?>
            </div>
        <?php else : ?>
            <table class="table table-striped table-condensed droptables_tables">
                <thead>
                <tr>

                    <th class="title">
                        <?php echo JHtml::_('searchtools.sort', 'JGLOBAL_TITLE', 'a.title', $listDirn, $listOrder); ?>
                    </th>
                    <th width="10%" class="nowrap hidden-phone">
                        <?php echo JHtml::_('searchtools.sort', 'JCATEGORY', 'a.id_category', $listDirn, $listOrder); ?>
                    </th>
                    <th width="15%" class="nowrap">
                        <?php echo JHtml::_('searchtools.sort', 'JDATE', 'a.modified_time', $listDirn, $listOrder); ?>

                    </th>
                    <th width="5%" class="nowrap hidden-phone">
                        <?php echo JHtml::_('searchtools.sort', 'JAUTHOR', 'a.author', $listDirn, $listOrder); ?>
                    </th>
                    <th width="1%" class="nowrap hidden-phone">
                        <?php echo JHtml::_('searchtools.sort', 'JGRID_HEADING_ID', 'a.id', $listDirn, $listOrder); ?>
                    </th>
                </tr>
                </thead>
                <tfoot>
                <tr>
                    <td colspan="5" style="border: none;">
                        <?php echo $this->pagination->getListFooter(); ?>
                    </td>
                </tr>
                </tfoot>
                <tbody>

                <?php foreach ($this->items as $i => $item) : ?>
                    <tr class="row<?php echo $i % 2; ?>">

                        <td>
                            <a href="javascript:void(0);"
                               onclick="if (window.parent) {window.parent.<?php echo $this->escape($function); ?>('<?php echo $item->id; ?>', '<?php echo $this->escape(addslashes($item->title)); ?>', '<?php echo $this->escape($item->id_category); ?>', null, '', '<?php echo $this->escape($lang); ?>', null); window.parent.jQuery('#ModalEditFronttable_jform_request_id').modal('hide')}">
                                <?php echo $this->escape($item->title); ?></a>

                        </td>
                        <td class="small hidden-phone">
                            <?php echo $this->escape($item->category_title); ?>
                        </td>

                        <td class="nowrap small hidden-phone">
                            <?php echo JHtml::_('date', $item->modified_time, JText::_('DATE_FORMAT_LC4')); ?>
                        </td>
                        <td class="nowrap small hidden-phone">
                            <?php echo $this->escape($item->author); ?>
                        </td>
                        <td class="nowrap small hidden-phone">
                            <?php echo (int)$item->id; ?>
                        </td>
                    </tr>
                <?php endforeach; ?>
                </tbody>
            </table>
        <?php endif; ?>

        <input type="hidden" name="task" value=""/>
        <input type="hidden" name="boxchecked" value="0"/>

        <?php echo JHtml::_('form.token'); ?>

    </form>
</div>

<script type="text/javascript">
    jQuery('.modal-footer', window.parent.document).hide();
    jQuery(".droptables_tables").tablesorter();
</script>
