<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') || die;

/**
 * Class DroptablesViewTables
 */
class DroptablesViewTables extends JViewLegacy
{
    /**
     * Items
     *
     * @var object
     */
    protected $items;
    /**
     * Pagination
     *
     * @var object
     */
    protected $pagination;
    /**
     * State
     *
     * @var object
     */
    protected $state;

    /**
     * Display the view
     *
     * @param string $tpl The name of the template file to parse
     *
     * @return void
     */
    public function display($tpl = null)
    {
        $this->canDo = DroptablesHelper::getActions();
        $params = JComponentHelper::getParams('com_droptables');
        $this->params = $params;

        $model = $this->getModel('categories');
        JFactory::getApplication()->setUserState('list.limit', 100000);
        $this->categories = $model->getItems();

        $modelTables = $this->getModel('tables');
        $this->items = $modelTables->getItemsForModal();
        //  $this->items = DroptablesTablesHelper::categoryObject($this->items);
        $this->state = $this->get('State');
        $this->pagination = $this->get('Pagination');
        $this->dbtable_cat = (int)$params->get('dbtable_cat', 0);

        $this->setLayout(JFactory::getApplication()->input->getCmd('layout', 'default'));

        parent::display($tpl);

        $app = JFactory::getApplication();
        if ($app->isClient('administrator')) {
            $this->addToolbar();
        }
    }

    /**
     * Add the page title and toolbar.
     *
     * @return void
     */
    protected function addToolbar()
    {

        $canDo = DroptablesHelper::getActions();

        JToolBarHelper::title(JText::_('COM_DROPTABLES_MAIN_PAGE'), 'droptables.png');

        $toolbar = JToolBar::getInstance();

        if ($canDo->get('core.admin')) {
            $toolbar->appendButton('popup', 'support', JText::_('COM_DROPTABLES_VIEW_SUPPORT'), 'index.php?option=com_droptables&view=support&tmpl=component', 700, 600, 0, 0);
            JToolBarHelper::preferences('com_droptables');
        }

        JToolBarHelper::divider();
    }
}
