<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;

/**
 * Class com_droptablesInstallerScript
 */
class com_droptablesInstallerScript //phpcs:ignore Squiz.Classes.ValidClassName.NotCamelCaps -- Class name not change
{
    /**
     * Method to install the component
     *
     * @return void
     */
    public static function install()
    {
        $lang = JFactory::getLanguage();
        $lang->load('com_droptables', JPATH_BASE . '/components/com_droptables', null, true);
        $dbo       = JFactory::getDbo();
        $queries   = array();
        $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_tables` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `id_category` int(11) NOT NULL,
                        `title` varchar(100) NOT NULL DEFAULT "",
                        `type` varchar(50) NOT NULL DEFAULT "html",
                        `style` mediumtext NULL,
                        `css` text NULL,
                        `hash` VARCHAR( 32 ) NULL DEFAULT "",
                        `params` text NULL,
                        `created_time` datetime NOT NULL,
                        `modified_time` datetime NOT NULL,
                        `author` int(11) NOT NULL,
						`position` int(11) NULL DEFAULT "0",
                        PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM  DEFAULT CHARSET=utf8';

        $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_charts` (
		      `id` int(11) NOT NULL AUTO_INCREMENT,
		      `id_table` int(11) NOT NULL,
		      `title` varchar(100) NOT NULL,
		      `datas` mediumtext NOT NULL,
		      `type` mediumtext NOT NULL,
		      `config` text NOT NULL,
		      `hash` varchar(32) NOT NULL,
		      `params` text NOT NULL,
		      `created_time` datetime NOT NULL,
		      `modified_time` datetime NOT NULL,
		      `author` int(11) NOT NULL,
		      PRIMARY KEY (`id`)
		    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';

        $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_table_options`  (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `id_table` int(11) NOT NULL,
                `option_name` varchar(255) NOT NULL,
                `option_value` text NOT NULL,
                PRIMARY KEY  (`id`)
              ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ';

        $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_range_styles` (
		      `id` int(11) NOT NULL AUTO_INCREMENT,
		      `id_table` int(11) NOT NULL,
		      `row_start` int(11) NOT NULL,
		      `row_end` int(11) NOT NULL,
		      `col_start` int(11) NOT NULL,
		      `col_end` int(11) NOT NULL,
		      `style` text NOT NULL,
		      PRIMARY KEY (`id`)
		    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';

        $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_charttyles` (
		      `id` int(11) NOT NULL AUTO_INCREMENT,
		      `name` varchar(50) NOT NULL,
		      `config` mediumtext NOT NULL,
		      `extra` text NOT NULL,
		      `image` text NOT NULL,
		      `ordering` int(11) NOT NULL,
		      PRIMARY KEY (`id`)
		    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';

        $queries[] = "INSERT INTO `#__droptables_table_options` (`id_table`, `option_name`, `option_value`) VALUES (0, 'droptables_tables_convert', '-1')";

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * Method to uninstall the component
     *
     * @return void
     */
    public function uninstall()
    {
        JLoader::register('JControllerLegacy', JPATH_LIBRARIES . 'legacy/controller/legacy.php');
        $session = JFactory::getSession();
        if ($session->get('droptablesUninstall', false) === false) {
            $session->set('droptablesUninstall', true);
            JFactory::getApplication()->enqueueMessage(JText::_('COM_DROPTABLES_INSTALLER_UNINSTALL_DB'), 'warning');
            $controller = new JControllerLegacy();
            $controller->setRedirect('index.php?option=com_installer&view=manage&confirm=1');
            $controller->redirect();
        }

        $dbo       = JFactory::getDbo();
        $queries   = array();
        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_tables`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_table_options`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_styles`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_range_styles`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_charts`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_charttyles`';
        //get list table data
        $dbo->setQuery(
            "SHOW TABLES LIKE '%_droptable_tbl%'"
        );
        $list_table_in_db = $dbo->loadObjectList();
        foreach ($list_table_in_db as $item) {
            $queries[] = 'DROP TABLE IF EXISTS ' . $item->{key($item)};
        }

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * Method to update the component
     *
     * @return void
     */
    public function update()
    {
        $dbo     = JFactory::getDbo();
        $queries = array();
        // $parent is the class calling this method
        if (version_compare($this->oldRelease, '2.0.0', 'lt')) {
            $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_charts` (
		      `id` int(11) NOT NULL AUTO_INCREMENT,
		      `id_table` int(11) NOT NULL,
		      `title` varchar(100) NOT NULL,
		      `datas` mediumtext NOT NULL,
		      `type` mediumtext NOT NULL,
		      `config` text NOT NULL,
		      `hash` varchar(32) NOT NULL,
		      `params` text NOT NULL,
		      `created_time` datetime NOT NULL,
		      `modified_time` datetime NOT NULL,
		      `author` int(11) NOT NULL,
		      PRIMARY KEY (`id`)
		    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';


            $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_charttyles` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `name` varchar(50) NOT NULL,
			  `config` mediumtext NOT NULL,
			  `extra` text NOT NULL,
			  `image` text NOT NULL,
			  `ordering` int(11) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';

            $queries[] = "INSERT INTO `#__droptables_charttyles` (`id`, `name`, `config`, `extra`, `image`, `ordering`) VALUES
			    (1, 'Line', '{   \r\n    \"scaleShowGridLines\" : false,\r\n  \"scaleGridLineColor\" : \"rgba(0,0,0,.05)\"\r\n   \r\n}', '', 'line.png', 0),
			    (2, 'Bar', '{\"scaleBeginAtZero\": true,\r\n \"scaleShowGridLines\" : true,\r\n \"scaleGridLineColor\" : \"rgba(0,0,0,.05)\",\r\n \"scaleGridLineWidth\":1,\r\n \"barShowStroke\" : true,\r\n \"barStrokeWidth\": 2,\r\n \"barValueSpacing\": 5,\r\n \"barDatasetSpacing\":10\r\n}', '', 'bar.png', 0),
			    (3, 'Radar', '', '', 'radar.png', 0),
			    (4, 'PolarArea', '', '', 'polar_area.png', 0),
			    (5, 'Pie', '', '', 'pie.png', 0),
			    (6, 'Doughnut', '', '', 'doughnut.png', 0)";
        }

        if (version_compare($this->oldRelease, '2.2.0', 'lt')) {
            $queries[] = 'ALTER TABLE `#__droptables_tables` ADD `position` INT NOT NULL';
        }

        if (version_compare($this->oldRelease, '3.6.4', 'lt')) {
            $queries[] = 'ALTER TABLE `#__droptables_tables` MODIFY `hash` VARCHAR( 32 ) NULL DEFAULT "", MODIFY `position` int(11) NULL DEFAULT "0" ';
        }

        if (version_compare($this->oldRelease, '3.6.0', 'lt')) {
            $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_table_options`  (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `id_table` int(11) NOT NULL,
                `option_name` varchar(255) NOT NULL,
                `option_value` text NOT NULL,
                PRIMARY KEY  (`id`)
              ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';
            $queries[] = 'ALTER TABLE `#__droptables_tables` ADD type char(50) DEFAULT \'html\'';
            $queries[] = 'UPDATE `#__droptables_tables` SET type = \'mysql\' WHERE params LIKE \'%table_type":"mysql%\'';

            $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_range_styles` (
		      `id` int(11) NOT NULL AUTO_INCREMENT,
		      `id_table` int(11) NOT NULL,
		      `row_start` int(11) NOT NULL,
		      `row_end` int(11) NOT NULL,
		      `col_start` int(11) NOT NULL,
		      `col_end` int(11) NOT NULL,
		      `style` text NOT NULL,
		      PRIMARY KEY (`id`)
		    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';

            $queries[] = 'DELETE FROM `#__droptables_charttyles`';

            $queries[] = "INSERT INTO `#__droptables_charttyles` (`id`, `name`, `config`, `extra`, `image`, `ordering`) VALUES
				(1, 'Line', '{   \r\n    \"scaleShowGridLines\" : false,\r\n  \"scaleGridLineColor\" : \"rgba(0,0,0,.05)\"\r\n   \r\n}', '', 'line.png', 0),
				(2, 'Bar', '{\"scaleBeginAtZero\": true,\r\n \"scaleShowGridLines\" : true,\r\n \"scaleGridLineColor\" : \"rgba(0,0,0,.05)\",\r\n \"scaleGridLineWidth\":1,\r\n \"barShowStroke\" : true,\r\n \"barStrokeWidth\": 2,\r\n \"barValueSpacing\": 5,\r\n \"barDatasetSpacing\":10\r\n}', '', 'bar.png', 0),
				(3, 'Radar', '', '', 'radar.png', 0),
				(4, 'PolarArea', '', '', 'polar_area.png', 0),
				(5, 'Pie', '', '', 'pie.png', 0),
				(6, 'Doughnut', '', '', 'doughnut.png', 0)";

            $backup = $this->backupTable();
            if ($backup) {//backup true then remove old-data
                $query = 'ALTER TABLE `#__droptables_tables` DROP COLUMN datas';
                $dbo->setQuery($query);
                $dbo->execute();
            }
        }
        if (version_compare($this->oldRelease, '4.0.0', 'lt')) {
            $this->droptablesUpdateStyles($dbo);
        }
        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * Function backup data from wp_droptables_tables table
     *
     * @return boolean
     */
    public function backupTable()
    {
        $dbo = JFactory::getDbo();
        $query = 'CREATE TABLE IF NOT EXISTS `#__droptables_backup` AS SELECT * FROM `#__droptables_tables`';

        $dbo->setQuery($query);
        if ($dbo->execute()) {
            return true;
        }
        return false;
    }

    /**
     * Method to run before an install/update/uninstall method
     *
     * @param string $type   Type
     * @param object $parent Parent
     *
     * @return boolean
     */
    public function preflight($type, $parent)
    {
        $app = JFactory::getApplication();
        if ($type === 'update') {
            $this->oldRelease = $this->getVersion('com_droptables');
            if (version_compare($this->oldRelease, $parent->getManifest()->version, 'gt')) {
                $app->enqueueMessage('You already have a newer version of Droptables', 'warning');
                jimport('joomla.application.component.controler');
                $controller = new JController();
                $controller->setRedirect('index.php?option=com_installer&view=install');
                $controller->redirect();

                return false;
            }
        } elseif ($type !== 'uninstall' && $type !== 'update') {
            // $parent is the class calling this method
            // $type is the type of change (install, update or discover_install)
            $this->release = $parent->getManifest()->version;
            $jversion      = new JVersion();
            // abort if the current Joomla release is older
            if (version_compare($jversion->getShortVersion(), '3.3.0', 'lt')) {
                $app->enqueueMessage('Cannot install Droptables component in a Joomla release prior to 3.7.0', 'warning');
                $controller = new JController();
                $controller->setRedirect('index.php?option=com_installer&view=install');
                $controller->redirect();

                return false;
            }
        }
    }

    /**
     * Method to run after an install/update/uninstall method
     *
     * @param string $type   Type
     * @param object $parent Parent
     *
     * @return boolean
     */
    public function postflight($type, $parent)
    {
        $dbo = JFactory::getDbo();
        if ($type === 'install') {
            $basePath = JPATH_ADMINISTRATOR . '/components/com_droptables';
            require_once $basePath . '/models/category.php';
            $config = array(
                'table_path' => $basePath . '/tables'
            );
            $catmodel = new DroptablesModelCategory($config);
            $catData  = array(
                'id'        => 0,
                'parent_id' => 1,
                'level'     => 1,
                'extension' => 'com_droptables',
                'title'     => JText::_('COM_DROPTABLES_INSTALLER_NEW_CATEGORY'),
                'alias'     => 'new-category',
                'published' => 1,
                'language'  => '*',
                'associations' => array()
            );
            $status   = $catmodel->save($catData);
            if (!$status) {
                $app = JFactory::getApplication();
                $app->enqueueMessage('Unable to create default content category!', 'warning');
            }
            
            $query = "INSERT INTO `#__droptables_charttyles` (`id`, `name`, `config`, `extra`, `image`, `ordering`) VALUES
				(1, 'Line', '{   \r\n    \"scaleShowGridLines\" : false,\r\n  \"scaleGridLineColor\" : \"rgba(0,0,0,.05)\"\r\n   \r\n}', '', 'line.png', 0),
				(2, 'Bar', '{\"scaleBeginAtZero\": true,\r\n \"scaleShowGridLines\" : true,\r\n \"scaleGridLineColor\" : \"rgba(0,0,0,.05)\",\r\n \"scaleGridLineWidth\":1,\r\n \"barShowStroke\" : true,\r\n \"barStrokeWidth\": 2,\r\n \"barValueSpacing\": 5,\r\n \"barDatasetSpacing\":10\r\n}', '', 'bar.png', 0),
				(3, 'Radar', '', '', 'radar.png', 0),
				(4, 'PolarArea', '', '', 'polar_area.png', 0),
				(5, 'Pie', '', '', 'pie.png', 0),
				(6, 'Doughnut', '', '', 'doughnut.png', 0)";

            $dbo->setQuery($query);
            $dbo->execute();
        }
        if ($type === 'install' || $type === 'update') {
            // $parent is the class calling this method
            // $type is the type of change (install, update or discover_install)
            $lang = JFactory::getLanguage();
            $lang->load('com_droptables.sys', JPATH_BASE . '/components/com_droptables', null, true);

            $manifest = $parent->getManifest();
            JLoader::register('DroptablesInstallerHelper', JPATH_ADMINISTRATOR . '/components/com_droptables/helpers/installer.php');
            echo '<h2>' . JText::_('COM_DROPTABLES_INSTALLER_TITLE') . '</h2>';
            echo JText::_('COM_DROPTABLES_INSTALLER_MSG');

            $extensions = $manifest->extensions;
            foreach ($extensions->children() as $extension) {
                $folder = $extension->attributes()->folder;
                $enable = $extension->attributes()->enable;
                if (DroptablesInstallerHelper::install(JPATH_ADMINISTRATOR . '/components/com_droptables/extensions/' . $folder, $enable)) {
                    //                        JFile::delete(JPATH_ADMINISTRATOR.'/components/com_sponsorshipreward/extensions/'.$folder);
                    echo '<img src="' . JURI::root() . '/components/com_droptables/assets/images/tick.png" />' . $folder . ' : ' . JText::sprintf('COM_DROPTABLES_INSTALLER_EXT_OK', '') . '<br/>';
                } else {
                    echo '<img src="' . JURI::root() . '/components/com_droptables/assets/images/exclamation.png" />' . $folder . ' : ' . JText::sprintf('COM_DROPTABLES_INSTALLER_EXT_NOK', '') . '<br/>';
                }
            }
            $this->droptablesUpdateStyles($dbo);
        }

        // add a menu type
        $query = $dbo->getQuery(true);
        $query->select('id');
        $query->from('#__menu_types');
        $query->where($dbo->quoteName('menutype') . '=' . $dbo->quote('droptables'));
        $dbo->setQuery($query);
        $menuTypeId = $dbo->loadResult();

        if (empty($menuTypeId)) {
            if (version_compare(JVERSION, '4.0.0', 'ge')) {
                $model = new Joomla\Component\Menus\Administrator\Model\MenuModel();
                $menuType = array(
                    'menutype' => 'droptables',
                    'title' => 'Droptables menu',
                    'description' => 'Droptables menu'
                );
                $saved = $model->save($menuType);
            } else {
                include_once JPATH_ADMINISTRATOR . '/components/com_menus/models/menu.php';
                $menuType = array('menutype'    => 'droptables',
                    'title'       => 'Droptables menu',
                    'description' => 'Droptables menu'
                );
                $model    = new MenusModelMenu();
                $saved    = $model->save($menuType);
            }

            // need to check errors and display message
            if (!$saved) {
                echo 'Error creating Droptables menu type: ' . $model->getError() . '<br />';
            }
        }

        // install template
        $sourcePath = JPATH_ADMINISTRATOR . '/components/com_droptables/templates';
        if ($type !== 'uninstall') {
            if (!JFolder::exists($sourcePath)) {
                echo json_encode($type);
                echo 'Unable to install droptables template, missing from source ZIP file!<br />';
                $templateExtensionId = false;
            } else {
                $installer = new JInstaller;
                $result    = $installer->install($sourcePath . '/droptablesfrontend');

                if (empty($result)) {
                    echo 'Error installing droptables template<br />';
                }
            }
        }

        $query = $dbo->getQuery(true);
        $query->select('id');
        $query->from('#__menu');
        $query->where($dbo->quoteName('menutype') . '=' . $dbo->quote('droptables'));
        $dbo->setQuery($query);
        $menuItemId = $dbo->loadResult();

        if (empty($menuItemId)) {
            $db    = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('id')->from('#__template_styles')->where($db->quoteName('template') . '=' . $db->Quote('droptablesfrontend'));
            $templateStyleId = $db->setQuery($query)->loadResult();

            if (empty($templateStyleId)) {
                echo 'Error reading template style <br />';
            } else {
                // now we can create the menu item. We can't use directly Joomla item model
                // has it has an hardcoded JPATH_COMPONENT require_once that fails if used
                // from another extension than com_menus

                // fetch installed Josetta extension id, as menu item needs that
                $query = $db->getQuery(true);
                $query->select('extension_id')->from('#__extensions')->where($db->quoteName('type') . '=' . $db->Quote('component'))
                      ->where($db->quoteName('element') . '=' . $db->Quote('com_droptables'));
                $componentId = $db->setQuery($query)->loadResult();

                if (empty($componentId)) {
                    echo 'Error reading just installed com_droptables extension id, cannot create front end menu item<br />';
                } else {
                    if (version_compare(JVERSION, '4.0.0', 'ge')) {
                        $model = new Joomla\Component\Menus\Administrator\Model\ItemModel();
                        // prepare menu item record
                        $menuItem = array(
                            'id' => 0,
                            'menutype' => 'droptables',
                            'title' => 'Manage Tables',
                            'alias' => 'manage-tables',
                            'path' => 'manage-tables',
                            'link' => 'index.php?option=com_droptables&view=manage',
                            'type' => 'component',
                            'component_id' => $componentId,
                            'published' => 1,
                            'parent_id' => 1,
                            'level' => 1,
                            'language' => '*',
                            'template_style_id' => $templateStyleId
                        );
                        $saved = $model->save($menuItem);
                    } else {
                        include_once JPATH_ADMINISTRATOR . '/components/com_droptables/helpers/item.php';
                        // prepare menu item record
                        $menuItem   = array(
                            'id'                => 0,
                            'menutype'          => 'droptables',
                            'title'             => 'Manage Tables',
                            'alias' => 'manage-tables',
                            'link'              => 'index.php?option=com_droptables&view=manage',
                            'type'              => 'component',
                            'component_id'      => $componentId,
                            'published'         => 1,
                            'parent_id'         => 1,
                            'level'             => 1,
                            'language'          => '*',
                            'template_style_id' => $templateStyleId
                        );
                        $model      = new MenusModelItem();
                        $saved      = $model->save($menuItem);
                    }

                    if (!$saved) {
                        echo 'Error creating Droptables menu item: ' . $model->getError() . '<br />';
                    }
                }
            }
        }

        //check joomunited token exist
        $dbo    = JFactory::getDbo();
        $tables = $dbo->getTableList();
        $app    = JFactory::getApplication();
        $prefix = $app->getCfg('dbprefix');
        if (in_array($prefix . 'joomunited_config', $tables)) {
            $query = $dbo->getQuery(true);
            $query->select('*');
            $query->from('#__joomunited_config AS h');
            $dbo->setQuery($query);

            $results = $dbo->loadObject();
            if (!empty($results)) {
                $token = $results->value;
                if (!empty($token)) {
                    $token    = str_replace('token=', '', $token);
                    $com_name = $parent->getElement();
                    $script   = '<script type="text/javascript">';
                    $script   .= 'jQuery(document).ready(function($){';
                    $script   .= "jQuery.ajax({
                                                url     :   'index.php?option=" . $com_name . "&task=jutoken.juAddToken',
                                                method    : 'GET',
                                                dataType : 'json',
                                                data    :   {
                                                    'token': '" . $token . "',
                                                }
                                            }).done(function(response){

                                            });";
                    $script   .= '});';
                    $script   .= '</script>';
                    echo $script;
                }
            }
        }

        return true;
    }

    /**
     * Function update wptm styles db
     *
     * @param object $dbo Object joomla database abstraction object.
     *
     * @return void
     */
    public function droptablesUpdateStyles($dbo)
    {
        $path = 'file_path';
        $paramsmedia = JComponentHelper::getParams('com_media');
        if (!defined('COM_MEDIA_BASE')) {
            define('COM_MEDIA_BASE', JPATH_ROOT . '/' . $paramsmedia->get($path, 'images'));
            define('COM_MEDIA_URL', JUri::root(true) . '/' . $paramsmedia->get($path, 'images'));
        }

        $queries[] = 'DROP TABLE IF EXISTS `#__droptables_styles`';
        $queries[] = 'CREATE TABLE IF NOT EXISTS `#__droptables_styles` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `image` text NOT NULL,
                        `data` mediumtext NOT NULL,
                        `cols_data` text NOT NULL,
                        `rows_data` text NOT NULL,
                        `styles` mediumtext NOT NULL,
                        `params` mediumtext NOT NULL,
                        PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }

        $params = JComponentHelper::getParams('com_droptables');
        $root_folder = $params->get('change_root_folder_old', 'com_droptables');
        $full_dir = COM_MEDIA_BASE . '/' . $root_folder . '/themes/';
        $full_url = COM_MEDIA_URL . '/' . $root_folder . '/themes/';
        if (!file_exists($full_dir)) {
            JFolder::create($full_dir);
            JFile::write($full_dir . 'index.html', '<html><body bgcolor="#FFFFFF"></body></html>');
        }

        $themeFile = JPATH_ADMINISTRATOR . '/components/com_droptables/views/style/theme.json';

        if (file_exists($themeFile)) {
            $json = file_get_contents($themeFile);
            $json_data = json_decode($json);
            $image_PATH = JPATH_SITE . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR
                . 'assets' . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . 'styles' . DIRECTORY_SEPARATOR;
            $image_url = JUri::root(true) . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR
                . 'assets' . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . 'styles' . DIRECTORY_SEPARATOR;
            $list_img = array();

            foreach ($json_data as $key => $data) {
                $data_cell = json_encode($data->data);
                if (isset($data->images)) {
                    foreach ($data->images as $key1 => $name) {
                        if (isset($list_img[$name])) {
                            $newData = $list_img[$name];
                        } else {
                            $newData = $this->uploadImage($name, $image_PATH . $name, $full_dir, $full_url);
                            $list_img[$name] = $newData;
                        }

                        $data_cell = str_replace('droptable_image_' . $key1, $newData, $data_cell);
//                        $data_cell = str_replace('wptm_image_id_' . $key1, 'wp-image-' . $newData[1], $data_cell);
                    }
                }

                $query = $dbo->getQuery(true);
                $query->insert($dbo->quoteName('#__droptables_styles'))
                    ->values(
                        implode(
                            ',',
                            array(
                                $dbo->quote($data_cell),
                                $dbo->quote(json_encode($data->cols)),
                                $dbo->quote(json_encode($data->rows)),
                                $dbo->quote(json_encode($data->range_styles)),
                                $dbo->quote(json_encode($data->params)),
                                $dbo->quote($image_url . 'theme' . $key . '.png')
                            )
                        )
                    )
                    ->columns(implode(',', array('data', 'cols_data', 'rows_data', 'styles', 'params', 'image')));
                $dbo->setQuery($query);
                $dbo->execute();
            }
        }
    }

    /**
     * Upload image to media
     *
     * @param string $name     Name image
     * @param string $url      Url image
     * @param string $full_dir New folder
     * @param string $full_url New folder url
     *
     * @return string
     */
    public function uploadImage($name, $url, $full_dir, $full_url)
    {
        $filename = basename($name);
        $image_data = file_get_contents($url);
        file_put_contents($full_dir . $filename, $image_data);
        return $full_url . $filename;
    }

    /**
     * Method to get the version of a component
     *
     * @param string $option Option
     *
     * @return null
     */
    private function getVersion($option)
    {
        $manifest = self::getManifest($option);
        if (!$manifest) {
            return null;
        }
        if (property_exists($manifest, 'version')) {
            return $manifest->version;
        }

        return null;
    }

    /**
     * Method to get an object containing the manifest values
     *
     * @param string $option Option
     *
     * @return object
     */
    private function getManifest($option)
    {
//                $component = JComponentHelper::getComponent($option);
        $dbo   = JFactory::getDbo();
        $query = 'SELECT extension_id FROM #__extensions WHERE element=' . $dbo->quote($option) . ' AND type="component"';
        if (!$dbo->setQuery($query)) {
            return false;
        }
        if (!$dbo->execute()) {
            return false;
        }
        $component = $dbo->loadResult();
        if (!$component) {
            return false;
        }
        $table = JTable::getInstance('extension');
        // Load the previous Data
        if (!$table->load($component, false)) {
            return false;
        }

        return json_decode($table->manifest_cache);
    }
}
