/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

import tableFunction from "./_functions";
import {initHandsontable} from "./_handsontable";
import selectOption from "./_toolbarOptions";
import DropChart from "./_charts";
import alternating from "./_alternating";

// jQuery(window).bind('beforeunload', function(){
//     if(!checkTimeOut)
//         return true;
// });

jQuery(document).ready(function ($) {
    function convert_data_table (id) {
        if (parseInt(id) >= 0) {
            $.ajax({
                url: Droptables.ajaxurl + "index.php?option=com_droptables&task=table.updateOldTable&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                type: 'POST',
                dataType: "json",
                data: {
                    'id': id
                },
                success: function (datas) {
                    if (datas.response === true) {
                        if (parseInt(datas.datas) < 0) {
                            setTimeout(function () {
                                $('.convert_tables').remove();
                            }, 3000);
                        } else {
                            convert_data_table(datas.datas);
                        }
                    } else {
                        bootbox.alert('Error while convert table' + ' : ' + datas.datas);
                    }
                },
                error: function (jqxhr, textStatus, error) {
                    bootbox.alert(textStatus);
                }
            });
        }
    }

    if (typeof droptable_update_data !== 'undefined' && parseInt(droptable_update_data) >= 0) {
        convert_data_table(droptable_update_data);
    }

    if (typeof droptable_update_data !== 'undefined' && parseInt(droptable_update_data) == -1) {
        if (parseInt(droptable_update_data) > -2) {
            function convert_data_table_362(id) {
                $.ajax({
                    url: Droptables.ajaxurl + "index.php?option=com_droptables&task=table.updateTable362&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                    type: 'POST',
                    dataType: "json",
                    data: {
                        'id': id
                    },
                    success: function (datas) {
                        if (datas.response === true) {
                            if (parseInt(datas.datas) < 0) {
                                setTimeout(function () {
                                    $('.convert_tables').remove();
                                }, 3000);
                            } else {
                                convert_data_table_362(datas.datas);
                            }
                        } else {
                            bootbox.alert('Error while convert table' + ' : ' + datas.datas);
                        }
                    },
                    error: function (jqxhr, textStatus, error) {
                        bootbox.alert(textStatus);
                    }
                });
            }
            convert_data_table_362(droptable_update_data);
        }
    }

    $('[data-toggle="tooltip"]').tooltip();
    window.jquery = $;

    if (typeof (Droptables) == 'undefined') {
        Droptables = {};
        Droptables.can = {};
        Droptables.can.create = true;
        Droptables.can.edit = true;
        Droptables.can.delete = true;
        Droptables.selection = {};
        Droptables.value_unit_chart = [];
        Droptables.hyperlink = {};
    } else {
        Droptables.value_unit_chart = [];
    }

    Droptables.updateSettings = {};
    Droptables.saveDataDbTable = [];

    window.Droptables_element = {
        wpreview: $('#droptable_toolbars'),
        primary_toolbars: $('#primary_toolbars'),
        mainTabContent: $('#mainTabContent'),
        tableContainer: $('#tableContainer'),
        droptable_popup: $('#droptable_popup'),
        content_popup_hide: $('#content_popup_hide'),

        cellValue: $('#CellValue'),
        settingCells: $('#setting-cells'),
        settingTable: $('#table-setting'),
        nameTable: $('#name-table'),
        alternating_color: $('#alternating_color'),
        editToolTip: $('#editToolTip'),
        edit_html_cell: $('#edit_html_cell'),
        Droptables_edit_html_cell: $('#Droptables_edit_html_cell'),
        saveToolTipbtn: $('#saveToolTipbtn'),
        chartTabContent: $('#chartTabContent'),
        DroptablesContentChart: $('#droptable_chart .droptable_content_chart')
    };

    // $('#droptables_editToolTip').css('')

    //saving all function data
    window.table_function_data = {
        replace_unit: {},
        text_replace_unit: '',
        text_replace_unit_function: '',
        date_format: [],
        check_value_data: true,
        string_currency_symbols: '',
        selectFetch: {},
        allAlternate: {},
        oldAlternate: {},
        changeAlternate: [],
        checkChangeAlternate: [],
        selection: [],
        styleToRender: '',
        content: '',
        needSaveAfterRender: false,
        alternateIndex: '',
        alternateSelection: [],
        save_table_params: [],
        firstRender: false,
        accountingNumber : {}
    };

    /* init menu actions */
    window.default_value = $.extend({}, {
        'use_sortable': '0',
        'default_sortable': '0',
        'default_order_sortable': '1',
        'enable_import_excel': 1,
        'table_align': 'center',
        'responsive_type': 'scroll',
        'table_breakpoint': '980',
        'freeze_col': 0,
        'table_height': 500,
        'style_repeated': 0,
        'freeze_row': 0,
        'enable_filters': 0,
        'enable_pagination': 0,
        'allRowHeight': '',
        'spreadsheet_url': '',
        'spreadsheet_style': 0,
        'cell_types': [],
        'auto_sync': 0,
        'auto_push': 0,
        'download_button': 0,
        'col_types': ["varchar","varchar","varchar","varchar","varchar","varchar","varchar","varchar","varchar","varchar"]
    }, default_value);

    if (typeof idTable !== 'undefined' && idTable !== '') {
        if (!(typeof default_value.enable_import_excel !== 'undefined' && parseInt(default_value.enable_import_excel) === 1)) {
            Droptables_element.primary_toolbars.find('.export_menu').parent().remove();
        }

        if (typeof user_roles !== 'undefined') {
            Droptables.user_roles = user_roles;
        } else {
            Droptables.user_roles = [];
        }

        if (typeof list_rolers_of_user !== 'undefined' && list_rolers_of_user !== null) {
            Droptables.list_rolers_of_user = list_rolers_of_user;
        } else {
            Droptables.list_rolers_of_user = [];
        }
        Droptables.check_super_user = false;
        Droptables.list_rolers_of_user.map(function (roler) {
            if (typeof Droptables.user_roles[roler] !== 'undefined' && Droptables.user_roles[roler] === 'Super Users') {
                Droptables.check_super_user = true;
            }
        });

        var curr_page = window.location.href;
        var cells = curr_page.split("?");
        var new_url;
        if (Droptables.view === 'manage') {
            // option=com_droptables&view=manage
            new_url = cells[0] + "?view=manage";
            if (typeof Droptables.e_name !== 'undefined' && Droptables.e_name !== '') {
                new_url += "&e_name=" + Droptables.e_name;
            }

            $('.back_to_tables').attr({'href': new_url});
        }

        updatepreview(idTable);

        if (Droptables_element.tableContainer.length > 0 && $('#sidebar-wrapper').length > 0) {
            var wh = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            var height_content = wh - $('#header').find('.header-inside').outerHeight() - 15;
            $('#sidebar-wrapper').css({'height' : height_content});
            var el1 = document.querySelector('#sidebar-wrapper');
            SimpleScrollbar.initEl(el1);
        }
    }

    $(document).on("click", "#fetch_browse", function(e) {
        var i = $(e.target).attr("href");

        $(i).css({'display': 'block', 'opacity': 1});

        $(i).find('.btn-close').unbind('click').on('click', function () {
            $(i).css({'display': 'none', 'opacity': 0});
        });
    })
});

function getOwn (position) {
    var userOwn = Droptables.userOwn;
    var data;
    switch (position) {
        case 'edit_cat':
            data = Droptables.userOwn.edit || Droptables.userOwn.editOwn;
            break;
        case 'delete_cat':
            data = Droptables.userOwn.delete;
            break;
        case 'create_cat':
            data = Droptables.userOwn.create;
            break;
        case 'edit':
            data = Droptables.userOwn.table_edit || (Droptables.userOwn.table_editOwn && Droptables.authorTable == Droptables.author);
            break;
        case 'delete':
            data = Droptables.userOwn.table_delete;
            break;
        case 'create':
            data = Droptables.userOwn.table_create;
            break;
        case 'access_db':
            data = Droptables.userOwn.access_db;
            break;
    }

    return data;
}

function checkLightOrDark(color) {
    var r, g, b, hsp;

    if (color.match(/^rgb/)) {
        color = color.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/);
        r = color[1];
        g = color[2];
        b = color[3];
    }
    else {
        color = +("0x" + color.slice(1).replace(color.length < 5 && /./g, '$&$&'));
        r = color >> 16;
        g = color >> 8 & 255;
        b = color & 255;
    }

    hsp = Math.sqrt(
        0.299 * (r * r) +
        0.587 * (g * g) +
        0.114 * (b * b)
    );

    if (hsp>127.5) {
        return 1;
    }
    else {
        return 0;
    }
}

function codemirror_tooltip($) {
    window.CustomEditor = Handsontable.editors.TextEditor.prototype.extend();

    $('.tip').tooltipster({
        theme: 'tooltipster-borderless',
        delay: 100,
        distance: 5,
    });


    window.CustomEditor.prototype.open = function () {
        $(this.TEXTAREA).attr('id', 'editor1');
        var lightOrDark = checkLightOrDark($(this.TEXTAREA).css( "backgroundColor" ));
        if (lightOrDark === 0) {
            $(this.TEXTAREA).css({'color':'#ffffff'});
        } else {
            $(this.TEXTAREA).css({'color':'#000000'});
        }

        if (typeof (Droptables.style.cells[this.row + '!' + this.col]) !== 'undefined'
            && typeof (Droptables.style.cells[this.row + '!' + this.col][2].cell_type) !== 'undefined'
            && Droptables.style.cells[this.row + '!' + this.col][2].cell_type === 'html') {
            // cell_html = true;
            Handsontable.editors.TextEditor.prototype.close.apply(this, arguments);
            // tinyMCE.EditorManager.execCommand('mceRemoveEditor', true, 'html_cell_content');

            if (Droptables_element.tableContainer.height() < 400) {
                $('#tableContainerParent.scrollable').find('.viewport').css({'overflow':'visible'});
            }
            if ($('.handsontableInputHolder').length > 0) {

                $("#btnDroptablesDescription").trigger('click');

                console.log(Handsontable.editors);
                var currentData = Handsontable.editors.TextEditor.prototype.getValue.apply(this, arguments);
                Joomla.editors.instances['droptablesDescription'].setValue(currentData);

            }
            Handsontable.editors.TextEditor.prototype.open.apply(this, arguments);

        } else {
            //close modal
            $("#lean_overlay").fadeOut(200);
            $("#modalDroptablesDescription").hide();
            Handsontable.editors.TextEditor.prototype.open.apply(this, arguments);
        }
    };


    window.CustomEditor.prototype.getValue = function () {
        return Handsontable.editors.TextEditor.prototype.getValue.apply(this, arguments);
    };

    window.CustomEditor.prototype.setValue = function (newValue) {
        return Handsontable.editors.TextEditor.prototype.setValue.apply(this, arguments);
    };

    window.CustomEditor.prototype.close = function () {
        if ($('#mybootstrap').hasClass('joomla30')) {
            $('.modal-backdrop').removeClass('droptable_hiden');
        }
        Droptables_element.mainTabContent.css({'z-index': '9'});

        $('#tableContainerParent.scrollable').find('.viewport').css({'overflow':'hidden'});
        return Handsontable.editors.TextEditor.prototype.close.apply(this, arguments);
    };
}

//Call ajax to get all data of table, add value to Wptm, table_function_data
function updatepreview(id,) {
    /*remove after change theme*/
    var url = Droptables.ajaxurl + "index.php?option=com_droptables&view=table&format=json&id=" + id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert);
    var $ = jquery;
    $.ajax({
        url: url,
        type: "POST",
        data: {},
        dataType: "json",
    }).done(function (data) {
        $('.minicolors-input').minicolors('settings', {
            change: function () {
                jQuery(this).trigger('change');
            }
        }).attr('maxlength', '7');

        //TODO: check user role table
        Droptables.id = id;
        Droptables.title = data.title;
        Droptables.authorTable = data.author;
        jquery('#primary_toolbars').find('.droptable_name_edit').text(Droptables.title);
        /*not change data cell(in db table)*/
        Droptables.type = 'html';
        Droptables.category = data.category;

        /*set height rows variable*/
        Droptables.rowsHeight = {};
        Droptables.table_height = 0;

        Droptables.hyperlink = {};
        if (typeof data.type !== 'undefined') {
            Droptables.type = data.type;
        } else {
            Droptables.type = (typeof data.params.type !== 'undefined') ? data.params.type : Droptables.type;
        }

        if (data.data === '' || data.data === false) {
            delete Droptables.datas;
            if (Droptables.type === 'mysql') {
                Droptables.datas = [
                    [Joomla.JText._('COM_DROPTABLES_LAYOUT_DBTABLES_NO_RESULTS', 'No results found')],
                ];
            } else {
                Droptables.datas = [
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""]
                ];
            }
        } else {
            try {
                if (typeof data.data === 'string') {
                    data.data = JSON.stringify(data.data);
                    data.data = JSON.parse(data.data);
                }
                Droptables.datas = data.data;
            } catch (err) {
                Droptables.datas = [
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""]
                ];
            }
        }

        Droptables.style = data.style;

        Droptables.css = data.css.replace(/\\n/g, "\n");
        // Droptables.style.table.mergeSetting = [];

        if (!(Droptables.style === "" || Droptables.style === null || Droptables.style.length == 0)) {
            if (Droptables.style.table === null) {
                Droptables.style.table = {};
            }
            if (typeof Droptables.style.table !== 'undefined' && typeof Droptables.style.table.headerOption !== 'undefined') {
                Droptables.style.table.headerOption = parseInt(Droptables.style.table.headerOption);
            }
            if (Droptables.style.table.headerOption < 1) {
                Droptables.style.table.headerOption = 1;
            }

            if (typeof Droptables.style.table.hyperlink !== 'undefined') {
                if (typeof Droptables.style.table.hyperlink === 'string') {
                    Droptables.style.table.hyperlink = $.parseJSON(Droptables.style.table.hyperlink);
                }

                $.each(Droptables.style.table.hyperlink, function (index, value) {
                    var rowCol = index.split("!");
                    if(typeof Droptables.datas[rowCol[0]] !== 'undefined' || typeof value.text == 'object') {
                        value.text =  Droptables.datas[rowCol[0]][rowCol[1]];
                        Droptables.datas[rowCol[0]][rowCol[1]] = '<a target="_blank" href="' + value.hyperlink + '">' + value.text + '</a>';
                        Droptables.hyperlink[index] = value;
                    }
                });
            }

            try {
                // if (typeof Droptables.style.table.mergeSetting === 'string') {
                //     Droptables.style.table.mergeSetting = $.parseJSON(Droptables.style.table.mergeSetting);
                // }
                //
                // if (Droptables.style.table.mergeSetting == null || Droptables.style.table.mergeSetting.length < 1) {
                //     Droptables.style.table.mergeSetting = [];
                // }
            } catch (e) {
                Droptables.style.table.mergeSetting = [];
            }
        }

        /*set default table data*/
        if (typeof (Droptables.style) === 'undefined' || Droptables.style === null) {
            $.extend(Droptables, {
                style: {
                    table: {},
                    rows: {},
                    cols: {},
                    cells: {}
                },
                css: ''
            });
        }

        if (typeof (Droptables.style.rows) === 'undefined' || Droptables.style.rows === null) {
            Droptables.style.rows = {};
        }
        var Droptables_number_col = Droptables.datas[0].length;
        if (typeof (Droptables.style.cols) === 'undefined' || Droptables.style.cols === null) {
            Droptables.style.cols = {};
            for (var ii = 0; ii <  Droptables_number_col; ii++) {
                Droptables.style.cols[ii] = [ii, {res_priority: ii}];
            }
        } else {
            for (var ii = 0; ii <  Droptables_number_col; ii++) {
                if (typeof window.Droptables.style.cols[ii] === 'undefined' || window.Droptables.style.cols[ii] === null) {
                    Droptables.style.cols[ii] = [ii, {res_priority: ii}];
                } else  if (typeof window.Droptables.style.cols[ii][1].res_priority === 'undefined') {
                    Droptables.style.cols[ii][1].res_priority =  ii;
                }
            }
        }
        if (typeof (Droptables.style.cells) === 'undefined' || Droptables.style.cells === null) {
            Droptables.style.cells = {};
        }

        tableFunction.mergeCollsRowsstyleToCells();

        Droptables.style.table = $.extend({}, window.default_value, Droptables.style.table);

        if (typeof table_function_data.auto_sync !== 'undefined') {
            Droptables.style.table.auto_sync = table_function_data.auto_sync;
            Droptables.style.table.spreadsheet_style = table_function_data.spreadsheet_style;
            Droptables.style.table.spreadsheet_url = table_function_data.spreadsheet_url;
            delete table_function_data.auto_sync;
        }

        if (Droptables.style.table.spreadsheet_url !== '' && Droptables.style.table.spreadsheet_url.indexOf("docs.google.com/spreadsheet") === -1) {//when first auto syn after update 2.7.0
            if (table_function_data.auto_sync == 1) {
                Droptables.style.table.excel_auto_sync = 1;
                Droptables.style.table.auto_sync = 0;
                Droptables.style.table.excel_spreadsheet_style = Droptables.style.table.spreadsheet_style;
            }
            Droptables.style.table.excel_url = table_function_data.spreadsheet_url;
            table_function_data.spreadsheet_url = '';
            Droptables.style.table.spreadsheet_url = '';
        }

        if (Droptables.style.table.headerOption > 0 && (typeof Droptables.style.header_data === 'undefined' || Droptables.style.header_data.length < Droptables.style.table.headerOption)) {
            Droptables.style.header_data = [];
            for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                Droptables.style.header_data[j] = Droptables.datas[j];
            }
        }

        window.table_function_data = tableFunction.createRegExpFormat(table_function_data, Droptables.style.table.currency_symbol, Droptables.style.table.date_format);
        if (typeof Droptables.style.table.date_formats !== 'undefined' && Droptables.style.table.date_formats !== '') {
            window.table_function_data.date_formats_momentjs = tableFunction.momentjsFormat(Droptables.style.table.date_formats);
        }
        window.Droptables = $.extend({}, window.Droptables, Droptables);

        $('#jform_css').val(Droptables.css);
        $('#jform_css').change();
        tableFunction.parseCss($, false);

        // tableFunction.setFormat_accounting();

        var handRisize, clearHandRisize;
        window.onresize = function () {
            if (!clearHandRisize) {
                clearTimeout(handRisize);
            }

            clearHandRisize = false;
            handRisize = setTimeout(function () {
                var height = tableFunction.calculateTableHeight(window.jquery('#droptable_toolbars'));
                jquery(Droptables_element.tableContainer).handsontable('updateSettings', {height: height});
                clearHandRisize = true;
            }, 500);
        };

        if (typeof (Droptables.style.table.alternateColorValue) === 'undefined' || typeof Droptables.style.table.alternateColorValue[0] === 'undefined') {
            var styleRows = null;
            alternating.setAlternateColor(styleRows, window.Droptables, window.Droptables_element);
        }

        if (tableFunction.droptablesCheckSize(window.table_function_data.oldAlternate) < 1) {
            window.table_function_data.oldAlternate = $.extend({}, Droptables.style.table.alternateColorValue);
        }

        if (tableFunction.droptablesCheckSize(window.table_function_data.allAlternate) < 1) {
            window.table_function_data.allAlternate = $.extend({}, Droptables.style.table.allAlternate);
        }

        //update option table
        selectOption.updateOptionValTable($, window.Droptables, [0, 0, 0, 0]);

        codemirror_tooltip($);

        $('#list_chart').find('.current_table a').text(Droptables.title);
        if (Droptables.type !== 'html') {
            // Droptables_element.primary_toolbars.find('.Droptables_name_edit').after('<div class="Droptables_warning"><p>' + DroptablesText.notice_msg_table_database + '</p></div>');
            if (Droptables_element.settingTable.find('.table-menu a.source_menu').length > 0) {
                Droptables_element.settingTable.find('.table-menu a.source_menu').parent().show();
            }
            if (Droptables.style.table.allRowHeight < 10 || isNaN(Droptables.style.table.allRowHeight)) {
                Droptables.style.table.allRowHeight = 30;
            }
        } else {
            Droptables_element.settingTable.find('.table-menu a.source_menu').parent().hide();
        }

        //check edit columns, get column key
        if (window.Droptables.type === 'mysql' && typeof data.query_option !== 'undefined') {
            Droptables.query_option = data.query_option;
            if (Droptables.query_option.column_options !== null && Droptables.query_option.column_options.length > 0) {
                table_function_data.columns = [];
                for (var i in Droptables.query_option.column_options) {
                    if (parseInt(Droptables.query_option.column_options[i].canEdit) !== 1 || (Droptables.query_option.column_options[i].table + '.' + Droptables.query_option.column_options[i].Field === Droptables.style.table.priKey)) {
                        table_function_data.columns[i] = {readOnly: true};
                    } else {
                        table_function_data.columns[i] = {readOnly: false}
                    }
                    if (typeof Droptables.style.table.lock_columns !== 'undefined'
                        && Droptables.style.table.lock_columns[i] != 0) {
                        table_function_data.columns[i] = {readOnly: true};
                    }
                    if (Droptables.style.table.priKey === Droptables.query_option.column_options[i].table + '.' + Droptables.query_option.column_options[i].Field) {
                        table_function_data.keyPosition = i;
                    }
                }
            }
        }

        if (typeof Droptables.style.table.lock_ranger_cells !== 'undefined' && Droptables.style.table.lock_ranger_cells.length > 0) {
            tableFunction.create_ranger_cells_lock(Droptables, table_function_data, null);
        }

        table_function_data.mysqlEdit = Droptables.type !== 'mysql' || (typeof Droptables.style.table.table_editing !== 'undefined' && parseInt(Droptables.style.table.table_editing) === 1);
        if (!table_function_data.mysqlEdit) {
            $('.warnning_edit_db_table').hide();
        }
        table_function_data.allowed_edit = getOwn('edit');
        table_function_data.delete = getOwn('delete');
        table_function_data.access_db = getOwn('access_db');
        Droptables.style.table.mergeSetting = tableFunction.convertMergeCell();

        /*render table */
        initHandsontable(Droptables.datas);

        Droptables_element.primary_toolbars.find('.droptable_name_edit').click(function () {
            if (!$(this).hasClass('editable')) {
                tableFunction.setText.call(
                    $(this),
                    Droptables_element.primary_toolbars.find('.droptable_name_edit'),
                    '#primary_toolbars .droptable_name_edit',
                    {'url': Droptables.ajaxurl + "index.php?option=com_droptables&task=table.setTitle&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert) + '&title=', 'selected': true}
                );
            }
        });

        $(window).bind('keydown', function(event) {//CTRL + S
            if (!(event.which == 83 && (event.ctrlKey || event.metaKey)) && !(event.which == 19)) return true;
            tableFunction.saveChanges(true);
            event.preventDefault();
            return false;
        });
    });

    if (typeof default_value.enable_import_excel !== 'undefined' && parseInt(default_value.enable_import_excel) === 1) {
        $("#procExcel").dropzone({
            url: "index.php?option=com_droptables&task=excel.import",
            maxFiles: 1,
            //acceptedFiles: 'xls,xlsx',
            init: function () {
                //Update form action
                this.on("addedfile", function (file) {
                    var dotPos = file.name.lastIndexOf('.') + 1;
                    var ext = file.name.substr(dotPos, file.name.length - dotPos);

                    if (ext !== 'xls' && ext !== 'xlsx') {
                        bootbox.alert('Please choose a file with type of xls or xlsx.');
                        this.options.autoProcessQueue = false;
                        this.removeFile(file);
                        //return false;
                    }
                    else {
                        if (this.options.autoProcessQueue === false) {
                            this.options.autoProcessQueue = true;
                        }
                    }

                });

                this.on("sending", function (file, xhr, formData) {
                    //Add table id to formData
                    $("#jform_id_table").val(Droptables.id);
                    formData.append('id_table', Droptables.id);
                    formData.append('onlydata', Droptables_element.droptable_popup.find("#import_style").val());

                    // Show the total progress bar when upload starts
                    //this.options.uploadprogress(file);
                    Droptables_element.droptable_popup.find(".progress").show();
                    Droptables_element.droptable_popup.find(".progress-bar-success").css('width', 30 + '%');
                    Droptables_element.droptable_popup.find(".progress-bar-success").css('opacity', 1);
                    // And disable the start button
                    //file.previewElement.querySelector(".start").setAttribute("disabled", "disabled");
                });

                this.on("success", function (file, responseText) {
                    Droptables_element.droptable_popup.find(".progress").fadeOut(1000);
                    var responseObj = JSON.parse(responseText);

                    Droptables_element.droptable_popup.find('.colose_popup').trigger('click');
                    if (responseObj.response === true) {
                        if (typeof responseObj.datas.too_large !== 'undefined') {
                            bootbox.confirm(responseObj.datas.msg, function (result) {
                                if (result === true) {
                                    var jsonVar = {
                                        id_table: responseObj.datas.id,
                                        onlydata: responseObj.datas.onlydata,
                                        file: encodeURI(responseObj.datas.file),
                                        ignoreCheck: 1
                                    };
                                    $.ajax({
                                        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=excel.import&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                                        type: 'POST',
                                        data: jsonVar,
                                        success: function (datas) {
                                            location.reload();
                                        }
                                    })
                                } else {
                                    //do nothing
                                }
                            });
                        } else {
                            location.reload();
                        }
                    } else {
                        bootbox.alert(responseObj.response);
                    }
                });

                this.on('complete', function (file) {
                    this.removeFile(file);
                    setTimeout(function () {
                        Droptables_element.droptable_popup.find(".progress-bar-success").css('width', 0);
                    }, 6000);
                });
                // Update the total progress bar
                this.on("uploadprogress", function (file, progress) {
                    Droptables_element.droptable_popup.find(".progress-bar-success").css('width', progress + "%");
                });
            }
        })
    }

    //codemirror
    var myTextArea = document.getElementById("jform_css");
    var myCssEditor = CodeMirror.fromTextArea(myTextArea, {mode: "css", lineNumbers: true});
    var ww = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    var wh = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    if (window.parent) {
        ww = window.parent.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
        wh = window.parent.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    }

    myCssEditor.setSize(ww * 50 / 100, wh - 500);

    Droptables_element.primary_toolbars.find('.custom-menu').leanModal({
        top: typeof Droptables.caninsert !== 'undefined' && Droptables.caninsert === 1 && typeof Droptables.isJoomla30 !== 'undefined' && Droptables.isJoomla30 === 1 ? 50 : 200,
        background: '#ffffff',
        closeButton: '#cancelCssbtn',
        beforeShow: function () {
            var selection = table_function_data.selection;
            var ht = jQuery(Droptables_element.tableContainer).handsontable('getInstance');
            ht.updateSettings({
                cells: function (row, col, prop) {
                    if (selection[0][0] === row && selection[0][1] === col) {
                        var cellProperties = {};

                        cellProperties.readOnly = true;
                        return cellProperties;
                    }
                }
            });
            window.jquery(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][0], selection[0][1]);
        },
        before_colose_modal: function () {
            var selection = table_function_data.selection;

            var ht = jQuery(Droptables_element.tableContainer).handsontable('getInstance');
            ht.updateSettings({
                cells: function (row, col, prop) {
                    if (selection[0][0] === row && selection[0][1] === col) {
                        var cellProperties = {};

                        cellProperties.readOnly = false;
                        return cellProperties;
                    }
                }
            });
            window.jquery(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][0], selection[0][1]);
        },
        modalShow: function () {
            myCssEditor.refresh();
            myCssEditor.focus();
        }
    });

    $(myTextArea).on('change', function () {
        myCssEditor.setValue($(myTextArea).val().replace(/\\n/g, "\n"));
    });

    // myCssEditor.on("blur", function() {
    $("#saveCssbtn").click(function () {
        myCssEditor.save();
        tableFunction.parseCss($, true);
        $(myTextArea).trigger("propertychange");
        //close leanModal
        $("#lean_overlay").fadeOut(200);
        $("#droptable_customCSS").css({"display": "none"})
    });

    $(document).on('click', '.search-open-btn', function (e) {
        var btn = $(this);
        var search_menu = btn.closest('.search-menu');
        if (!search_menu.hasClass("open")) {
            search_menu.addClass("open");
            $('.search-menu #dp-form-search').focus()
        }
    });
    $(document).on('mouseup', function (e) {
        var container = $(".search-menu");
        // if the target of the click isn't the container nor a descendant of the container
        if (!container.is(e.target) && container.has(e.target).length === 0 && container.hasClass("open")) {
            container.removeClass("open");
        }
    });
    Droptables_element.editToolTip.leanModal({
        top: 100, left: 50, background: '#ffffff', closeButton: '#cancelToolTipbtn', modalShow: function () {
            var $tooltip_content = $('#tooltip_content');
            $('#tooltip_content_ifr')[0].contentWindow.focus();
            if ($tooltip_content.length > 0 && typeof Joomla.editors.instances['tooltip_content'] !== "undefined") {
                Joomla.editors.instances['tooltip_content'].setValue($tooltip_content.val());
            }
        }
    });

    $("#droptable_editToolTip").find('.colose_popup').unbind('click').on('click', function () {
        $('#cancelToolTipbtn').trigger('click');
    });

    Droptables_element.saveToolTipbtn.click(function () {
       // var newTooltipContent = CKEDITOR.instances.tooltip_content.getData();
        var newTooltipContent =   Joomla.editors.instances['tooltip_content'].getValue();
        var $tooltip_content = $('#tooltip_content');
        $tooltip_content.val(newTooltipContent);
        $tooltip_content.trigger("change");
        //close leanModal
        $("#lean_overlay").fadeOut(200);

        $("#droptable_editToolTip").css({"display": "none"});
        $('#edit_toolTip').trigger('change');
    })

    $("#btnDroptablesDescription").leanModal({
        top: 100, left: 50, background: '#ffffff', closeButton: '#btnCancelCellHtml', modalShow: function () {
            $('#droptablesDescription_ifr')[0].contentWindow.focus();
        }
    });

    if (typeof Droptables.droptable_read_excel_message !== 'undefined') {
        bootbox.alert(
            Joomla.JText._('COM_DROPTABLES_IMPORT_FINISHED'
            , 'Import is finished!') + '<br/>' +
            Joomla.JText._('COM_DROPTABLES_ERROR_READER_EXCEL'
            , ' Note that the import tool wasn\'t able to read some cell data and therefore have removed some values. Cells concerned:') +
        Droptables.droptable_read_excel_message);
    }
}

export default {
    updatepreview
};