// import alternating from "./_alternating"
import DroptablePreview from "./_droptables";
import {initHandsontable} from "./_handsontable";
import alternating from "./_alternating";

var F_name = ["january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december"];
var M_name = ["jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sept", "oct", "nov", "dec"];
var l_name = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
var D_name = ["sun", "mon", "tue", "wed", "thu", "fri", "sat"];

//mer rows, columns style to cells style
function mergeCollsRowsstyleToCells() {
    var $ = window.jquery;
    var style = $.extend({}, window.Droptables.style);
    $.each(style.cols, function (col, cValue) {
        $.each(style.rows, function (row, rValue) {
            var styleCell = {};
            if (typeof (window.Droptables.style.cells[row + '!' + col]) === 'undefined') {
                window.Droptables.style.cells[row + '!' + col] = [row, col, {}];
            }
            if (typeof (style.rows[row]) !== 'undefined' && style.rows[row] !== null && Object.keys(style.rows[row][1]).length !== 0) {
                styleCell =  $.extend({}, styleCell, rValue[1]);
            }
            if (typeof (style.cols[col]) !== 'undefined' && style.cols[col] !== null && Object.keys(style.cols[col][1]).length !== 0) {
                styleCell =  $.extend({}, styleCell, cValue[1]);
            }
            window.Droptables.style.cells[row + '!' + col][2] = $.extend({}, styleCell, window.Droptables.style.cells[row + '!' + col][2]);
        });
    });
}

//create string_currency_symbols, replace_unit, text_replace_unit, date_format RegExp string
function createRegExpFormat(table_function_data, currency_symbol, date_formats) {
    if (currency_symbol !== false) {
        table_function_data.string_currency_symbols = currency_symbol.replace(/ /g, "");
        // create string reg currency symbols
        table_function_data.replace_unit = new RegExp('[' + table_function_data.string_currency_symbols.replace(/,/g, "|") + ']', "g");

        // create string reg have not currency symbols
        table_function_data.text_replace_unit = '[^a-zA-Z|' + table_function_data.string_currency_symbols.replace(/,/g, "|^") + ']';
        table_function_data.text_replace_unit = new RegExp(table_function_data.text_replace_unit, "g");
        table_function_data.text_replace_unit_function = new RegExp('[^ |' + table_function_data.string_currency_symbols.replace(/,/g, "|^") + ']', "g");
    }
    if (date_formats !== false) {
        table_function_data.date_format = date_formats.match(/[a-zA-Z|\\]+/g);
    }
    return table_function_data;
}

//create string_currency_symbols, replace_unit, text_replace_unit, date_format RegExp string
function createRegExpFormatForCell(currency_symbol, date_formats, cell_function_data) {
    if (currency_symbol !== false) {
        cell_function_data.string_currency_symbols = currency_symbol.replace(/ /g, "");
        // create string reg currency symbols
        cell_function_data.replace_unit = new RegExp('[' + cell_function_data.string_currency_symbols.replace(/,/g, "|") + ']', "g");

        // create string reg have not currency symbols
        cell_function_data.text_replace_unit = '[^a-zA-Z|' + cell_function_data.string_currency_symbols.replace(/,/g, "|^") + ']';
        cell_function_data.text_replace_unit = new RegExp(cell_function_data.text_replace_unit, "g");
        cell_function_data.text_replace_unit_function = new RegExp('[^ |' + cell_function_data.string_currency_symbols.replace(/,/g, "|^") + ']', "g");
    }
    if (date_formats !== false) {
        cell_function_data.date_format = date_formats.match(/[a-zA-Z|\\]+/g);
    }
    return cell_function_data;
}

function parseCss($, hasSaveData) {
    var parser = new (less.Parser);
    var content = '#mainTabContent .handsontable .ht_master .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_top .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_bottom .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_left .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_top_left_corner .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '.reset {background-color: rgb(238, 238, 238);border-bottom-color: rgb(204, 204, 204);border-bottom-style: solid;border-bottom-width: 1px;border-collapse: collapse;border-left-color: rgb(204, 204, 204);border-left-style: solid;border-left-width: 1px;border-right-color: rgb(204, 204, 204);border-right-style: solid;border-right-width: 1px;border-top-color: rgb(204, 204, 204);border-top-style: solid;border-top-width: 1px;box-sizing: border-box;color: rgb(34, 34, 34);display: table-cell;empty-cells: show;font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;font-size: 13px;font-weight: normal;line-height: 21px;outline-width: 0px;overflow-x: hidden;overflow-y: hidden;padding-bottom: 0px;padding-left: 4px;padding-right: 4px;padding-top: 0px;text-align: center;vertical-align: top;white-space: nowrap;position: relative;}';
    content += '#mainTabContent .handsontable .ht_master .wtHider .wtSpreader .htCore tbody tr th {.reset() !important;}';
    // content += '#mainTabContent .handsontable .ht_master .wtHider .wtSpreader .htCore tbody tr th {border: unset !important;}';

    parser.parse(content, function (err, tree) {
        if (err) {
            //Here we can throw the erro to the user
            return false;
        } else {
            Droptables.css = $('#jform_css').val();
            if ($('#headCss').length === 0) {
                $('head').append('<style id="headCss"></style>');
            }
            $('#headCss').text(tree.toCSS());
            if (hasSaveData) {
                saveChanges(true);
            }
            return true;
        }
    });
}

function setFormat_accounting() {
    var data = {};
    data.thousand_symbol = Droptables.style.table.thousand_symbol;
    data.symbol_position = Droptables.style.table.symbol_position;
    data.decimal_symbol = Droptables.style.table.decimal_symbol;
    data.decimal_count = Droptables.style.table.decimal_count;
    data.currency_symbol = Droptables.style.table.currency_symbol;

    accounting.settings = {
        currency: {
            symbol : data.currency_symbol,   // default currency symbol is '$'
            format: data.symbol_position == 1 ? "%v %s" : "%s %v", // controls output: %s = symbol, %v = value/number (can be object: see below)
            decimal : data.decimal_symbol,  // decimal point separator
            thousand: data.thousand_symbol,  // thousands separator
            precision : typeof data.decimal_count !== 'undefined' ? data.decimal_count : 0   // decimal places
        },
        number: {
            decimal : data.decimal_symbol,  // decimal point separator
            thousand: data.thousand_symbol,  // thousands separator
            precision : typeof data.decimal_count !== 'undefined' ? data.decimal_count : 0   // decimal places
        }
    };
}

function setFormat_accounting_for_cells(setFormat_accounting_for_cells_raw) {
    return {
        currency: {
            symbol : setFormat_accounting_for_cells_raw.currency_symbol,   // default currency symbol is '$'
            format: setFormat_accounting_for_cells_raw.symbol_position == 1 ? "%v%s" : "%s%v", // controls output: %s = symbol, %v = value/number (can be object: see below)
            decimal : setFormat_accounting_for_cells_raw.decimal_symbol,  // decimal point separator
            thousand: setFormat_accounting_for_cells_raw.thousand_symbol,  // thousands separator
            precision : typeof setFormat_accounting_for_cells_raw.decimal_count !== 'undefined' ? setFormat_accounting_for_cells_raw.decimal_count : 0   // decimal places
        },
        number: {
            decimal : setFormat_accounting_for_cells_raw.decimal_symbol,  // decimal point separator
            thousand: setFormat_accounting_for_cells_raw.thousand_symbol,  // thousands separator
            precision : typeof setFormat_accounting_for_cells_raw.decimal_count !== 'undefined' ? setFormat_accounting_for_cells_raw.decimal_count : 0   // decimal places
        }
    };
}

function calculateTableHeight(topElement) {
    var top, paddingBottom;

    if (jquery('#mybootstrap').hasClass('joomla4')) {
        top = topElement.outerHeight() + 20;
        paddingBottom = typeof Droptables.caninsert !== 'undefined' && Droptables.caninsert == 1 ? 55 : 10;
    } else {
        top = topElement.outerHeight() + 85;
        paddingBottom = typeof Droptables.caninsert !== 'undefined' && Droptables.caninsert == 1 ? -10 : 10;
    }

    if (jquery('body.com_droptables').find('header.header').length > 0) {
        top += jquery('body.com_droptables').find('header.header').outerHeight();
    }

    var windownHeight = jquery(window).height();
    var height = windownHeight - top - paddingBottom;
    return height;
}

// check for existence of nested object key
// example: var test = {level1:{level2:{level3:'level3'}} };
// checkObjPropertyNested(test, 'level1', 'level2', 'level3'); // true
function checkObjPropertyNested(obj /*, level1, level2, ... levelN*/) {
    var args = Array.prototype.slice.call(arguments, 1);
    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i])) {
            return false;
        }
        obj = obj[args[i]];
    }
    return true;
}

// check for existence of nested object key and check value not empty
// example: var test = {level1:{level2:{level3:'level3'}} };
// checkObjPropertyNestedNotEmpty(test, 'level1', 'level2', 'level3'); // true
function checkObjPropertyNestedNotEmpty(obj /*, level1, level2, ... levelN*/) {
    var args = Array.prototype.slice.call(arguments, 1);

    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i]) || !obj[args[i]]) {
            return false;
        }
        obj = obj[args[i]];
    }
    return true;
}

//Code from http://stackoverflow.com/questions/9905533/convert-excel-column-alphabet-e-g-aa-to-number-e-g-25
var convertAlpha = function (val) {
    var base = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', i, j, result = 0;

    for (i = 0, j = val.length - 1; i < val.length; i += 1, j -= 1) {
        result += Math.pow(base.length, j) * (base.indexOf(val[i]) + 1);
    }

    return result;
};


// Convert date in date_format to the format: m/d/Y /a/t g:i A
// example: number -> array(2016,03,26)
function convertDate(date_format, number, timezone) {
    var date_array = [];
    number = (!!number) ? number : [];
    if (date_format.length !== number.length) {
        return false;
    }
    if (typeof timezone === 'undefined') {
        timezone = true;
    }
    for (var n = 0; n < date_format.length; n++) {
        number[n] = (!!number[n]) ? number[n] : '';
        if (date_format[n] === 'd' || date_format[n] === 'j') {
            date_array[2] = (number[n] !== '') ? number[n] : '';
        } else if (date_format[n] === 'S' || date_format[n] === 'jS' || date_format[n] === 'dS') {
            date_array[2] = number[n].match(/[0-9]+/g);
        } else if (date_format[n] === 'm' || date_format[n] === 'n') {
            date_array[1] = number[n];
        } else if (date_format[n] === 'F') {
            date_array[1] = F_name.indexOf(number[n].toLowerCase()) + 1;
        } else if (date_format[n] === 'M') {
            date_array[1] = M_name.indexOf(number[n].toLowerCase()) + 1;
        } else if (date_format[n].toLowerCase() === 'y') {
            date_array[3] = number[n];
        } else if (date_format[n].toLowerCase() === 'g' || date_format[n].toLowerCase() === 'h') {
            date_array[4] = Number(number[n]);
        } else if (date_format[n].toLowerCase() === 'ga' || date_format[n].toLowerCase() === 'ha') {
            date_array[4] = number[n].match(/[0-9]+/g);
            date_array[4] = (number[n].toLowerCase().match(/[a-z]+/g) === 'am') ? date_array[4] : date_array[4] + 12;
        } else if (date_format[n].toLowerCase() === 'a') {
            date_array[7] = number[n];
        } else if (date_format[n].toLowerCase() === 'i' || date_format[n].toLowerCase() === 'ia') {
            date_array[5] = number[n].match(/[0-9]+/g);
        } else if (date_format[n].toLowerCase() === 's' || date_format[n].toLowerCase() === 'sa') {
            date_array[6] = number[n].match(/[0-9]+/g);
        } else if (date_format[n] === 'T') {
            date_array[8] = number[n];
        } else if (date_format[n] === 'r') {
            if (M_name.indexOf(number[2].toLowerCase()) + 1 > 0) {
                date_array[1] = M_name.indexOf(number[2].toLowerCase()) + 1;
            } else {
                date_array[1] = F_name.indexOf(number[2].toLowerCase()) + 1;
            }
            return date_array[1] + '/' + number[1] + '/' + number[3] + ' ' + number[4] + ':' + number[5] + ':' + number[6] + ' ' + number[7];
        }
    }
    date_array[4] = (!!date_array[4]) ? date_array[4] : 0;
    date_array[5] = (!!date_array[5]) ? date_array[5] : '00';
    date_array[6] = (!!date_array[6]) ? date_array[6] : '00';
    date_array[7] = (!!date_array[7]) ? ' ' + date_array[7] : '';
    date_array[8] = (!!date_array[8]) ? ' ' + date_array[8] : '';
    date_array[8] = (timezone === true) ? ' ' + date_array[8] : '';

    if (date_array[7] !== 'undefined' && date_array[7] !== '' && date_array[4] > 12) {
        date_array[4] = date_array[4] - 12;
    }
    if (date_array[1] === 0 || date_array[2] > 31 || date_array[1] > 12) {
        return false;
    }
    return date_array[1] + '/' + date_array[2] + '/' + date_array[3] + ' ' + date_array[4] + ':' + date_array[5] + ':' + date_array[6] + date_array[7] + date_array[8];
}


/**
 * convert cell data by column type
 *
 * @param position cell position
 * @param value    New value
 * @returns {string|boolean}
 */
function cell_type_to_column (position, value) {
    if ((Droptables.type !== 'mysql' && typeof Droptables.style.table.col_types[position[1]] !== 'undefined')
        || (typeof Droptables.query_option !== 'undefined' && typeof Droptables.query_option.column_options[position[1]] !== 'undefined')) {
        if (value === null) {
            value = '';
        }
        var type_column;
        if (Droptables.type === 'mysql' && typeof Droptables.query_option.column_options !== 'undefined' && typeof Droptables.query_option.column_options[position[1]] !== 'undefined') {
            type_column = Droptables.query_option.column_options[position[1]].Type;
        } else {
            type_column = Droptables.style.table.col_types[position[1]];
        }
        var data = validate_type_cell(type_column, value);
        return data;
    }
    return true;
}


function validate_type_cell (type_column, value) {
    var date_string;
    var length = value.length;
    switch (type_column.toUpperCase()) {
        case 'INT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -2147483648 && parseInt(value) > 2147483647) {
                return false;
            }
            break;
        case 'SMALLINT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -32768 && parseInt(value) > 32767) {
                return false;
            }
            break;
        case 'TINYINT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -128 && parseInt(value) > 127) {
                return false;
            }
            break;
        case 'MEDIUMINT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -8368608 && parseInt(value) > 8368607) {
                return false;
            }
            break;
        case 'bigint unsigned':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            break;
        case 'DECIMAL(16,4)':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9|.]+/g, '') !== '') {
                return false;
            }
            break;

        case 'DATE':
            if (value !== '') {
                date_string = convertDate(["Y", "m", "d"], value.match(/[a-zA-Z0-9|+|-|\\]+/g), true);
                if (date_string === false) {
                    return false;
                }
                if (date_string === '00-00-0000') {
                    return '0000-00-00';
                }
                var date_string1 = new Date(date_string);
                if (isNaN(date_string1.getTime())) {
                    return false;
                }
                return date_string1.getFullYear() + '-' + ((date_string1.getMonth() < 10) ? '0' + (date_string1.getMonth() + 1) : date_string1.getMonth() + 1) + '-' + date_string1.getDate();
            } else {
                return '0000-00-00';
            }
            break;
        case 'DATETIME':
            if (value !== '') {
                date_string = convertDate(["Y", "m", "d", "h", "i", "s"], value.match(/[a-zA-Z0-9|+|-|\\]+/g), true);
                if (date_string === false) {
                    return false;
                }
                if (date_string === '00/00/0000 0:00:00 ') {
                    return '0000-00-00 00:00:00';
                }
                date_string = new Date(date_string);
                if (isNaN(date_string.getTime())) {
                    return false;
                }
                return date_string.getFullYear() + '-' + ((date_string.getMonth() < 10) ? '0' + (date_string.getMonth() + 1) : date_string.getMonth() + 1) + '-' + date_string.getDate() + ' ' + date_string.getHours() + ':' + date_string.getMinutes() + ':' + date_string.getSeconds();
            } else {
                return '0000-00-00 00:00:00';
            }
            break;
        case 'TIME':
            if (value !== '') {
                date_string = convertDate(["H", "m", "S"], value.match(/[a-zA-Z0-9|+|-|\\]+/g), true);
                if (date_string === false) {
                    return false;
                }
                if (date_string === '00-00-00 ') {
                    return '00:00:00';
                }
                date_string = new Date(date_string);
                if (isNaN(date_string.getTime())) {
                    return false;
                }
                return date_string.getHours() + ':' + date_string.getMinutes() + ':' + date_string.getSeconds();
            } else {
                return '00:00:00';
            }
            break;
        case 'TIMESTAMP':
            if (value !== '') {
                if (isNaN(value) || parseInt(value) < 0) {
                    return false;
                }
                date_string = (new Date(value)).getTime() > 0;

                if (date_string === false) {
                    return false;
                }

                return value;
            }
            break;

        case 'VARCHAR':
            if (length > 255) {
                return false;
            }
            break;
        case 'TEXT':
            if (length > 65500) {
                return false;
            }
            break;
        case 'LONGTEXT':
            if (length > 4294967294) {
                return false;
            }
            break;
        case 'MEDIUMTEXT':
            if (length > 16777214) {
                return false;
            }
            break;
        case 'CHAR':
            if (length > 255) {
                return false;
            }
            break;
        case 'FLOAT':
            if (value === '') {
                value = '0';
            }
            if (isNaN(parseFloat(value))) {
                return false;
            }
            break;
        default:
            return value;
            break;
    }
    return value;
}

/**
 * change cells value when add function in toolbar
 *
 * @param selection
 * @param values
 * @param keyColum
 */
function change_value_cells(selection, values, keyColum) {
    table_function_data.data_argument = [];
    var i, j, jj, value;
    if (selection === null) {
        selection = table_function_data.selection;
    }

    for (jj = 0; jj < table_function_data.selectionSize; jj++) {
        for (i = selection[jj][0]; i <= selection[jj][2]; i++) {
            for (j = selection[jj][1]; j <= selection[jj][3]; j++) {
                if (Array.isArray(values)) {
                    value = values[i][keyColum.replace('%key', j)];
                    table_function_data.data_argument.push([i, j, value, 'droptables_change_value_after_set_columns_types']);
                } else {
                    value = values;
                    table_function_data.data_argument.push([i, j, value]);
                }
                Droptables.datas[i][j] = value;
            }
        }
    }

    if (table_function_data.changeTheme) {
        DroptablePreview.updatepreview(Droptables.id);
    }
    if (table_function_data.data_argument.length < 5) {//if cells number < 5 then setDataAtCell() is more performance
        window.jquery(window.Droptables_element.tableContainer).data('handsontable').setDataAtCell(table_function_data.data_argument, 'setDataAtCell');
    } else {
        window.jquery(window.Droptables_element.tableContainer).data('handsontable').loadData(Droptables.datas);
    }
}

//add, change style for column, rows, cells
function getFillArray(selection, Droptables, value) {
    var i, ij, ik, first_cell;
    if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
        for (i = 0; i < table_function_data.selectionSize; i++) {
            first_cell = false;
            if (selection[i][0] < 1) {
                first_cell = true;
            }
            for (ik = selection[i][1]; ik <= selection[i][3]; ik++) {
                Droptables.style.cols = fillArray(Droptables.style.cols, value, ik);
                if (first_cell) {
                    Droptables.style.cells = fillArray(Droptables.style.cells, value, 0, ik);
                }
            }
        }
    } else {
        for (i = 0; i < table_function_data.selectionSize; i++) {
            for (ij = selection[i][0]; ij <= selection[i][2]; ij++) {
                for (ik = selection[i][1]; ik <= selection[i][3]; ik++) {
                    Droptables.style.cells = fillArray(Droptables.style.cells, value, ij, ik);
                }
            }
        }
    }

    var action = Array.prototype.slice.call(arguments, 3);
    var save_data = false;
    if (action.length === 0) {
        action = 'style';
    } else {
        if (action.length > 1) {
            save_data = action[1];
        }
        if (action.length > 2) {
            action[2].call();
        }
        action = action[0];
    }

    if (saveData.length > 0) {
        var old_saveData = saveData[saveData.length - 1];
        var checkRangeStyleExists = false;
        if (action === old_saveData.action) {
            for (i = 0; i < table_function_data.selectionSize; i++) {
                if (old_saveData.selection[i][0] == selection[i][0] &&
                    old_saveData.selection[i][1] == selection[i][1] &&
                    old_saveData.selection[i][2] == selection[i][2] &&
                    old_saveData.selection[i][3] == selection[i][3]) {
                    checkRangeStyleExists = true;
                }
            }
        }

        if (checkRangeStyleExists) {
            old_saveData.style = window.jquery.extend(old_saveData.style, value);
        } else {
            if (droptablesCheckSize(value) > 0) {
                saveData.push({action: action, selection: selection, style: value});
                if (save_data) {
                    saveChanges(true);
                }
            }
        }
    } else {
        if (droptablesCheckSize(value) > 0) {
            saveData.push({action: action, selection: selection, style: value});
            if (save_data) {
                saveChanges(true);
            }
        }
    }
}

function droptablesCheckSize (obj) {
    var size = 0,
        key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

//update new value for array
function fillArray(array, val, val1, val2) {
    if (typeof (val2) === 'undefined') {
        if (typeof (val1) !== 'undefined') {
            if (typeof (array[val1]) !== 'undefined') {
                array[val1][1] = window.jquery.extend(array[val1][1], val);
            } else {
                array[val1] = [val1, {}];
                array[val1][1] = val;
            }
        } else {
            array = window.jquery.extend(array, val);
        }
    } else {
        if (typeof (array[val1 + "!" + val2]) !== 'undefined') {
            array[val1 + "!" + val2][2] = window.jquery.extend(array[val1 + "!" + val2][2], val);
        } else {
            array[val1 + "!" + val2] = [val1, val2, {}];
            array[val1 + "!" + val2][2] = val;
        }
    }
    return array;
}

// set value for an html input element from cellStyle object
function updateParamFromStyleObject(styleObj, prop, that, defaultValue, callback) {
    if (checkObjPropertyNested(styleObj, prop)) {
        that.val(styleObj[prop] === false ? defaultValue : styleObj[prop]);
    } else {
        that.val(defaultValue);
    }
    if (typeof callback !== 'undefined') {
        callback.call(that);
    }
}

// set value for an html switch-button element from Style object
function updateSwitchButtonFromStyleObject(styleObj, prop, that, defaultValue, callback) {
    if (checkObjPropertyNested(styleObj, prop)) {
        defaultValue = styleObj[prop];
    }
    that.val(defaultValue == 1 ? 'yes' : 'no').prop("checked", defaultValue == 1);

    if (typeof callback !== 'undefined') {
        callback.call(that);
    }
}

// set value for an html input element from cellStyle object
function updateParamFromStyleObjectSelectBox(styleObj, prop, that, defaultValue, callback, multiple_select) {
    if (styleObj !== '') {
        if (checkObjPropertyNested(styleObj, prop)) {
            defaultValue = styleObj[prop];
        }
    }
    defaultValue += '';
    that.data('value', defaultValue);
    var text = '';
    if (multiple_select) {
        jquery.each(defaultValue.split('|'), function (i, v) {
            if (text !== '') {
                text += ',' + that.find('li[data-value="' + v + '"]').text();
            } else {
                text += that.find('li[data-value="' + v + '"]').text();
            }
        })
    } else if (that.find('li[data-value="' + defaultValue + '"]').length > 0) {
        text += that.find('li[data-value="' + defaultValue + '"]').text();
    }

    that.prev('.droptable_select_box_before').text(text === '' ? defaultValue : text).data('value', defaultValue);
    if (typeof callback !== 'undefined' && callback !== null) {
        callback.call(that);
    }
}

//get size of cell selected when open change height, row popup
function getSizeCells($, Droptables, cells) {
    if (Droptables.type === 'mysql') {
        updateParamFromStyleObject(Droptables.style.rows[0][1], 'height', $('#cell_row_height'), '30');
    } else {
        if (checkObjPropertyNested(Droptables.style.rows, cells[0], 1, 'height')) {
            $('#cell_row_height').val(Droptables.style.rows[cells[0]][1].height);
        }
    }

    if (checkObjPropertyNested(Droptables.style.cols, cells[1], 1, 'width')) {
        $('#cell_col_width').val(Droptables.style.cols[cells[1]][1].width);
    }
    if (checkObjPropertyNested(Droptables.style.table, 'allRowHeight')) {
        $('#all_cell_row_height').val(Droptables.style.table.allRowHeight);
    }
}

//convert droptables's dateformat to momentjs's dateformat
function momentjsFormat(value) {
    value = value.replaceAll("M", "MMM");
    value = value.replaceAll("n", "M");
    value = value.replaceAll("F", "MMMM");
    value = value.replaceAll("m", "MM");

    value = value.replaceAll("D", "ddd");
    let date = new RegExp('(\\b)d(?!d)', "g");
    value = value.replaceAll(date, "DD");
    value = value.replaceAll("j", "D");
    value = value.replaceAll("z", "DDDD");
    value = value.replaceAll("l", "dddd");
    value = value.replaceAll("S", "Do");
    value = value.replaceAll("N", "e");

    value = value.replaceAll("w", "do");
    value = value.replaceAll("W", "w");

    value = value.replaceAll("Y", "YYYY");
    value = value.replaceAll("o", "Y");
    value = value.replaceAll("y", "YY");


    value = value.replaceAll("h", "hh");
    value = value.replaceAll("g", "h");
    value = value.replaceAll("H", "HH");
    value = value.replaceAll("G", "H");

    value = value.replaceAll("i", "mm");
    value = value.replaceAll("s", "ss");
    value = value.replaceAll("T", "z");
    return value;
}

/*print getSelect cell to element*/
function getSelectedVal(dataSelect, selectRange) {
    var valueRange = '';

    if (dataSelect[1] > 25) {
        valueRange += String.fromCharCode(97) + String.fromCharCode(97 + dataSelect[1] - 26);
    } else {
        if (dataSelect[1] !== false) {
            valueRange += String.fromCharCode(97 + dataSelect[1]);
        }
    }
    if (dataSelect[0] !== false) {
        valueRange += dataSelect[0] + 1;
    }

    valueRange += ':';


    if (dataSelect[3] > 25) {
        valueRange += String.fromCharCode(97) + String.fromCharCode(97 + dataSelect[3] - 26);
    } else {
        if (dataSelect[3] !== false) {
            valueRange += String.fromCharCode(97 + dataSelect[3]);
        }
    }
    if (dataSelect[2] !== false) {
        valueRange += dataSelect[2] + 1;
    }

    if (typeof selectRange !== 'undefined') {
        selectRange.val(valueRange);
    } else {
        return valueRange;
    }
}

function status_noti (status, text) {
    var $ = window.jquery;
    var status_e = $('#savedInfoTable');
    if (status === 1) {
        status_e = $('#savedInfoTable');
    } else {
        status_e = $('#saveErrorTable');
    }
    status_e.html(text);
    var position = window.jquery('#setting-cells').offset();
    setTimeout(function () {
        status_e.animate({'opacity': '0.8', 'top': position.top - 35}, 500).delay(2000).animate({'opacity': '0', 'top': '-45px'}, 1000);
    }, 1000);
}

function setText ($name_edit, press_enter_selector, obj) {
    unbindall();
    /*select rename table*/
    var oldTitle = $name_edit.text();
    var droptable_name_edit = document.querySelector('.rename.droptable_name_edit');
    $name_edit.attr('contentEditable', true).focus();

    $name_edit.not('.editable').bind('click.mm', hstop); //let's click on the editable object
    jquery(press_enter_selector).bind('keydown.mm', enterKey); //let's press enter to validate new title'
    jquery('*').not('.droptable_name_edit').bind('click.mm', houtside);

    // $name_edit.addClass('editable');
    if (obj.selected) {
        $name_edit.trigger('click.mm');
    }

    function unbindall(reselectCell) {
        $name_edit.not('.editable').unbind('click.mm', hstop);  //let's click on the editable object
        jquery(press_enter_selector).unbind('keydown.mm', enterKey); //let's press enter to validate new title'
        jquery('*').not('.droptable_name_edit').unbind('click.mm', houtside);
        $name_edit.attr('contentEditable', false);

        if (reselectCell && typeof table_function_data.selection[0][1] !== 'undefined') {//reselect cell after enter/esc name table
            var selection = window.jquery(Droptables_element.tableContainer).handsontable('getSelected');
            window.jquery(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][0], selection[0][1]);
        }
    }

    //Validation
    function hstop(e) {
        event.stopPropagation();
        $name_edit.addClass('editable');
        if (droptable_name_edit !== null) {
            droptable_name_edit.focus();
        }
        return false;
    }

    function enterKey(e) {
        e.stopImmediatePropagation();
        if (e.which == 13) {
            e.preventDefault();
            $name_edit.removeClass('editable');
            updateTitle($name_edit.text(), jquery);
            unbindall(true);
        }
        if (e.which == 27) {
            e.preventDefault();
            $name_edit.text(oldTitle);
            $name_edit.removeClass('editable');
            unbindall(true);
        }
        $name_edit.removeClass('rename');
    }

    function houtside(e) {
        if ($name_edit.hasClass('editable') && !$name_edit.hasClass('rename')) {
            $name_edit.removeClass('editable');
            updateTitle($name_edit.text(), jquery);
            unbindall(true);
            $name_edit.removeClass('rename');
        }
        return false;
    }

    function updateTitle(title, $) {
        if (!table_function_data.allowed_edit) {
            return false;
        }

        if (oldTitle === title) {
            return false;
        }

        if (title.trim() !== '' && typeof obj.url !== 'undefined') {
            obj.url += title;
            $.ajax({
                url: obj.url,
                type: "POST",
                data: {},
                dataType: "json",
                beforeSend: function () {
                    Droptables_element.settingTable.find('.droptable_saving').removeClass('droptable_hiden');
                },
                success: function (datas) {
                    if (datas.response === true) {
                        $name_edit.text(title);
                        if ($('.pwrapper').hasClass('droptable_hiden')) {
                            $('#list_chart').find('.chart-menu.active a').text(title);
                        } else {
                            $('#list_chart').find('.current_table a').text(title);
                        }
                        if (typeof obj.action !== 'undefined') {
                            obj.action(title);
                        }
                        Droptables_element.settingTable.find('.droptable_saving').addClass('droptable_hiden');

                        setTimeout(function () {
                            localStorage.setItem('droptables_change_table_name', JSON.stringify({'id': Droptables.id,'title': title, 'modified_time': datas.datas.modified_time}));

                            Droptables_element.settingTable.find('.droptable_saved').removeClass('droptable_hiden');
                            Droptables_element.settingTable.find('.droptable_saved').animate({'opacity': '1'}, 500).delay(500).animate({
                                'opacity': '0'
                            }, 500);
                        }, 500);
                    } else {
                        $name_edit.text(oldTitle);
                        bootbox.alert(datas.response);
                    }
                },
                error: function (jqxhr, textStatus, error) {
                    $name_edit.text(oldTitle);
                    bootbox.alert(textStatus);
                }
            });
        } else {
            $name_edit.text(oldTitle);
            return false;
        }
        $name_edit.css('white-space', 'normal');
        setTimeout(function () {
            $name_edit.css('white-space', '');
        }, 200);
    }
};

function pullDims(Droptables, $) {
    var args = Array.prototype.slice.call(arguments, 1);
    var cols = [];
    var rows = [];
    var row, lengthRows, lengthCols, col;

    // get count of Droptables.style.rows
    if (typeof Droptables.style.rows.length !== 'undefined') {
        lengthRows = Droptables.style.rows.length;
    } else {
        lengthRows = Object.keys(Droptables.style.rows).length;
    }

    for (row = 0; row < lengthRows; row++) {
        if (checkObjPropertyNested(Droptables.style.rows[row], 1, 'height')) {
            rows[row] = Droptables.style.rows[row][1].height;
        } else if (Droptables.type === 'mysql' && typeof Droptables.style.table.allRowHeight !== 'undefined' && Droptables.style.table.allRowHeight !== '') {
            rows[row] = Droptables.style.table.allRowHeight;
        } else {
            rows[row] = null;
        }
    }

    // get count of Droptables.style.cols
    if (typeof Droptables.style.cols.length !== 'undefined') {
        lengthCols = Droptables.style.cols.length;
    } else {
        lengthCols = Object.keys(Droptables.style.cols).length;
    }

    for (col = 0; col < lengthCols; col++) {
        if (checkObjPropertyNested(Droptables.style.cols[col], 1, 'width')) {
            cols[col] = Droptables.style.cols[col][1].width;
        } else {
            cols[col] = null;
        }
    }
    Droptables.updateSettings.manualColumnResize = $.extend([], cols);
    Droptables.updateSettings.rowHeights = $.extend([], rows);

    if (typeof args[1] === 'undefined' || args[1] === true) {
        delete Droptables.updateSettings.manualColumnResize;
        delete Droptables.updateSettings.manualRowResize;
        Droptables_element.tableContainer.handsontable('updateSettings', {'manualColumnResize': cols});
        Droptables_element.tableContainer.handsontable('updateSettings', {'manualRowResize': rows});
        /*different from wptm, haven't found a reason to use manualRowResize*/
        // Droptables_element.tableContainer.('updateSettings', {'manualRowResize': rows});
    }
}

/*time out auto save*/
var autosaveNotification;
var getSaveAjax;

function cleanHandsontable () {
    Droptables_element.primary_toolbars.find('#undo_cell').removeClass('active').addClass('no_active');
    Droptables_element.primary_toolbars.find('#redo_cell').removeClass('active').addClass('no_active');
    setTimeout(function () {
        jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.clear();
    }, 500);
}


function getLinkSync (link, type, warningDisplay) {
    var data = {};
    switch (type) {
        case 'excel':
            if (link.indexOf("docs.google.com/spreadsheet") !== -1 && warningDisplay) {
                bootbox.alert(Joomla.JText._('COM_DROPTABLES_TABLES_ERROR_IMPORT', 'Your path is incorrect, please enter the link again, thanks!'));
                Droptables.style.table.excel_url = '';
                return false;
            }
            data.auto_sync = Droptables.style.table.excel_auto_sync != '1' ? 0 : 1;
            data.spreadsheet_style = Droptables.style.table.excel_spreadsheet_style != '1' ? 0 : 1;
            data.url = encodeURI(link);
            break;
        case 'spreadsheet':
            var end_link = link.split('?');
            var end_link0 = end_link[0].slice(-7);
            if (link.indexOf("docs.google.com/spreadsheet") === -1 && end_link0.match(/html|csv|pdf|xlsx/gi) === null && (typeof end_link[1] !== "undefined" && end_link[1].match(/sharing|html|csv|pdf|xlsx/gi) === null) && warningDisplay) {
                bootbox.alert(Joomla.JText._('COM_DROPTABLES_TABLES_ERROR_LINK_GG', 'Please double check the Google Sheet access configuration, cannot get the data.'));
                Droptables.style.table.spreadsheet_url = '';
                return false;
            }
            data.auto_sync = Droptables.style.table.auto_sync != '1' ? 0 : 1;
            data.spreadsheet_style = Droptables.style.table.spreadsheet_style != '1' ? 0 : 1;
            data.url = encodeURI(link);
            break;
    }

    return data;
}


function saveChanges(autosave, ajaxCallback) {
    var $ = window.jquery;
    if (!table_function_data.allowed_edit) {
        return false;
    }

    Droptables.saveDataDbTable = [];

    //check save calculate date
    if (window.table_function_data.check_value_data === false) {
        setTimeout(function () {
            $('#saveErrorTable').animate({'top': '+=75px', 'opacity': '1'}, 500).delay(2000).animate({
                'top': '-=75px',
                'opacity': '0'
            }, 1000);
        }, 1000);
        window.table_function_data.check_value_data = true;
        return;
    }

    if ((typeof autosave == 'undefined' && !enable_autosave) || autosave === false) {
        checkTimeOut = false;
        return;
    }
    if (!checkTimeOut) {
        clearTimeout(getSaveAjax);
    }

    checkTimeOut = false;

    var delay_time = enable_autosave ? 5000 : 0;

    if (autosave === true) {
        delay_time = 100;
    }

    getSaveAjax = setTimeout(function () {
        /*check have the change Alternate*/
        // if (droptablesCheckSize((window.table_function_data.checkChangeAlternate) > 0) {
        //     window.Droptables.style.cells = $.extend({}, alternating.reAlternateColor());
        // }


        //fix style.cols length
        var cols_length = droptablesCheckSize(window.Droptables.style.cols)
        if (cols_length > window.Droptables.max_Col) {
            var newCols = {}
            for (var ii = 0; ii < window.Droptables.max_Col; ii++) {
                newCols[ii] = window.Droptables.style.cols[ii];

                if (window.Droptables.max_Col === ii + 1) {
                    window.Droptables.style.cols = $.extend({}, newCols);
                }
            }
        }

        var save_data;

        if (window.Droptables.style.table.mergeSetting.length > 0) {//update header option by merger cells
            var i;
            var maxHeader = window.Droptables.headerOption;
            for (i = 0; i < window.Droptables.style.table.mergeSetting.length; i++) {
                var mergeSetting = window.Droptables.style.table.mergeSetting[i];
                maxHeader = (mergeSetting.row < maxHeader && mergeSetting.row + mergeSetting.rowspan > maxHeader) ? mergeSetting.row + mergeSetting.rowspan : maxHeader;
            }

            if (maxHeader > window.Droptables.headerOption) {
                saveData.push({
                    action: 'set_header_option',
                    value: maxHeader
                });
                window.Droptables.headerOption = maxHeader;

                if (Droptables.style.table.freeze_row > 0) {
                    $(Droptables_element.tableContainer).handsontable('updateSettings', {fixedRowsTop: maxHeader});
                }
            }
        }
        if (typeof table_function_data.colsSetType !== 'undefined') {
            saveData.push({
                action: 'set_columns_types',
                value: table_function_data.colsSetType
            });
            delete table_function_data.colsSetType;
        }

        if (table_function_data.save_table_params.length > 0) {
            save_data = JSON.stringify(table_function_data.save_table_params);
        } else {
            if (typeof table_function_data.create_col_after_paste !== 'undefined' && table_function_data.create_col_after_paste.length > 0) {
                saveData = table_function_data.create_col_after_paste.concat(saveData)
                table_function_data.create_col_after_paste = []
            }
            save_data = JSON.stringify(saveData)
        }

        var params = !(window.Droptables.type !== 'html') ? $.extend(window.Droptables.style.table, {
            "mergeSetting": reConvertMergeCell(),
            "hyperlink": JSON.stringify(window.Droptables.hyperlink),
            "headerOption": window.Droptables.headerOption
        }) : $.extend(window.Droptables.style.table, {"mergeSetting": reConvertMergeCell(), "headerOption": 1});

        if (typeof params.cell_types !== 'undefined') {
            params = $.extend({}, params, {
                "cell_types": JSON.stringify(params.cell_types)
            });
        }
        if (typeof params.col_types !== 'undefined') {
            params = $.extend({}, params, {
                "col_types": JSON.stringify(params.col_types)
            });
        }
        if (typeof params.mergeSetting !== 'undefined') {
            params = $.extend({}, params, {
                "mergeSetting": JSON.stringify(params.mergeSetting)
            });
        }
        if (typeof params.alternateColorValue !== 'undefined') {
            params = $.extend({}, params, {
                "alternateColorValue": JSON.stringify(params.alternateColorValue)
            });
        }

        var jsonVar = {
            jform: {
                datas: save_data,
                style: JSON.stringify({'cols': window.Droptables.style.cols, 'rows': window.Droptables.style.rows}),
                css: window.Droptables.css,
                header_data: Droptables.style.header_data,
                params: params,
                count: {'countRows': $(window.Droptables_element.tableContainer).handsontable('countRows'), 'countCols': $(window.Droptables_element.tableContainer).handsontable('countCols')}
            },
            id: window.Droptables.id
        };

        if (typeof window.Droptables.syn_hash !== 'undefined' && window.Droptables.syn_hash !== '') {
            jsonVar.jform.syn_hash = window.Droptables.syn_hash;
        }

        window.Droptables.style = cleanStyle(window.Droptables.style, $(window.Droptables_element.tableContainer).handsontable('countRows'), $(window.Droptables_element.tableContainer).handsontable('countCols'));
        window.table_function_data.old_slection = window.table_function_data.selection;

        $.ajax({
            url: Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.save' + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
            type: "POST",
            data: jsonVar,
            dataType: "json",
            beforeSend: function () {
                Droptables_element.settingTable.find('.droptable_saving').removeClass('droptable_hiden');
                Droptables_element.settingTable.find('.saveErrorTable').addClass('droptable_hiden');
                window.table_function_data.firstRender = false;
            },
            success: function (datas) {
                if (datas.response === true) {
                    Droptables_element.settingTable.find('.saveErrorTable').addClass('droptable_hiden');
                    Droptables_element.settingTable.find('.droptable_saving').addClass('droptable_hiden');
                    Droptables_element.settingTable.find('.droptable_saved').removeClass('droptable_hiden');
                    Droptables_element.settingTable.find('.droptable_saved').animate({'opacity': '1'}, 500).delay(500).animate({
                        'opacity': '0'
                    }, 500);

                    if (datas.datas === 'reload') {
                        location.reload();
                    }

                    //empty data in saveData
                    if (table_function_data.save_table_params.length > 0) {
                        table_function_data.save_table_params = [];
                    } else {
                        saveData = [];
                    }
                    update_after_save(datas.datas);
                    if (typeof ajaxCallback !== 'undefined' && ajaxCallback === 'render') {
                        setTimeout(function () {
                            $(window.Droptables_element.tableContainer).handsontable('render');
                        }, 500);
                    }

                    setTimeout(function () {
                        Droptables_element.settingTable.find('.droptable_saved').addClass('droptable_hiden');
                    }, 1500);
                } else {
                    bootbox.alert(datas.response);
                    Droptables_element.settingTable.find('.saveErrorTable').removeClass('droptable_hiden');
                    setTimeout(function () {
                        Droptables_element.settingTable.find('.saveErrorTable').addClass('droptable_hiden');
                    }, 1000);
                }
                window.table_function_data.firstRender = true;
            },
            error: function (jqxhr, textStatus, error) {
                bootbox.alert(textStatus);
            }
        });

        checkTimeOut = true;
        Droptables.style.table.mergeSetting = convertMergeCell();
    }, delay_time);
}

function updateDataAndParamsTable() {
    var url = Droptables.ajaxurl + "index.php?option=com_droptables&view=table&format=json&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert);
    var $ = jquery;
    $.ajax({
        url: url,
        type: "POST",
        data: {},
        dataType: "json",
    }).done(function (data) {
        if (data.datas === '' || data.datas === false) {
            delete Droptables.datas;
            Droptables.datas = [
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""]
            ];
        } else {
            try {
                if (typeof data.data === 'string') {
                    data.data = JSON.stringify(data.data);
                    data.data = JSON.parse(data.data);
                }
                Droptables.datas = data.data;
            } catch (err) {
                Droptables.datas = [
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""]
                ];
            }
        }
        // reConvertMergeCell()
        Droptables.style = data.style;

        if (data.params === "" || data.params === null || data.params.length == 0) {
            Droptables.style.table.mergeSetting = [];
            Droptables.style.table.headerOption = 1;
        } else {
            if (typeof Droptables.style.table.lock_ranger_cells !== 'undefined' && Droptables.style.table.lock_ranger_cells.length > 0) {
                create_ranger_cells_lock(Droptables, table_function_data, null);
            }
            if (typeof (data.params) == 'string') {
                data.params = $.parseJSON(data.params);
            }

            if (typeof data.params.headerOption !== 'undefined') {
                Droptables.style.table.headerOption = parseInt(data.params.headerOption);
            } else {
                Droptables.style.table.headerOption = 1;
            }
            if (Droptables.style.table.headerOption > 0
                && (typeof Droptables.style.header_data === 'undefined'
                    || Droptables.style.header_data.length < Droptables.style.table.headerOption)
            ) {
                Droptables.style.header_data = [];
                for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                    Droptables.style.header_data[j] = Droptables.datas[j];
                }
            }

            Droptables.style.table.mergeSetting = convertMergeCell();
            window.jquery(window.Droptables_element.tableContainer).data('handsontable').loadData(Droptables.datas);
        }
        Droptables_element.mainTabContent.removeClass('loading_ajax');
    })
    return false;
}

function update_after_save (datas) {
    if (typeof datas.type !== 'undefined') {
        jquery.each(datas.type, function (i, v) {
            switch (i) {
                case "reload_table":
                    updateDataAndParamsTable();
                    break;
                case "set_columns_types":
                    var selected = [];

                    jquery.each(window.table_function_data.old_slection, function (i, v) {
                        if (typeof Droptables.style.table.headerOption !== 'undefined') {
                            if (v[0] < parseInt(Droptables.style.table.headerOption)) {
                                v[0] = parseInt(Droptables.style.table.headerOption);
                            }
                        }
                        selected[i] = v;
                    });
                    change_value_cells(selected, v, 'col%key');
                    break;
                case "update_cells_type":
                    var value = jquery.parseJSON(v);

                    Droptables.style.table.cell_types = jquery.extend([], value);

                    break;
                case "update_params":
                    var params = jquery.parseJSON(v);
                    if (typeof params.style.table.headerOption !== 'undefined') {
                        Droptables.style.table.headerOption = parseInt(params.style.table.headerOption);
                    } else {
                        Droptables.style.table.headerOption = 1;
                    }
                    try {
                        Droptables.style.table.mergeSetting = jquery.parseJSON(params.mergeSetting);
                        if (Droptables.style.table.mergeSetting == null) {
                            Droptables.style.table.mergeSetting = [];
                        }
                    } catch (e) {
                        Droptables.style.table.mergeSetting = [];
                    }

                    //not update header_data, it was updated
                    if (typeof params.header_data !== 'undefined') {
                        delete params.header_data;
                    }

                    window.Droptables.style.table = jquery.extend({}, params);
                    break;
            }
        });
    }
    if (typeof table_function_data.fetch_data !== 'undefined') {
        fetchSpreadsheet(table_function_data.fetch_data);
    }
}

function loading(e) {
    e.addClass('dploadingcontainer');
    e.append('<div class="dploading"></div>');
}
function rloading(e) {
    e.removeClass('dploadingcontainer');
    e.find('div.dploading').remove();
}

function deleteRowDbTable(table, field, id_row) {
    var url = Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.deleteRowDbTable';
    Droptables_element.mainTabContent.addClass('loading_ajax');

    jquery.ajax({
        url: url,
        data: {
            id_table: Droptables.id,
            value: id_row,
            field: field,
            table: table
        },
        type: 'POST',
        success: function (datas) {
            datas = JSON.parse(datas);
            if (datas.response === true) {
                updateDataAndParamsTable();
            } else {
                bootbox.alert(datas.response);
            }
        },
        error: function (jqxhr, textStatus, error) {
            bootbox.alert(textStatus);
        }
    })
}

function createRowDbTable (dbtable, list_value) {
    var url = Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.createRowDbTable';
    Droptables_element.mainTabContent.addClass('loading_ajax');
    jquery.ajax({
        url: url,
        data: {
            id: Droptables.id,
            data: list_value,
            dbtable: dbtable
        },
        type: 'POST',
        success: function (datas) {
            datas = JSON.parse(datas);
            if (datas.response === true) {
                updateDataAndParamsTable();
            } else {
                bootbox.alert(datas.response);
            }
        },
        error: function (jqxhr, textStatus, error) {
            bootbox.alert(textStatus);
        }
    })
}

function fetchSpreadsheet(obj) {
    loading(Droptables_element.wpreview);

    var auto_sync, spreadsheet_style, url;
    var $close_popup = Droptables_element.droptable_popup.find('.colose_popup');
    var loader = Droptables_element.droptable_popup.find('.lds-ring');
    var popup_notification = Droptables_element.droptable_popup.find('.popup_notification');
    var data;

    if (obj.type === 'spreadsheet') {
        data = getLinkSync(Droptables.style.table.spreadsheet_url, 'spreadsheet', true);
        if (!data) {
            return false;
        }
    } else if (obj.type === 'excel') {
        data = getLinkSync(Droptables.style.table.excel_url, 'excel', true);
        if (!data) {
            return false;
        }
    } else {
        return false;
    }

    var jsonVar = {
        spreadsheet_url: data.url,
        id: Droptables.id,
        sync: data.auto_sync,
        syncType: obj.type,
        style: data.spreadsheet_style
    };
    delete table_function_data.fetch_data;

    jquery.ajax({
        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=excel.fetchSpreadsheet&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
        type: "POST",
        data: jsonVar,
        beforeSend: function() {
            loader.removeClass('droptable_hiden');
            popup_notification.addClass('droptable_hiden');
        },
        success: function (datas) {
            loader.addClass('droptable_hiden');
            var result = jQuery.parseJSON(datas);
            if (result.response === true) {
                if (obj.type === 'spreadsheet') {
                    // table_function_data.auto_sync = result.datas.sync;
                    table_function_data.spreadsheet_style = result.datas.style;
                    table_function_data.spreadsheet_url = Droptables.style.table.spreadsheet_url;
                } else if(obj.type === 'excel') {
                    if (typeof result.datas.style !== 'undefined') {
                        // table_function_data.excel_auto_sync = result.datas.sync;
                        table_function_data.excel_spreadsheet_style = result.datas.style;
                        table_function_data.excel_url = Droptables.style.table.excel_url;
                    }
                }
                popup_notification.html('<span class="noti_success">'+Joomla.JText._('COM_DROPTABLES_ERROR_FETCH_EXCEL', 'Data has been fetched')+'</span>');
                if (typeof result.datas.error !== 'undefined' && result.datas.error !== '') {
                    popup_notification.html('<span class="noti_false">'+result.datas.error+'</span>');
                    popup_notification.removeClass('droptable_hiden');
                } else {
                    popup_notification.removeClass('droptable_hiden');
                    $close_popup.trigger('click');
                }
                location.reload();
            } else {
                popup_notification.html('<span class="noti_false" style="font-size: 14px; color: red">'+result.response+'</span>');
                popup_notification.removeClass('droptable_hiden');
                setTimeout(function () {
                    location.reload();
                }, 5000);
            }
        },
        error: function (jqxhr, textStatus, error) {
            popup_notification.html('<span class="noti_false">'+Joomla.JText._('COM_DROPTABLES_ERROR_FETCH_EXCEL', 'Data has been fetched')+'</span>');
            popup_notification.removeClass('droptable_hiden');
            rloading(Droptables_element.wpreview);
        }
    });
}

function convertMergeCell() {//convert to value in js
    var mergeCell = [];
    let mergeSetting = typeof Droptables.style.table.mergeSetting === 'string' ? JSON.parse(Droptables.style.table.mergeSetting) : Droptables.style.table.mergeSetting;
    if (typeof mergeSetting !== 'undefined' && mergeSetting.length > 0) {
        for (var i = 0; i < mergeSetting.length; i++) {
            mergeCell.push({'col': parseInt(mergeSetting[i][2]),
                'colspan': parseInt(mergeSetting[i][3]),
                'row': parseInt(mergeSetting[i][0]),
                'rowspan': parseInt(mergeSetting[i][1])
            });
        }
    }
    return mergeCell;
}

function reConvertMergeCell() {//convert to value in db
    var mergeCell = [];
    if (typeof Droptables.style.table.mergeSetting !== 'undefined' && Droptables.style.table.mergeSetting.length > 0) {
        for (var i = 0; i < Droptables.style.table.mergeSetting.length; i++) {
            mergeCell.push([Droptables.style.table.mergeSetting[i].row,
                Droptables.style.table.mergeSetting[i].rowspan,
                Droptables.style.table.mergeSetting[i].col,
                Droptables.style.table.mergeSetting[i].colspan
            ]);
        }
    }
    return mergeCell;
}

/*render data table, cells, rows, cols*/
function cleanStyle(style, nbRows, nbCols) {
    for (var col in style.cols) {
        if (!style.cols[col] || style.cols[col][0] >= nbCols) {
            delete style.cols[col];
        }
    }
    for (var row in style.rows) {
        if (!style.rows[row] || style.rows[row][0] >= nbRows) {
            delete style.rows[row];
        }
    }
    for (var cell in style.cells) {
        if (style.cells[cell][0] >= nbRows || style.cells[cell][1] >= nbCols) {
            delete style.cells[cell];
        }
    }
    var propertiesPos, cells;
    for (var obj in style) {
        if (obj == 'table') {
            continue;
        }
        for (cells in style[obj]) {
            if (!(typeof style[obj][cells] === 'undefined' || style[obj][cells] === null)) {
                propertiesPos = style[obj][cells].length - 1;
                for (var property in style[obj][cells][propertiesPos]) {
                    if (style[obj][cells][propertiesPos][property] === null) {
                        delete style[obj][cells][propertiesPos][property];
                    }
                }
            } else {
                delete style[obj][cells];
            }
        }
    }
    return style;
}

//add row height, col width for Droptables.style
function pushDims($, Droptables) {
    //get value height rows
    var rows = $(window.Droptables_element.tableContainer).handsontable('countRows');
    var i = 0;
    var value = 0;
    for (i = 0; i < rows; i++) {
        value = $(window.Droptables_element.tableContainer).handsontable('getRowHeight', i);
        if (Droptables.type === 'html') {
            if (!value || value === 0) {
                if (typeof (Droptables.style.rows[i]) !== 'undefined' && typeof (Droptables.style.rows[i][1].height) !== 'undefined') {
                    value = parseInt(Droptables.style.rows[i][1].height);
                }
                if (value === null) {
                    value = 22;
                }
            }
        } else { //type mysql
            if (checkObjPropertyNestedNotEmpty(Droptables.style.rows[i], 1, 'height')) { //Row height is set
                value = parseInt(Droptables.style.rows[i][1].height);
            } else {
                value = null; //if aviation height is set then height === null
            }
        }

        Droptables.style.rows = fillArray(Droptables.style.rows, {height: parseInt(value)}, i);
        value = 0;
    }
    //get value width columns
    var cols = $(window.Droptables_element.tableContainer).handsontable('countCols');
    Droptables.max_Col = cols;
    Droptables.max_row = rows;

    Droptables.style.table.width = 0;
    var valueCols = 0;
    for (i = 0; i < cols; i++) {
        valueCols = $(window.Droptables_element.tableContainer).handsontable('getColWidth', i);
        if (!valueCols || valueCols === 0) {
            if (typeof (Droptables.style.cols[i]) !== 'undefined' && Droptables.style.cols[i] !== null && (typeof (Droptables.style.cols[i][1].width) !== 'undefined')) {
                valueCols = parseInt(Droptables.style.cols[i][1].width);
            } else {
                valueCols = null;
            }
        }
        if (!valueCols || valueCols === 0) {
            valueCols = 100;
        }

        Droptables.style.cols = fillArray(Droptables.style.cols, {width: parseInt(valueCols)}, i);

        Droptables.style.table.width += parseInt(valueCols);
        valueCols = 0;
    }
}


// Build column selection for default sort parameter
function default_sortable(tableData) {
    var $ = window.jquery;
    if (tableData && typeof tableData[0] !== 'undefined') {
        var $jform_default_sortable = $('#content_popup_hide').find('.select_columns');
        var $jform_reponsive_table = $('#content_popup_hide').find('#responsive_table table tbody');
        var $jform_column_type_table = $('#content_popup_hide').find('#column_type_table table tbody');
        var $columnsSortType = $('#content_popup_hide').find('.columnsSortType');

        $jform_default_sortable.contents('li').remove();
        $jform_reponsive_table.html('');
        $jform_column_type_table.html('');
        $columnsSortType.contents('.columnSortItem:not(.droptable_hiden)').remove();

        var html = '';
        var html2 = '';
        var column_type_html = '';
        var ii = 0;

        var responsive_priority = '';
        for (var number = 0; number < (window.Droptables.max_Col > 12 ? window.Droptables.max_Col : 12); number++) {
            responsive_priority += '<li data-value="' + number + '">' + number + '</li>\n';
        }

        $.each(tableData[0], function (i, e) {
            var table_headers = $(window.Droptables_element.tableContainer).handsontable('getColHeader');
            var header = table_headers[i];

            var $columnSortItemDefault = $columnsSortType.find('.columnSortItem.droptable_hiden').clone();
            $columnSortItemDefault.removeClass('droptable_hiden');
            $columnSortItemDefault.find('.column_name').data('value', ii).text('Column ' + header + ' : ').attr('data-value', ii);
            $columnSortItemDefault.appendTo($columnsSortType);

            html += '<li data-value="' + ii + '">' + header + '</li>';

            html2 += '<tr data-col="' + ii + '">';
            html2 += '<td><label>' + header + '</label></td>';
            html2 += '<td><span class="responsive_priority popup_select mb-0 droptable_select_box_before"></span><ul class="droptable_select_box">\n'
                + responsive_priority +
                '</ul></td>';
            html2 += '</tr>';

            column_type_html += '<tr data-col="' + ii + '">';
            column_type_html += '<td><label>' + header + '</label></td>';
            column_type_html += '<td><span class="column_type popup_select mb-0 droptable_select_box_before"></span><ul class="droptable_select_box">\n' +
                '                        <li data-value="varchar">varchar</li>\n' +
                '                        <li data-value="int">integer</li>\n' +
                '                        <li data-value="float">float</li>\n' +
                '                        <li data-value="date">date</li>\n' +
                '                        <li data-value="datetime">datetime</li>\n' +
                '                        <li data-value="text">text</li>\n' +
                '                    </ul></td>';
            column_type_html += '</tr>';
            ii++;
        });
        $(html).appendTo($jform_default_sortable);
        $jform_default_sortable.trigger("liszt:updated");
        $(html2).appendTo($jform_reponsive_table);
        $jform_reponsive_table.trigger("liszt:updated");
        $(column_type_html).appendTo($jform_column_type_table);
        $jform_column_type_table.trigger("liszt:updated");
    }
}

function updateStyleAutofill (start_rangess, new_range, direction) {
    var respectively = [], data_respectively;
    var maxRange = [start_rangess[2] - start_rangess[0] + 1, start_rangess[3] - start_rangess[1] + 1];

    for (var i = new_range[0]; i <= new_range[2]; i++) {//rows
        for (var j = new_range[1]; j <= new_range[3]; j++) {//cols
            respectively[0] = i - new_range[0] > maxRange[0]
                ? ((i - new_range[0]) % maxRange[0]) + start_rangess[0]
                : i - new_range[0] + start_rangess[0];
            respectively[1] = j - new_range[1] > maxRange[1]
                ? ((j - new_range[1]) % maxRange[1]) + start_rangess[1]
                : j - new_range[1] + start_rangess[1];
            //update cell hyperlink
            if (typeof Droptables.hyperlink[i + '!' + j] !== 'undefined') {
                delete Droptables.hyperlink[i + '!' + j];
            }
            if (typeof Droptables.hyperlink[respectively[0] + '!' + respectively[1]] !== 'undefined') {
                data_respectively = Droptables.hyperlink[respectively[0] + '!' + respectively[1]];
                Droptables.hyperlink[i + '!' + j] = {};
                Droptables.hyperlink[i + '!' + j].hyperlink = data_respectively.hyperlink;
                Droptables.hyperlink[i + '!' + j].text = data_respectively.text;
            }

            //update cell type and col type
            var selection = {'0': [i,j,i,j]};
            if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined'
                && Droptables.style.cells[i + '!' + j][2].cell_type === 'html') {
                Droptables.style.cells[i + '!' + j][2].cell_type = null;
                saveData.push({action: 'set_cells_type', selection: selection, style: {cell_type: null}});
                window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, '']);
            } else if (typeof Droptables.style.cells[i + '!' + j] === 'undefined' || typeof Droptables.style.cells[i + '!' + j][2] === 'undefined') {
                Droptables.style.cells[i + '!' + j] = [i, j, {}];
            }

            if (typeof Droptables.style.cells[respectively[0] + '!' + respectively[1]] !== 'undefined'
                && Droptables.style.cells[respectively[0] + '!' + respectively[1]][2].cell_type === 'html') {
                Droptables.style.cells[i + '!' + j][2].cell_type = 'html';
                saveData.push({action: 'set_cells_type', selection: selection, style: {cell_type: 'html'}});
                window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, 'html']);

                if (typeof Droptables.style.table.col_types !== 'undefined'
                    && Droptables.style.table.col_types[j] !== 'text') {
                    Droptables.style.table.col_types[j] = 'text';
                    if (typeof table_function_data.colsSetType === 'undefined') {
                        table_function_data.colsSetType = {};
                    }
                    table_function_data.colsSetType[j] = 'text';
                }
            }
        }
    }
}

//convert value of calculation by format selected
function formatSymbols(resultCalc, decimal_count, thousand_symbols, decimal_symbols, symbol_position, value_unit) {
    decimal_count = parseInt(decimal_count);
    if (typeof resultCalc === 'undefined') {
        return;
    }
    var negative = resultCalc < 0 ? "-" : "",
        i = parseInt(resultCalc = Math.abs(+resultCalc || 0).toFixed(decimal_count), 10) + "",
        j = (j = i.length) > 3 ? j % 3 : 0;

    resultCalc = (j ? i.substr(0, j) + thousand_symbols : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand_symbols) + (decimal_count ? decimal_symbols + Math.abs(resultCalc - i).toFixed(decimal_count).slice(2) : "");

    resultCalc = Number(symbol_position) === 0
        ? ((negative === "-") ? negative + value_unit : value_unit) + resultCalc
        : negative + resultCalc + ' ' + value_unit;

    return resultCalc;
};

//Toggle between the charts and the table
function showChartOrTable(showChart, $chart) {
    if (showChart) {//show chart
        if (jquery('#droptable_chart .droptable_rightcol').find('.ss-content').length < 1) {
            var el2 = document.querySelector('#droptable_chart .droptable_rightcol');
            SimpleScrollbar.initEl(el2);
        }
        jquery('#droptable_chart').removeClass('droptable_hiden');
        jquery('.pwrapper').addClass('droptable_hiden');
        $chart.trigger('click');
        jquery('#list_chart').find('.current_table').unbind('click').on('click', showChartOrTable.bind(this, false));
    } else {//show table
        // if (jquery('#inserttable').length > 0) {
        //     Wptm.chart_active = 0;
        //     if (!jquery('#inserttable').hasClass('not_change_type')) {
        //         jquery('#inserttable').data('type', 'table').attr('data-type', 'table').text(insert_table);
        //     }
        //     jquery('#inserttable').removeClass("no_click");
        // }
        jquery('#droptable_chart').addClass('droptable_hiden');
        jquery('.pwrapper').removeClass('droptable_hiden');
        Droptables_element.tableContainer.handsontable('render');
    }
    jquery('#over_loadding_open_chart').hide();
    Droptables_element.primary_toolbars.find('.menu_loading').closest('li').removeClass('menu_loading');
    Droptables_element.settingTable.find('.ajax_loading').removeClass('loadding').addClass('droptable_hiden');
}

function getCellData(cellPos) {
    var pos = cellPos.split(":");
    var value = Droptables_element.tableContainer.handsontable('getDataAtCell', parseInt(pos[0]), parseInt(pos[1]));

    return value;
}

//replace string by decimal_symbol value and thousand_symbol value in calculation cell
function stringReplace(arr, unit) {
    var thousand_symbol = (!Droptables.style.table.thousand_symbol) ? default_value.thousand_symbol : Droptables.style.table.thousand_symbol;
    var decimal_symbol = (!Droptables.style.table.decimal_symbol) ? default_value.decimal_symbol : Droptables.style.table.decimal_symbol;
    if (typeof arr === 'number') {
        return arr;
    }
    var thousand_re = new RegExp('[' + thousand_symbol + ']', "g");
    // var thousand_re = new RegExp(thousand_symbol,"g");
    if (typeof arr !== 'undefined' && arr !== '' && arr !== null) {
        if (unit === true) {
            if (typeof arr !== 'string') {
                arr = arr.toString();
            }
            arr = arr.replace(table_function_data.text_replace_unit, "");
        } else {
            arr = arr.replace(table_function_data.replace_unit, "");
            arr = arr.replace(thousand_re, "");
            // arr = (thousand_symbol === ',') ? arr.replace(/,/g, "") : (thousand_symbol === '.' ? arr.replace(/\./g, "") : arr);
            arr = (decimal_symbol === ',') ? arr.replace(/,/g, ".") : arr;
        }
    } else {
        arr = '';
    }
    return arr;
}

function isSameArray(array1, array2) {
    return array1.length === array2.length && array1.every(function (element, index) {
        return element === array2[index];
    });
}
function convertStringToNumber (val) {
    var base = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', i, j, result = 0;

    for (i = 0, j = val.length - 1; i < val.length; i += 1, j -= 1) {
        result += Math.pow(base.length, j) * (base.indexOf(val[i]) + 1);
    }

    return result;
}
//add res priority of columns to set resposive priority popup
function responsive_col(Droptables) {
    var col = this.val();
    if (typeof (Droptables.style.cols) !== 'undefined' && typeof (Droptables.style.cols[col]) !== 'undefined' && typeof (Droptables.style.cols[col][1]) !== 'undefined' && typeof (Droptables.style.cols[col][1].res_priority) !== 'undefined') {
        var res_priority = Droptables.style.cols[col][1].res_priority;

        this.siblings('#responsive_priority').val(res_priority);
    } else {

        this.siblings('#responsive_priority').val(0);
    }
    this.siblings('#responsive_priority').trigger('liszt:updated');
}

function checkCellsOptionsValidate(selection, parametor, value) {
    var i, j;
    if (typeof arguments[3] !== 'undefined') {
        j = arguments[3];
        for (i = 0; i < j.length; i++) {
            if (typeof j[i][parametor] !== 'undefined' && j[i][parametor] == value) {
                return true;
            }
        }
    } else if (selection.length > 0) {
        for (i = selection[0][0]; i <= selection[0][2]; i++) {
            for (j = selection[0][1]; j <= selection[0][3]; j++) {
                if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined' && typeof Droptables.style.cells[i + '!' + j][2] !== 'undefined'){
                    if (typeof Droptables.style.cells[i + '!' + j][2][parametor] !== 'undefined' && Droptables.style.cells[i + '!' + j][2][parametor] == value) {
                        return true;
                    }
                }
            }
        }
    }
    return false;
}

function deleteFormatCells(selection) {
    if (selection.length > 0) {
        var i, j;
        for (i = selection[0][0]; i <= selection[0][2]; i++) {
            for (j = selection[0][1]; j <= selection[0][3]; j++) {
                if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined' && typeof Droptables.style.cells[i + '!' + j][2] !== 'undefined'){
                    if (typeof Droptables.style.cells[i + '!' + j][2].date_formats !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].date_formats = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].date_formats_momentjs !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].date_formats_momentjs = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].currency_symbol !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].currency_symbol = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].symbol_position !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].symbol_position = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].decimal_symbol !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].decimal_symbol = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].decimal_count !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].decimal_count = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].thousand_symbol !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].thousand_symbol = false;
                    }
                }
            }
        }
    }
}

function check_cell_readOnly_mysql(row, col, cellProperties) {
    if (table_function_data.allowed_edit) {
        cellProperties.readOnly = false;
        if (row >= 1) {
            if (!table_function_data.mysqlEdit) {
                cellProperties.readOnly = true;
            } else {
                if (typeof Droptables.style.table.lock_columns !== 'undefined' && Droptables.style.table.lock_columns[col] != 0) {
                    cellProperties.readOnly = true;
                }
                if (typeof table_function_data.columns !== 'undefined' && table_function_data.columns[col].readOnly) {
                    cellProperties.readOnly = true;
                }
            }
        }
    } else {
        cellProperties.readOnly = true;
    }

    return cellProperties;
}

//table_function_data.allowed_edit && table_function_data.mysqlEdit
function check_cell_readOnly(row, col, prop) {
    var cellProperties = {};

    if (window.Droptables.type === 'mysql') {
        // console.log(Droptables);
        cellProperties = check_cell_readOnly_mysql(row, col, cellProperties);
    }

    if (!Droptables.check_super_user) {
        var lock_cell_id = [], not_lock_cell = false;
        if (typeof table_function_data.protect_columns !== 'undefined'
            && typeof table_function_data.protect_columns[col] !== 'undefined') {
            //protect columns
            lock_cell_id.push(table_function_data.protect_columns[col]);
        }
        if (typeof table_function_data.protect_rows !== 'undefined'
            && typeof table_function_data.protect_rows[col] !== 'undefined') {
            //protect rows
            lock_cell_id.push(table_function_data.protect_rows[row]);
        }
        if (typeof Droptables.style.cells[row + "!" + col] !== 'undefined' && typeof Droptables.style.cells[row + "!" + col][2].lock_cell !== 'undefined') {
            lock_cell_id.push(Droptables.style.cells[row + "!" + col][2].lock_cell);
        }
        if (lock_cell_id.length > 0 && typeof lock_cell_id[0] !== 'undefined'
            && typeof table_function_data.lock_ranger_cells_user !== 'undefined') {
            for (var ij in lock_cell_id) {
                if (table_function_data.lock_ranger_cells_user[lock_cell_id[ij]]) {//allow edit
                    not_lock_cell = true;
                    break;
                }
            }
            if (!not_lock_cell) {
                cellProperties.readOnly = true;
            }
        }
    }

    return cellProperties;
}

function create_ranger_cells_lock (Droptables, table_function_data, update_rangers) {
    var lock_ranger_cells_user;
    // table_function_data.ranger_cells_lock_top = '';
    // table_function_data.ranger_cells_lock_left = '';
    // table_function_data.ranger_cells_lock_right = '';
    // table_function_data.ranger_cells_lock_bottom = '';
    table_function_data.lock_ranger_cells_user = [];
    table_function_data.protect_columns = [];
    table_function_data.protect_rows = [];
    // table_function_data.render_first_cell_protect_has_icon = [];

    if (typeof Droptables.style.table.lock_ranger_cells_user == 'undefined') {
        Droptables.style.table.lock_ranger_cells_user = [];
    }

    var ij, enable_lock, value;
    if (typeof Droptables.style.table.lock_ranger_cells === 'undefined' || Droptables.style.table.lock_ranger_cells.length < 1) {
        return false;
    }

    if (update_rangers !== null) {
        var current_rangers = [];
        var current_ranger_cells_user = [];
    }

    var i;

    for (i = 0; i < Droptables.style.table.lock_ranger_cells.length; i++) {
        // table_function_data.render_first_cell_protect_has_icon[i] = true;
        enable_lock = false;
        table_function_data.lock_ranger_cells_user[i] = false;
        if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
            lock_ranger_cells_user = Droptables.style.table.lock_ranger_cells_user[i].split('|');
            lock_ranger_cells_user.map(function(v) {
                if (Droptables.list_rolers_of_user.includes(parseInt(v))) {
                    table_function_data.lock_ranger_cells_user[i] = true;
                }
            });
            // if (lock_ranger_cells_user.indexOf(Droptables_userRoles) !== -1) {//ok edit
            //     table_function_data.lock_ranger_cells_user[i] = true;
            // } else if (!Droptables_administrator) {
            //     enable_lock = true;
            // }
        }

        value = Droptables.style.table.lock_ranger_cells[i].replace(/[ ]+/g, "").toUpperCase();
        var arrayRange = value.split(":");

        var check_value = 0;
        if (arrayRange[0].replace(/[ |A-Za-z]+/g, "") === '') {
            check_value = 1;//value A:B
        } else if (arrayRange[0].replace(/[ |1-9]+/g, "") === '') {
            check_value = 2;//value 8:9
        }

        var selection = [];
        if (check_value === 0) {
            if (typeof arrayRange[1] == 'undefined') {
                arrayRange[1] = arrayRange[0];
            }
            selection.push(parseInt(arrayRange[0].split(/[ |A-Za-z]+/g)[1]) - 1);
            selection.push(convertStringToNumber(arrayRange[0].split(/[ |1-9]+/g)[0]) - 1);
            selection.push(parseInt(arrayRange[1].split(/[ |A-Za-z]+/g)[1]) - 1);
            selection.push(convertStringToNumber(arrayRange[1].split(/[ |1-9]+/g)[0]) - 1);

            if (update_rangers !== null) {
                if (update_rangers.type === 'create_row') {
                    if (selection[0] >= update_rangers.index) {//rows >= index
                        if (selection[2] >= update_rangers.amount + update_rangers.index) {//index + amount <= after_col
                            selection[2] = selection[2] + update_rangers.amount;
                            selection[0] = update_rangers.amount + update_rangers.index >= selection[0] ? selection[0] : (selection[0] + update_rangers.amount);
                        } else {//index + amount > after_col
                            selection[2] = selection[2] + update_rangers.amount;
                        }
                    } else if (selection[0] < update_rangers.index && selection[2] >= update_rangers.index) {//row < index < after_row
                        selection[2] = selection[2] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_row') {
                    if (selection[0] >= update_rangers.index) {//rows >= index
                        if (update_rangers.amount + update_rangers.index >= selection[2]) {//remove all index + amount >= after_rows
                            continue;
                        }
                        if ((update_rangers.amount + update_rangers.index) >= selection[0]
                            && (update_rangers.amount + update_rangers.index) < selection[2]) {//index <= rows <= index + amount < after_rows
                            selection[0] = update_rangers.index;
                            selection[2] = selection[2] - update_rangers.amount;
                        } else {//index + amount < rows
                            selection[0] = selection[0] - update_rangers.amount;
                            selection[2] = selection[2] - update_rangers.amount;
                        }
                    } else if (selection[0] < update_rangers.index && selection[2] >= update_rangers.index) {//rows < index < after_rows
                        selection[2] = update_rangers.amount + update_rangers.index >= selection[2] ? (update_rangers.index - 1) : (selection[2] - update_rangers.amount);
                    }
                }
                if (update_rangers.type === 'add_col') {
                    if (selection[1] > update_rangers.index) {//col >= index
                        if (selection[3] >= update_rangers.amount + update_rangers.index) {//index + amount <= after_col
                            selection[3] = selection[3] + update_rangers.amount;
                            selection[1] = update_rangers.amount + update_rangers.index >= selection[1] ? selection[1] : (selection[1] + update_rangers.amount);
                        } else {//index + amount > after_col
                            selection[3] = selection[3] + update_rangers.amount;
                        }
                    } else if (selection[1] < update_rangers.index && selection[3] >= update_rangers.index) {//row < index < after_row
                        selection[3] = selection[3] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_col') {
                    if (selection[1] >= update_rangers.index) {//col >= index
                        if (update_rangers.amount + update_rangers.index >= selection[3]) {//remove all index + amount >= after_col
                            continue;
                        }
                        if ((update_rangers.amount + update_rangers.index) >= selection[1]
                            && (update_rangers.amount + update_rangers.index) < selection[3]) {//index <= col <= index + amount < after_col
                            selection[1] = update_rangers.index;
                            selection[3] = selection[3] - update_rangers.amount;
                        } else {//index + amount < col
                            selection[1] = selection[1] - update_rangers.amount;
                            selection[3] = selection[3] - update_rangers.amount;
                        }
                    } else if (selection[1] < update_rangers.index && selection[3] >= update_rangers.index) {//col < index < after_col
                        selection[3] = update_rangers.amount + update_rangers.index >= selection[3] ? (update_rangers.index - 1) : (selection[3] - update_rangers.amount);
                    }
                }

                current_rangers.push(getSelectedVal(selection));
                if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
                    current_ranger_cells_user.push(Droptables.style.table.lock_ranger_cells_user[i]);
                }
            }

            for (ij = selection[0]; ij <= selection[2]; ij++) {//row
                for (var ij2 = selection[1]; ij2 <= selection[3]; ij2++) {
                    if (typeof Droptables.style.cells[ij + '!' + ij2] !== 'undefined') {
                        Droptables.style.cells[ij + '!' + ij2][2] = window.jquery.extend(Droptables.style.cells[ij + '!' + ij2][2], {lock_cell: i});
                    }
                }
            }
        } else if (check_value === 1) {//columns
            selection.push(convertStringToNumber(arrayRange[0].split(/[ |1-9]+/g)[0]) - 1);
            selection.push(convertStringToNumber(arrayRange[1].split(/[ |1-9]+/g)[0]) - 1);

            if (update_rangers !== null) {
                if (update_rangers.type === 'add_col') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        selection[1] = selection[1] + update_rangers.amount;
                        selection[0] = update_rangers.amount + update_rangers.index >= selection[0] ? selection[0] : (selection[0] + update_rangers.amount);
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//row < index < after_row
                        selection[1] = selection[1] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_col') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        if (update_rangers.amount + update_rangers.index >= selection[1]) {//remove all
                            continue;
                        }
                        if (update_rangers.amount + update_rangers.index < selection[0]) {
                            selection[0] = selection[0] - update_rangers.amount;
                            selection[1] = selection[1] - update_rangers.amount;
                        } else {
                            selection[0] = update_rangers.index;
                            selection[1] = selection[1] - update_rangers.amount - update_rangers.index;
                        }
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//col < index < after_col
                        selection[1] = update_rangers.amount + update_rangers.index >= selection[1] ? (update_rangers.index - 1) : (selection[1] - update_rangers.amount);
                    }
                }

                current_rangers.push(getSelectedVal([false, selection[0], false, selection[1]]));
                if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
                    current_ranger_cells_user.push(Droptables.style.table.lock_ranger_cells_user[i]);
                }
            }

            for (ij = selection[0]; ij <= selection[1]; ij++) {
                table_function_data.protect_columns[ij] = i;
            }
        } else {//rows
            selection.push(parseInt(arrayRange[0].split(/[ |A-Za-z]+/g)[0]) - 1);
            selection.push(parseInt(arrayRange[1].split(/[ |A-Za-z]+/g)[0]) - 1);

            if (update_rangers !== null) {
                if (update_rangers.type === 'create_row') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        selection[1] = selection[1] + update_rangers.amount;
                        selection[0] = update_rangers.amount + update_rangers.index >= selection[0] ? selection[0] : (selection[0] + update_rangers.amount);
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//row < index < after_row
                        selection[1] = selection[1] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_row') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        if (update_rangers.amount + update_rangers.index >= selection[1]) {//remove all
                            continue;
                        }
                        if (update_rangers.amount + update_rangers.index < selection[0]) {
                            selection[0] = selection[0] - update_rangers.amount;
                            selection[1] = selection[1] - update_rangers.amount;
                        } else {
                            selection[0] = update_rangers.index;
                            selection[1] = selection[1] - update_rangers.amount - update_rangers.index;
                        }
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//col < index < after_col
                        selection[1] = update_rangers.amount + update_rangers.index >= selection[1] ? (update_rangers.index - 1) : (selection[1] - update_rangers.amount);
                    }
                }

                current_rangers.push(getSelectedVal([selection[0], false, selection[1], false]));
                if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
                    current_ranger_cells_user.push(Droptables.style.table.lock_ranger_cells_user[i]);
                }
            }

            for (ij = selection[0]; ij <= selection[1]; ij++) {
                table_function_data.protect_rows[ij] = i;
            }
        }
    };

    if (update_rangers !== null) {
        Droptables.style.table.lock_ranger_cells = jquery.extend([], current_rangers);
        Droptables.style.table.lock_ranger_cells_user = jquery.extend([], current_ranger_cells_user);
        // render_css_lock(Droptables, table_function_data);
    }
}

function render_css_lock(Droptables, table_function_data) {
    var column_i;
    var css_lock_columns = '';
    var $droptable_add_css_lock_columns = document.getElementById('droptable_add_css_lock_columns');

    // if (typeof Droptables.style.table.lock_columns !== 'undefined') {
    //     for (column_i in Droptables.style.table.lock_columns) {
    //         if (Droptables.style.table.lock_columns[column_i] != 0) {
    //             column_i = parseInt(column_i);
    //             css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + ') {position: relative;} ';
    //             css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + '):after {content: "lock";} ';
    //         }
    //     }
    // }

    if (typeof Droptables.style.table.lock_columns !== 'undefined') {
        for (column_i in Droptables.style.table.lock_columns) {
            if (Droptables.style.table.lock_columns[column_i] != 0) {
                column_i = parseInt(column_i);
                css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + ') {position: relative;} ';
                css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + '):after {content: "lock";} ';
            }
        }
    }

    setTimeout(function () {
        if (css_lock_columns !== '') {
            $droptable_add_css_lock_columns.innerHTML = css_lock_columns;
            $droptable_add_css_lock_columns.cssText = css_lock_columns;
        }
    }, 100);
}

function check_collide_two_range(selection1, selection2) {
    if ((Math.abs(selection1[0] - selection2[0]) < Math.abs(selection1[2] - selection1[0] + selection2[2] - selection2[0]) / 2)
        && (Math.abs(selection1[1] - selection2[1]) < Math.abs(selection1[3] - selection1[1] + selection2[3] - selection2[1]) / 2)
    ) {
        return true;
    }
    return false;
}

function changeValue(oldValue, index, amount, lengths, LeftRight, copyHeightRow) {
    var i;
    var new_data = {};
    if (LeftRight) {//left
        for (i = index; i < lengths; i++) {
            if (typeof new_data[i + amount] === 'undefined') {
                new_data[i + amount] = [i + amount, {}];
            }

            new_data[i + amount][1] = oldValue[i][1];
            if (i + 1 === lengths) {
                var return_data = jquery.extend({}, oldValue, new_data);
                return return_data;
            }
        }
    } else {//right
        for (i = index; i < lengths + amount; i++) {
            if (typeof new_data[i] === 'undefined') {
                new_data[i] = [i, {}];
            }

            if (!copyHeightRow) {
                new_data[i][1] = jquery.extend({}, oldValue[i - amount][1]);
            }

            if ((i + 1) === (lengths + amount)) {
                return jquery.extend({}, oldValue, new_data);
            }
        }
    }
}

export default {
    mergeCollsRowsstyleToCells,
    createRegExpFormat,
    createRegExpFormatForCell,
    parseCss,
    setFormat_accounting,
    setFormat_accounting_for_cells,
    calculateTableHeight,
    checkObjPropertyNested,
    convertAlpha,
    convertDate,
    cell_type_to_column,
    validate_type_cell,
    change_value_cells,
    getFillArray,
    fillArray,
    updateParamFromStyleObject,
    updateSwitchButtonFromStyleObject,
    updateParamFromStyleObjectSelectBox,
    getSizeCells,
    momentjsFormat,
    getSelectedVal,
    setText,
    pullDims,
    cleanHandsontable,
    updateStyleAutofill,
    droptablesCheckSize,
    getLinkSync,
    saveChanges,
    convertMergeCell,
    reConvertMergeCell,
    cleanStyle,
    pushDims,
    default_sortable,
    checkObjPropertyNestedNotEmpty,
    formatSymbols,
    showChartOrTable,
    getCellData,
    isSameArray,
    stringReplace,
    convertStringToNumber,
    responsive_col,
    checkCellsOptionsValidate,
    deleteFormatCells,
    status_noti,
    deleteRowDbTable,
    createRowDbTable,
    check_cell_readOnly_mysql,
    check_cell_readOnly,
    create_ranger_cells_lock,
    render_css_lock,
    check_collide_two_range,
    changeValue
}