import droptablesPreview from "./_droptables";
import tableFunction from "./_functions";
import customRenderer from "./_customRenderer";
import DropChart from "./_charts";
import alternating from "./_alternating";

//Control functions when select table items
const selectOption = function () {
    var Droptables_element = window.Droptables_element;
    var popupOption = {};
    var render = false;
    var autoRender;
    var check_saving;
    var new_col_types = [];
    var changed_cols = [];

    if (!table_function_data.allowed_edit) {
        return false;
    }

    if (Droptables.max_Col * Droptables.max_row < 1) {
        return false;
    }

    custom_select_box.call(window.jquery('#setting-cells .droptable_select_box_before'), window.jquery);

    Droptables_element.primary_toolbars.find('.table_option:not(.menu_loading)').unbind('change click').on('change click', function (e) {
        var function_data = window.table_function_data;
        var Droptables = window.Droptables;
        var $ = window.jquery;

        if ($(this).parent('li.no_active').length > 0) {
            return false;
        }
        var selection = {};
        selection = table_function_data.selection;

        var popup = $.extend({}, {});
        var html = '';
        //for undo
        // var oldStyle = JSON.parse(JSON.stringify(Wptm.style));
        //for mergecells
        // var ht = Droptables_element.tableContainer.handsontable('getInstance');

        /*click cell*/
        switch ($(this).attr('name')) {
            case 'rename_menu':
                tableFunction.setText.call(
                    $(this),
                    Droptables_element.primary_toolbars.find('.droptable_name_edit'),
                    '#primary_toolbars .droptable_name_edit',
                    {'url': Droptables.ajaxurl + "index.php?option=com_droptables&task=table.setTitle&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert) + '&title=', 'selected': true}
                );
                break;
            case 'new_table_menu':
                if (createNewTable($)) {
                    return true;
                }
                break;
            case 'save_menu':
                tableFunction.saveChanges(true);
                break;
            case 'export_menu':
                // if (Wptm.type == 'mysql') {
                //     return false;
                // }
                html = '';
                html += '<div class="control-group">';
                html += '<div  class="popup_top border_top">';
                html += '<span>' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL', 'Export excel') + ' :</span>';
                html += '</div>';
                html += '<span class="popup_select style_export droptable_select_box_before" data-value="1">' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL_DATA_STYLE', 'Data + styles') + '</span>';
                html += '<ul class="droptable_select_box">';
                html += '<li data-value="1">' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL_DATA_STYLE', 'Data + styles') + '</li>';
                html += '<li data-value="0">' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL_ONLY', 'Data only') + '</li>';
                html += '</ul>';
                html += '<div style="margin-top: 10px"><input type="button" class="droptables_button droptables_done" value="Export excel" id="export_excel"></div>';
                html += '</div>';
                popup = {
                    'html': $(html),
                    'selector': {'export_excel': '.style_export'},
                    'showAction': function () {
                        custom_select_box.call(this.find('.style_export'), $);
                    },
                    'option': {'export_excel': 1},
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, false);

                //Export-excel
                $('#export_excel').bind('click', function (e) {
                    var format = default_value.export_excel_format;
                    var url = Droptables.ajaxurl + 'index.php?option=com_droptables&task=excel.export&id=' + Droptables.id + '&format_excel=' + format + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert);
                    url = url + '&onlydata=' + popup.option['export_excel'];

                    $.fileDownload(url, {
                        failCallback: function (html, url) {
                            bootbox.alert(html);
                        }
                    });
                });
                break;
            case 'source_menu':
                if (table_function_data.access_db) {
                    var curr_page = window.location.href;
                    var cells = curr_page.split("?");
                    var new_url;
                    if (parseInt(Droptables.caninsert) > 0) {
                        new_url = cells[0] + '?option=com_droptables&task=dbtable.display&view=droptables&id_table=' + idTable + '&noheader=1&caninsert=1&tmpl=component';
                    } else {
                        if (Droptables.view === 'manage') {
                            new_url = cells[0] + "?option=com_droptables&view=manage&task=dbtable.display&id_table=" + idTable;
                        } else {
                            new_url = cells[0] + '?option=com_droptables&task=dbtable.display&id_table=' + idTable;
                        }
                    }
                    window.location = new_url;
                }
                break;
            case 'access_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#access_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('.droptable_done').addClass('droptable_blu');
                        this.find('.droptable_cancel').addClass('droptable_grey');

                        if (typeof Droptables.authorTable !== 'undefined' && parseInt(Droptables.authorTable) > 0) {
                            this.find('#jform_role_table').val(parseInt(Droptables.authorTable)).change();
                        }

                        return true;
                    },
                    'submitAction': function () {
                        var author = this.find('#jform_role_table').val();
                        if (parseInt(author) > 0 && parseInt(author) !== parseInt(Droptables.authorTable)) {//change own category
                            $.ajax({
                                url: Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.setUser&id=' + Droptables.id + '&user=' + author + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                                dataType: "json",
                                type: "POST",
                                data: {},
                                beforeSend: function () {
                                    Droptables_element.settingTable.find('.droptable_saving').removeClass('droptable_hiden');
                                },
                                success: function (datas) {
                                    if (datas.response === true) {
                                        Droptables.authorTable = author;
                                    } else {
                                        bootbox.alert(datas.response, 'Ok');
                                    }
                                    Droptables_element.settingTable.find('.droptable_saving').addClass('droptable_hiden');
                                },
                                error: function (jqxhr, textStatus, error) {
                                    bootbox.alert(textStatus + " : " + error, 'Ok');
                                }
                            });
                        }
                        this.siblings('.colose_popup').trigger('click');
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'select_theme_menu':
                if (Droptables.type == 'mysql') {
                    return false;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#table_styles'),
                    'showAction': function () {
                        var image_hover_url = '';
                        var $image_hover = '';
                        var $image_height = 0;
                        var max_size_window = {};
                        max_size_window.height = $('#wrapper').outerHeight();
                        max_size_window.width = $('#wrapper').outerWidth();
                        Droptables_element.droptable_popup.find('#table_styles li').mousemove(function(e) {
                            var x = e.clientX;
                            var y = e.clientY;
                            var upside = 0;

                            if (image_hover_url !== $(this).data('image')) {
                                $('#wrapper').find('.full_image').remove();
                                image_hover_url = $(this).data('image');
                                $image_hover = $('<img class="full_image" style="width:500px" src="' + image_hover_url + '">');
                                $('#wrapper').append($image_hover);
                            }

                            if (max_size_window.width < (x + 500)) {
                                upside += 2;
                            }

                            if ($image_hover.outerHeight() > 400) {
                                $image_height = 400;
                                $image_hover.css({height: 400, width: 'auto'});
                            } else {
                                $image_height = $image_hover.outerHeight();
                            }
                            if (max_size_window.height < (y + $image_height)) {
                                upside++;
                            }

                            if (upside === 3) {
                                $image_hover.css({ top: y - $image_height - 20, left: x - 520});
                            } else if(upside === 2 ) {
                                $image_hover.css({ top: y, left: x  - 520});
                            } else if(upside === 1 ) {
                                $image_hover.css({ top: y - $image_height - 20, left: x  + 20});
                            } else {
                                $image_hover.css({ top: y, left: x  + 20});
                            }
                        }).mouseout(function(e) {
                            $('#wrapper').find('.full_image').remove();
                            image_hover_url = '';
                            image_hover_url = '';
                        });
                    },
                    'cancelAction': function () {
                        Droptables_element.droptable_popup.find('#table_styles li').unbind('mousemove');
                        $('#wrapper').find('.full_image').remove();
                        return true;
                    }
                };

                droptables_popup(false, Droptables_element.droptable_popup, popup, true);

                Droptables_element.droptable_popup.find('#table_styles a').click(function (e) {
                    e.preventDefault();
                    var cellsData = $(Droptables_element.tableContainer).handsontable('getData');
                    var ret = true;
                    var nbCols = 0;
                    var id = $(this).data('id');

                    //check table data exist
                    $.each(cellsData, function (index, value) {
                        nbCols = value.length;
                        $.each(value, function (i, v) {
                            if (v && v.toString().trim() !== '') {
                                ret = false;
                                return false;
                            }
                        });
                    });
                    change_theme(ret, id, cellsData);
                })
                break;
            case 'alternate_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#alternating_color'),
                    'showAction': function () {
                        var selection, reSelection, valueRange;
                        valueRange = ''
                        if (Droptables.type === 'mysql') {
                            $(Droptables_element.tableContainer).handsontable("selectAll");
                            selection = $.extend([], function_data.selection[0]);
                        } else {
                            if (typeof function_data.selection === 'undefined' || function_data.selection === undefined || function_data.selection === false) { //if unselected cells
                                var i;
                                if (droptablesCheckSize(function_data.oldAlternate) < 1 || typeof Droptables.style.table.alternateColorValue === 'undefined') {
                                    selection = [0, 0, tableFunction.droptablesCheckSize(Droptables.style.cols) - 1, tableFunction.droptablesCheckSize(Droptables.style.rows) - 1];
                                    valueRange = 'a1:';
                                    //remove undefined cols in array
                                    var cols = [];
                                    for (i = 0; i < tableFunction.droptablesCheckSize(Droptables.style.cols); i++) {
                                        if (typeof Droptables.style.cols[i] !== 'undefined' && Droptables.style.cols[i] !== undefined && Droptables.style.cols[i] !== null) {
                                            cols[i] = Droptables.style.cols[i];
                                        }
                                    }
                                    Droptables.style.cols = cols;

                                    valueRange += String.fromCharCode(97 + tableFunction.droptablesCheckSize(Droptables.style.cols) - 1);
                                    valueRange += tableFunction.droptablesCheckSize(Droptables.style.rows);
                                }
                            } else {
                                selection = $.extend([], function_data.selection[0]);
                                // check if selecting more than 3 rows then process
                                var selection_rows = selection[2] - selection[0];
                                if (selection_rows >= 2) {
                                    if (tableFunction.droptablesCheckSize(function_data.oldAlternate) >= 1 || typeof Droptables.style.table.alternateColorValue !== 'undefined') {
                                        for (var i = 0; i < tableFunction.droptablesCheckSize(function_data.oldAlternate); i++) {
                                            var oldAlternateData = function_data.oldAlternate[i];
                                            if (oldAlternateData !== false && typeof oldAlternateData !== 'undefined' && typeof oldAlternateData.selection !== 'undefined') {
                                                var isSameSelection = tableFunction.isSameArray(selection, oldAlternateData.selection);
                                                if (isSameSelection) {
                                                    var colorData = oldAlternateData.default.split('|');
                                                    var dftAlternateHeader = colorData[0];
                                                    var dftAlternateTile1 = colorData[1];
                                                    var dftAlternateTile2 = colorData[2];
                                                    var dftAlternateFooter = colorData[3];
                                                    var currTile = this.find('.pane-color-tile[data-tile-header="' + dftAlternateHeader + '"][data-tile-1="' + dftAlternateTile1 + '"][data-tile-2="' + dftAlternateTile2 + '"][data-tile-footer="' + dftAlternateFooter + '"]');
                                                    currTile.addClass('active');
                                                    if (oldAlternateData.header !== '') {
                                                        this.find('.banding-header-checkbox').trigger('click');
                                                    }
                                                    if (oldAlternateData.footer !== '') {
                                                        this.find('.banding-footer-checkbox').trigger('click');
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        if (function_data.selectionSize > 0) {
                            selection = $.extend([], function_data.selection[0]);
                            for (i = 0; i < function_data.selectionSize; i++) {
                                if (function_data.selection[i][0] < selection[0]) {
                                    selection[0] = function_data.selection[i][0];
                                }
                                if (function_data.selection[i][1] < selection[1]) {
                                    selection[1] = function_data.selection[i][1];
                                }
                                if (function_data.selection[i][2] > selection[2]) {
                                    selection[2] = function_data.selection[i][2];
                                }
                                if (function_data.selection[i][3] > selection[3]) {
                                    selection[3] = function_data.selection[i][3];
                                }
                            }
                            valueRange += String.fromCharCode(97 + selection[1]) + (selection[0] + 1)
                                + ':' + String.fromCharCode(97 + selection[3]) + (selection[2] + 1);
                        }

                        if (valueRange !== '') {
                            this.find('.cellRangeLabelAlternate').val(valueRange);
                            this.find('#get_select_cells').trigger('click');
                        }

                        this.find('.formatting_style .pane-color-tile').on('click', (e) => {
                            var that = $(e.currentTarget);
                            //check exist selector and
                            selection = $.extend([], function_data.selection[0]);

                            if (typeof selection[1] !== 'undefined' && Math.abs(selection[0] - selection[2]) > 1) {
                                if (Droptables.type === 'mysql') { //alternate for all cell
                                    function_data.allAlternate = {};
                                    function_data.allAlternate.even = that.data('tile-1');
                                    function_data.allAlternate.old = that.data('tile-2');
                                    function_data.allAlternate.header = that.data('tile-header');
                                    function_data.allAlternate.footer = that.data('tile-footer');
                                    function_data.allAlternate.default = '' + function_data.allAlternate.header + '|' + function_data.allAlternate.even + '|' + function_data.allAlternate.old + '|' + function_data.allAlternate.footer;

                                    if (this.find('.banding-header-checkbox:checked').length < 1) {
                                        function_data.allAlternate.header = '';
                                    }

                                    if (this.find('.banding-footer-checkbox:checked').length < 1) {
                                        function_data.allAlternate.footer = '';
                                    }
                                    alternating.renderCell();
                                } else {
                                    var count = alternating.setNumberAlternate(selection, function_data.oldAlternate);

                                    /*create/reset oldAlternate[count]*/
                                    function_data.oldAlternate[count] = {};
                                    function_data.oldAlternate[count].selection = selection;
                                    function_data.oldAlternate[count].even = that.data('tile-1');
                                    function_data.oldAlternate[count].old = that.data('tile-2');
                                    function_data.oldAlternate[count].header = that.data('tile-header');
                                    function_data.oldAlternate[count].footer = that.data('tile-footer');

                                    function_data.oldAlternate[count].default = '' + function_data.oldAlternate[count].header + '|' + function_data.oldAlternate[count].even + '|' + function_data.oldAlternate[count].old + '|' + function_data.oldAlternate[count].footer;

                                    if (this.find('.banding-header-checkbox:checked').length < 1) {
                                        function_data.oldAlternate[count].header = '';
                                    }

                                    if (this.find('.banding-footer-checkbox:checked').length < 1) {
                                        function_data.oldAlternate[count].footer = '';
                                    }
                                    alternating.selectAlternatingColor(function_data.oldAlternate, selection, count),
                                        alternating.renderCell();
                                }

                                this.find('.pane-color-tile.active').removeClass('active');
                                that.addClass('active');
                            }
                            return false;
                        });

                        this.find('.banding-header-footer-checkbox-wrapper input').on('click', (e) => {
                            selection = $.extend([], function_data.selection[0]);
                            if (typeof selection[1] !== 'undefined' && Math.abs(selection[0] - selection[2]) > 1) {
                                if (Droptables.type === 'mysql') { //alternate for all cell
                                    if (typeof function_data.allAlternate.default !== 'undefined') {
                                        var defaultStyle = function_data.allAlternate.default.split("|");

                                        if (this.find('.banding-header-checkbox:checked').length > 0) {
                                            function_data.allAlternate.header = defaultStyle[0];
                                        } else {
                                            function_data.allAlternate.header = '';
                                        }

                                        if (this.find('.banding-footer-checkbox:checked').length > 0) {
                                            function_data.allAlternate.footer = defaultStyle[3];
                                        } else {
                                            function_data.allAlternate.footer = '';
                                        }
                                        alternating.renderCell();
                                    }
                                } else {
                                    var oldCount = tableFunction.droptablesCheckSize(function_data.oldAlternate);
                                    var count = alternating.setNumberAlternate(selection, function_data.oldAlternate);
                                    if (oldCount !== count) {
                                        var defaultStyle = [];
                                        if (typeof function_data.oldAlternate[count].default !== 'undefined') {
                                            defaultStyle = function_data.oldAlternate[count].default.split("|");
                                        } else {
                                            if (this.find('.pane-color-tile.active').length > 0) {
                                                defaultStyle[0] = this.find('.pane-color-tile.active').find('.pane-color-tile-header').data('value');
                                                defaultStyle[3] = this.find('.pane-color-tile.active').find('.pane-color-tile-footer').data('value');
                                            } else {
                                                defaultStyle[0] = function_data.oldAlternate[count].header;
                                                defaultStyle[3] = function_data.oldAlternate[count].footer;
                                            }
                                        }
                                        if (this.find('.banding-header-checkbox:checked').length > 0) {
                                            function_data.oldAlternate[count].header = defaultStyle[0];
                                        } else {
                                            function_data.oldAlternate[count].header = '';
                                        }

                                        if (this.find('.banding-footer-checkbox:checked').length > 0) {
                                            function_data.oldAlternate[count].footer = defaultStyle[3];
                                        } else {
                                            function_data.oldAlternate[count].footer = '';
                                        }

                                        function_data.oldAlternate[count].default = '' + defaultStyle[0] + '|' + function_data.oldAlternate[count].even + '|' + function_data.oldAlternate[count].old + '|' + defaultStyle[3];

                                        alternating.selectAlternatingColor(function_data.oldAlternate, selection, count),
                                            alternating.renderCell();
                                    }
                                }
                            }
                            return true;
                        });

                        this.find('#alternate_color_done').click((e) => {
                            e.preventDefault();
                            alternating.applyAlternate.call(this);
                        });
                        return true;
                    },
                    'cancelAction': function () {
                        if (tableFunction.droptablesCheckSize(function_data.checkChangeAlternate) > 0) {
                            if (Droptables.type === 'mysql') { //alternate for all cell
                                function_data.allAlternate = {};
                            } else {
                                Droptables.style.cells = $.extend({}, alternating.reAlternateColor());
                                function_data.oldAlternate = $.extend({}, Droptables.style.table.alternateColorValue);
                            }

                            alternating.renderCell();
                        }
                        return true;
                    }
                };
                if (Droptables.type === 'mysql') {
                    droptables_popup(false, Droptables_element.droptable_popup, popup, true, false);
                } else {
                    droptables_popup(false, Droptables_element.droptable_popup, popup, true, true);
                }
                break;
            case 'resize_column':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#column_size_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        var selection = table_function_data.selection;
                        var change_selected = false;
                        for (var i = 0; i < selection.length; i++) {
                            if (Droptables.newSelect === 'col') {
                                if (selection[i][0] !== 0 || selection[i][2] !== Droptables.max_row - 1) {
                                    table_function_data.selection.splice(i, 1);
                                    change_selected = true;
                                }
                            }
                        }

                        this.find('#jform_row_height-lbl').closest('.control-group').addClass('droptable_hiden');
                        this.find('.popup_top span').text(Joomla.JText._('COM_DROPTABLES_TABLES_COLUMN_WIDTH_START', 'Resize columns'));
                        if (table_function_data.selectionSize > 1) {
                            this.find('#jform_col_width-lbl').text(Joomla.JText._('COM_DROPTABLES_TABLES_COLUMN_WIDTH_START', 'Resize columns'));
                        }

                        if (table_function_data.selectionSize < 2) {
                            if (selection[0][1] !== selection[0][3]) {//columns
                                var text = [];
                                if (selection[0][1] > 25) {
                                    text[0] = String.fromCharCode(65) + String.fromCharCode(65 + selection[0][1] - 26);
                                } else {
                                    text[0] = String.fromCharCode(65 + selection[0][1]);
                                }
                                if (selection[0][3] > 25) {
                                    text[1] = String.fromCharCode(65) + String.fromCharCode(65 + selection[0][3] - 26);
                                } else {
                                    text[1] = String.fromCharCode(65 + selection[0][3]);
                                }
                                this.find('#jform_col_width-lbl')
                                    .text(Joomla.JText._('COM_DROPTABLES_TABLES_COLUMN_WIDTH_START', 'Resize columns') + ': ' + text[0] + '-' + text[1]);
                            }
                        }
                        var endCell = [selection[table_function_data.selectionSize - 1][2], selection[table_function_data.selectionSize - 1][3]];
                        tableFunction.getSizeCells($, Droptables, endCell);

                        this.find('.cellRangeLabelAlternate').addClass('select_column').data('text_change', '#jform_col_width-lbl');
                        if (change_selected) {
                            $(Droptables_element.tableContainer).handsontable("selectCells", table_function_data.selection);
                            tableFunction.getSelectedVal(table_function_data.selection[selection.length - 1], this.find('.cellRangeLabelAlternate'));
                        }
                        return true;
                    },
                    'submitAction': function () {
                        var col_width_val = this.find('#cell_col_width').val();
                        var selection = table_function_data.selection;
                        var i = -1;
                        var ii = 0;
                        if (typeof selection !== 'undefined' && selection !== undefined && table_function_data.selectionSize > 0) {
                            for (ii = 0; ii < table_function_data.selectionSize; ii++) {
                                for (i = selection[ii][1]; i <= selection[ii][3]; i++) {
                                    if (typeof Droptables.style.cols[i] === 'undefined' ||  Droptables.style.cols[i] === null) {
                                        Droptables.style.cols[i] = [i, {width: parseInt(col_width_val)}];
                                    }
                                    Droptables.style.cols[i][1].width = parseInt(col_width_val);
                                }
                            }
                            i++;
                        }
                        if (i !== -1) { //have changing
                            table_function_data.needSaveAfterRender = true;
                            tableFunction.pullDims(Droptables, $);
                        }

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    },
                    'cancelAction': function () {
                        Droptables_element.droptable_popup.find('.content').contents().remove();
                        return true;
                    }
                };
                if (Droptables.type === 'mysql') {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, false);
                } else {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, true);
                }
                break;
            case 'resize_row':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#column_size_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        var selection = table_function_data.selection;
                        var change_selected = false;
                        for (var i = 0; i < selection.length; i++) {
                            if (Droptables.newSelect === 'row') {
                                if (selection[i][1] !== 0 || selection[i][3] !== Droptables.max_Col - 1) {
                                    table_function_data.selection.splice(i, 1);
                                    change_selected = true;
                                }
                            }
                        }

                        this.find('#jform_col_width-lbl').closest('.control-group').addClass('droptable_hiden');
                        this.find('.popup_top span').text(Joomla.JText._('COM_DROPTABLES_TABLES_ROW_HEIGHT_START', 'Resize rows'));
                        if (Droptables.type === 'mysql') {
                            this.find('#all_cell_row_height').closest('.control-group').removeClass('droptable_hiden');
                            this.find('#jform_row_height-lbl').text(Joomla.JText._('COM_DROPTABLES_TABLES_SELECTROW_HEIGHT_START', 'Row height (header):'));
                            this.find('#all_cell_row_height').val(Droptables.style.table.allRowHeight);
                        } else {
                            if (table_function_data.selectionSize > 1) {
                                this.find('#jform_row_height-lbl').text(Joomla.JText._('COM_DROPTABLES_TABLES_SELECTROW_HEIGHT_START', 'Selected rows '));
                            } else {
                                if (selection[0][0] !== selection[0][2]) {//rows
                                    this.find('#jform_row_height-lbl')
                                        .text(Joomla.JText._('COM_DROPTABLES_TABLES_ROW_HEIGHT_START', 'Resize rows') + ': ' + (selection[0][0] + 1) + '-' + (selection[0][2] + 1));
                                }
                            }
                        }

                        var endCell = [selection[table_function_data.selectionSize - 1][2], selection[table_function_data.selectionSize - 1][3]];
                        tableFunction.getSizeCells($, Droptables, endCell);

                        this.find('.cellRangeLabelAlternate').addClass('select_row').data('text_change', '#jform_row_height-lbl')
                        if (change_selected) {
                            $(Droptables_element.tableContainer).handsontable("selectCells", table_function_data.selection);
                            tableFunction.getSelectedVal(table_function_data.selection[selection.length - 1], this.find('.cellRangeLabelAlternate'));
                        }
                        return true;
                    },
                    'submitAction': function () {
                        var row_height_val = parseInt(this.find('#cell_row_height').val());
                        var selection = table_function_data.selection;
                        var i = -1;
                        var ii = 0;
                        if (typeof selection !== 'undefined' && selection !== undefined && table_function_data.selectionSize > 0) {
                            for (ii = 0; ii < table_function_data.selectionSize; ii++) {
                                for (i = selection[ii][0]; i <= selection[ii][2]; i++) {
                                    if (Droptables.type !== 'mysql') {
                                        if (typeof Droptables.style.rows[i] === 'undefined') {
                                            Droptables.style.rows[i] = [i, {height: row_height_val}];
                                        }
                                        Droptables.style.rows[i][1].height = row_height_val;
                                    }
                                }
                            }

                            if (Droptables.type === 'mysql') {
                                var all_row_height_val = this.find('#all_cell_row_height').val();
                                Droptables.style.rows[0][1].height = row_height_val;
                                Droptables.style.table = tableFunction.fillArray(Droptables.style.table, {allRowHeight: parseFloat(all_row_height_val)});
                            }
                            i++;
                        }
                        if (i !== -1) { //have changing
                            table_function_data.needSaveAfterRender = true;
                            tableFunction.pullDims(Droptables, $);
                        }

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    },
                    'cancelAction': function () {
                        Droptables_element.droptable_popup.find('.content').contents().remove();
                        return true;
                    }
                };
                if (Droptables.type === 'mysql') {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, false);
                } else {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, true);
                }
                break;
            case 'header_option_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#header_option'),
                    'showAction': function() {
                        var length = -1;
                        for (var i = 4; i > 0; i--) {
                            if (typeof Droptables.datas[i] !== 'undefined') {
                                for (var ii = 0; ii < Droptables.datas[i].length; ii++) {
                                    if (Droptables.datas[i][ii] !== '') {
                                        length = i;
                                        break;
                                    }
                                }
                            }
                            if (length > -1) {
                                break;
                            }
                        }
                        this.find('#number_first_rows').next().find('li[data-value=' + (length + 1) + ']').nextAll().hide();
                        tableFunction.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'headerOption', this.find('#number_first_rows').next('.droptable_select_box'), length + 1 > 0 ? 1 : 0);
                        if (Droptables.type == 'mysql') {
                            this.find('#number_first_rows').addClass('no_active');
                        } else {
                            custom_select_box.call(this.find('#number_first_rows'), $);
                        }
                        //freeze_row
                        var freeze_row = parseInt(Droptables.style.table.freeze_row) > 0 ? 1 : 0;
                        tableFunction.updateSwitchButtonFromStyleObject({'freeze_row': freeze_row}, 'freeze_row', this.find('#freeze_row'), '0');
                    },
                    'submitAction': function () {
                        if (Droptables.type !== 'mysql') {
                            if (this.find('#number_first_rows').data('value') !== '') {
                                if (this.find('#number_first_rows').data('value') != Droptables.style.table.headerOption) {
                                    saveData.push({
                                        action: 'set_header_option',
                                        value: this.find('#number_first_rows').data('value')
                                    });
                                }
                                Droptables.style.table.headerOption = parseInt(this.find('#number_first_rows').data('value'));
                            }
                        }


                        Droptables.style.table.freeze_row = this.find("#freeze_row").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.freeze_row > 0) {
                            $(Droptables_element.tableContainer).handsontable('updateSettings', {fixedRowsTop: Droptables.style.table.headerOption});
                        } else {
                            $(Droptables_element.tableContainer).handsontable('updateSettings', {fixedRowsTop: 0});
                        }
                        Droptables.style.header_data = Droptables.datas.slice(0, Droptables.style.table.headerOption);

                        tableFunction.saveChanges(true);
                        this.siblings('.colose_popup').trigger('click');

                        return true;
                    },
                    'cancelAction': function () {
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'sort_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#sortable_table'),
                    'option': {
                        'sort_columns': {},
                    },
                    'showAction': function () {
                        var that = this;
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'use_sortable', this.find('#use_sortable'), '0');
                        tableFunction.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'default_order_sortable', this.find('#default_order_sortable').next('.droptable_select_box'), '');
                        tableFunction.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'default_sortable', this.find('#default_sortable').next('.droptable_select_box'), '');

                        custom_select_box.call(this.find('#default_order_sortable'), $);
                        custom_select_box.call(this.find('#default_sortable'), $);

                        let sort_column = [];
                        $.each(this.find('.columnSortItem:not(.droptable_hiden)'), function (i, v) {
                            let column = $(v).find('.column_name').data('value');
                            sort_column[column] = {};
                            var sort_type_default = (Droptables.style.table.col_types && Droptables.style.table.col_types[column])
                                ? ((Droptables.style.table.col_types[column] === 'varchar' || Droptables.style.table.col_types[column] === 'text')
                                    ? 'string'
                                    : ((Droptables.style.table.col_types[column] === 'int' || Droptables.style.table.col_types[column] === 'float')
                                        ? 'number'
                                        : 'date'))
                                : 'string';

                            if (Droptables.style.cols[column][1]) {
                                sort_column[column] = $.extend({}, Droptables.style.cols[column][1]);
                                if (!sort_column[column].sort_type) {
                                    sort_column[column].sort_type = sort_type_default;
                                }
                                if (!(typeof sort_column[column].sort_format !== 'undefined' && sort_column[column].sort_type)) {
                                    sort_column[column].sort_format = sort_column[column].sort_type === 'date' ? Droptables.style.table.date_format : ''
                                }
                            } else {
                                sort_column[column] = {'res_priority': 1, 'sort_format': '', 'sort_type': sort_type_default, 'width': 80};
                            }
                            popup.option.sort_columns[column] = $.extend({}, sort_column[column]);
                            tableFunction.updateParamFromStyleObjectSelectBox(sort_column[column], 'sort_type', $(v).find('.select_sort_type'), 'string');
                            $(v).find('.sort_format').val(sort_column[column].sort_format || '');

                            if (sort_column[column].sort_type !== 'date') {
                                $(v).find('.sort_format').addClass('readonly').prop('readonly', true);
                            }

                            custom_select_box.call($(v).find('.sort_type'), $, function () {
                                let sort_type = this.data('value');
                                popup.option.sort_columns[column] = popup.option.sort_columns[column] || sort_column[column];
                                popup.option.sort_columns[column].sort_type = sort_type;

                                if (sort_type === 'date') {
                                    popup.option.sort_columns[column].sort_format = popup.option.sort_columns[column].sort_format || Droptables.style.table.date_format;
                                    $(v).find('.sort_format').val(popup.option.sort_columns[column].sort_format).removeClass('readonly').prop('readonly', false);
                                } else {
                                    popup.option.sort_columns[column].sort_format = '';
                                    $(v).find('.sort_format').val('').addClass('readonly').prop('readonly', true);
                                }
                            });

                            $(v).find('.sort_format').unbind('change').on('change', function (e) {
                                popup.option.sort_columns[column] = popup.option.sort_columns[column] || sort_column[column];
                                popup.option.sort_columns[column].sort_type = 'date';
                                popup.option.sort_columns[column].sort_format = $(e.target).val();
                            })
                        })

                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.use_sortable = this.find("#use_sortable").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.use_sortable == 1) {
                            Droptables_element.primary_toolbars.find('.sort_menu').parent().addClass('selected');
                        } else {
                            Droptables_element.primary_toolbars.find('.sort_menu').parent().removeClass('selected');
                        }

                        if (this.find('#default_order_sortable').data('value') !== '') {
                            Droptables.style.table.default_order_sortable = this.find('#default_order_sortable').data('value');
                        }
                        Droptables.style.table.default_sortable = this.find('#default_sortable').data('value');

                        $.each(popup.option.sort_columns, function (i, v) {
                            Droptables.style.cols[i][1] = $.extend({}, v);
                        });

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'download_button_menu':
                if ($(this).parent().hasClass('selected')) {
                    Droptables.style.table.download_button = 0;
                    $(this).parent().removeClass('selected');
                } else {
                    Droptables.style.table.download_button = 1;
                    $(this).parent().addClass('selected');
                }
                tableFunction.saveChanges(true);
                break;
            case 'filters_menu':
                if ($(this).parent().hasClass('selected')) {
                    Droptables.style.table.enable_filters = 0;
                    $(this).parent().removeClass('selected');
                } else {
                    Droptables.style.table.enable_filters = 1;
                    $(this).parent().addClass('selected');
                }
                tableFunction.saveChanges(true);
                break;
            case 'column_type_menu':
                tableFunction.default_sortable(window.Droptables.datas);
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#column_type_table'),
                    'showAction': function () {
                        var col_types = Droptables.style.table.col_types;

                        this.find('tbody tr').each(function () {
                            var i = $(this).data('col');
                            col_types[i] = typeof col_types[i] !== 'undefined' ? col_types[i].toLowerCase() === 'varchar(255)' ? 'varchar' : col_types[i].toLowerCase() : 'varchar';
                            if (Droptables.type === 'mysql') {
                                $(this).find('.droptable_select_box_before').addClass('no_active').text(col_types[i]);
                            } else {
                                tableFunction.updateParamFromStyleObjectSelectBox(col_types, i, $(this).find('.droptable_select_box'), 'varchar');
                                custom_select_box.call($(this).find('.column_type'), $);
                            }
                        });
                    },
                    'submitAction': function () {
                        var cols_selected = [];
                        if (Droptables.type !== 'mysql') {
                            this.find('tbody tr').each(function () {
                                var i = $(this).data('col');
                                var that = $(this).find('.droptable_select_box_before');
                                if (that.data('value') !== '') {
                                    if (that.data('value') != Droptables.style.table.col_types[i]) {
                                        cols_selected[i] = that.data('value');
                                    }
                                    Droptables.style.table.col_types[i] = that.data('value');
                                }
                            });

                            if (cols_selected.length > 0) {
                                saveData.push({
                                    action: 'set_columns_types',
                                    value: cols_selected
                                });
                            }
                            tableFunction.cleanHandsontable();
                            tableFunction.saveChanges(true);
                        }
                        this.siblings('.colose_popup').trigger('click');

                        return true;
                    },
                    'cancelAction': function () {
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'responsive_menu':
                tableFunction.default_sortable(window.Droptables.datas);
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#responsive_table'),
                    'selector': {
                        'responsive_type': '#responsive_type',
                        'table_breakpoint': '.table_breakpoint',
                        'table_height': '.table_height',
                        'freeze_col': '#freeze_col',
                        'responsive_col': '#responsive_col',
                        'style_repeated': '#style_repeated',
                        'responsive_priority': '#responsive_priority'
                    },
                    'option': {
                        'responsive_type': Droptables.style.table.responsive_type,
                        'freeze_col': Droptables.style.table.freeze_col,
                        'table_height': Droptables.style.table.table_height,
                        'style_repeated': Droptables.style.table.style_repeated,
                        'table_breakpoint': Droptables.style.table.table_breakpoint,
                    },
                    'showAction': function () {
                        tableFunction.updateParamFromStyleObjectSelectBox(popup.option, 'responsive_type', this.find('#responsive_type').next('.droptable_select_box'), 'scroll');
                        custom_select_box.call(this.find('#responsive_type'), $);

                        tableFunction.updateParamFromStyleObjectSelectBox(popup.option, 'freeze_col', this.find('#freeze_col').next('.droptable_select_box'), '0');
                        custom_select_box.call(this.find('#freeze_col'), $);

                        tableFunction.updateParamFromStyleObjectSelectBox(popup.option, 'style_repeated', this.find('#style_repeated').next('.droptable_select_box'), '0');
                        custom_select_box.call(this.find('#style_repeated'), $);

                        tableFunction.updateParamFromStyleObject(popup.option, 'table_height', this.find('.table_height'), '0');
                        tableFunction.updateParamFromStyleObject(popup.option, 'table_breakpoint', this.find('.table_breakpoint'), '980');

                        this.find('table tr .responsive_priority').each(function () {
                            custom_select_box.call($(this), $);
                        });

                        popup.inputAction.call(this, 'responsive_type');
                        check_saving = false;
                    },
                    'submitAction': function () {
                        Droptables.style.table.responsive_type = this.find('#responsive_type').data('value');
                        Droptables.style.table.freeze_col = this.find("#freeze_col").data('value');
                        Droptables.style.table.style_repeated = this.find("#style_repeated").data('value');
                        Droptables.style.table.table_height = popup.option.table_height;
                        Droptables.style.table.table_breakpoint = popup.option.table_breakpoint;
                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    },
                    'inputAction': function (selector) {
                        if (selector === 'responsive_type') {
                            if (popup.option.responsive_type === 'scroll') {
                                this.find('.hiding').hide();
                                this.find('.repeatedHeader').hide();
                                this.find('.scrolling').show();
                            }

                            if (popup.option.responsive_type === 'repeatedHeader') {
                                this.find('.hiding').hide();
                                this.find('.scrolling').hide();
                                this.find('.repeatedHeader').show();
                                $(Droptables_element.tableContainer).handsontable('updateSettings', {
                                    manualColumnFreeze: false,
                                    fixedColumnsLeft: 0
                                });
                            }

                            if (popup.option.responsive_type === 'hideCols') {
                                this.find('.hiding').show();
                                this.find('.scrolling').hide();
                                this.find('.repeatedHeader').hide();

                                tableFunction.responsive_col.call(this.find('#responsive_col'), Droptables);
                            }
                        }

                        //scrolling
                        if (selector === 'freeze_col') {
                            if (parseInt(popup.option.freeze_col) === 0) {
                                $(Droptables_element.tableContainer).handsontable('updateSettings', {
                                    manualColumnFreeze: false,
                                    fixedColumnsLeft: 0
                                });
                            } else {
                                $(Droptables_element.tableContainer).handsontable('updateSettings', {
                                    manualColumnFreeze: true,
                                    fixedColumnsLeft: popup.option.freeze_col
                                });
                            }
                        }

                        for (var i = 0; i < tableFunction.droptablesCheckSize(Droptables.style.cols); i++) {
                            if(typeof Droptables.style.cols[i] !== 'undefined' && Droptables.style.cols[i] !== null) {
                                var col_priority = typeof Droptables.style.cols[i][1].res_priority !== 'undefined' ? Droptables.style.cols[i][1].res_priority: 0;
                                if (typeof col_priority !== 'undefined') {
                                    var curr_col = Droptables_element.droptable_popup.find('table tbody tr').eq(i);
                                    curr_col.find('.responsive_priority').text(col_priority).data('value', col_priority);
                                }
                            }
                        }
                        $('.responsive_priority').unbind('change').on('change', (e) => {
                            var col = $(e.target).closest('tr').data('col');

                            if (typeof Droptables.style.cols[col] !== 'undefined' && Droptables.style.cols[col] !== null && $(e.target).val() !== Droptables.style.cols[col].res_priority) {
                                check_saving = true;
                            }
                            Droptables.style.cols = tableFunction.fillArray(Droptables.style.cols, {res_priority: $(e.target).data('value')}, col);
                        });
                        setTimeout(() => {
                            if ($(this).parent().height() < $(this).height()) {
                                $(this).parent().addClass('droptables_scroll');
                            } else {
                                $(this).parent().removeClass('droptables_scroll');
                            }
                        }, 200);
                    },
                    'cancelAction': function () {
                        for (var key in popup.option) {
                            if (popup.option[key] !== Droptables.style.table[key]) {
                                check_saving = false;
                                break;
                            }
                        }
                        if (check_saving) {
                            Droptables.style.table = $.extend({}, Droptables.style.table, popup.option), tableFunction.saveChanges();
                        }
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'pagination_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#pagination_table'),
                    'showAction': function () {
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'enable_pagination', this.find('#enable_pagination'), '0');

                        tableFunction.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'limit_rows', this.find('#limit_rows').next('.droptable_select_box'), 0);
                        custom_select_box.call(this.find('#limit_rows'), $);

                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.limit_rows = this.find('#limit_rows').data('value');
                        Droptables.style.table.enable_pagination = this.find("#enable_pagination").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.enable_pagination == 1) {
                            Droptables_element.primary_toolbars.find('.pagination_menu').parent().addClass('selected');
                        } else {
                            Droptables_element.primary_toolbars.find('.pagination_menu').parent().removeClass('selected');
                        }
                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'date_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#date_menu'),
                    'inputEnter': true,
                    'render': true,
                    'showAction': function () {
                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'date_formats', this.find('#date_format'), '');

                        this.find('.select_date_format li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var date_format = $(e.currentTarget).addClass('active').data('value');
                            if (typeof date_format !== 'undefined' && date_format !== '') {
                                this.find('#date_format').val(date_format);
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (this.find('#date_format').val() !== '') {
                            Droptables.style.table.date_formats = this.find('#date_format').val();
                            function_data.date_formats_momentjs = tableFunction.momentjsFormat(Droptables.style.table.date_formats);
                        }

                        function_data = tableFunction.createRegExpFormat(function_data, false, Droptables.style.table.date_formats);
                        table_function_data.needSaveAfterRender = true;
                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'date_menu_cell':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#date_menu_cell'),
                    'inputEnter': true,
                    'render': true,
                    'showAction': function () {
                        this.find('#popup_done').val(Joomla.JText._('COM_DROPTABLES_APPLY', 'Apply'));
                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'date_formats', this.find('#date_format'), '');

                        this.find('.select_date_format li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var date_format = $(e.currentTarget).addClass('active').data('value');
                            if (typeof date_format !== 'undefined' && date_format !== '') {
                                this.find('.date_formats').val(date_format);
                            }
                        });

                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('.date_formats').val() !== 'undefined') {
                            tableFunction.getFillArray(selection, Droptables, {
                                date_formats: this.find('.date_formats').val(),
                                // use_format: this.find("#use_format").is(":checked") ? 1 : 0,
                                date_formats_momentjs: tableFunction.momentjsFormat(this.find('.date_formats').val())});
                        }

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'lock_ranger_cells':
                if (!Droptables.check_super_user) {
                    break;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#lock_ranger_cells'),
                    'inputEnter': true,
                    'render': true,
                    'current_rangers': null,
                    'current_rangers_user': null,
                    'showAction': function () {
                        this.find('#jform_role_can_edit_lock').next('.droptable_select_box').prepend(this.find('#jform_role_can_edit_lock').next('.droptable_select_box').find('.root'));
                        var current_rangers_user_default = this.find('.droptable_select_box').find('li:first').data('value');
                        custom_select_box.call(this.find('#jform_role_can_edit_lock'), $, null, true);
                        tableFunction.updateParamFromStyleObjectSelectBox('', 0, this.find('#jform_role_can_edit_lock').next('.droptable_select_box'),  current_rangers_user_default, null, true);

                        // wptm_element.wptm_popup.find('.content .control-group:first').after(window.wptm_element.content_popup_hide.find('#select_cells').clone());
                        var function_data = window.table_function_data;
                        if (typeof function_data.selection !== 'undefined' && function_data.selection[0] !== undefined && tableFunction.droptablesCheckSize(function_data.selection[0]) > 0) {
                            var selection = function_data.selection[0];
                            if (selection[0] == 0 && selection[2] == Droptables.max_row - 1) {
                                tableFunction.getSelectedVal([false, selection[1], false, selection[3]], this.find('.cellRangeLabelAlternate'));
                            } else {
                                if (selection[1] == 0 && selection[3] == Droptables.max_Col - 1) {
                                    tableFunction.getSelectedVal([selection[0], false, selection[2], false], this.find('.cellRangeLabelAlternate'));
                                } else {
                                    tableFunction.getSelectedVal(selection, this.find('.cellRangeLabelAlternate'));
                                }
                            }
                        }

                        this.find('#get_select_cells').val(Joomla.JText._('COM_DROPTABLES_TABLES_SAVE_RANGE', 'Save range'));

                        var current_ranger = null;
                        if (typeof Droptables.style.table.lock_ranger_cells !== 'undefined') {
                            $.each(Droptables.style.table.lock_ranger_cells, (i, v) => {
                                if (v !== '') {
                                    var $lock_ranger_cell = this.find('.select_lock_ranger_cells').find('.droptable_hiden').clone();
                                    $lock_ranger_cell.removeClass('droptable_hiden');
                                    $lock_ranger_cell.attr('data-value', v).find('.label_text').text(v);
                                    this.find('.select_lock_ranger_cells').append($lock_ranger_cell);
                                }
                            });
                        } else {
                            Droptables.style.table.lock_ranger_cells = [];
                        }
                        if (typeof Droptables.style.table.lock_ranger_cells_user == 'undefined') {
                            Droptables.style.table.lock_ranger_cells_user = [];
                        }
                        popup.current_rangers = jquery.extend([], Droptables.style.table.lock_ranger_cells);
                        popup.current_rangers_user = jquery.extend([], Droptables.style.table.lock_ranger_cells_user);

                        this.find('.cellRangeLabelAlternate').unbind('keyup').on('click', function (e) {
                            e.preventDefault();
                            return false;
                        });
                        var select_ranger = () => {
                            //select
                            this.find('.select_lock_ranger_cells').find('.nfd-format-pill:not(.droptable_hiden)').unbind('click').on('click', (e) => {
                                if (!$(e.target).hasClass('delete_range')) {
                                    $(e.currentTarget).siblings('.nfd-format-pill.active').removeClass('active');
                                    current_ranger = popup.current_rangers.indexOf($(e.currentTarget).find('.label_text').text());
                                    this.find('.cellRangeLabelAlternate').val(popup.current_rangers[current_ranger]);
                                    alternating.affterRangeLabe.call(this, window.Droptables, window.jquery);
                                    $(e.currentTarget).addClass('active');
                                    // jform_role_can_edit_lock
                                    tableFunction.updateParamFromStyleObjectSelectBox(popup.current_rangers_user, current_ranger, this.find('#jform_role_can_edit_lock').next('.droptable_select_box'), current_rangers_user_default, null, true);

                                    // this.find('#popup_done').addClass('not_active');
                                }
                            });

                            //delete
                            this.find('.select_lock_ranger_cells').find('.nfd-format-pill:not(.droptable_hiden) .delete_range').unbind('click').on('click', (e) => {
                                e.preventDefault();
                                var $li = $(e.currentTarget).parents('.nfd-format-pill');
                                current_ranger = popup.current_rangers.indexOf($li.data('value'));

                                if ($li.hasClass('active')) {
                                    $li.removeClass('active');
                                    this.find('.cellRangeLabelAlternate').val('');
                                }
                                $li.remove();

                                popup.current_rangers.splice(current_ranger, 1);
                                popup.current_rangers_user.splice(current_ranger, 1);
                                tableFunction.updateParamFromStyleObjectSelectBox('', current_ranger, this.find('#jform_role_can_edit_lock').next('.droptable_select_box'),  current_rangers_user_default, null, true);

                                // this.find('#popup_done').removeClass('not_active');
                            });
                        }

                        //apply
                        this.find('#get_select_cells').unbind('click').on('click', () => {
                            alternating.affterRangeLabe.call(this, window.Droptables, window.jquery);
                            var ranger = this.find('.cellRangeLabelAlternate').val();

                            if (ranger !== '') {
                                var value = ranger.replace(/[ ]+/g, "").toUpperCase();
                                var arrayRange = value.split(":");
                                if (arrayRange.length < 2) {
                                    ranger += ':' + ranger;
                                } else if (arrayRange.length > 2) {
                                    return false;
                                }
                                var data_role_can_edit_lock = this.find('#jform_role_can_edit_lock').data('value');
                                if (current_ranger == null) {//new
                                    this.find('.nfd-format-pill.active').removeClass('active');
                                    var $lock_ranger_cell1 = this.find('.select_lock_ranger_cells').find('.droptable_hiden').clone();
                                    $lock_ranger_cell1.removeClass('droptable_hiden').addClass('active');
                                    $lock_ranger_cell1.attr('data-value', ranger).find('.label_text').text(ranger);
                                    this.find('.select_lock_ranger_cells').append($lock_ranger_cell1);
                                    popup.current_rangers.push(ranger);
                                    popup.current_rangers_user.push(data_role_can_edit_lock === '' ? current_rangers_user_default : data_role_can_edit_lock);
                                } else {
                                    this.find('.select_lock_ranger_cells').find('.nfd-format-pill.active').attr('data-value', ranger).find('.label_text').text(ranger);
                                    popup.current_rangers[current_ranger] = ranger;
                                    popup.current_rangers_user[current_ranger] = data_role_can_edit_lock === '' ? current_rangers_user_default : data_role_can_edit_lock;
                                }
                            }
                            // this.find('#popup_done').removeClass('not_active');

                            this.find('.cellRangeLabelAlternate').val('');
                            this.find('.nfd-format-pill.active').removeClass('active');
                            current_ranger = null;
                            select_ranger();
                        });

                        select_ranger();

                        return true;
                    },
                    'submitAction': function () {
                        this.find('#get_select_cells').trigger('click');
                        setTimeout( () => {
                            Droptables.style.table.lock_ranger_cells = jquery.extend([], popup.current_rangers);
                            Droptables.style.table.lock_ranger_cells_user = jquery.extend([], popup.current_rangers_user);
                            this.siblings('.colose_popup').trigger('click');
                            tableFunction.saveChanges(true);
                        }, 200);
                        return true;
                    },
                    'cancelAction': function () {
                        Droptables.style.table.lock_ranger_cells = jquery.extend([], popup.current_rangers);
                        Droptables.style.table.lock_ranger_cells_user = jquery.extend([], popup.current_rangers_user);
                        tableFunction.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, false);
                break;
            case 'curency_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#curency_menu'),
                    'render': true,
                    'inputEnter': true,
                    'selector': {
                        'symbol_position': '#symbol_position'
                    },
                    'option': {
                        'symbol_position': Droptables.style.table.symbol_position
                    },
                    'showAction': function () {
                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'currency_symbol', this.find('#currency_symbol'), '');
                        tableFunction.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'symbol_position', this.find('#symbol_position').next('.droptable_select_box'), '');
                        custom_select_box.call(this.find('#symbol_position'), $);

                        this.find('.select_curency_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var currency_symbol = $(e.currentTarget).addClass('active').data('currency_sym');
                            if (typeof currency_symbol !== 'undefined' && currency_symbol !== '') {
                                this.find('#currency_symbol').val(currency_symbol);
                            }

                            var symbol_position = $(e.currentTarget).data('symbol_position');
                            if (typeof symbol_position !== 'undefined' && symbol_position !== '') {
                                this.find('#symbol_position').data('value', symbol_position).text(symbol_position == 1 ? 'After': 'Before').change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (this.find('#currency_symbol').val() !== '') {
                            Droptables.style.table.currency_symbol = this.find('#currency_symbol').val();
                        }
                        function_data = tableFunction.createRegExpFormat(function_data, Droptables.style.table.currency_symbol, false);

                        Droptables.style.table = $.extend({}, Droptables.style.table, popup.option);
                        table_function_data.needSaveAfterRender = true;
                        // tableFunction.setFormat_accounting();

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'curency_menu_cell':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#curency_menu_cell'),
                    'render': true,
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('#popup_done').val(Joomla.JText._('COM_DROPTABLES_APPLY', 'Apply'));
                        custom_select_box.call(this.find('.symbol_position'), $);

                        this.find('.select_curency_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var currency_symbol = $(e.currentTarget).addClass('active').data('currency_sym');
                            if (typeof currency_symbol !== 'undefined' && currency_symbol !== '' && currency_symbol !== false) {
                                this.find('.currency_symbol').val(currency_symbol);
                            }

                            var symbol_position = $(e.currentTarget).data('symbol_position');
                            if (typeof symbol_position !== 'undefined' && symbol_position !== '' && symbol_position !== false) {
                                this.find('.symbol_position').data('value', symbol_position).text(symbol_position == 1 ? 'After': 'Before').change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('.currency_symbol').val() !== 'undefined') {
                            tableFunction.getFillArray(selection, Droptables, {currency_symbol: this.find('.currency_symbol').val(),currency_symbol_second: null});
                        }

                        if (typeof this.find('.symbol_position').data('value') !== 'undefined' && this.find('.symbol_position').data('value') !== '') {
                            tableFunction.getFillArray(selection, Droptables, {symbol_position: this.find('.symbol_position').data('value'), symbol_position_second: null});
                        }

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'decimal_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#decimal_menu'),
                    'render': true,
                    'inputEnter': true,
                    'showAction': function () {
                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'thousand_symbol', this.find('#thousand_symbol'), '');
                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'decimal_symbol', this.find('#decimal_symbol'), '');
                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'decimal_count', this.find('#decimal_count'), '');
                        this.find('.select_decimal_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var thousand_symbol = $(e.currentTarget).addClass('active').data('thousand_symbol');
                            if (typeof thousand_symbol !== 'undefined') {
                                this.find('#thousand_symbol').val(thousand_symbol).change();
                            }

                            var decimal_symbol = $(e.currentTarget).data('decimal_symbol');
                            if (typeof decimal_symbol !== 'undefined') {
                                this.find('#decimal_symbol').val(decimal_symbol).change();
                            }

                            var decimal_count = $(e.currentTarget).data('decimal_count');
                            if (typeof decimal_count !== 'undefined' && decimal_count !== '') {
                                this.find('#decimal_count').val(decimal_count).change();
                            } else {
                                this.find('#decimal_count').val(0).change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('#decimal_symbol').val() !== 'undefined') {
                            Droptables.style.table.decimal_symbol = this.find('#decimal_symbol').val();
                        }
                        if (typeof this.find('#decimal_count').val() !== 'undefined') {
                            Droptables.style.table.decimal_count = this.find('#decimal_count').val() == '' ? 0: this.find('#decimal_count').val();
                        }
                        if (typeof this.find('#thousand_symbol').val() !== 'undefined') {
                            Droptables.style.table.thousand_symbol = this.find('#thousand_symbol').val();
                        }
                        table_function_data.needSaveAfterRender = true;
                        // tableFunction.setFormat_accounting();

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'decimal_menu_cell':
                if (Droptables.type === 'mysql') {
                    return true;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#decimal_menu_cell'),
                    'render': true,
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('#popup_done').val(Joomla.JText._('COM_DROPTABLES_APPLY', 'Apply'));
                        this.find('.select_decimal_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var thousand_symbol = $(e.currentTarget).addClass('active').data('thousand_symbol');
                            if (typeof thousand_symbol !== 'undefined' && thousand_symbol !== false) {
                                this.find('.thousand_symbol').val(thousand_symbol).change();
                            }

                            var decimal_symbol = $(e.currentTarget).data('decimal_symbol');
                            if (typeof decimal_symbol !== 'undefined' && decimal_symbol !== false) {
                                this.find('.decimal_symbol').val(decimal_symbol).change();
                            }

                            var decimal_count = $(e.currentTarget).data('decimal_count');
                            if (typeof decimal_count !== 'undefined' && decimal_count !== '' && decimal_count !== false) {
                                this.find('.decimal_count').val(decimal_count).change();
                            } else {
                                this.find('.decimal_count').val(0).change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('.decimal_symbol').val() !== 'undefined') {
                            tableFunction.getFillArray(selection, Droptables, {decimal_symbol: this.find('.decimal_symbol').val(), decimal_symbol_second: null});
                        }
                        if (typeof this.find('.decimal_count').val() !== 'undefined') {
                            tableFunction.getFillArray(selection, Droptables, {decimal_count: this.find('.decimal_count').val() == '' ? 0: this.find('.decimal_count').val(), decimal_count_second: null});
                        }
                        if (typeof this.find('.thousand_symbol').val() !== 'undefined') {
                            tableFunction.getFillArray(selection, Droptables, {thousand_symbol: this.find('.thousand_symbol').val(), thousand_symbol_second: null});
                        }

                        this.siblings('.colose_popup').trigger('click');
                        tableFunction.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'google_sheets_menu':
                if (Droptables.type == 'mysql') {
                    return false;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#google_sheets_menu'),
                    'showAction': function () {
                        this.find('#fetch_browse').hide();
                        this.find('#jform_excel_url-lbl').hide();
                        this.find('#import_style').parent().hide();
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'auto_sync', this.find('#auto_sync'), '0');
                        // tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'download_button', this.find('#download_button'), '0');
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'spreadsheet_style', this.find('#spreadsheet_style'), '0');
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'auto_push', this.find('#auto_push'), '0');

                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'spreadsheet_url', this.find('#spreadsheet_url'), '');
                        check_saving = 0;

                        this.find('#fetch_google').unbind('click').on('click', (e) => {
                            Droptables.style.table.spreadsheet_url = this.find("#spreadsheet_url").val();
                            if (Droptables.style.table.spreadsheet_url === '' || Droptables.style.table.spreadsheet_url === undefined) {
                                return false;
                            }

                            Droptables.style.table.spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;
                            Droptables.style.table.auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                            if (Droptables.style.table.auto_sync === 1) {
                                Droptables.style.table.excel_auto_sync = 0;
                            }

                            Droptables.style.table.auto_push = this.find("#auto_push").is(":checked") ? 1 : 0;

                            // Droptables.style.table.download_button = this.find("#download_button").is(":checked") ? 1 : 0;

                            var data = {'type': 'spreadsheet'};
                            table_function_data.fetch_data = data;

                            tableFunction.saveChanges(true);
                            return true;
                        });
                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.spreadsheet_url = this.find("#spreadsheet_url").val();

                        Droptables.style.table.spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;

                        Droptables.style.table.auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.auto_sync === 1) {
                            Droptables.style.table.excel_auto_sync = 0;
                        }

                        Droptables.style.table.auto_push = this.find("#auto_push").is(":checked") ? 1 : 0;

                        // Droptables.style.table.download_button = this.find("#download_button").is(":checked") ? 1 : 0;
                        check_saving = 1;

                        if (this.find('#google_url').val() !== '') {
                            Droptables.syn_hash = this.find('#google_url').val();
                        }

                        this.siblings('.colose_popup').trigger('click');
                        return true;
                    },
                    'cancelAction': function () {
                        if (check_saving === 1) {
                            tableFunction.saveChanges(true);
                        }
                        return true;
                    },
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'synchronization_menu':
                if (Droptables.type == 'mysql') {
                    return false;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#google_sheets_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('#google_url').parent().hide();
                        this.find('#jform_spreadsheet_url-lbl').hide();
                        // this.find("#download_button").closest('.control-group').hide();
                        this.find("#auto_push").closest('.push-notification-group').hide();

                        if (typeof default_value.enable_import_excel !== 'undefined'
                            && default_value.enable_import_excel == '1') {
                            this.find('#google_sheets_menu .control-group').eq(0).before(Droptables_element.content_popup_hide.find('#import_excel'));
                            this.find('#google_sheets_menu').addClass('excel_syn');
                        }
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'excel_auto_sync', this.find('#auto_sync'), '0');
                        tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'excel_spreadsheet_style', this.find('#spreadsheet_style'), '0');

                        tableFunction.updateParamFromStyleObject(Droptables.style.table, 'excel_url', this.find('#spreadsheet_url'), '');
                        check_saving = 0;

                        this.find('#fetch_google').unbind('click').on('click', (e) => {
                            Droptables.style.table.excel_url = this.find("#spreadsheet_url").val();
                            if (Droptables.style.table.excel_url === '' || Droptables.style.table.excel_url === undefined) {
                                return false;
                            }

                            Droptables.style.table.excel_spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;
                            Droptables.style.table.excel_auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                            if (Droptables.style.table.excel_auto_sync === 1) {
                                Droptables.style.table.auto_sync = 0;
                            }

                            var data = {'type': 'excel'};
                            table_function_data.fetch_data = data;

                            tableFunction.saveChanges(true);
                            return true;
                        });

                        custom_select_box.call(this.find('#import_style'), $);
                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.excel_auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.excel_auto_sync === 1) {
                            Droptables.style.table.auto_sync = 0;
                        }
                        Droptables.style.table.excel_spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;

                        Droptables.style.table.excel_url = this.find("#spreadsheet_url").val();

                        check_saving = 1;
                        this.siblings('.colose_popup').trigger('click');
                        return true;
                    },
                    'cancelAction': function () {
                        this.find('#import_excel').appendTo(Droptables_element.content_popup_hide);
                        if (check_saving === 1) {
                            tableFunction.saveChanges(true);
                        }
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'new_chart_menu':
                DropChart.functions.addChart();
                break;
            case 'view_chart_menu':
                if (Droptables.ChartLength > 0) {
                    Droptables_element.settingTable.find('.ajax_loading').addClass('loadding').removeClass('droptable_hiden');
                    $(this).closest('li').addClass('menu_loading');
                    tableFunction.showChartOrTable(true, jquery('#list_chart').find('.chart-menu').eq(0));
                } else {
                    var text = Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_NO_CHART_CREATE', 'No charts have been created for this table, sorry.');
                    bootbox.alert(text);
                }
                break;
            case 'editToolTip':
                var content = $('#tooltip_content').val();

                if (content !== '') {
                    Droptables_element.tableContainer.find('tbody td.current').addClass('isTooltipContent');
                } else {
                    Droptables_element.tableContainer.find('tbody td.current').removeClass('isTooltipContent');
                }

                if (typeof content !== 'undefined') {
                    var i, j;
                    var selection = table_function_data.selection[0];
                    var width = $('#tooltip_width').val();
                    for (i = selection[0]; i <= selection[2]; i++) {
                        for (j = selection[1]; j <= selection[3]; j++) {
                            if (width !== '') {
                                Droptables.style.cells = tableFunction.fillArray(Droptables.style.cells, {
                                    tooltip_content: content,
                                    tooltip_width: width
                                }, i, j);
                            } else {
                                Droptables.style.cells = tableFunction.fillArray(Droptables.style.cells, {tooltip_content: content}, i, j);
                            }
                            if (i == selection[2] && j == selection[3]) {
                                saveData.push({action: 'style', selection: table_function_data.selection, style: {
                                        tooltip_content: content,
                                        tooltip_width: width
                                    }});
                                tableFunction.saveChanges();
                            }
                        }
                    }
                }
                break;
        }

        return false;
    });

    //select option in sub-menu(first top menu)
    Droptables_element.primary_toolbars.find('.has_sub_menu ul li').on('change click', function () {
        if (!table_function_data.allowed_edit) {
            return false;
        }

        var function_data = window.table_function_data;
        Droptables = window.Droptables;
        var $ = window.jquery;
        var option_name = $(this).parents('.sub-menu').siblings('.table_option');
        switch (option_name.attr('name')) {
            case 'align_menu':
                Droptables.style.table.table_align = $(this).attr('name').toString();
                $(this).siblings('.selected').removeClass('selected');
                $(this).addClass('selected');
                break;
        }
        return true;
    });

    Droptables_element.primary_toolbars.find('.minicolors-input').unbind('change').on('change', function (e) {
        e.preventDefault();

        render = second_menu.call(this, render);
        clearTimeout(autoRender);

        autoRender = setTimeout(function () {
            if (render === true) {
                table_function_data.needSaveAfterRender = true;
                window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
            }
            render = false;
        }, 300);
    });

    Droptables_element.primary_toolbars.find('a.cell_option').unbind('click').on('click', function (e) {
        e.preventDefault();

        render = second_menu.call(this, render);
        clearTimeout(autoRender);

        autoRender = setTimeout(function () {
            if (render === true) {
                table_function_data.needSaveAfterRender = true;
                window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
            }
            render = false;
        }, 300);
    });

    Droptables_element.primary_toolbars.find('.cell_option').unbind('change').on('change', function (e) {
        e.preventDefault();

        render = second_menu.call(this, render);
        clearTimeout(autoRender);

        autoRender = setTimeout(function () {
            if (render === true) {
                table_function_data.needSaveAfterRender = true;
                window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
            }
            render = false;
        }, 300);
    });

    //select calculator function
    Droptables_element.primary_toolbars.find('.calculater_function').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (Droptables.type !== 'html') {
            return;
        }
        var $ = window.jquery;

        var selection = $.extend({}, table_function_data.selection);
        var calculater = $(this).data('calculater');

        tableFunction.change_value_cells(selection, '=' + calculater + '()');
        var CellValue = document.getElementById('CellValue');

        Droptables_element.cellValue.focus().val('=' + calculater + '()');

        if (CellValue) {
            if (typeof CellValue.setSelectionRange === 'function') {
                var x = calculater.length + 2;
                CellValue.setSelectionRange(x, x);
            }
            Droptables_element.cellValue.click();
        }
    });

    //change value cells by #CellValue
    Droptables_element.cellValue.on('keyup', function (e) {
        if (Droptables_element.cellValue.val() !== table_function_data.cellValueChange) {
            table_function_data.checkCellValueChange = table_function_data.selection;
        } else {
            table_function_data.checkCellValueChange = false;
        }

        if (e.keyCode === 13 && Droptables.type == 'html') {
            tableFunction.change_value_cells(table_function_data.selection, Droptables_element.cellValue.val());
            var $ = window.jquery;
            var selection = table_function_data.selection;
            table_function_data.checkCellValueChange = false;
            if (typeof selection[1] === 'undefined'
                && typeof selection[0][2] !== 'undefined'
                && selection[0][0] === selection[0][2]
                && selection[0][1] === selection[0][3]) {
                if (typeof Droptables.datas[selection[0][0] + 1] === 'undefined') {
                    $(Droptables_element.tableContainer).handsontable("selectCell", 0, selection[0][1] + 1, 0, selection[0][3] + 1);
                } else {
                    $(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0] + 1, selection[0][1], selection[0][2] + 1, selection[0][3]);
                }
            }
        }

        return true;
    });
};

/**
 * Update status item in table_menu by cell seletoed
 *
 * @param $
 * @param Droptables
 * @param selection
 */
function updateOptionValTable($, Droptables, selection) {
    if (tableFunction.checkObjPropertyNested(Droptables.style, 'table')) {
        var styleTable = Droptables.style.table;
        var Droptables_element = window.Droptables_element;
        var selector;
        $.each(styleTable, function (index, value) {
            switch (index) {
                case 'enable_filters':
                    selector = Droptables_element.settingTable.find('.filters_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'download_button':
                    selector = Droptables_element.settingTable.find('.download_button_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'enable_pagination':
                    selector = Droptables_element.settingTable.find('.pagination_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'use_sortable':
                    selector = Droptables_element.settingTable.find('.sort_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'table_align':
                    if (value !== '') {
                        selector = Droptables_element.settingTable.find('.align_menu').siblings('.sub-menu').find('li[name="' + value + '"]');
                        selector.siblings('li.selected').removeClass('selected');
                        selector.addClass('selected');
                    }
                    break;
                case 'col_types':
                    if (typeof table_function_data.selection[0] !== 'undefined') {
                        var first_column_selected = table_function_data.selection[0][1];
                        if (typeof value[first_column_selected] !== 'undefined') {
                            table_function_data.type_column_selected = value[first_column_selected];
                        }
                    }
                    break;
                default:
                    break;
            }
        });
    } else {

    }
}

/**
 * Update status item in cell_menu and table_menu by cell selected
 *
 * @param $
 * @param Droptables
 * @param selection Cell selected
 *
 * @returns {boolean}
 */
var loadSelection = function ($, Droptables, selection) {
    selection = getSelector();
    if (!selection) {
        return true;
    }
    //show value cell to #CellValue when selector a cell
    var size_selection = table_function_data.selectionSize - 1;
    if (selection[size_selection][0] === selection[size_selection][2] && selection[size_selection][1] === selection[size_selection][3]) {
        Droptables_element.cellValue.val(Droptables.datas[selection[size_selection][0]][selection[size_selection][1]]);
        table_function_data.cellValueChange = Droptables.datas[selection[size_selection][0]][selection[size_selection][1]];
    } else {
        Droptables_element.cellValue.val('');
        table_function_data.cellValueChange = '';
    }
    table_function_data.checkCellValueChange = false;

    //set value option by selection
    updateOptionValTable($, Droptables, selection);

    updateOptionValCell($, Droptables, selection);
    //Todo: populate jform_responsive_col

    return true;
}

/**
 * add value for table_function_data.selection and table_function_data.selectionSize
 *
 * @returns {*}
 */
var getSelector = function () {
    var selection = [];
    // if (typeof selection === 'undefined' || selection === undefined || !selection) {
    selection = window.jquery(window.Droptables_element.tableContainer).handsontable('getSelected');//get all cells selected ex:[[0,0,1,9],[3,0,3,9]]
    // }
    if (typeof selection[0] !== 'undefined' && !Array.isArray(selection[0])) {
        selection = [window.jquery(window.Droptables_element.tableContainer).handsontable('getSelected')];
    }
    if (selection !== false && typeof selection !== 'undefined' && selection.length > 0) {
        //check when handsontable('getSelected') return array[0] = array;
        window.table_function_data.selectionSize = selection.length;
        for (var i = 0; i < table_function_data.selectionSize; i++) {
            if (selection[i][0] > selection[i][2]) {
                selection[i] = [selection[i][2], selection[i][3], selection[i][0], selection[i][1]];
            }
            if (selection[i][1] > selection[i][3]) {
                selection[i] = [selection[i][0], selection[i][3], selection[i][2], selection[i][1]];
            }
        }
        window.table_function_data.selection = selection;
    } else {
        window.table_function_data.selection = false;
        window.table_function_data.selectionSize = 0;
    }
    return selection;
}

/**
 * Update status item in cell_menu by cell seletoed
 *
 * @param $
 * @param Droptables
 * @param selection
 */
function updateOptionValCell($, Droptables, selection) {
    var colsStyle = Droptables.style.cols;
    var cellsStyle = Droptables.style.cells;
    var rowsStyle = Droptables.style.rows;
    var size_selection = table_function_data.selectionSize - 1;
    if (size_selection < 0) {//not cell selected
        return;
    }

    var endCell = [selection[size_selection][2], selection[size_selection][3]];
    var end_cell = selection[size_selection][2] + '!' + selection[size_selection][3];

    if (!tableFunction.checkObjPropertyNested(Droptables.style, 'cells')) {//fix when Droptables.style.cells not exist
        Droptables.style.cells = {};
    }

    window.table_function_data.selectOption = true;//if == true then not click function
    var cell_style = {};

    if (typeof colsStyle[selection[size_selection][3]] !== 'undefined') {
        cell_style = $.extend({}, colsStyle[selection[size_selection][3]][1]);
    }
    if (typeof rowsStyle[selection[size_selection][2]] !== 'undefined') {
        cell_style = $.extend({}, cell_style, rowsStyle[selection[size_selection][2]][1]);
    }

    if (tableFunction.checkObjPropertyNested(Droptables.style, 'cells', end_cell, 2)) {
        if (tableFunction.checkObjPropertyNestedNotEmpty(cellsStyle[end_cell][2], 'tooltip_content')) {
            cell_style.tooltip_content = cellsStyle[end_cell][2].tooltip_content;
            cell_style.tooltip_width = cellsStyle[end_cell][2].tooltip_width;
        }
        if ((Droptables.type === 'html' || selection[size_selection][2] === 0) && typeof cellsStyle[end_cell] !== 'undefined') {
            cell_style = $.extend({}, cell_style, cellsStyle[end_cell][2]);
        }
    } else {//fix when Droptables.style.cells[endCell] not exist
        tableFunction.getFillArray(selection, Droptables, {});
    }

    if (tableFunction.checkCellsOptionsValidate(table_function_data.selection, 'cell_type', 'html')) {//hide cell formats
        Droptables_element.settingTable.find('a.date_menu_cell').parent('li').addClass('no_active');
        Droptables_element.settingTable.find('a.curency_menu_cell').parent('li').addClass('no_active');
        Droptables_element.settingTable.find('a.decimal_menu_cell').parent('li').addClass('no_active');
    } else {
        Droptables_element.settingTable.find('a.date_menu_cell').parent('li').removeClass('no_active');
        Droptables_element.settingTable.find('a.curency_menu_cell').parent('li').removeClass('no_active');
        Droptables_element.settingTable.find('a.decimal_menu_cell').parent('li').removeClass('no_active');
    }

    tableFunction.updateParamFromStyleObject(cell_style, 'thousand_symbol', Droptables_element.content_popup_hide.find('#decimal_menu_cell').find('.thousand_symbol'), '');
    tableFunction.updateParamFromStyleObject(cell_style, 'decimal_symbol', Droptables_element.content_popup_hide.find('#decimal_menu_cell').find('.decimal_symbol'), '');
    tableFunction.updateParamFromStyleObject(cell_style, 'decimal_count', Droptables_element.content_popup_hide.find('#decimal_menu_cell').find('.decimal_count'), '');

    tableFunction.updateParamFromStyleObject(cell_style, 'currency_symbol', Droptables_element.content_popup_hide.find('#curency_menu_cell').find('.currency_symbol'), '');
    tableFunction.updateParamFromStyleObjectSelectBox(cell_style, 'symbol_position', Droptables_element.content_popup_hide.find('#curency_menu_cell').find('.symbol_position').next('.droptable_select_box'), '');

    tableFunction.updateParamFromStyleObject(cell_style, 'date_formats', Droptables_element.content_popup_hide.find('#date_menu_cell').find('.date_formats'), Droptables.style.table.date_formats);
    // tableFunction.updateSwitchButtonFromStyleObject(cell_style, 'use_format', Droptables_element.content_popup_hide.find('#date_menu_cell').find('.use_format'), 1);

    //tooltip
    var $tooltip_content = $('#tooltip_content');
    if ($tooltip_content.length > 0) {
        tableFunction.updateParamFromStyleObject(cell_style, 'tooltip_width', $('#tooltip_width'), 0);
        tableFunction.updateParamFromStyleObject(cell_style, 'tooltip_content', $('#tooltip_content'), "");
    }

    tableFunction.updateParamFromStyleObjectSelectBox(cell_style, 'cell_font_family', Droptables_element.primary_toolbars.find('#cell_font_family'), 'inherit');
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_font_size', Droptables_element.primary_toolbars.find('#cell_font_size'), 13);
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_font_bold', Droptables_element.primary_toolbars.find('#cell_format_bold'), false, function () {
        active_table_option(this);
    });

    tableFunction.updateParamFromStyleObject(cell_style, 'cell_font_underline', Droptables_element.primary_toolbars.find('#cell_format_underlined'), false,
        function () {
            active_table_option(this);
        }
    );
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_font_italic', Droptables_element.primary_toolbars.find('#cell_format_italic'), false,
        function () {
            active_table_option(this);
        }
    );
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_background_color', Droptables_element.primary_toolbars.find('#cell_background_color'), '',
        function () {
            if (typeof cell_style.cell_background_color !== "undefined") {
                var color = cell_style.cell_background_color;
                $('#cell_background_color').minicolors('value', color);
                this.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
            }
        }
    );
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_font_color', Droptables_element.primary_toolbars.find('#cell_font_color'), '',
        function () {
            var color = cell_style.cell_font_color;
            $('#cell_font_color').minicolors('value', color);
            this.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
        }
    );

    tableFunction.updateParamFromStyleObject(cell_style, 'text_wrapping', Droptables_element.primary_toolbars.find('#text_wrapping'), 'text_wrapping', function () {
        var value = (typeof cell_style.text_wrapping === 'undefined' || cell_style.text_wrapping === 'break-word')
            ? 'wrap_cell' : (cell_style.text_wrapping === 'normal' ? 'overflow_cell' : 'clip_cell');
        Droptables_element.primary_toolbars.find('a[name="overflow_cell"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="wrap_cell"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="clip_cell"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="' + value + '"]').addClass('active');
    });
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_text_align', Droptables_element.primary_toolbars.find('#cell_text_align'), 'left', function () {
        var value = typeof cell_style.cell_text_align === 'undefined' ? '' : cell_style.cell_text_align;

        Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_' + value + '"]').addClass('active');
    });
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_vertical_align', Droptables_element.primary_toolbars.find('#cell_vertical_align'), 'middle', function () {
        var value = typeof cell_style.cell_vertical_align === 'undefined' ? cell_style.cell_vertical_align = 'top' : cell_style.cell_vertical_align;

        Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="vertical_align_' + value + '"]').addClass('active');
    });
    tableFunction.updateParamFromStyleObject(cell_style, 'cell_type', Droptables_element.primary_toolbars.find('#cell_type'), '', function () {
        var value = cell_style.cell_type;
        if (typeof value === 'undefined' || value === '' || value === null) {
            Droptables_element.primary_toolbars.find('#cell_type').removeClass('active');
        } else {
            Droptables_element.primary_toolbars.find('#cell_type').addClass('active');
        }
    });
    Droptables_element.primary_toolbars.find('#cell_border').find('a').each(function () {
        $(this).removeClass('active');
    });

    var mergeCellRanger = {
        'col': selection[size_selection][1],
        'colspan': selection[size_selection][3] - selection[size_selection][1] + 1,
        'row': selection[size_selection][0],
        'rowspan': selection[size_selection][2] - selection[size_selection][0] + 1
    };
    if (Droptables.style.table.mergeSetting.some(function (mergeSetting) {
        return mergeSetting.col === mergeCellRanger.col && mergeSetting.row === mergeCellRanger.row;
    })) {
        Droptables_element.primary_toolbars.find('#merge_cell').addClass('active');
    } else {
        Droptables_element.primary_toolbars.find('#merge_cell').removeClass('active');
    }

    window.table_function_data.selectOption = false;
    //get size(height, width) end cells
    tableFunction.getSizeCells($, Droptables, endCell);
}

function active_table_option(that) {
    if (that.val() === true) {
        that.addClass('active');
    } else {
        that.removeClass('active');
    }
}

/**
 * Create custom select box
 *
 * @param $
 * @param select_function cell function when click select
 */
function custom_select_box ($, select_function, multiple) {
    $(this).on('click', function (e) {
        var $that = $(this);
        var old_value;

        $('#mybootstrap').find('.droptable_select_box').each(function () {
            $(this).hide();
            $(this).siblings('.show').removeClass('show');
        });
        var position = $(this).position();

        if ($(this).hasClass('show')) {
            $(this).next().hide();
            $(this).removeClass('show');
            $(document).unbind('click.droptable_select_box');
            return;
        }

        $that.addClass('show');
        var $select = $(this).next().css({top: position.top + 40, left: position.left, 'min-width': $that.outerWidth()}).show();

        if (multiple) {
            $select.find('li input').prop("checked", false);
            old_value = $that.data('value').split('|');
            $.each(old_value, function (i, v) {
                $select.find('li:not(.data-none)[data-value="' + v + '"]').find('input').prop("checked", true);
            })
        } else {
            old_value = $that.data('value');
        }


        $select.find('li').unbind('click').on('click', function (e) {
            var text = '', data = '';
            var li_tag = $(this);
            if (multiple) {
                if ($(e.target).is('input')) {
                    li_tag = $(e.target).parent();
                } else if(li_tag.find('input').length > 0) {
                    li_tag.find('input').prop("checked", !li_tag.find('input').is(":checked"));
                }
            }
            if (!multiple || li_tag.hasClass('data-none')) {
                text = li_tag.text();
                data = li_tag.data('value');
            } else {
                $select.find('li:not(.data-none)').each(function (i, e) {
                    if ($(e).find('input').is(":checked")) {
                        if (data !== '') {
                            text += ',' + $(e).text();
                            data += '|' + $(e).data('value');
                        } else {
                            text += $(e).text();
                            data += $(e).data('value');
                        }
                    }
                });
            }
            $select.data('value', data).change();
            $that.val(data).text(text).data('value', data).change();

            if (typeof select_function !== 'undefined' && select_function !== null) {
                select_function.call(li_tag);
            }
            if (!multiple || li_tag.hasClass('data-none')) {
                $('#mybootstrap').find('.droptable_select_box').hide();
            }
        });

        $(document).bind('click.droptable_select_box', (e) => {
            if (!$(e.target).is($(this)) && !(!!multiple && $(e.target).parents('.droptable_select_box').length > 0)) {
                $select.hide();
                $that.removeClass('show');
                $(document).unbind('click.droptable_select_box');
            }
        });
    });
}

//event change value option in cell_menu
function second_menu(render, name) {
    if (!table_function_data.allowed_edit) {
        return false;
    }

    if (table_function_data.selectOption) {
        return false;
    }

    var Droptables = window.Droptables;
    var $ = window.jquery;
    var value;
    var parentLi = $(this).parents('.cells_option');
    var i;
    table_function_data.option_selected_mysql = '';

    var selection = $.extend({}, table_function_data.selection);

    if (Droptables.type === 'mysql') {
        for (i = 0; i < table_function_data.selectionSize; i++) {
            if (selection[i][0] + selection[i][2] !== 0) {//not cell in header
                selection[i][0] = selection[i][0] > 0 ? 1 : selection[i][0];
                selection[i][2] = Droptables.datas.length - 1;
                table_function_data.option_selected_mysql = jquery(this).attr('name');
            }
        }
    }

    if (typeof selection[0][1] === 'undefined') {
        return;
    }

    switch ($(this).attr('name')) {
        case 'undo_cell':
            if ($(this).hasClass('active')) {
                jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.undo()
                render = true;
            } else {
                tableFunction.status_noti(1, Joomla.JText._('COM_DROPTABLES_SOME_ACTION_CANT_BE_DONE', "Some actions can't be done due to the Technical Problem") + '!');
            }
            break;
        case 'redo_cell':
            if ($(this).hasClass('active')) {
                jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.redo()
                render = true;
            } else {
                tableFunction.status_noti(1, Joomla.JText._('COM_DROPTABLES_SOME_ACTION_CANT_BE_DONE', "Some actions can't be done due to the Technical Problem") + '!');
            }
            break;
        case 'cell_font_family':
            tableFunction.getFillArray(selection, Droptables, {cell_font_family: $(this).data('value')});
            render = true;
            break;
        case 'cell_font_size':
            tableFunction.getFillArray(selection, Droptables, {cell_font_size: $(this).val()});
            render = true;
            break;
        case 'cell_format_bold':
            if (parentLi.find('.active').length < 1) {
                value = true;
                parentLi.find('.cell_option').addClass('active');
            } else {
                value = false;
                parentLi.find('.active').removeClass('active');
            }

            tableFunction.getFillArray(selection, Droptables, {cell_font_bold: value});
            render = true;
            break;
        case 'cell_font_underline':
            if (parentLi.find('.active').length < 1) {
                value = true;
                parentLi.find('.cell_option').addClass('active');
            } else {
                value = false;
                parentLi.find('.active').removeClass('active');
            }
            tableFunction.getFillArray(selection, Droptables, {cell_font_underline: value});
            render = true;
            break;
        case 'cell_font_italic':
            if (parentLi.find('.active').length < 1) {
                value = true;
                parentLi.find('.cell_option').addClass('active');
            } else {
                value = false;
                parentLi.find('.active').removeClass('active');
            }
            tableFunction.getFillArray(selection, Droptables, {cell_font_italic: value});
            render = true;
            break;
        case 'cell_background_color':
            value = $(this).val();
            tableFunction.getFillArray(selection, Droptables, {cell_background_color: value});
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', value);
            render = true;
            break;
        case 'cell_font_color':
            value = $(this).val();
            tableFunction.getFillArray(selection, Droptables, {cell_font_color: value});
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', value);
            render = true;
            break;
        case 'format_align_left':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_text_align: 'left'});
            render = true;
            break;
        case 'format_align_center':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_text_align: 'center'});
            render = true;
            break;
        case 'format_align_right':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_text_align: 'right'});
            render = true;
            break;
        case 'format_align_justify':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').addClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_text_align: 'justify'});
            render = true;
            break;
        case 'vertical_align_bottom':
            Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').removeClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_vertical_align: 'bottom'});
            render = true;
            break;
        case 'vertical_align_middle':
            Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').removeClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_vertical_align: 'middle'});
            render = true;
            break;
        case 'vertical_align_top':
            Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').addClass('active');
            tableFunction.getFillArray(selection, Droptables, {cell_vertical_align: 'top'});
            render = true;
            break;
        case 'overflow_cell':
            Droptables_element.primary_toolbars.find('#wrap_cell').removeClass('active');
            Droptables_element.primary_toolbars.find('#clip_cell').removeClass('active');
            if (Droptables_element.primary_toolbars.find('#overflow_cell').hasClass('active')) {
                Droptables_element.primary_toolbars.find('#overflow_cell').removeClass('active');
                tableFunction.getFillArray(selection, Droptables, {text_wrapping: false});
            } else {
                Droptables_element.primary_toolbars.find('#overflow_cell').addClass('active');
                tableFunction.getFillArray(selection, Droptables, {text_wrapping: "normal"});
            }

            render = true;
            break;
        case 'wrap_cell':
            Droptables_element.primary_toolbars.find('#overflow_cell').removeClass('active');
            Droptables_element.primary_toolbars.find('#clip_cell').removeClass('active');
            if (Droptables_element.primary_toolbars.find('#wrap_cell').hasClass('active')) {
                Droptables_element.primary_toolbars.find('#wrap_cell').removeClass('active');
                tableFunction.getFillArray(selection, Droptables, {text_wrapping: false});
            } else {
                Droptables_element.primary_toolbars.find('#wrap_cell').addClass('active');
                tableFunction.getFillArray(selection, Droptables, {text_wrapping: "break-word"});
            }
            render = true;
            break;
        case 'clip_cell':
            Droptables_element.primary_toolbars.find('#overflow_cell').removeClass('active');
            Droptables_element.primary_toolbars.find('#wrap_cell').removeClass('active');
            if (Droptables_element.primary_toolbars.find('#clip_cell').hasClass('active')) {
                Droptables_element.primary_toolbars.find('#clip_cell').removeClass('active');
                tableFunction.getFillArray(selection, Droptables, {text_wrapping: false});
            } else {
                Droptables_element.primary_toolbars.find('#clip_cell').addClass('active');
                tableFunction.getFillArray(selection, Droptables, {text_wrapping: "hidden"});
            }
            render = true;
            break;
        case 'padding_border':
            var popup;

            popup = {
                'html': Droptables_element.content_popup_hide.find('#padding_border'),
                'showAction': function () {
                    var size_selection = table_function_data.selectionSize - 1;
                    var cellStyle = window.Droptables.style.cells[selection[size_selection][0] + '!' + selection[size_selection][1]][2];

                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_padding_left', this.find('#jform_cell_padding_left'), 0);
                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_padding_top', this.find('#jform_cell_padding_top'), 0);
                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_padding_right', this.find('#jform_cell_padding_right'), 0);
                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_padding_bottom', this.find('#jform_cell_padding_bottom'), 0);

                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_background_radius_left_top', this.find('#jform_cell_background_radius_left_top'), 0);
                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_background_radius_right_top', this.find('#jform_cell_background_radius_right_top'), 0);
                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_background_radius_right_bottom', this.find('#jform_cell_background_radius_right_bottom'), 0);
                    tableFunction.updateParamFromStyleObject(cellStyle, 'cell_background_radius_left_bottom', this.find('#jform_cell_background_radius_left_bottom'), 0);

                    this.find('.observeChanges').unbind('change').on('change', (e) => {
                        var name = $(e.currentTarget).attr('name');
                        var value = $(e.currentTarget).val();
                        switch (name) {
                            case 'jform[jform_cell_padding_left]':
                                tableFunction.getFillArray(selection, Droptables, {cell_padding_left: value});
                                break;
                            case 'jform[jform_cell_padding_top]':
                                tableFunction.getFillArray(selection, Droptables, {cell_padding_top: value});
                                break;
                            case 'jform[jform_cell_padding_right]':
                                tableFunction.getFillArray(selection, Droptables, {cell_padding_right: value});
                                break;
                            case 'jform[jform_cell_padding_bottom]':
                                tableFunction.getFillArray(selection, Droptables, {cell_padding_bottom: value});
                                break;
                            case 'jform[jform_cell_background_radius_left_top]':
                                tableFunction.getFillArray(selection, Droptables, {cell_background_radius_left_top: value});
                                break;
                            case 'jform[jform_cell_background_radius_right_top]':
                                tableFunction.getFillArray(selection, Droptables, {cell_background_radius_right_top: value});
                                break;
                            case 'jform[jform_cell_background_radius_right_bottom]':
                                tableFunction.getFillArray(selection, Droptables, {cell_background_radius_right_bottom: value});
                                break;
                            case 'jform[jform_cell_background_radius_left_bottom]':
                                tableFunction.getFillArray(selection, Droptables, {cell_background_radius_left_bottom: value});
                                break;
                        }
                    });
                    return true;
                },
                'submitAction': function () {
                    this.siblings('.colose_popup').trigger('click');
                    tableFunction.saveChanges();
                    return true;
                },
                'cancelAction': function () {
                    window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
                    return true;
                }
            };
            droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
            break;
        case 'cell_type':
            if (Droptables.type !== 'mysql') {
                if (parentLi.find('.active').length < 1) {
                    tableFunction.getFillArray(selection, Droptables, {cell_type: 'html'}, "set_cells_type");
                    window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, 'html']);

                    parentLi.find('.cell_option').addClass('active');

                    // add cell type == text for column selected
                    var i, jj, ii;
                    var cols_selected = [];

                    for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                        for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {//column
                            cols_selected[i] = 'text';
                            if (!(typeof Droptables.style.table.col_types[i] !== 'undefined' && Droptables.style.table.col_types[i] === 'text')) {
                                tableFunction.cleanHandsontable();
                            }
                            Droptables.style.table.col_types[i] = 'text';
                            for (ii = table_function_data.selection[jj][0]; ii <= table_function_data.selection[jj][2]; ii++) {//row
                                customRenderer.render(null, window.jquery('.dtr' + ii + '.dtc' + i), ii, i, null, Droptables.datas[ii][i], false);
                            }
                        }
                    }

                    saveData.push({
                        action: 'set_columns_types',
                        value: cols_selected
                    });

                    tableFunction.saveChanges(true);
                } else {
                    tableFunction.getFillArray(selection, Droptables, {cell_type: null}, "set_cells_type");
                    window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, '']);

                    parentLi.find('.active').removeClass('active');
                }
                render = true;
            }
            break;
        case 'border_color':
            value = $(this).val();
            // tableFunction.getFillArray(selection, Droptables, {cell_font_color: value});
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', value);
            border_cell(selection, Droptables, 'color', render);
            render = true;
            break;
        case 'border_all':
            if ($(this).hasClass('active')) {
                tableFunction.getFillArray(selection, Droptables, {cell_border_left: ''});
                tableFunction.getFillArray(selection, Droptables, {cell_border_top: ''});
                tableFunction.getFillArray(selection, Droptables, {cell_border_right: ''});
                tableFunction.getFillArray(selection, Droptables, {cell_border_bottom: ''});

                $(this).removeClass('active');
            } else {
                border_cell(selection, Droptables, 'position', 'cell_border_left', 'cell_border_top', 'cell_border_right', 'cell_border_bottom');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_top':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][0], selection[i][1], selection[i][0], selection[i][3]];
            }
            var parameter;
            if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
                parameter = 'cell_border_top_start';
            } else {
                parameter = 'cell_border_top';
            }
            if ($(this).hasClass('active')) {
                var x = {};
                x[parameter] = '';
                tableFunction.getFillArray(border_selection, Droptables, x);
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', parameter);
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_bottom':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][2], selection[i][1], selection[i][2], selection[i][3]];
            }
            var parameter;
            if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
                parameter = 'cell_border_bottom_end';
            } else {
                parameter = 'cell_border_bottom';
            }
            if ($(this).hasClass('active')) {
                var x = {};
                x[parameter] = '';
                tableFunction.getFillArray(border_selection, Droptables, x);
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', parameter);
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_left':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][0], selection[i][1], selection[i][2], selection[i][1]];
            }
            if ($(this).hasClass('active')) {
                tableFunction.getFillArray(border_selection, Droptables, {cell_border_left: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_left');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_right':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][0], selection[i][3], selection[i][2], selection[i][3]];
            }
            if ($(this).hasClass('active')) {
                tableFunction.getFillArray(border_selection, Droptables, {cell_border_right: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_right');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_horizontal':
            var border_selection = {};

            for (i = 0; i < table_function_data.selectionSize; i++) {
                if (selection[i][0] === selection[i][2]) {
                    return false;
                } else {
                    border_selection[i] = [selection[i][0], selection[i][1], selection[i][2] - 1, selection[i][3]];
                }
            }

            if ($(this).hasClass('active')) {
                tableFunction.getFillArray(border_selection, Droptables, {cell_border_bottom: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_bottom');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_clear':
            tableFunction.getFillArray(selection, Droptables, {cell_border_left: ''});
            tableFunction.getFillArray(selection, Droptables, {cell_border_top: ''});
            tableFunction.getFillArray(selection, Droptables, {cell_border_right: ''});
            tableFunction.getFillArray(selection, Droptables, {cell_border_bottom: ''});

            if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
                tableFunction.getFillArray(selection, Droptables, {cell_border_top_start: ''});
                tableFunction.getFillArray(selection, Droptables, {cell_border_bottom_end: ''});
            }

            // Get cells range above selection
            var topCellsSelections = {};
            Object.keys(selection).map(function(key, index) {
                var x = selection[key][0] - 1 > 0 ? selection[key][0] - 1 : 0;
                topCellsSelections[key] = [x, selection[key][1], x, selection[key][3]];
            });
            tableFunction.getFillArray(topCellsSelections, Droptables, {cell_border_bottom: ''});

            var leftCellsSelections = {};
            var fillLeftCells = true;
            Object.keys(selection).map(function(key, index) {
                var y = selection[key][1] - 1 > 0 ? selection[key][1] - 1 : 0;
                leftCellsSelections[key] = [selection[key][0], y, selection[key][2], y];
                if (parseInt(selection[key][1]) === 0) {
                    fillLeftCells = false;
                }
            });
            if (fillLeftCells) {
                tableFunction.getFillArray(leftCellsSelections, Droptables, {cell_border_right: ''});
            }

            render = true;
            break;
        case 'border_vertical':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                if (selection[i][1] === selection[i][3]) {
                    return false;
                } else {
                    border_selection[i] = [selection[i][0], selection[i][1], selection[i][2], selection[i][3] - 1];
                }
            }

            if ($(this).hasClass('active')) {
                tableFunction.getFillArray(border_selection, Droptables, {cell_border_right: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_right');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_inner':
            var new_selection = [];
            new_selection['bottom'] = [];
            new_selection['right'] = [];
            for (i = 0; i < table_function_data.selectionSize; i++) {
                new_selection['bottom'][i] = $.extend([], selection[i]);
                new_selection['right'][i] = $.extend([], selection[i]);
                if (selection[i][1] === selection[i][3]) {
                    return false;
                } else {
                    new_selection['right'][i][3] = selection[i][3] - 1;
                }
                if (selection[i][0] === selection[i][2]) {
                    return false;
                } else {
                    new_selection['bottom'][i][2] = selection[i][2] - 1;
                }
            }
            if ($(this).hasClass('active')) {
                tableFunction.getFillArray(new_selection['right'], Droptables, {cell_border_right: ''});
                tableFunction.getFillArray(new_selection['bottom'], Droptables, {cell_border_bottom: ''});
                $(this).removeClass('active');
            } else {
                border_cell(new_selection['bottom'], Droptables, 'position', 'cell_border_bottom');
                border_cell(new_selection['right'], Droptables, 'position', 'cell_border_right');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_outer':
            var val, ij, ik;
            if ($(this).hasClass('active')) {
                $(this).removeClass('active');
                val = 'no_active';
            } else {
                $(this).addClass('active');
                val = 'active';
            }
            $.map(selection, function (v) {
                if (val === 'no_active') {
                    for (ij = v[0]; ij <= v[2]; ij++) {
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_right: ''}, ij, v[1] - 1);//before cell
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_right: ''}, ij, v[3]);
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_left: ''}, ij, v[3] + 1);//after cell
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_left: ''}, ij, v[1]);
                    }
                    for (ik = v[1]; ik <= v[3]; ik++) {
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_top: ''}, v[2] + 1, ik);
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_top: ''}, v[0], ik);
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_bottom: ''}, v[0] - 1, ik);
                        tableFunction.fillArray(Droptables.style.cells, {cell_border_bottom: ''}, v[2], ik);
                    }
                } else {
                    border_cell([[v[0], v[3], v[2], v[3]]], Droptables, 'position', 'cell_border_right');
                    border_cell([[v[0], v[1], v[2], v[1]]], Droptables, 'position', 'cell_border_left');
                    border_cell([[v[2], v[1], v[2], v[3]]], Droptables, 'position', 'cell_border_bottom');
                    border_cell([[v[0], v[1], v[0], v[3]]], Droptables, 'position', 'cell_border_top');
                }
            });

            render = true;
            break;
        case 'border_width':
            border_cell(selection, Droptables, 'border_width', render);
            render = true;
            break;
        case 'border_solid':
            $(this).siblings('.border_style.active').removeClass('active');
            $(this).addClass('active');
            border_cell(selection, Droptables, 'border_style', render);

            render = true;
            break;
        case 'border_dashed':
            $(this).siblings('.border_style.active').removeClass('active');
            $(this).addClass('active');
            border_cell(selection, Droptables, 'border_style', render);

            render = true;
            break;
        case 'border_dotted':
            $(this).siblings('.border_style.active').removeClass('active');
            $(this).addClass('active');
            border_cell(selection, Droptables, 'border_style', render);

            render = true;
            break;
        // case 'border_width_1':
        //     $(this).siblings('.border_width.active').removeClass('active');
        //     $(this).addClass('active');
        //
        //     render = true;
        //     break;
        // case 'border_width_2':
        //     $(this).siblings('.border_width.active').removeClass('active');
        //     $(this).addClass('active');
        //
        //     render = true;
        //     break;
        // case 'border_width_3':
        //     $(this).siblings('.border_width.active').removeClass('active');
        //     $(this).addClass('active');
        //
        //     render = true;
        //     break;
        case 'merge_cell':
            if (Droptables.type !== 'mysql') {
                if ((selection[0][3] - selection[0][1] + selection[0][2] - selection[0][0]) < 1) {
                    return false;
                }
                if (table_function_data.selectionSize > 1) {//if selection > 1 when not merge and select selection[0]
                    $(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][2], selection[0][3]);
                    return false;
                }
                if ($(this).hasClass('active')) {
                    $(Droptables_element.tableContainer).handsontable('getInstance').getPlugin('mergeCells').unmergeSelection();
                    $(this).removeClass('active');
                } else {
                    $(Droptables_element.tableContainer).handsontable('getInstance').getPlugin('mergeCells').mergeSelection();
                    $(this).addClass('active');
                }
            }
            break;
    }
    return render;
}

function createNewTable($) {
    if (!table_function_data.allowed_edit) {
        return false;
    }

    if (!Droptables.userOwn.create) {
        bootbox.alert(Joomla.JText._('COM_DROPTABLES_ERROR_PERMISSION_CREATE_NEW_TABLE', 'You don\'t have permission to create new tables'), 'ok');
        return false;
    }

    var id_category = Droptables.category;
    var curr_page = window.location.href;
    var cells = curr_page.split("?");

    $.ajax({
        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=table.add&id_category=" + id_category + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
        type: "POST",
        dataType: "json",
        success: function (datas) {
            if (datas.response === true) {
                var new_url = cells[0] + '?option=com_droptables&id_table=' + datas.datas.id;
                window.open(new_url);
                return true;
            } else {
                bootbox.alert(datas.response, 'Ok');
                return false;
            }
        },
        error: function (jqxhr, textStatus, error) {
            bootbox.alert(textStatus + " : " + error, 'Ok');
            return false;
        }
    });
}

/**
 * Convert border value for cell
 *
 * @param selection Selected cells
 * @param Droptables
 */
function border_cell(selection, Droptables) {
    var border_color = Droptables_element.primary_toolbars.find('#border_color').val();
    if (typeof border_color === 'undefined' || border_color === '') {
        border_color = 'rgba(214, 214, 214, 1)';
    }

    var cell_border_style = 'solid';
    switch (Droptables_element.primary_toolbars.find('#cell_border_style a.border_style.active').attr('name')) {
        case 'border_solid':
            cell_border_style = 'solid';
            break;
        case 'border_dashed':
            cell_border_style = 'dashed';
            break;
        case 'border_dotted':
            cell_border_style = 'dotted';
            break;
    }

    var width = '1';
    var cell_border_width = Droptables_element.primary_toolbars.find('#cell_border_width').val();
    width = cell_border_width !== '' ? cell_border_width : '1';
    var position = [];
    if (arguments[2] !== 'position') {
        position = Droptables_element.primary_toolbars.find('#cell_border > div > a.cell_option.active').each(function () {
            second_menu.call(jquery(this), arguments[3], 're_active');
        });
        return false;
    } else {
        position = Array.prototype.slice.call(arguments, 3);
    }

    position.map(function (foo) {
        var value = {};
        value[foo] = '' + width + 'px ' + cell_border_style + ' ' + border_color;
        switch (foo) {
            case 'cell_border_top':
                // Get cells range above selection
                var topCellsSelections = {};
                var topCellsSelections2;
                tableFunction.getFillArray(selection, Droptables, value);
                Object.keys(selection).map(function(key, index) {
                    if (selection[key][0] > 0) {
                        var x = selection[key][0] - 1;
                        topCellsSelections[key] = [x, selection[key][1], x, selection[key][3]];
                    }
                    if (selection[key][0] <= Droptables.headerOption && selection[key][2] >= Droptables.headerOption) {
                        topCellsSelections2 = {};
                        topCellsSelections2[key] = [Droptables.headerOption, selection[key][1], Droptables.headerOption, selection[key][3]];
                        tableFunction.getFillArray(topCellsSelections2, Droptables, {'cell_border_top': ''});
                    }
                });
                if (typeof topCellsSelections[0] !== 'undefined') {
                    tableFunction.getFillArray(topCellsSelections, Droptables, {cell_border_bottom: '' + width + 'px ' + cell_border_style + ' ' + border_color});
                }
                break;
            case 'cell_border_left':
                // Get cells range left selection
                var leftCellsSelections = {};
                var fillLeftCells = true;
                Object.keys(selection).map(function(key, index) {
                    var y = selection[key][1] - 1 > 0 ? selection[key][1] - 1 : 0;
                    if (parseInt(selection[key][1]) === 0) {
                        fillLeftCells = false;
                    }
                    leftCellsSelections[key] = [selection[key][0], y, selection[key][2], y];
                });
                if (fillLeftCells) {
                    tableFunction.getFillArray(leftCellsSelections, Droptables, {cell_border_right: '' + width + 'px ' + cell_border_style + ' ' + border_color});
                }
                tableFunction.getFillArray(selection, Droptables, value);
                break;
            default:
                tableFunction.getFillArray(selection, Droptables, value);
                break;
        }
    });
}

function set_height_popup() {

}

/*
popup and action for this
droptables_popup     #droptables_popup
popup          object data popup
clone          check clone content in popup
selector_cells get selector cells to popup window
submit_button  get submit button to popup window
arguments[5]   updateOptionValCell
*/
function droptables_popup(update_option_cell, droptables_popup, popup, clone, selector_cells, submit_button) {
    if (update_option_cell === true) {
        var selection = getSelector();
        updateOptionValCell(jquery, Droptables, selection);
    }

    droptables_popup.find('.content').contents().remove();
    var over_popup = droptables_popup.siblings('#over_popup');
    var that;
    if (!clone) {
        that = droptables_popup.find('.content').append(popup.html);
    } else {
        that = droptables_popup.find('.content').append(popup.html.clone());
    }

    if (selector_cells === true) {
        droptables_popup.find('.content .popup_top').after(window.Droptables_element.content_popup_hide.find('#select_cells').clone());
        var function_data = window.table_function_data;
        if (typeof function_data.selection !== 'undefined' && function_data.selection[0] !== undefined && function_data.selection[0].length > 0) {
            tableFunction.getSelectedVal(function_data.selection[0], that.find('.cellRangeLabelAlternate'));
        }
    }

    if (submit_button === true) {
        that.find('>div').append(window.Droptables_element.content_popup_hide.find('#submit_button').clone());
    }
    droptables_popup.animate({'opacity': '1'}, 10);

    droptables_popup.show();
    over_popup.show();

    that.find('.tooltipster').tooltipster({
        theme: 'tooltipster-borderless',
        delay: 100,
        maxWidth: 300,
    });

    //selection cells
    that.find('#get_select_cells').unbind('click').on('click', function () {
        alternating.affterRangeLabe.call(that, window.Droptables, window.jquery);
        that.find('.cellRangeLabelAlternate').val();
    });
    that.find('.cellRangeLabelAlternate').on('keyup', function (e) {
        if (e.which == 13) {
            alternating.affterRangeLabe.call(that, window.Droptables, window.jquery);
        }
    });

    /*action when show popup*/
    if (typeof popup.showAction !== 'undefined') {
        popup.showAction.call(that);
    }

    /*action selector*/
    if (typeof popup.selector !== 'undefined') {
        var select = select_input_popup.bind(popup, that);
        select();
    }

    /*action enter input*/
    if (popup.inputEnter) {
        that.find('input').on('keyup', function (e, i) {
            if (e.keyCode === 13) {
                if (typeof popup.submitAction !== 'undefined') {
                    popup.submitAction.call(that);
                } else {
                    jquery(this).trigger('change');
                }
                droptables_popup.find('.colose_popup').trigger('click');
            }
            return true;
        });
    }

    /*click done button*/
    that.find('#popup_done').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (typeof popup.submitAction !== 'undefined') {
            popup.submitAction.call(that);
        }
        return false;
    });

    /*click cancel button*/
    that.find('#popup_cancel').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (typeof popup.cancelAction !== 'undefined') {
            droptables_popup.animate({'opacity': '0'}, 10);
            popup.cancelAction.call(that);
        }
        setTimeout(function () {
            droptables_popup.hide();
            over_popup.hide();
        }, 200);
        return false;
    });

    //action colose
    droptables_popup.find('.colose_popup').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (typeof popup.cancelAction !== 'undefined') {
            droptables_popup.animate({'opacity': '0'}, 10);
            popup.cancelAction.call(that);
        }

        if (typeof popup.render !== 'undefined' && popup.render === true) {
            window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
        }

        setTimeout(function () {
            droptables_popup.hide();
            over_popup.hide();
        }, 200);
        return false;
    });
    over_popup.unbind('click').on('click', function (e) {
        e.preventDefault();
        droptables_popup.find('.colose_popup').trigger('click');
        return false;
    });

    //set top for popup
    //droptables_popup.css('top', (over_popup.outerHeight() - droptables_popup.outerHeight()) / 2);

    return false;
}

/**
 * Selector Control function in popup
 *
 * @param that Wptm_popup.find('.content')
 */
var select_input_popup = function (that) {
    if (typeof this.selector !== 'undefined') {
        window.jquery.each(this.selector, (i, e) => {
            that.find(e).change((e) => {
                if (typeof this.option[i] !== 'undefined') {
                    this.option[i] = window.jquery(e.currentTarget).val();
                }
                if (typeof this.inputAction !== 'undefined') {
                    this.inputAction.call(that, i);
                }
            });
        });
    }
}

function change_theme(ret, id, cellsData) {
    var $ = window.jquery;

    bootbox.confirm(Joomla.JText._('COM_DROPTABLES_JS_WARNING_CHANGE_THEME', 'Warning - all data and styles will be removed & replaced on theme switch'), function (result) {
        if (result) {
            $.ajax({
                url: Droptables.ajaxurl + "index.php?option=com_droptables&view=style&format=json&id=" + id + "&id-table=" + Droptables.id
                    + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                type: 'POST',
                dataType: 'json',
                data: {}
            }).done(function (data) {
                if (typeof (data) === 'object') {
                    location.reload();
                } else {
                    bootbox.alert(data, Joomla.JText._('Ok'));
                }
                $('#droptable_popup').find('.colose_popup').trigger('click');
            });
        } else {
            $('#droptable_popup').find('.colose_popup').trigger('click');
        }
    });
}

export default {selectOption, loadSelection, updateOptionValTable, droptables_popup}