// import tableFunction from "./_functions";

/**
 * Droptable
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Droptable
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

jQuery(document).ready(function ($) {
    var $mainTabContent = $('#mainTabContent');
    var $droptable_mysql_tables = $('#droptable_mysql_tables');
    var $droptable_mysql_tables_columns = $('#droptable_mysql_tables_columns');
    var $droptable_mysql_tables_columns_title = $('#droptable_mysql_tables_columns_title');
    var $droptable_mysql_tables_columns_title_list = $('#droptable_mysql_tables_columns_title table tbody');
    var $droptable_mysql_default_ordering = $('#droptable_mysql_default_ordering');
    var $droptable_mysql_table_pagination = $('#droptable_mysql_table_pagination');
    var $droptable_mysql_number_of_rows = $('#droptable_mysql_number_of_rows');
    var $droptable_define_mysql_relations = $('.droptable_define_mysql_relations');
    var $droptable_define_mysql_conditions = $('.droptable_define_mysql_conditions');
    var $droptable_define_mysql_grouping = $('.droptable_define_mysql_grouping');
    var $droptable_previewTable = $('.droptable_previewTable');
    var $droptable_mysqlRelationBlock = $('#droptables-template-mysqlRelationBlock');
    var $droptable_lock_columns = $('.droptable_lock_columns');
    var Droptable = {};
    var first_loader = true;

    $mainTabContent.find('.step_animation').css({'display': 'grid'});
    $('#btn_previous').addClass('droptable_hiden');
    $('#btn_preview').addClass('droptable_hiden');
    $('#btn_tableCreate').addClass('droptable_hiden');
    $('#btn_tableUpdate').addClass('droptable_hiden');

    if (typeof constructedTableData.id_table !== 'undefined') {//table existed
        $mainTabContent.find('.step_animation .step_one').addClass('droptable_hiden').animate({'left': '-=100%', 'opacity': '0'}, 10);
        $mainTabContent.find('.step_animation .step_two').removeClass('droptable_hiden').animate({'opacity': '1','left': '-=100%'}, 10);
        $mainTabContent.find('.sql_table_button #btn_previous').removeClass('droptable_hiden').animate({'opacity': '1'}, 10);
        $mainTabContent.find('.sql_table_button #btn_next').addClass('droptable_hiden');
        $mainTabContent.find('.sql_table_button #btn_preview').removeClass('droptable_hiden').animate({'opacity': '1'}, 10);
        $mainTabContent.css({overflow: 'visible'});
    }

    if ($('#adminmenuwrap').length > 0) {
        $('#adminmenuwrap').addClass('smooth-scrollbar');
        var el1 = document.querySelector('#adminmenuwrap');
        SimpleScrollbar.initEl(el1);
    }

    if ($droptable_mysql_tables_columns.find('.uploader').outerHeight() > $droptable_mysql_tables_columns.outerHeight()) {
        $droptable_mysql_tables_columns.addClass('margin_left');
    }

    function droptablesCheckSize (obj) {
        var size = 0,
            key;
        for (key in obj) {
            if (obj.hasOwnProperty(key)) size++;
        }
        return size;
    };

    // Add smooth scrolling to all links
    $("a.btn-next-step").on('click', function (event) {
        // Make sure this.hash has a value before overriding default behavior
        if (this.hash !== "") {
            // Prevent default anchor click behavior
            event.preventDefault();

            // Store hash
            var hash = this.hash;

            // Using jQuery's animate() method to add smooth page scroll
            // The optional number (800) specifies the number of milliseconds it takes to scroll to the specified area
            $('html, body').animate({
                scrollTop: $(hash).offset().top
            }, 500, function () {

                // Add hash (#) to URL when done scrolling (default click behavior)
                window.location.hash = hash;
            });
        } // End if
    });

    if ($droptable_mysql_tables_columns.find('.uploader').outerHeight() > $droptable_mysql_tables_columns.outerHeight()) {
        $droptable_mysql_tables_columns.addClass('margin_left');
    }
    /**
    Select mysql table
    */
    $droptable_mysql_tables.find('.mysql_table').on('click', function () {
        var that = $(this);
        if (that.hasClass('active')) {
            that.removeClass('active');
        } else {
            that.addClass('active');
        }

        //delete customquery
        delete constructedTableData.query;
        delete constructedTableData.customquery;

        var selected_tables = {};
        $droptable_mysql_tables.find('.mysql_table.active').each(function (i) {
            selected_tables[i] = $(this).data('value');
        });
        constructedTableData.tables = selected_tables;
        jsonVar = {
            'tables': selected_tables
        };

        $.ajax({
            url: droptables_ajaxurl + "task=dbtable.changeTables",
            type: "POST",
            data: jsonVar
        }).done(function (data) {
            var result = jQuery.parseJSON(data);
            if (result.response === true) {
                var columns;
                columns = result.datas.columns;

                $droptable_mysql_tables_columns.find('.uploader').html('');
                var col;
                for (i = 0; i < columns.all_columns.length; i++) {
                    col = columns.all_columns[i];
                    $droptable_mysql_tables_columns.find('.uploader').append('<div data-value="' + col + '" class="mysql_option mysql_column">' +
                        '<span>' + col + '</span></div>');
                }
                $.each(constructedTableData.mysql_columns, function () {
                    $droptable_mysql_tables_columns.find('.uploader .mysql_option[data-value="' + this + '"]').addClass('active');
                });
                var curr_columns = [];
                $droptable_mysql_tables_columns.find('.mysql_column.active').each(function (idx, obj) {
                    curr_columns.push($(obj).data('value'));
                });
                constructedTableData.mysql_columns = curr_columns;
                render_custom_title_column();

                $droptable_define_mysql_relations.find('div.mysqlRelationsContainer > div').remove();
                $droptable_define_mysql_relations.hide();

                if ($droptable_mysql_tables_columns.find('.uploader').outerHeight() > $droptable_mysql_tables_columns.outerHeight()) {
                    $droptable_mysql_tables_columns.addClass('margin_left');
                } else {
                    $droptable_mysql_tables_columns.removeClass('margin_left');
                }

                if (droptablesCheckSize(selected_tables) > 1) {
                    var conditions_columns = {post_type_columns: []};
                    // Generate HTML block for relations constructor
                    for (var i in columns.sorted_columns) {
                        var mysql_table_block = {table: i, columns: [], other_table_columns: []};
                        for (var col_index in columns.sorted_columns[i]) {
                            conditions_columns.post_type_columns.push(columns.sorted_columns[i][col_index]);
                        }
                        for (var j in columns.sorted_columns) {
                            if (i === j) {
                                for (var k in columns.sorted_columns[i]) {
                                    mysql_table_block.columns.push(columns.sorted_columns[i][k].replace(i + '.', ''));
                                }
                                continue;
                            }
                            for (var k in columns.sorted_columns[j]) {
                                mysql_table_block.other_table_columns.push(columns.sorted_columns[j][k]);
                            }
                        }

                        var mysqlRelationBlockTemplate = $droptable_mysqlRelationBlock.html();
                        var template = Handlebars.compile(mysqlRelationBlockTemplate);
                        var relationBlockHtml = template(mysql_table_block);
                        $droptable_define_mysql_relations.find('div.mysqlRelationsContainer').append(relationBlockHtml);

                    }
                    $droptable_define_mysql_relations.show();
                    $droptable_define_mysql_conditions.find('.whereConditionColumn').each(function() {
                        var old_val = $(this).val();
                        $(this).empty();
                        for(var i in conditions_columns.post_type_columns) {
                            $(this).append('<option value="' + conditions_columns.post_type_columns[i] + '" >' + conditions_columns.post_type_columns[i] + '</option>');
                        }
                        $(this).val(old_val);
                    });
                }
                if (droptablesCheckSize(selected_tables) > 0) {
                    $('.please_select_table').hide();
                } else {
                    $('.please_select_table').show();
                    $droptable_define_mysql_conditions.find('.whereConditionColumn').each(function() {
                        $(this).empty();
                    });
                }
            } else {
                bootbox.alert(result.response);
            }
        });
    });
    $(document).on('keyup', '.search_table', function (e) {
        var key_search = $(this).val();
        search_items($('#' + $(this).data('search')).find('.mysql_option'), key_search, 'droptable_hiden', false);
    });

    /**
     * Add the selected MySQL columns to the constructed table data
     */
    $droptable_mysql_tables_columns.on('click', '.mysql_column', function () {
        //delete customquery
        delete constructedTableData.query;
        delete constructedTableData.customquery;

        var that = $(this);
        if (that.hasClass('active')) {
            that.removeClass('active');
            var index = constructedTableData.mysql_columns.indexOf($(this).data('value'));
            if (index > -1) {
                constructedTableData.mysql_columns.splice(index, 1);
            }
        } else {
            that.addClass('active');
            if (typeof constructedTableData.mysql_columns === 'undefined') {
                constructedTableData.mysql_columns = []
            }
            constructedTableData.mysql_columns.push($(this).data('value'));
        }
        render_custom_title_column();
    });
    $('.droptable_mysql_tables_columns').find('ul li:not(.border_active)').on('click', function () {
        if (!$(this).hasClass('active')) {
            var left = $(this).position().left;
            $(this).siblings('.border_active').animate({'left': left + 'px'});
        }
    })

    /**
     * Render content in set column titles and add value for that
     */
    function render_custom_title_column() {
        constructedTableData.columnCount = droptablesCheckSize(constructedTableData.mysql_columns);
        $droptable_mysql_tables_columns_title.find('.column_title').appendTo($('.custom_title_column'));
        old_default_ordering = $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_column').val();
        $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_column').empty();
        $('.droptable_define_mysql_grouping').find('.groupingRuleColumn').empty();
        if (constructedTableData.columnCount > 0) {
            for (var i = 0; i < constructedTableData.columnCount; i++) {
                column_id = constructedTableData.mysql_columns[i].replace(".", "_");
                $('.custom_title_column').find('#droptable_row_' + column_id).appendTo($droptable_mysql_tables_columns_title_list);
                if ($droptable_mysql_tables_columns_title_list.find('#droptable_column_' + column_id).length === 0) {
                    $droptable_mysql_tables_columns_title_list.append('<tr class="droptable_row column_title" id="droptable_row_' + column_id + '"><td><label>' + constructedTableData.mysql_columns[i] + ' </label></td><td><input type="text" name="" id="droptable_column_' + column_id + '" class="" value=""  /></td></tr>');
                }

                $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_column').append('<option value="' + constructedTableData.mysql_columns[i] + '" >' + constructedTableData.mysql_columns[i] + '</option>');
                $('.droptable_define_mysql_grouping').find('.groupingRuleColumn').each(function() {
                    $(this).append('<option value="' + constructedTableData.mysql_columns[i] + '" >' + constructedTableData.mysql_columns[i] + '</option>');
                });
            }

            $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_column').val(old_default_ordering);
        }
    }

    /**
     * Add a "WHERE" condition to the WP POSTS based table
     */
    $droptable_define_mysql_conditions.on('click', '#droptable_mysql_add_where_condition', function (e) {
        e.preventDefault();
        var whereBlockTemplate = $('#whereConditionTemplate').html();
        var template = Handlebars.compile(whereBlockTemplate);

        var where_block = {
            post_type_columns: $droptable_mysql_tables_columns.find('div.mysql_column').map(function () {
                return $(this).data('value');
            }).toArray()
        };
        var whereBlockHtml = template(where_block);
        $droptable_define_mysql_conditions.find('div.mysqlConditionsContainer').append(whereBlockHtml);
    });
    /**
     * Delete a "WHERE" condition
     */
    $(document).on('click', 'button.deleteConditionPosts', function (e) {
        e.preventDefault();
        e.stopImmediatePropagation();
        $(this).closest('div.post_where_blocks').remove();
    });

    /**
     * Add a grouping rule for MySQL based tables
     */
    $droptable_define_mysql_grouping.on('click', '#droptable_mysql_add_grouping_rule', function (e) {
        e.preventDefault();

        // Generate HTML block for the grouping rule constructor
        var grouping_rule_block = {post_type_columns: []};

        grouping_rule_block.post_type_columns = $droptable_mysql_tables_columns.find('div.mysql_column.active').map(function () {
            return $(this).data('value');
        }).toArray();

        var groupingRuleBlockTemplate = $('#groupingRuleTemplate').html();
        var template = Handlebars.compile(groupingRuleBlockTemplate);
        var groupingRuleHtml = template(grouping_rule_block);

        $droptable_define_mysql_grouping.find('div.mysqlGroupingContainer').append(groupingRuleHtml);
    });
    /**
     * Delete a grouping rule
     */
    $(document).on('click', 'button.deleteGroupingRulePosts', function (e) {
        e.preventDefault();
        $(this).closest('div.post_grouping_rule_blocks').remove();
    });

    /**
     * check column and table selected
     */
    function check_selected_table_and_column() {
        var flag = true;
        var number_table = $('#droptable_mysql_tables').find('.mysql_table.active');
        var number_column = $('#droptable_mysql_tables_columns').find('.mysql_column.active');
        if (number_table.length < 1) {
            flag = false;
        }
        if (number_column.length < 1) {
            flag = false;
        }
        return flag;
    }

    function set_constructed_table_data() {
        constructedTableData.join_rules = [];
        constructedTableData.where_conditions = [];
        constructedTableData.grouping_rules = [];
        /*custom title */
        constructedTableData.custom_titles = [];
        var i;
        for (i = 0; i < droptablesCheckSize(constructedTableData.mysql_columns); i++) {
            column_id = constructedTableData.mysql_columns[i].replace(".", "_");
            if ($droptable_mysql_tables_columns_title.find('#droptable_column_' + column_id).val()) {
                constructedTableData.custom_titles.push($droptable_mysql_tables_columns_title.find('#droptable_column_' + column_id).val());
            } else {
                constructedTableData.custom_titles.push(constructedTableData.mysql_columns[i]);
            }
        }

        constructedTableData.default_ordering = $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_column').val();
        constructedTableData.default_ordering_dir = $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_dir input:checked').val();
        constructedTableData.enable_pagination = $droptable_mysql_table_pagination.is(":checked") ? 1 : 0;
        constructedTableData.limit_rows = $droptable_mysql_number_of_rows.find('input:checked').val();

        /**
         * Join rules
         */
        $droptable_define_mysql_relations.find('.mysqlRelationsContainer').find('.mysql_table_blocks').each(function () {
            var join_rule = {};
            join_rule.initiator_table = $(this).find('select.relationInitiatorColumn').data('table');
            join_rule.initiator_column = $(this).find('select.relationInitiatorColumn').val();
            join_rule.connected_column = $(this).find('select.relationConnectedColumn').val();
            join_rule.type = $(this).find('select.innerjoin').val();
            constructedTableData.join_rules.push(join_rule);
        });

        /**
         * Where block
         */
        $droptable_define_mysql_conditions.find('.mysqlConditionsContainer').find('.post_where_blocks').each(function () {
            var where_condition = {};
            where_condition.column = $(this).find('select.whereConditionColumn').val();
            where_condition.operator = $(this).find('select.whereOperator').val();
            where_condition.value = $(this).find('input[type="text"]').val();
            constructedTableData.where_conditions.push(where_condition);
        });

        /**
         * Grouping rules
         */
        $droptable_define_mysql_grouping.find('.mysqlGroupingContainer').find('.post_grouping_rule_blocks select').each(function () {
            constructedTableData.grouping_rules.push($(this).val());
        });
    }

    function search_items($option, text, classText, compare) {
        $option.each(function () {
            $(this).removeClass(classText);
            if (text !== '') {
                var value = false;
                if ($(this).data('value').search(text) !== -1) {
                    value = compare ? true : false;
                } else {
                    value = compare ? false : true;
                }
                if (value) {
                    $(this).addClass(classText);
                }
            }
        });
    }

    //mysql query
    var textArea = document.getElementById("jform_custom_mysql");
    var myCssEditor;

    function setTableIndexKey() {
        $mainTabContent.find('#column_key').data('value', '');
        var $droptable_lock_columns_content;
        $droptable_lock_columns.find('.droptable_container_content').contents().remove();

        $.ajax({
            url: droptables_ajaxurl + "task=dbtable.getTableColumnsOptions",
            data: {
                tableList: typeof constructedTableData.mysql_columns !== 'undefined' && constructedTableData.mysql_columns.length > 0 ? constructedTableData.tables : {},
                query: constructedTableData.query
            },
            type: 'post',
            dataType: 'json',
            success: function (result) {
                if (result.response && result.datas !== false) {
                    $mainTabContent.find('#column_key').siblings('ul').contents('li').remove();
                    $mainTabContent.find('#column_key').siblings('ul').data('value', '');
                    $mainTabContent.find('#column_key').parent().addClass('droptable_hiden');
                    constructedTableData.column_options = $.extend({}, {});
                    constructedTableData.tables_list = $.extend({}, result.datas['table']);

                    if (typeof constructedTableData.lock_columns !== 'undefined') {
                        var lock_columns = $.extend([], constructedTableData.lock_columns);
                    }
                    constructedTableData.lock_columns = [];

                    // var prikey_in_tables = false;
                    var i = 0;
                    var html, column;
                    for (column in result.datas['result']) {
                        html = '';
                        var key = result.datas['result'][column].table + '.' + result.datas['result'][column].Field;
                        var index = result.datas['column'].indexOf(key);
                        if (typeof constructedTableData.mysql_columns !== 'undefined' && !constructedTableData.mysql_columns.includes(key)) {
                            continue;
                        }

                        constructedTableData.column_options[index] = {};
                        constructedTableData.column_options[index].Extra = result.datas['result'][column].Extra;
                        constructedTableData.column_options[index].Default = result.datas['result'][column].Default;
                        constructedTableData.column_options[index].priKey = result.datas['result'][column].priKey;
                        constructedTableData.column_options[index].notNull = result.datas['result'][column].notNull;
                        constructedTableData.column_options[index].canEdit = result.datas['result'][column].canEdit;
                        constructedTableData.column_options[index].Type = result.datas['result'][column].Type;
                        constructedTableData.column_options[index].Field = result.datas['result'][column].Field;
                        constructedTableData.column_options[index].table = result.datas['result'][column].table;

                        $droptable_lock_columns_content = $droptable_lock_columns.find('.droptable_hiden').clone();
                        $droptable_lock_columns_content.attr('data-value', index);
                        $droptable_lock_columns_content.find('span').text(key);

                        if (typeof lock_columns !== 'undefined' && lock_columns[index] == 1) {
                            $droptable_lock_columns_content.find('.switch-button').prop("checked", true);
                            constructedTableData.lock_columns[index] = 1;
                        } else {
                            constructedTableData.lock_columns[index] = 0;
                        }

                        for (j = index; j >= 0; j--) {
                            if ($mainTabContent.find('.droptable_lock_columns .droptable_container_content .droptable_lock_column[data-value="' + j + '"]').length > 0) {
                                $mainTabContent.find('.droptable_lock_columns .droptable_container_content .droptable_lock_column[data-value="' + j + '"]').after($droptable_lock_columns_content.removeClass('droptable_hiden'));
                                break;
                            } else {
                                $mainTabContent.find('.droptable_lock_columns .droptable_container_content').append($droptable_lock_columns_content.removeClass('droptable_hiden'));
                            }
                        }

                        html += '<li data-value="' + key + '">' + key + '</li>';
                        if (typeof constructedTableData.priKey !== 'undefined' && key === constructedTableData.priKey) {
                            constructedTableData.priKey = key;
                            $mainTabContent.find('#column_key').data('value', constructedTableData.priKey).text(key);
                            // $mainTabContent.find('.droptable_mysql_table_editing').removeClass('droptable_hiden');
                            // prikey_in_tables = true;
                        } else if (typeof constructedTableData.priKey === 'undefined') {
                            constructedTableData.priKey = key;
                            $mainTabContent.find('#column_key').data('value', constructedTableData.priKey).text(key);
                        }
                        i++;
                        if (result.datas['result'][column].Extra === 'auto_increment' || result.datas['result'][column].priKey === true) {
                            $(html).prependTo($mainTabContent.find('#column_key').siblings('ul'));
                        } else {
                            $(html).appendTo($mainTabContent.find('#column_key').siblings('ul'));
                        }
                    }
                    // if (!prikey_in_tables) {
                    //     delete constructedTableData.priKey;
                    // }

                    custom_select_box.call($mainTabContent.find('#column_key'), $, function () {
                    //     var value_column_key = this.data('value');
                    //     if (typeof value_column_key !== 'undefined' && value_column_key !== '') {
                    //         $mainTabContent.find('.droptable_mysql_table_editing').removeClass('droptable_hiden');
                    //     }
                    });

                    if (constructedTableData.placeholder_query == 1) {
                        constructedTableData.table_editing = 0;
                    }

                    if (constructedTableData.table_editing == 1) {
                        $mainTabContent.find('#column_key').parent().removeClass('droptable_hiden');
                        $mainTabContent.find('.droptable_lock_columns').removeClass('droptable_hiden');
                    }

                    return result.datas;
                } else {
                    return false;
                }
            },
            error: function (jqxhr, textStatus, error) {
                bootbox.alert(textStatus);
            }
        })
    }

    function show_button_submit (action, params) {
        if (typeof constructedTableData.lock_columns == 'undefined') {
            constructedTableData.lock_columns = [];
        }

        $droptable_lock_columns.find('.droptable_container_content .droptable_lock_column').each(function (i, e) {
            var data = $(this).data('value');
            constructedTableData.lock_columns[data] = $(this).find('.switch-button').is(":checked") ? 1 : 0;
        });
        switch (action) {
            case 'first':
                $mainTabContent.find('.sql_table_button #btn_preview').removeClass('droptable_hiden').animate({'opacity': '1'}, 200);
                break;
            case 'next':
                first_loader = false;
                if (params !== true) {
                    if (!$mainTabContent.find('.step_animation .step_one').hasClass('droptable_hiden')) {
                        $mainTabContent.find('.step_animation .step_one').animate({'left': '-=100%', 'opacity': '0'}, 1000, function () {
                            $mainTabContent.find('.step_animation .step_two').removeClass('droptable_hiden').animate({'opacity': '1','left': '-=100%'}, 700);
                            $mainTabContent.find('.step_animation .step_one').addClass('droptable_hiden');
                        }).delay(200).animate({'opacity': '0'}, 500, function () {
                            $mainTabContent.find('.sql_table_button #btn_previous').removeClass('droptable_hiden').animate({'opacity': '1'}, 200);
                            $mainTabContent.find('.sql_table_button #btn_next').addClass('droptable_hiden');
                            $mainTabContent.find('.sql_table_button #btn_preview').removeClass('droptable_hiden').animate({'opacity': '1'}, 200);
                            $mainTabContent.css({overflow: 'visible'});
                        });
                    }
                }
                break;
            case 'btn_previous':
                $mainTabContent.css({'overflow-x': 'hidden'});
                if (typeof constructedTableData.priKey !== 'undefined') {
                    delete constructedTableData.priKey;
                }

                $mainTabContent.find('#droptable_mysql_review .droptable_previewTable').contents().remove();

                $mainTabContent.find('.step_animation .step_one').removeClass('droptable_hiden').animate({'left': '+=100%', 'opacity': '1'}, 1000, function () {
                    $mainTabContent.find('.step_animation .step_two').animate({'opacity': '0','left': '+=100%'}, 700, function () {
                        $mainTabContent.find('.step_animation .step_two').addClass('droptable_hiden');
                    });
                    $mainTabContent.find('.sql_table_button #btn_previous').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                    $mainTabContent.find('.sql_table_button #btn_preview').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                    $mainTabContent.find('.sql_table_button #btn_next').removeClass('droptable_hiden');
                    $mainTabContent.find('.sql_table_button #btn_tableUpdate').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                    $mainTabContent.find('.sql_table_button #btn_tableCreate').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                });
                break;
            case 'btn_preview':
                if (params !== null && params.response && params.datas !== false) {
                    Droptable.preview = params.datas.preview;
                    Droptable.hasRow = params.datas.hasRow;

                    constructedTableData.query = params.datas.query;
                    $droptable_previewTable.html(params.datas.preview);
                }
                if (Droptable.hasRow) {
                    $mainTabContent.find('.sql_table_button #btn_preview').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                    $mainTabContent.find('.sql_table_button #btn_tableUpdate').removeClass('droptable_hiden').animate({'opacity': '1'}, 200);
                    $mainTabContent.find('.sql_table_button #btn_tableCreate').removeClass('droptable_hiden').animate({'opacity': '1'}, 200);
                }
                break;
            case 'btn_tableCreate':
                if (params.response && params.datas !== false) {
                    constructedTableData.query = params.datas.query;
                    constructedTableData.priKey = $mainTabContent.find('#column_key').data('value');
                    constructedTableData.table_editing = $mainTabContent.find('#droptable_mysql_table_editing').is(":checked") ? 1 : 0;
                    constructedTableData.placeholder_query = $mainTabContent.find('#droptable_placeholder_query').is(":checked") ? 1 : 0;

                    if (typeof constructedTableData.priKey == 'undefined'
                        || constructedTableData.priKey === '') {
                        constructedTableData.table_editing = 0;
                    }

                    if (typeof constructedTableData.placeholder_query !== 'undefined'
                        || constructedTableData.placeholder_query === 1) {
                        constructedTableData.table_editing = 0;
                    }

                    if (constructedTableData.query.search("{user_id}") >= 0 || constructedTableData.query.search("{user_email}") >= 0 ) {
                        constructedTableData.table_editing = 0;
                        constructedTableData.placeholder_query = 1;
                    }

                    $.ajax({
                        url: droptables_ajaxurl + "task=dbtable.createTable",
                        data: {
                            table_data: constructedTableData,
                            id_cat: id_cat
                        },
                        type: 'post',
                        dataType: 'json',
                        success: function (result) {
                            if (result.response) {
                                localStorage.setItem('new_db_table', JSON.stringify(result.datas));
                                var curr_page = window.location.href.split("?");
                                var url = curr_page[0] + "?option=com_droptables&id_table=" + result.datas;
                                if (Droptables.isAdmin !== 1) {
                                    url = curr_page[0] + "?option=com_droptables&view=manage&id_table=" + result.datas;
                                }

                                if (droptables_caninsert === 1) {
                                    url += "&view=droptables&caninsert=1&tmpl=component";
                                }

                                window.location.href = url;
                            }
                        }
                    });
                }
                break;
            case 'btn_tableUpdate':
                if (params.response && params.datas !== false) {
                    constructedTableData.query = params.datas.query;
                    constructedTableData.priKey = $mainTabContent.find('#column_key').data('value');
                    constructedTableData.table_editing = $mainTabContent.find('#droptable_mysql_table_editing').is(":checked") ? 1 : 0;
                    constructedTableData.placeholder_query = $mainTabContent.find('#droptable_placeholder_query').is(":checked") ? 1 : 0;

                    if (typeof constructedTableData.priKey == 'undefined'
                        || constructedTableData.priKey === '') {
                        constructedTableData.table_editing = 0;
                    }

                    if (typeof constructedTableData.placeholder_query !== 'undefined'
                        && constructedTableData.placeholder_query == 1) {
                        constructedTableData.table_editing = 0;
                    }

                    if (constructedTableData.query.search("{user_id}") >= 0 || constructedTableData.query.search("{user_email}") >= 0 ) {
                        constructedTableData.table_editing = 0;
                        constructedTableData.placeholder_query = 1;
                    }

                    $.ajax({
                        url: droptables_ajaxurl + "task=dbtable.updateTable",
                        data: {
                            table_data: constructedTableData
                        },
                        type: 'post',
                        dataType: 'json',
                        success: function (result) {
                            if (result.response) {
                                var curr_page = window.location.href.split("?");
                                var url = curr_page[0] + "?option=com_droptables&id_table=" + constructedTableData.id_table;
                                if (Droptables.isAdmin !== 1) {
                                    url = curr_page[0] + "?option=com_droptables&view=manage&id_table=" + constructedTableData.id_table;
                                }

                                if (droptables_caninsert === 1) {
                                    url += "&view=droptables&caninsert=1&tmpl=component";
                                }

                                window.location.href = url;
                            }
                        }
                    })
                }
                break;
        }
    }

    function generateQueryAndPreviewdata (constructedTableData, action, callFunction) {
        $.ajax({
            url: droptables_ajaxurl + "task=dbtable.generateQueryAndPreviewdata",
            data: {
                table_data: constructedTableData
            },
            type: 'post',
            dataType: 'json',
            success: function (result) {
                if (callFunction !== null) {
                    callFunction.call(constructedTableData, action, result);
                } else {
                    $mainTabContent.find('#over_loadding_open_chart').hide();
                    if (result.response && result.datas !== false) {
                        constructedTableData.query = result.datas.query;
                        if (typeof Droptable == 'undefined') {
                            Droptable = {};
                        }
                        Droptable.preview = result.datas.preview;
                        Droptable.hasRow = result.datas.hasRow;
                        setTimeout(function () {
                            myCssEditor.getDoc().setValue(result.datas.query);
                            setTableIndexKey();
                        }, 1000);

                        return result.datas;
                    } else {
                        return false;
                    }
                }
            },
            error: function (jqxhr, textStatus, error) {
                $mainTabContent.find('#over_loadding_open_chart').hide();
                bootbox.alert(textStatus);
            }
        });
    }

    function applyCustomQuery (action) {
        var custom_mysql = myCssEditor.getValue();
        $mainTabContent.find('#over_loadding_open_chart').show();

        if (action === 'click') {
            $droptable_lock_columns.find('.droptable_container_content .droptable_lock_column').each(function (i, e) {
                var data = $(this).data('value');
                constructedTableData.lock_columns[data] = $(this).find('.switch-button').is(":checked") ? 1 : 0;
            });
        }

        $.ajax({
            url: droptables_ajaxurl + "task=dbtable.applyCustomQuery",
            data: {
                custom_mysql: custom_mysql
            },
            type: 'post',
            dataType: 'json',
            success: function (result) {
                if (result.response && result.datas !== false) {
                    delete Droptable.preview;
                    delete Droptable.hasRow;
                    if (result.datas.hasRow) {//Custom query pass
                        delete constructedTableData.columnCount;
                        delete constructedTableData.default_ordering;
                        delete constructedTableData.default_ordering_dir;
                        delete constructedTableData.grouping_rules;
                        delete constructedTableData.join_rules;
                        delete constructedTableData.mysql_columns;
                        delete constructedTableData.tables;
                        delete constructedTableData.where_conditions;
                        delete constructedTableData.custom_titles;

                        // delete constructedTableData.priKey;
                        constructedTableData.query = custom_mysql;
                        constructedTableData.customquery = true;

                        $droptable_mysql_tables.find('.mysql_table.active').each(function () {
                            $(this).removeClass('active');
                        })

                        $droptable_mysql_tables_columns.find('.uploader').contents().remove();
                        $droptable_mysql_default_ordering.find('#droptable_mysql_default_ordering_column').contents().remove();
                        $droptable_define_mysql_relations.find('div.mysqlRelationsContainer .mysql_table_blocks').remove();
                        $droptable_define_mysql_conditions.find('div.mysqlConditionsContainer .post_where_blocks').remove();
                        $droptable_define_mysql_grouping.find('div.mysqlGroupingContainer .post_grouping_rule_blocks').remove();

                        setTableIndexKey();
                    }

                    Droptable.preview = result.datas.preview;
                    Droptable.hasRow = result.datas.hasRow;
                    $mainTabContent.find('#over_loadding_open_chart').hide();

                    if (action === 'click') {
                        setTimeout(function () {
                            $mainTabContent.find('.sql_table_button #btn_preview').trigger('click');
                        }, 300);
                    } else {
                        $mainTabContent.find('.sql_table_button #btn_preview').removeClass('droptable_hiden').animate({'opacity': '1'}, 200);
                        $mainTabContent.find('.sql_table_button #btn_tableUpdate').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                        $mainTabContent.find('.sql_table_button #btn_tableCreate').addClass('droptable_hiden').animate({'opacity': '0'}, 200);
                    }
                    return true;
                } else {
                    $mainTabContent.find('#over_loadding_open_chart').hide();
                    bootbox.alert(result.datas.error);
                    return false;
                }
            },
            error: function (jqxhr, textStatus, error) {
                $mainTabContent.find('#over_loadding_open_chart').hide();
                bootbox.alert(jqxhr.responseText);
            }
        })
        return false;
    }

    var DroptableCreateMyCssEditor = false;
    $(document).on('click', '#btn_next', function (e) {
        if (DroptableCreateMyCssEditor === false) {
            DroptableCreateMyCssEditor = true;

            myCssEditor = CodeMirror.fromTextArea(textArea, {
                mode: 'text/x-mariadb',
                indentWithTabs: true,
                smartIndent: true,
                lineNumbers: true,
                matchBrackets : true,
                autofocus: true,
                extraKeys: {"Ctrl-Space": "autocomplete"},
                hintOptions: {tables: {
                        users: ["name", "score", "birthDate"],
                        countries: ["name", "population", "size"]
                    }}
            });
            if (window.parent) {
                ww = window.parent.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
            }

            myCssEditor.setSize(ww - 150, 350);
        }

        e.preventDefault();
        $.ajax({
            url: droptables_ajaxurl + "task=dbtable.getQuery",
            data: {
                id: constructedTableData.id_table
            },
            type: 'post',
            dataType: 'json',
            success: function (result) {
                if (result.response === true) {
                    if (result.datas !== null && typeof result.datas !== 'undefined') {
                        constructedTableData.query = result.datas.replace(/[\\]/g, '');
                    }

                    if (typeof constructedTableData.customquery !== 'undefined' && constructedTableData.customquery == 'true') {//has custom
                        myCssEditor.setValue(constructedTableData.query);
                        $(textArea).change();
                        applyCustomQuery('getQuery');
                    } else {//no custom
                        if (!check_selected_table_and_column()) {//not selected columns
                            return false;
                        }
                        set_constructed_table_data();

                        $mainTabContent.find('#over_loadding_open_chart').show();
                        generateQueryAndPreviewdata (constructedTableData, '', null);
                    }

                    if (first_loader) {
                        show_button_submit.call(constructedTableData, 'next', true);
                    } else {
                        show_button_submit.call(constructedTableData, 'next', null);
                    }
                    $mainTabContent.css({overflow: 'visible'});
                }
            },
            error: function (jqxhr, textStatus, error) {
                $mainTabContent.find('#over_loadding_open_chart').hide();
                bootbox.alert(jqxhr.responseText);
            }
        });
    });

    $(document).on('click', '#btn_preview', function (e) {
        e.preventDefault();

        if (typeof Droptable.preview !== 'undefined') {//has table html
            $droptable_previewTable.html(Droptable.preview);
            show_button_submit.call(constructedTableData, 'btn_preview', null);
        } else {//has not table html
            var selected_table = check_selected_table_and_column();
            if (!selected_table) {
                return false;
            }
            set_constructed_table_data();
            generateQueryAndPreviewdata(constructedTableData, 'btn_preview', show_button_submit);
        }

        return false;
    });

    $mainTabContent.find('.droptable_custom_mysql #btn_apply_mysql').click(function (e) {
        e.preventDefault();

        applyCustomQuery('click');
        return false;
    });

    $mainTabContent.find('#btn_previous').click(function (e) {
        e.preventDefault();

        show_button_submit.call(constructedTableData, 'btn_previous', null);
        return false;
    });

    $(document).on('click', '#btn_tableCreate', function (e) {
        e.preventDefault();
        if (constructedTableData.customquery === true) {
            // $droptable_previewTable.html(Droptable.preview);
            var result = {
                response: Droptable.hasRow,
                datas: {
                    query: constructedTableData.query,
                }
            };

            show_button_submit.call(constructedTableData, 'btn_tableCreate', result);
        } else {
            var selected_table = check_selected_table_and_column();
            if (!selected_table) {
                return false;
            }
            set_constructed_table_data();

            generateQueryAndPreviewdata(constructedTableData, 'btn_tableCreate', show_button_submit);
        }

        return false;
    });

    $(document).on('click', '#btn_tableUpdate', function (e) {
        e.preventDefault();

        if (constructedTableData.customquery === true) {
            // $droptable_previewTable.html(Droptable.preview);
            var result = {
                response: Droptable.hasRow,
                datas: {
                    query: constructedTableData.query,
                }
            };

            show_button_submit.call(constructedTableData, 'btn_tableUpdate', result);
        } else {
            var selected_table = check_selected_table_and_column();
            if (!selected_table) {
                return false;
            }

            set_constructed_table_data();

            generateQueryAndPreviewdata(constructedTableData, 'btn_tableUpdate', show_button_submit);
        }
        return false;
    });

    $mainTabContent.find('.droptable_mysql_table_editing').on('change', function (e) {
        if (e.target.checked) {
            constructedTableData.table_editing = 1;
            $mainTabContent.find('#column_key').parent().removeClass('droptable_hiden');
            $mainTabContent.find('.droptable_lock_columns').removeClass('droptable_hiden');
        } else {
            constructedTableData.table_editing = 0;
            $mainTabContent.find('#column_key').parent().addClass('droptable_hiden');
            $mainTabContent.find('.droptable_lock_columns').addClass('droptable_hiden');
        }
    });

    $mainTabContent.find('#droptable_placeholder_query').on('change', function (e) {
        if (e.target.checked) {
            constructedTableData.placeholder_query = 1;
            if (constructedTableData.table_editing == 1) {
                $mainTabContent.find('#droptable_mysql_table_editing').trigger('click');
            }
        } else {
            constructedTableData.placeholder_query = 0;
        }
    });

    /**
     * Create custom select box
     *
     * @param $
     * @param select_function cell function when click select
     */
    function custom_select_box ($, select_function) {
        $(this).on('click', function (e) {
            $('#mybootstrap').find('.droptable_select_box').each(function () {
                $(this).hide();
                $(this).siblings('.show').removeClass('show');
            });
            var position = $(this).position();

            if ($(this).hasClass('show')) {
                $(this).next().hide();
                $(this).removeClass('show');
                $(document).unbind('click.droptable_select_box');
                return;
            }

            var $that = $(this).addClass('show');
            var $select = $(this).next().css({top: position.top + 40, left: position.left, 'min-width': $that.outerWidth()}).show();

            $select.find('li').unbind('click').on('click', function (e) {
                $select.data('value', $(this).data('value')).change();
                $that.val($(this).data('value')).text($(this).text()).data('value', $(this).data('value')).change();
                if (typeof select_function !== 'undefined') {
                    select_function.call($(this));
                }
                $('#mybootstrap').find('.droptable_select_box').hide();
            });

            $(document).bind('click.droptable_select_box', (e) => {
                if (!$(e.target).is($(this))) {
                    $select.hide();
                    $that.removeClass('show');
                    $(document).unbind('click.droptable_select_box');
                }
            });
        });
    }

    if (typeof constructedTableData.id_table !== 'undefined') {//table existed
        $(document).find('#btn_next').trigger('click');
    }
})
