<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access.
defined('_JEXEC') || die;
$where_conditions = $this->where_conditions;
$grouping_rules = $this->grouping_rules;
$class_name = '';
if (droptablesBase::isJoomla40()) {
    $class_name .= ' joomla4';
} elseif (droptablesBase::isJoomla30()) {
    $class_name .= ' joomla30';
}
if ($this->caninsert) {
    $class_name .= ' caninsert';
}
?>
<div id="mybootstrap" class="wrap droptables-dbtable <?php echo $class_name;?>">
    <div id="pwrapper">
        <div id="droptablesreview">
            <?php if (empty($this->id_table)) : ?>
                <h2><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_TABLE_CREATION_WIZARD'); ?></h2>
            <?php elseif (!empty($this->id_table)) : ?>
                <h2><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_TABLE_WIZARD'); ?></h2>
            <?php endif; ?>
            <h3><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_CHOOSE_MYSQL_TABLES'); ?></h3>
        </div>
        <div id="mainTabContent" class="tab-content">
            <div class="step_animation">
                <div class="full_width step_one">
                    <div class="droptable_container droptable_mysql_tables">
                        <label
                                for="droptable_mysql_tables"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_TABLES_SELECTION'); ?></span></label>
                        <div class="droptable_container_content">
                            <i class="search_table mi mi-search"></i>
                            <input class="observeChanges search_table" type="text" name="page" value=""
                                   placeholder="<?php echo JText::_('COM_DROPTABLES_VIEW_DROPTABLES_SEARCH_TABLE'); ?>" data-search="droptable_mysql_tables">
                            <div id="droptable_mysql_tables" data-scrollbar class="uploader" style="margin-top: 15px;">
                                <?php foreach ($this->mysql_tables as $mysql_table) { ?>
                                    <div data-value="<?php echo $mysql_table; ?>" class="mysql_table mysql_option
                                    <?php
                                    if (in_array($mysql_table, $this->selected_tables)) {
                                        echo ' active';
                                    };
                                    ?>">
                                        <span><?php echo $mysql_table; ?></span>
                                    </div>
                                <?php } ?>
                                <div style="clear: both"></div>
                            </div>
                            <div class="full_width mb-0 align-right">
                                <a href="#droptable_mysql_tables_columns_wrapper"
                                   class="orange-button text-upper btn-next-step"><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_NEXT_SELECT_COLUMN'); ?></a>
                            </div>
                        </div>
                    </div>
                    <div class="droptable_container droptable_mysql_tables_columns" id="droptable_mysql_tables_columns_wrapper">
                        <label for="droptable_mysql_tables_columns">
                            <span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_COLUMNS_SELECTION'); ?></span>
                        </label>
                        <div class="droptable_container_content">
                            <i class="search_table mi mi-search"></i>
                            <input class="observeChanges search_table" type="text" name="page" value=""
                                   placeholder="Search Columns" data-search="droptable_mysql_tables_columns">
                            <div id="droptable_mysql_tables_columns" class="active" data-scrollbar style="margin-top: 15px">
                                <div class="uploader">
                                    <?php if (count($this->availableColumns)) { ?>
                                        <?php foreach ($this->availableColumns as $column) { ?>
                                            <div data-value="<?php echo $column ?>" class="mysql_option mysql_column
                                            <?php echo in_array($column, $this->selected_columns) ? ' active' : ''; ?>">
                                                <span><?php echo $column; ?></span>
                                            </div>
                                        <?php } ?>
                                    <?php } else { ?>
                                        <div class="please_select_table"><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_SELECT_TABLE_FIRST'); ?></div>
                                    <?php } ?>
                                    <div style="clear: both"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="droptable_define_mysql_relations droptable_container" style="<?php
                    if (empty($this->join_rules)) {
                        echo 'display: none';
                    } ?>">
                        <div class="droptable_container_content uploader mysqlRelationsContainer">
                            <label
                                    class="full_width"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_DEFINE_RELATION_BETWEEN_TABLES'); ?></span></label>
                            <?php if (!empty($this->join_rules)) :
                                foreach ($this->join_rules as $join_rule) {
                                    if (is_array($join_rule)) {
                                        $initiator_table = $join_rule['initiator_table'];
                                        $initiator_column = $join_rule['initiator_column'];
                                        $connected_column = $join_rule['connected_column'];
                                        $type = $join_rule['type'];
                                    } else {
                                        $initiator_table = $join_rule->initiator_table;
                                        $initiator_column = $join_rule->initiator_column;
                                        $connected_column = $join_rule->connected_column;
                                        $type = $join_rule->type;
                                    }
                                    ?>
                                    <div class="mysql_table_blocks">
                                    <span class="relationInitiatorTable dbtbl-tooltip" title="<?php echo $initiator_table; ?>">
                                        <?php echo $initiator_table; ?>.
                                    </span>
                                        <select class="relationInitiatorColumn"
                                                data-table="<?php echo $initiator_table; ?>">
                                            <option value=""></option>
                                            <?php foreach ($this->sorted_columns[$initiator_table] as $key => $column) {
                                                $col = str_replace($initiator_table . '.', '', $column); ?>
                                                <option value="<?php echo $col; ?>"
                                                    <?php
                                                    if ((string)$join_rule->initiator_column === (string)$col) {
                                                        echo 'selected';
                                                    } ?> >
                                                    <?php echo $col; ?></option>
                                            <?php } ?>

                                        </select>
                                        <div>=</div>
                                        <select class="relationConnectedColumn"
                                                data-table="<?php echo $initiator_table; ?>">
                                            <option value=""></option>
                                            <?php
                                            foreach ($this->sorted_columns as $tbl => $columns) {
                                                if ((string)$tbl !== (string)$initiator_table) {
                                                    foreach ($this->sorted_columns[$tbl] as $column) { ?>
                                                        <option value="<?php echo $column; ?>"
                                                            <?php
                                                            if ((string)$connected_column === (string)$column) {
                                                                echo 'selected';
                                                            } ?> >
                                                            <?php echo $column; ?></option>
                                                        <?php
                                                    }
                                                }
                                            } ?>
                                        </select>
                                        <span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_INNER_JOIN_LABEL'); ?></span>
                                        <select class="innerjoin">
                                            <option value="left"><?php echo 'left'; ?></option>
                                            <option value="inner"><?php echo 'inner'; ?></option>
                                        </select>
                                    </div>
                                    <?php
                                }
                            endif; ?>
                        </div>
                    </div>
                    <div class="droptable_define_mysql_conditions droptable_container">
                        <div class="droptable_container_content">
                            <div class="d-flex flex-justify-sb flex-align-center">
                                <label for="droptable_mysql_conditions"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_DATA_DISPLAY_CONDITION_LABEL'); ?></span></label>
                                <div class="d-flex flex-align-center">
                                    <a class="button droptable_active"
                                       id="droptable_mysql_add_where_condition"><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_TABLE_ADD'); ?></a>
                                </div>
                            </div>

                            <div class="uploader mysqlConditionsContainer full_width"
                                 style="margin: 0;display: block">
                                <?php
                                if (isset($this->where_conditions)) :
                                    $count = count($this->where_conditions);
                                    for ($i = 0; $i < $count; $i++) :
                                        $where_conditions = $this->where_conditions[$i];
                                        ?>
                                        <div class="post_where_blocks">
                                            <div class="full_width">
                                                <select class="whereConditionColumn">
                                                    <option value=""></option>
                                                    <?php foreach ($this->availableColumns as $column) : ?>
                                                        <option value="<?php echo $column ?>" <?php echo $where_conditions->column === $column ? ' selected' : ''; ?>><?php echo $column ?></option>
                                                    <?php endforeach; ?>
                                                </select>
                                                <button class="button-secondary deleteConditionPosts"
                                                        style="line-height: 26px; font-size: 26px"><span
                                                            class="dashicons dashicons-no"></span></button>
                                            </div>
                                            <div class="full_width" style="width: 96%">
                                                <select class="whereOperator"
                                                        value="<?php echo $where_conditions->operator; ?>">
                                                    <option value="eq" <?php echo $where_conditions->operator === 'eq' ? 'selected' : '' ?>>
                                                        =
                                                    </option>
                                                    <option value="gt" <?php echo $where_conditions->operator === 'gt' ? 'selected' : '' ?>>
                                                        &gt;
                                                    </option>
                                                    <option value="gtoreq" <?php echo $where_conditions->operator === 'gtoreq' ? 'selected' : '' ?>>
                                                        &gt;=
                                                    </option>
                                                    <option value="lt" <?php echo $where_conditions->operator === 'lt' ? 'selected' : '' ?>>
                                                        &lt;
                                                    </option>
                                                    <option value="ltoreq" <?php echo $where_conditions->operator === 'ltoreq' ? 'selected' : '' ?>>
                                                        &lt;=
                                                    </option>
                                                    <option value="neq" <?php echo $where_conditions->operator === 'neq' ? 'selected' : '' ?>>
                                                        &lt;&gt;
                                                    </option>
                                                    <option value="like" <?php echo $where_conditions->operator === 'like' ? 'selected' : '' ?>>
                                                        LIKE
                                                    </option>
                                                    <option value="plikep" <?php echo $where_conditions->operator === 'plikep' ? 'selected' : '' ?>>
                                                        %LIKE%
                                                    </option>
                                                    <option value="in" <?php echo $where_conditions->operator === 'in' ? 'selected' : '' ?>>
                                                        IN
                                                    </option>
                                                </select>

                                                <input type="text"
                                                       value="<?php echo $where_conditions->value; ?>"/>
                                            </div>
                                        </div>
                                    <?php endfor;
                                endif;
                                ?>
                            </div>
                        </div>
                    </div>

                    <div class="droptable_define_mysql_grouping droptable_container">
                        <div class="droptable_container_content">
                            <div class="d-flex flex-justify-sb flex-align-center">
                                <label
                                        for="droptable_posts_grouping"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_DATA_GROUP_RULES'); ?></span></label>
                                <div  class="d-flex flex-align-center">
                                    <a class="button droptable_active"
                                       id="droptable_mysql_add_grouping_rule"><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_TABLE_ADD'); ?></a>
                                </div>
                            </div>

                            <div class="uploader mysqlGroupingContainer full_width"
                                 style="margin: 0;display: block">
                                <?php
                                if (isset($this->grouping_rules)) :
                                    $count = count($this->grouping_rules);
                                    for ($i = 0; $i < $count; $i++) :
                                        $grouping_rules = $this->grouping_rules[$i];
                                        ?>
                                        <div class="post_grouping_rule_blocks">
                                            <span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_GROUP_BY'); ?></span>

                                            <select class="groupingRuleColumn">
                                                <option value=""></option>
                                                <?php foreach ($this->selected_columns as $column) : ?>
                                                    <option value="<?php echo $column; ?>" <?php echo $grouping_rules === $column ? ' selected' : ''; ?>><?php echo $column; ?></option>
                                                <?php endforeach; ?>
                                            </select>

                                            <button class="button-secondary deleteGroupingRulePosts"
                                                    style="line-height: 26px; font-size: 26px"><span
                                                        class="dashicons dashicons-no"></span></button>
                                        </div>
                                    <?php endfor;
                                endif;
                                ?>
                            </div>
                        </div>
                    </div>

                    <div class="droptable_container" id="droptable_mysql_default_ordering">
                        <div class="droptable_container_content">
                            <label for="droptable_mysql_default_ordering_column"
                                   class="full_width"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_DATA_DEFAULT_ORDERING'); ?></span></label>
                            <select id="droptable_mysql_default_ordering_column" class="full_width" style="margin-top: 10px;">
                                <?php
                                if (count($this->selected_columns) > 0) {
                                    foreach ($this->selected_columns as $column) { ?>
                                        <option value="<?php echo $column; ?>"
                                            <?php
                                            if ((string)$column === (string)$this->default_ordering_column) {
                                                echo ' selected';
                                            }; ?>>
                                            <?php echo $column; ?>
                                        </option>
                                    <?php }
                                }
                                ?>
                            </select>
                            <div id="droptable_mysql_default_ordering_dir" class="full_width">
                                <input id="default_ordering_dir_asc" type="radio" name="default_ordering_dir" value="asc"
                                    <?php
                                    if ('asc' === (string)$this->default_ordering_dir) {
                                        echo ' checked';
                                    }; ?>>
                                <label for="default_ordering_dir_asc"> <?php echo JText::_('JGLOBAL_ORDER_ASCENDING'); ?></label>
                                <input id="default_ordering_dir_desc" type="radio" name="default_ordering_dir" value="desc"
                                    <?php
                                    if ('desc' === (string)$this->default_ordering_dir) {
                                        echo ' checked';
                                    }; ?>>
                                <label for="default_ordering_dir_desc"> <?php echo JText::_('JGLOBAL_ORDER_DESCENDING'); ?></label>
                            </div>
                        </div>
                    </div>

                    <div class="droptable_container">
                        <div class="droptable_container_content">
                            <label
                                    for="droptable_mysql_table_pagination"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_ACTIVATE_PAGINATION'); ?></span></label>
                            <div style="float: right;margin-right: 15px;line-height: inherit;">
                                <input class="switch-button"
                                       id="droptable_mysql_table_pagination" type="checkbox" value="" <?php echo isset($this->params->enable_pagination) && (int)$this->params->enable_pagination === 1 ? ' checked' : '';?>>
                            </div>

                        </div>
                    </div>

                    <div class="droptable_container" id="droptable_mysql_number_of_rows">
                        <div class="droptable_container_content">
                            <label for="droptable_mysql_number_of_rows"
                                   class="full_width"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_NUMBER_OF_ROWS'); ?></span></label>
                            <input id="droptable_mysql_number_of_rows_10" type="radio" name="droptable_mysql_number_of_rows"
                                   value="10" <?php echo isset($this->params->limit_rows) && (int)$this->params->limit_rows === 10 ? ' checked' : '';?>>
                            <label for="droptable_mysql_number_of_rows_10" style="font-weight: 400"> 10 <?php echo JText::_('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_FREEZE_ROWS'); ?></label>
                            <input id="droptable_mysql_number_of_rows_20" type="radio" name="droptable_mysql_number_of_rows"
                                   value="20"  <?php echo (isset($this->params->limit_rows) && (int)$this->params->limit_rows === 20) || !isset($this->params->limit_rows) ? ' checked' : '';?>>
                            <label for="droptable_mysql_number_of_rows_20" style="font-weight: 400"> 20 <?php echo JText::_('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_FREEZE_ROWS'); ?></label>
                            <input id="droptable_mysql_number_of_rows_40" type="radio" name="droptable_mysql_number_of_rows"
                                   value="40" <?php echo isset($this->params->limit_rows) && (int)$this->params->limit_rows === 40 ? ' checked' : '';?>>
                            <label for="droptable_mysql_number_of_rows_40" style="font-weight: 400"> 40 <?php echo JText::_('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_FREEZE_ROWS'); ?></label>
                            <input id="droptable_mysql_number_of_rows_0" type="radio" name="droptable_mysql_number_of_rows"
                                   value="0" <?php echo isset($this->params->limit_rows) && (int)$this->params->limit_rows === 0 ? ' checked' : '';?>>
                            <label for="droptable_mysql_number_of_rows_0" style="font-weight: 400"> <?php echo JText::_('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_FREEZE_ALL_ROWS'); ?></label>
                        </div>
                    </div>
                </div>
                <?php if (empty($this->id_table)) :?>
                <div class="full_width step_two droptable_hiden">
                <?php elseif (!empty($this->id_table)) :?>
                    <div class="full_width step_two" style="left: 0%; opacity: 1;">
                <?php endif;?>
                        <div id="over_loadding_open_chart" class="loadding" style="display: none;"></div>
                        <div class="droptable_container full_width" style="display: grid;grid-template-columns: 49% 49%;grid-gap: 0;width: 100%">
                            <div class="droptable_container_content droptable_mysql_table_editing" style="display: inline-table;margin: 15px 10px 15px 0">
                                <label
                                        for="droptable_mysql_table_editing"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_ALLOW_EDIT'); ?></span></label>
                                <div style="float: right;margin-right: 15px;line-height: inherit;">
                                    <input class="switch-button"
                                           id="droptable_mysql_table_editing" type="checkbox" <?php echo isset($this->params->table_editing) && (int)$this->params->table_editing === 1 ? ' checked' : '';?> value="">
                                </div>
                            </div>
                            <div class="droptable_container_content" style="margin: 15px 0 15px 0">
                                <label for="droptable_mysql_conditions" style="margin-bottom: 10px"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_BASE_COLUMN'); ?></span>
                                    <br/>
                                    <span style="display:block;margin-left:5px;font-size: 12px;color: #404852;line-height: 18px;font-weight: 300;font-stretch: normal;font-style: inherit;letter-spacing: 0.6px;"><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_BASE_COLUMN_NOTICE'); ?></span>
                                </label>
                                <span id="column_key" class="popup_select droptable_select_box_before select_column_key"></span>
                                <ul class="droptable_select_box">
                                </ul>
                            </div>
                        </div>
                        <div class="droptable_container droptable_custom_mysql">
                            <div class="droptable_container_content" style="display: inline-block;width: 100%;box-sizing: border-box;">
                                <label for="droptable_custom_mysql"><span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_MYSQL_QUERY'); ?></span></label>
                                <div id="droptable_custom_mysql" style="margin-top: 15px;">
                                    <textarea rows="10" cols="50" id="jform_custom_mysql" cols="50" name="jform[jform_custom_mysql]"style="width:100%" ></textarea>
                                </div>
                                <input type="button" id="btn_apply_mysql" class="orange-button ju-button-while"
                                       value="<?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_APPLY'); ?>" style="opacity: 1;float: right;margin-top: 19px;">
                            </div>
                        </div>
                    </div>
                    <div class="full_width sql_table_button" style="float: right">
                        <input type="button" id="btn_previous" class="orange-button ju-button-while" style="max-width: unset;"
                               value="<?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_BACK_DATABASE'); ?>"/>
                        <input type="button" id="btn_next" class="orange-button ju-button-while"
                               value="<?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_NEXT'); ?>"/>
                        <input type="button" id="btn_preview" class="orange-button ju-button-while"
                               value="<?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_PREVIEW'); ?>"/>
                        <?php
                        if (!empty($this->id_table) && $this->id_table > 0) { ?>
                            <input type="button" id="btn_tableUpdate" class="orange-button ju-button-while"
                                   value="<?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_GOTO_TABLE_EDITOR'); ?>"/>
                            <?php
                        } else {
                            ?>
                            <input type="button" id="btn_tableCreate" class="orange-button"
                                   value="<?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_CREATE_TABLE'); ?>"/>
                        <?php } ?>
                    </div>

                    <div id="droptable_mysql_review" class="full_width" style="float: left;width: 100%">
                        <div class="uploader droptable_previewTable full_width" style="max-width: 100%">
                        </div>
                        <div class="droptable_hiden custom_title_column"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script type="text/javascript">
        var Droptables = {};
        <?php if (empty($this->id_table)) : ?>
        table_id = '';
        <?php elseif (!empty($this->id_table)) : ?>
        table_id = "<?php echo $this->id_table; ?>";
        Droptables.id = "<?php echo $this->id_table; ?>";
        <?php endif; ?>
        id_cat = "<?php echo $this->id_cat; ?>";
        droptables_ajaxurl = "index.php?option=com_droptables&";
        constructedTableData = {};
        <?php if (!empty($this->params)) : ?>
        constructedTableData =<?php echo json_encode($this->params);?>;
        <?php endif; ?>
        <?php if (!empty($this->id_table)) : ?>
        constructedTableData.id_table = <?php echo $this->id_table;?>;
        <?php endif; ?>
        constructedTableData.tables =<?php echo json_encode($this->selected_tables);?>;
        constructedTableData.enable_pagination = <?php echo(isset($this->params->enable_pagination) ? $this->params->enable_pagination : 1);?>;
        constructedTableData.limit_rows = <?php echo(isset($this->params->limit_rows) ? $this->params->limit_rows : 20);?>;
        <?php if (!empty($this->selected_columns)) {?>
        constructedTableData.mysql_columns =<?php echo json_encode($this->selected_columns);?>;
        <?php } ?>
        droptables_caninsert = <?php echo !empty($this->caninsert) ? 1 : 0;?>;
        Droptables.url = '<?php echo JUri::root(true);?>';
        Droptables.isAdmin = <?php echo $this->isAdmin ? 1 : '0';?>;
    </script>
</div>
<?php
if ($this->caninsert) {
    ?>
    <div id="droptables_bottom_toolbar">
        <div class="bottom_left_toolbar">
            <a class="droptables_back_list" href="<?php
            echo JUri::root() . 'index.php?option=com_droptables&view=droptables&backtolist=1&noheader=1&caninsert=1&tmpl=component&e_name=' . JFactory::getApplication()->input->getVar('e_name'); ?>">
                <?php echo JText::_('COM_DROPTABLES_TABLES_BACK_TO_TABLES_LIST'); ?></a>
        </div>

        <div class="bottom_right_toolbar">
            <a id="inserttable" class="button button-primary button-big" data-type="table"
               href="javascript:void(0)"><?php echo JText::_('COM_DROPTABLES_TABLES_INSERT_TABLE'); ?></a>
        </div>
    </div>
<?php }?>
</div>

<script type="text/x-handlebars-template" id="droptables-template-mysqlRelationBlock">
    <div class="mysql_table_blocks">
        <span class="relationInitiatorTable">{{table}}.</span>
        <select class="relationInitiatorColumn" data-table="{{table}}">
            <option value=""></option>
            {{#each columns}}
            <option value="{{this}}">{{this}}</option>
            {{/each}}
        </select>
        =
        <select class="relationConnectedColumn" data-table="{{table}}">
            <option value=""></option>
            {{#each other_table_columns}}
            <option value="{{this}}">{{this}}</option>
            {{/each}}
        </select>
        <span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_INNER_JOIN_LABEL'); ?></span>
        <select class="innerjoin">
            <option value="inner"><?php echo 'inner'; ?></option>
            <option value="left"><?php echo 'left'; ?></option>
        </select>
    </div>


</script>

<script type="text/x-handlebars-template" id="whereConditionTemplate">
    <div class="post_where_blocks">
        <div class="full_width">
            <select class="whereConditionColumn">
                <option value=""></option>
                {{#each post_type_columns}}
                <option value="{{this}}">{{this}}</option>
                {{/each}}
            </select>
            <button class="btn button-secondary deleteConditionPosts"><span class="dashicons dashicons-no"></span>x</button>
        </div>
        <div class="full_width" style="width: 96%">
            <select class="whereOperator">
                <option value="eq">=</option>
                <option value="gt">&gt;</option>
                <option value="gtoreq">&gt;=</option>
                <option value="lt">&lt;</option>
                <option value="ltoreq">&lt;=</option>
                <option value="neq">&lt;&gt;</option>
                <option value="like">LIKE</option>
                <option value="plikep">%LIKE%</option>
                <option value="in">IN</option>
            </select>

            <input type="text"/>
        </div>
    </div>
</script>


<script type="text/x-handlebars-template" id="groupingRuleTemplate">
    <div class="post_grouping_rule_blocks">
        <span><?php echo JText::_('COM_DROPTABLES_LAYOUT_DBTABLES_GROUP_BY'); ?></span>

        <select class="groupingRuleColumn">
            <option value=""></option>
            {{#each post_type_columns}}
            <option value="{{this}}">{{this}}</option>
            {{/each}}
        </select>

        <button class="button-secondary deleteGroupingRulePosts" style="line-height: 26px; font-size: 26px"><span
                    class="dashicons dashicons-no"></span></button>
    </div>
</script>