<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') || die;


/**
 * Class DroptablesViewDbtable
 */
class DroptablesViewDbtable extends JViewLegacy
{
    /**
     * State
     *
     * @var mixed
     */
    protected $state;

    /**
     * Display the view
     *
     * @param null|string $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return mixed
     */
    public function display($tpl = null)
    {
        JHtml::_('jquery.framework');
        $document = JFactory::getDocument();
        $document->addStyleSheet(JURI::root() . 'components/com_droptables/assets/codemirror/codemirror.css');
        $document->addStyleSheet(JURI::root() . 'components/com_droptables/assets/css/dbtable.css');

        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/jquery-ui.js');
        $document->addScript(JURI::root() . 'components/com_droptables/assets/codemirror/codemirror.js');
        $document->addScript(JURI::root() . 'components/com_droptables/assets/codemirror/mode/sql/sql.js');
        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/bootbox.min.js');
        $document->addScript(JUri::root() . 'components/com_droptables/assets/tablesorter/jquery.tablesorter.js');
        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/smooth-scrollbar.js');
        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/handlebars-v4.7.7.js');
        $document->addScript(JURI::root() . 'components/com_droptables/assets/js/droptable_dbtable.js');


        $id_table = JFactory::getApplication()->input->getInt('id_table');
        $id_cat = JFactory::getApplication()->input->getInt('id_cat');
        $new_table = JFactory::getApplication()->input->get('action');

        if ($id_cat !== null) {
            $this->id_cat = $id_cat;
        } elseif (empty($id_table)) {
            require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'controllers' . DIRECTORY_SEPARATOR . 'category.php');
            $DroptablesControllerCategory = new DroptablesControllerCategory();
            $data = $DroptablesControllerCategory->createCategory('new Category', 0);
            $this->id_cat = $data['id_category'];
        } else {
            $this->id_cat = null;
        }

        if ((int)JFactory::getApplication()->input->getInt('caninsert', 'GET', 'bool')) {
            $this->caninsert = true;
        } else {
            $this->caninsert = false;
        }

        $model = $this->getModel('dbtable');

        $this->selected_tables = array();
        $this->availableColumns = array();
        $this->selected_columns = array();
        $this->join_rules = array();
        $this->where_conditions = array();
        $this->grouping_rules = array();
        $this->params = new stdClass();
        $this->default_ordering_dir = 'asc';

        if (!empty($id_table)) {
            $this->id_table = $id_table;

            require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'table.php');
            $modelTable = new DroptablesModelTable();
            $item = $modelTable->getItem($id_table);
            $params = $item->params;

            $this->params = $params;

            if (isset($params->tables)) {
                $this->selected_tables = $params->tables;
                $columns               = $model->listMySQLColumns($this->selected_tables);

                $this->availableColumns = $columns['all_columns'];
                $this->selected_columns = $params->mysql_columns;
                $this->sorted_columns   = $columns['sorted_columns'];
            }

            if (isset($params->join_rules)) {
                $this->join_rules = $params->join_rules;
            }

            if (isset($params->default_ordering_column)) {
                $this->default_ordering_column = $params->default_ordering;
            } else {
                $this->default_ordering_column = '';
            }

            if (isset($params->default_ordering_dir)) {
                $this->default_ordering_dir = $params->default_ordering_dir;
            }

            if (isset($params->custom_titles)) {
                $this->custom_titles = $params->custom_titles;
            } else {
                $this->custom_titles = array();
            }
        }

        $this->mysql_tables = $model->listMySQLTables();
        if ($new_table !== 'create' && $id_table < 1) {//get list db table or create new table when not db table exist 24
            require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'tables.php');
            $modelTable = new DroptablesModelTables();
            $item        = $modelTable->getDbItems();
            $this->count = count($item);
            if ($this->count > 0) {//list
                $this->item = $item;
            }
        }

        $app = JFactory::getApplication();
        $this->isAdmin = $app->isClient('administrator');
        parent::display($tpl);
    }
}
