<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') || die;


/**
 * Class DroptablesViewDroptables
 */
class DroptablesViewDroptables extends JViewLegacy
{
    /**
     * Execute and display a template script.
     *
     * @param null $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return mixed
     */
    public function display($tpl = null)
    {
        $app      = JFactory::getApplication();
        $this->canDo = DroptablesHelper::getActions();
        $userManage = $this->canDo->get('core.manage');

        if (!isset($userManage) && $userManage !== true) {
            die();
        }

        $this->idTable = $app->input->getInt('id');

        $params = JComponentHelper::getParams('com_droptables');
        $this->params = $params;

        $this->editorHideButtons = false;
        if (isset($this->params['include_editor_buttons'])) {
            $loadEditorButtons = explode(',', $this->params['include_editor_buttons']);
            $excludeEditorButtons =  array();
            $plugins = JPluginHelper::getPlugin('editors-xtd');
            foreach ($plugins as $plugin) {
                if (!in_array($plugin->name, $loadEditorButtons)) {
                    $excludeEditorButtons[] = $plugin->name;
                }
            }
            if (!empty($excludeEditorButtons)) {
                $this->editorHideButtons = $excludeEditorButtons;
            }
        }

        require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'table.php');
        $modelTable1 = new DroptablesModelTable();

        if ($this->idTable > 0) {
            //get table theme style
            $modelStyles = $this->getModel('styles');
            $this->styles = $modelStyles->getStyles();
            //get chart theme style
            $modelChartTypes = $this->getModel('chartTypes');
            $this->chartTypes = $modelChartTypes->getChartTypes();

            $this->setLayout($app->input->getCmd('layout', 'default'));

            $this->firstData = $modelTable1->firstGetTable($this->idTable);
            if ($this->firstData->type === 'mysql') {
                $this->tableParams = array();
//                $this->tableParams = $modelTable1->getTableParams($this->idTable);
//                if (is_string($this->tableParams->params)) {
//                    $this->tableParams = json_decode($this->tableParams->params, true);
//                }
                require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'dbtable.php');
                $modelDbTable = new DroptablesModelDbtable();
                $query_option = $modelDbTable->getQueryOption($this->idTable);
                if (!empty($query_option->option_value) && is_string($query_option->option_value)) {
                    $query_option = json_decode($query_option->option_value, true);
                }
                $this->tableParams['query_option'] = $query_option;
            }
        } else {
            $model = $this->getModel('categories');
            $app->setUserState('list.limit', 100000);
            $this->categories = $model->getItems();
            $this->dbtable_cat = (int)$params->get('dbtable_cat', 0);

            $modelTables = $this->getModel('tables');
            $this->tables = $modelTables->getItems();
            $this->tables = DroptablesTablesHelper::categoryObject($this->tables);
        }

        $modelTable = $this->getModel('tables');
        $this->authors = $modelTable->getUsers();

        $this->user_roles = $modelTable->getUserRoles();
        $getUser = JFactory::getUser();
        $list_rolers_of_user = $getUser->groups;
        if (!empty($list_rolers_of_user) && is_array($list_rolers_of_user)) {
            $this->list_rolers_of_user = array_keys($list_rolers_of_user);
        } else {
            $this->list_rolers_of_user = array();
        }
        $this->user_roles1 = array();

        if ((int)$app->input->getInt('caninsert', 'GET', 'bool')) {
            $this->caninsert = true;
            //get charts
            require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR
                . 'components' . DIRECTORY_SEPARATOR . 'com_droptables'
                . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'charts.php');
            $modelCharts = new DroptablesModelCharts();
            $this->listChart = $modelCharts->getCharts();
            $this->listChart = $this->sortChartsByTable($this->listChart);
            $this->back_to_list = $app->input->getInt('backtolist', 0);
        } else {
            $this->caninsert = false;
            $this->back_to_list = 0;
        }
        $this->id_charts = $app->input->getInt('chart', 'GET');

        parent::display($tpl);
    }

    /**
     * Load params
     *
     * @param string      $theme         Theme loader
     * @param null|string $cat_params    Category params
     * @param null|string $global_params Global params
     *
     * @return stdClass
     */
    public function loadParams($theme = 'default', $cat_params = null, $global_params = null)
    {
        $ob = new stdClass();
        if ($theme === '') {
            $theme = 'default';
        }
        foreach ((array) $cat_params as $key => $val) {
            $ob->$key = $global_params->get($theme . '_' . $key, $val);
        }

        return $ob;
    }
}
