<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

use Joomla\CMS\Factory;

defined('_JEXEC') || die;

/**
 * Class DroptablesViewFronttable
 */
class DroptablesViewFronttable extends JViewLegacy
{
    /**
     * Execute and display a template script.
     *
     * @param null $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return mixed
     */
    public function display($tpl = null)
    {
        $app      = JFactory::getApplication();
        $id_table = $app->input->getInt('id');

        JPluginHelper::importPlugin('content', 'droptables');
        $item       = new stdClass();
        $item->text = '<img data-droptablestable="' . $id_table . '"  />';
        // Trigger the data preparation event.
        $params     = new JObject;
        Factory::getApplication()->triggerEvent('onContentPrepare', array('com_droptables.table', &$item, &$params, 0));
        $this->item = $item;

        parent::display($tpl);
    }

    /**
     * Load params
     *
     * @param string      $theme         Theme loader
     * @param null|string $cat_params    Category params
     * @param null|string $global_params Global params
     *
     * @return stdClass
     */
    public function loadParams($theme = 'default', $cat_params = null, $global_params = null)
    {
        $ob = new stdClass();
        if ($theme === '') {
            $theme = 'default';
        }
        foreach ((array) $cat_params as $key => $val) {
            $ob->$key = $global_params->get($theme . '_' . $key, $val);
        }

        return $ob;
    }
}
