<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') || die;

//require_once(JPATH_SITE . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'views' . DIRECTORY_SEPARATOR . 'droptables' . DIRECTORY_SEPARATOR . 'view.html.php');

/**
 * Class DroptablesViewManage
 */
class DroptablesViewManage extends JViewLegacy
{
    /**
     * State
     *
     * @var mixed
     */
    protected $state;

    /**
     * Execute and display a template script.
     *
     * @param null $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return mixed
     */
    public function display($tpl = null)
    {
        $app      = JFactory::getApplication();

        $user        = JFactory::getUser();
        $loginUserId = (int) $user->get('id');
        if (!$loginUserId) {
            $app->redirect(JRoute::_('index.php?option=com_users&view=login'));
        }

        $this->idTable = $app->input->getInt('id', null) !== null ? $app->input->getInt('id', 0) : $app->input->getInt('id_table', 0);
        $this->canDo = DroptablesHelper::getActions();
        $this->params = JComponentHelper::getParams('com_droptables');

        JModelLegacy::addIncludePath(JPATH_ROOT . '/administrator/components/com_droptables/models/', 'DroptablesModel');
        $modelTable1 = JModelLegacy::getInstance('Table', 'droptablesModel');
        $modelTables = JModelLegacy::getInstance('Tables', 'droptablesModel');
        $this->getView = 'manage';

        if ($this->idTable > 0) {
            //get table theme style
            $modelStyles = JModelLegacy::getInstance('Styles', 'droptablesModel');
            $this->styles = $modelStyles->getStyles();
            //get chart theme style
            $modelChartTypes = JModelLegacy::getInstance('ChartTypes', 'droptablesModel');
            $this->chartTypes = $modelChartTypes->getChartTypes();

            $this->setLayout($app->input->getCmd('layout', 'default'));

            $this->firstData = $modelTable1->firstGetTable($this->idTable);

            $this->editorHideButtons = false;
            if (isset($this->params['include_editor_buttons'])) {
                $loadEditorButtons = explode(',', $this->params['include_editor_buttons']);
                $excludeEditorButtons =  array();
                $plugins = JPluginHelper::getPlugin('editors-xtd');
                foreach ($plugins as $plugin) {
                    if (!in_array($plugin->name, $loadEditorButtons)) {
                        $excludeEditorButtons[] = $plugin->name;
                    }
                }
                if (!empty($excludeEditorButtons)) {
                    $this->editorHideButtons = $excludeEditorButtons;
                }
            }
        } else {
            $model = JModelLegacy::getInstance('Categories', 'droptablesModel');
            $app->setUserState('list.limit', 100000);
            $this->categories = $model->getItems();
            $this->dbtable_cat = (int)$this->params->get('dbtable_cat', 0);

            $this->tables = $modelTables->getItems();
            $this->tables = DroptablesTablesHelper::categoryObject($this->tables);
        }

        $this->authors = $modelTables->getUsers();

        if ((int)$app->input->getInt('caninsert', 'GET', 'bool')) {
            $this->caninsert = true;
            //get charts
            require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR
                . 'components' . DIRECTORY_SEPARATOR . 'com_droptables'
                . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'charts.php');
            $modelCharts = new DroptablesModelCharts();
            $this->listChart = $modelCharts->getCharts();
            $this->listChart = $this->sortChartsByTable($this->listChart);
            $this->back_to_list = $app->input->getInt('backtolist', 0);
        } else {
            $this->caninsert = false;
            $this->back_to_list = 0;
        }
        $this->id_charts = $app->input->getInt('chart', 'GET');

        parent::display($tpl);

        $app = JFactory::getApplication();
        if ($app->isClient('administrator')) {
            $this->addToolbar();
        }
    }

    /**
     * Add the page title and toolbar.
     *
     * @return void
     * @since  1.6
     */
    protected function addToolbar()
    {

        $canDo = DroptablesHelper::getActions();

        JToolBarHelper::title(JText::_('COM_DROPTABLES_MAIN_PAGE'), 'droptables.png');

        $toolbar = JToolBar::getInstance();

        if ($canDo->get('core.admin')) {
            $toolbar->appendButton('popup', 'support', JText::_('COM_DROPTABLES_VIEW_SUPPORT'), 'index.php?option=com_droptables&view=support&tmpl=component', 700, 600, 0, 0);
            JToolBarHelper::preferences('com_droptables');
        }

        JToolBarHelper::divider();
    }
}
