/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./site/assets/js/_alternating.js":
/*!****************************************!*\
  !*** ./site/assets/js/_alternating.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_functions */ "./site/assets/js/_functions.js");
//alternate color handling functions


const alternating = {
    /**
     * Check that the selection matches the saved alternate values
     *
     * @param selection
     * @param oldAlternate
     * @returns {*}
     */
    setNumberAlternate : (selection, oldAlternate) => {
        var count = _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(oldAlternate);

        window.jquery.each(oldAlternate, function (i, v) {
            if (typeof v.selection !== 'undefined') {
                if (v.selection[0] == selection[0] &&
                    v.selection[1] == selection[1] &&
                    v.selection[2] == selection[2] &&
                    v.selection[3] == selection[3]) {
                    count = i;
                }
            } else {
                return count;
            }
        });

        return count;
    },
    /**
     * when select alternating_color
     *
     * @param value
     * @param selection
     * @param count
     */
    selectAlternatingColor : (value, selection, count) => {//when select alternating_color
        //ij is row, ik is coll
        var ij, ik;
        var beforeChange = window.jquery.extend({}, window.Droptables.style.cells);
        var size = _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(window.table_function_data.checkChangeAlternate);
        window.table_function_data.checkChangeAlternate[size] = {};

        for (ij = selection[0]; ij <= selection[2]; ij++) {
            for (ik = selection[1]; ik <= selection[3]; ik++) {
                if (typeof (beforeChange[ij + "!" + ik]) !== 'undefined') {
                    window.table_function_data.checkChangeAlternate[size][ij + "!" + ik] = beforeChange[ij + "!" + ik][2].AlternateColor;
                    beforeChange[ij + "!" + ik][2] = window.jquery.extend(beforeChange[ij + "!" + ik][2], {AlternateColor: count});
                } else { //cell not have style
                    beforeChange[ij + "!" + ik] = [ij, ik, {}];
                    beforeChange[ij + "!" + ik][2] = {AlternateColor: count};
                }
                if (typeof window.table_function_data.checkChangeAlternate[size][ij + "!" + ik] === 'undefined' || window.table_function_data.checkChangeAlternate[size][ij + "!" + ik] === null) {
                    window.table_function_data.checkChangeAlternate[size][ij + "!" + ik] = -1;
                }
            }
        }

        window.Droptables.style.cells = beforeChange;

        var listChangeAlternate = [];
        var i = count, oldCount = count;
        window.table_function_data.changeAlternate = [];
        for (var ii = count - 1; ii >= 0; ii--) {
            var check = 1;
            if (value[ii] !== false && typeof value[ii] !== 'undefined' && typeof value[ii].selection !== 'undefined') {
                if(value[ii].selection[0] >= value[i].selection[0]) {
                    check++;
                }

                if(value[ii].selection[1] >= value[i].selection[1]) {
                    check++;
                }

                if(value[ii].selection[2] <= value[i].selection[2]) {
                    check++;
                }

                if(value[ii].selection[3] <= value[i].selection[3]) {
                    check++;
                }
            } else {
                check = 5;
            }

            if (check === 5) {
                value[ii] = value[count];
                listChangeAlternate[ii] = count;
                if (typeof listChangeAlternate[count] !== 'undefined') {
                    listChangeAlternate[ii] = listChangeAlternate[count];
                    delete listChangeAlternate[count];
                }
                delete value[count];
                count--;
                i = ii;
            }
        }
        for (var j = 0; j < oldCount; j ++) {
            if (typeof listChangeAlternate[j] !== 'undefined') {
                window.table_function_data.changeAlternate[listChangeAlternate[j]] = j;
            }
        }
        window.table_function_data.alternateIndex = count;
        window.table_function_data.alternateSelection = selection;
    },
    /**
     * Cancel alternateColor
     */
    reAlternateColor : () => {
        var styleCells = {};
        styleCells = window.jquery.extend({}, Droptables.style.cells);

        for (var i = _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(window.table_function_data.checkChangeAlternate) - 1; i >= 0; i--) {
            window.jquery.map(window.table_function_data.checkChangeAlternate[i], function (v, ii) {
                if (typeof styleCells[ii] !== 'undefined') {
                    if (v !== -1) {
                        styleCells[ii][2].AlternateColor = v;
                    } else {
                        delete styleCells[ii][2].AlternateColor;
                    }
                }
            });
        }

        window.table_function_data.checkChangeAlternate = [];
        return styleCells;
    },
    /**
     * Set alternate color by alternate_row_odd_color option(in params)
     *
     * @param styleRows style.rows
     * @param Droptables
     * @param $element
     */
    setAlternateColor : (styleRows, Droptables, $element) => {
        Droptables.style.table.alternateColorValue = {};
        var countCols, countRows;
        if (typeof Droptables_element.tableContainer !== 'undefined') {
            countCols = window.jquery(Droptables_element.tableContainer).handsontable('countCols');
            countRows = window.jquery(Droptables_element.tableContainer).handsontable('countRows');
        }

        if (typeof countRows == 'undefined') {/*get count cols, rows when handsontable not activated*/
            countCols = Droptables.datas[0].length - 1;
            countRows = Droptables.datas.length - 1;
        }

        var checkExistAlternateOld = 0;
        var checkExistAlternateEven = 0;

        if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(Droptables.style.table, 'alternate_row_odd_color') && Droptables.style.table.alternate_row_odd_color) {
            checkExistAlternateOld = 1;
        }
        if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(Droptables.style.table, 'alternate_row_even_color') && Droptables.style.table.alternate_row_even_color) {
            checkExistAlternateEven = 1;
        }

        var header = '';
        if (styleRows !== null && typeof styleRows[0][1].cell_background_color !== 'undefined') {
            header = styleRows[0][1].cell_background_color;
        }

        if (checkExistAlternateEven + checkExistAlternateOld > 0) {
            Droptables.style.table.alternateColorValue = {};
            Droptables.style.table.alternateColorValue[0] = {};
            Droptables.style.table.alternateColorValue[0].selection = [0, 0, countRows - 1, countCols - 1];
            Droptables.style.table.alternateColorValue[0].footer = '';
            Droptables.style.table.alternateColorValue[0].even = checkExistAlternateEven === 1 ? Droptables.style.table.alternate_row_even_color : '#ffffff';
            Droptables.style.table.alternateColorValue[0].header = header;
            Droptables.style.table.alternateColorValue[0].old = checkExistAlternateOld === 1 ? Droptables.style.table.alternate_row_odd_color : '#ffffff';
            Droptables.style.table.alternateColorValue[0].default = '' + header + '|' + Droptables.style.table.alternateColorValue[0].even + '|' + Droptables.style.table.alternateColorValue[0].old + '|' + '';
            saveData.push({action: 'style', selection: [[0, 0, countRows, countCols]], style: {AlternateColor: 0}});
        }

        Droptables.style.table.alternate_row_even_color = null;
        Droptables.style.table.alternate_row_odd_color = null;

        if (typeof Droptables.style.table.alternateColorValue[0] !== 'undefined') {
            var ij, ik;
            for (ij = 0; ij <= countRows; ij++) {
                for (ik = 0; ik <= countCols; ik++) {
                    if (typeof (Droptables.style.cells[ij + "!" + ik]) !== 'undefined') {
                        Droptables.style.cells[ij + "!" + ik][2].AlternateColor = 0;
                    } else {
                        Droptables.style.cells[ij + "!" + ik] = [ij, ik, {}];
                        Droptables.style.cells[ij + "!" + ik][2] = jQuery.extend({}, {AlternateColor: 0});
                    }
                    if (header !== '' && ij === 0) {
                        delete Droptables.style.cells[ij + "!" + ik][2].cell_background_color;
                    }
                }
            }
        }

        window.Droptables = window.jquery.extend({}, Droptables);
    },
    /**
     * add new alternate to saving function and Droptables.style.table
     */
    applyAlternate : function () { //save oldAlternate value to Droptables and save
        window.Droptables.style.table.alternateColorValue = window.jquery.extend({}, window.table_function_data.oldAlternate);
        window.Droptables.style.table.allAlternate = window.jquery.extend({}, window.table_function_data.allAlternate);

        if (Droptables.type === 'mysql' && typeof window.Droptables.style.table.alternateColorValue[0] !== 'undefined') { //alternate for all cell
            window.Droptables.style.table.alternateColorValue = {};
        }

        if(window.table_function_data.alternateIndex !== '') {
            var i, k;
            for (i = window.table_function_data.alternateSelection[0]; i <= window.table_function_data.alternateSelection[2]; i++) {
                for (k = window.table_function_data.alternateSelection[1]; k <= window.table_function_data.alternateSelection[3]; k++) {
                    if (typeof (window.Droptables.style.cells[i + "!" + k]) !== 'undefined') {
                        window.Droptables.style.cells[i + "!" + k][2] = window.jquery.extend(window.Droptables.style.cells[i + "!" + k][2], {AlternateColor: window.table_function_data.alternateIndex});
                    } else { //cell not have style
                        window.Droptables.style.cells[i + "!" + k] = [i, k, {}];
                        window.Droptables.style.cells[i + "!" + k][2] = {AlternateColor: window.table_function_data.alternateIndex};
                    }
                }
            }

            window.table_function_data.save_table_params.push({action: 'style', selection: [window.table_function_data.alternateSelection], style: {AlternateColor: window.table_function_data.alternateIndex}});
        }
        window.table_function_data.checkChangeAlternate = [];

        _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
        this.siblings('.colose_popup').trigger('click');
    },
    /**
     * set the change options of altenate when selector cell/change rangeLabe
     * @param Droptables
     * @param $
     */
    affterRangeLabe : function (Droptables, $) {
        try {
            var rangeLabel = this.find('.cellRangeLabelAlternate').val();
            rangeLabel = rangeLabel.replace(/[ ]+/g, "").toUpperCase();
            var arrayRange = rangeLabel.split(":");
            if (arrayRange.length > 1) {
                var check_value = 0;
                if (arrayRange[0].replace(/[ |A-Za-z]+/g, "") === '') {
                    check_value = 1;//value A:B
                } else if (arrayRange[0].replace(/[ |1-9]+/g, "") === '') {
                    check_value = 2;//value 8:9
                }
                var selection = [];
                if (check_value === 0) {
                    selection.push(parseInt(arrayRange[0].split(/[ |A-Za-z]+/g)[1]) - 1);
                    selection.push(_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertStringToNumber(arrayRange[0].split(/[ |1-9]+/g)[0]) - 1);
                    selection.push(parseInt(arrayRange[1].split(/[ |A-Za-z]+/g)[1]) - 1);
                    selection.push(_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertStringToNumber(arrayRange[1].split(/[ |1-9]+/g)[0]) - 1);
                } else if (check_value === 1) {
                    selection.push(0);
                    selection.push(_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertStringToNumber(arrayRange[0].split(/[ |1-9]+/g)[0]) - 1);
                    selection.push(Droptables.max_row - 1);
                    selection.push(_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertStringToNumber(arrayRange[1].split(/[ |1-9]+/g)[0]) - 1);
                } else {
                    selection.push(parseInt(arrayRange[0].split(/[ |A-Za-z]+/g)[0]) - 1);
                    selection.push(0);
                    selection.push(parseInt(arrayRange[1].split(/[ |A-Za-z]+/g)[0]) - 1);
                    selection.push(Droptables.max_Col - 1);
                }

                if (Droptables.type === 'mysql') {
                    if (selection[2] + selection[0] === 0) {
                        this.find('.droptable_range_labe_show').removeClass('droptable_hiden');
                    } else {
                        this.find('.droptable_range_labe_show').addClass('droptable_hiden');
                    }
                }
                // $(Droptables_element.tableContainer).handsontable("selectCells", [[0, 0, 4, 4]]);
                $(Droptables_element.tableContainer).handsontable("selectCells", [[selection[0],selection[1],selection[2],selection[3]]]);

                if (typeof this.find('.cellRangeLabelAlternate').data('text_change') !== 'undefined') {
                    if (this.find('.cellRangeLabelAlternate').hasClass('select_row')) {
                        if (selection[0] === selection[2]) {
                            $(this.find('.cellRangeLabelAlternate').data('text_change')).text(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_ROW_HEIGHT', 'Row height'));
                        } else {
                            $(this.find('.cellRangeLabelAlternate').data('text_change')).text(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_ROW_HEIGHT', 'Row height:') + (selection[0] + 1) + '-' + (selection[2] + 1));
                        }
                    } else if (this.find('.cellRangeLabelAlternate').hasClass('select_column')) {
                        $(this.find('.cellRangeLabelAlternate').data('text_change')).text(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_PARAM_COL_WIDTH', 'Column width:')
                            + arrayRange[0].split(/[ |1-9]+/g)[0] + '-' + arrayRange[1].split(/[ |1-9]+/g)[0]);
                    } else {
                        $(this.find('.cellRangeLabelAlternate').data('text_change')).text(rangeLabel);
                    }
                }
            }
        } catch (err) {}
    },
    /**
     * active alternating
     *
     * @param format
     */
    getActiveFormatColor: (format) => {
        $alternating_color.find('.formatting_style .pane-color-tile').each(function () {
            if (window.jquery(this).find('.pane-color-tile-1').data('value') === format.even) {
                if (window.jquery(this).find('.pane-color-tile-2').data('value') === format.old) {
                    var check = 0;
                    if (format.header !== '') {
                        check = format.header === window.jquery(this).find('.pane-color-tile-header').data('value') ? 1 : -1;
                    } else {
                        check = 1;
                    }

                    if (format.footer !== '') {
                        check = format.footer === window.jquery(this).find('.pane-color-tile-footer').data('value') ? check : -1;
                    }

                    switch (check) {
                        case 1:
                            window.jquery(this).addClass('active');
                            break;
                        case -1:
                            // No active
                            break;
                    }
                }
            }
        });
    },
    /**
     * handsontable render after set alternating
     */
    renderCell : () => { //render cells
        window.jquery(Droptables_element.tableContainer).handsontable('render');
    }
}

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (alternating);


/***/ }),

/***/ "./site/assets/js/_charts.js":
/*!***********************************!*\
  !*** ./site/assets/js/_charts.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_functions */ "./site/assets/js/_functions.js");
/* harmony import */ var _alternating__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_alternating */ "./site/assets/js/_alternating.js");
/* harmony import */ var _customRenderer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_customRenderer */ "./site/assets/js/_customRenderer.js");




var DropChart = {};
DropChart.default = {
    "dataUsing": "row",
    "switchDataUsing": true,
    "useFirstRowAsLabels": true,
    "useFirstRowAsGraph": true,
    "width": 500,
    "height": 375,
    "chart_align": "center",
    "scaleShowGridLines": false,
    "scaleBeginAtZero": false,
};
DropChart.default.colors = "#DCDCDC,#97BBCD,#4C839E";
DropChart.default.pieColors = "#F7464A,#46BFBD,#FDB45C,#949FB1,#4D5360";
DropChart.datas = {};

/* Chart functions */
DropChart.functions = {};

//get list chart of table
DropChart.functions.loadCharts = function () {
    var $ = jquery;
    DropChart.default.currency_symbol = default_value.currency_symbol;
    DropChart.default.thousand_symbol = default_value.thousand_symbol;
    DropChart.default.decimal_symbol = default_value.decimal_symbol;

    if (typeof Droptables.id !== 'undefined' && Droptables.id !== '') {
        var url = Droptables.ajaxurl + "index.php?option=com_droptables&view=charts&format=json&id_table=" + Droptables.id + "&front=" + ((typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert));
        $.ajax({
            url: url,
            type: "POST",
            data: {},
            dataType: "json",
        }).done(function (data) {
            var i = 0;
            for (i = 0; i < data.length; i++) {
                var cells = $.parseJSON(data[i].datas);
                if ($.isArray(cells) !== false || cells.length !== 0) {
                    DropChart.datas[data[i].id] = {
                        author: data[i].author,
                        config: $.parseJSON(data[i].config),
                        data: cells,
                        title: data[i].title,
                        type: data[i].type,
                    };
                    $('#list_chart').append('<li class="chart-menu" data-id="' + data[i].id + '"><a>' + data[i].title + '</a></li>');
                }
            }
            droptable_chart();
        });
    }
}

function droptable_chart(first_load) {
    var chart_id;
    var $ = jquery;
    var $droptable_top_chart = $('#droptable_chart').find('.droptable_left_content .droptable_top_chart');
    $('#list_chart').find('.chart-menu').unbind('click').on('click', function (e) {
        var chart_name = '';
        if (!$(this).data('id')) {
            $(this).closest('.chart-menu').siblings('.chart-menu').removeClass('active');
            chart_id = $(this).closest('.chart-menu').data('id');
            $(this).closest('.chart-menu').addClass('active');
            chart_name = $(this).text();
        } else {
            $(this).siblings('.chart-menu').removeClass('active');
            chart_id = $(this).data('id');
            $(this).addClass('active');
            chart_name = $(this).find('a').text();
        }
        $droptable_top_chart.find('.droptable_name_edit').text(chart_name);

        if ($('#inserttable').length > 0) {
            Droptables.chart_active = chart_id;
            if (!$('#inserttable').hasClass('not_change_type')) {
                jquery('#inserttable').data('type', 'chart').attr('data-type', 'chart');
            }
            $('#inserttable').removeClass("no_click");
        }

        if(first_load) {
            DropChart.functions.render(chart_id, false, first_load);
        } else {
            DropChart.functions.render(chart_id);
        }
        return false;
    });

    // if (typeof Droptables.chart_active !== 'undefined' && parseInt(Droptables.chart_active) > 0) {
    //     if ($('.over_popup').length > 0) {
    //         $('.over_popup').hide();
    //     }
    //     tableFunction.showChartOrTable(true, $('#list_chart').find('.chart-menu[data-id="' + Droptables.chart_active + '"]'));
    // }

    $droptable_top_chart.find('.edit').unbind('click').on('click', function (e) {
        $droptable_top_chart.find('.droptable_name_edit').addClass('rename');
        $droptable_top_chart.find('.droptable_name_edit').trigger('click');
    });

    $droptable_top_chart.find('.droptable_name_edit').click(function () {
        if (!$(this).hasClass('editable')) {
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.setText.call(
                $(this),
                $droptable_top_chart.find('.droptable_name_edit'),
                '#droptable_chart .droptable_name_edit',
                {
                    'url': Droptables.ajaxurl + "index.php?option=com_droptables&task=chart.setTitle&id=" + DropChart.id_chart + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert) + '&title=',
                    'selected': true,
                    'action': function (obj) {
                        if (arguments[0] != '') {
                            $('#list_chart').find('.chart-menu.active a').text(arguments[0]);
                        }
                    }
                }
            );
        }
    });

    $droptable_top_chart.find('.trash').unbind('click').on('click', function (e) {
        var that = this;
        var list_chart = $('#list_chart');
        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_JS_WANT_DELETE', 'Do you really want to delete ') + "\"" + $(this).siblings('.droptable_name_edit').text().trim() + '"?', function (result) {
            if (result === true) {
                $.ajax({
                    url: Droptables.ajaxurl + "index.php?option=com_droptables&task=chart.delete&id=" + DropChart.id_chart + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                    type: "POST",
                    data: {},
                    dataType: "json",
                    success: function (datas) {
                        if (datas.response === true) {
                            list_chart.find('li.chart-menu[data-id="' + DropChart.id_chart + '"]').remove();
                            Droptables_element.DroptablesContentChart.find('canvas.droptable_chart_' + DropChart.id_chart).remove();
                            if (list_chart.find('li.chart-menu').length > 1) {
                                list_chart.find('.chart-menu').eq(0).trigger('click');
                            } else {
                                list_chart.find('.current_table').trigger('click');
                            }
                        } else {
                            bootbox.alert(datas.response);
                        }
                    },
                    error: function (jqxhr, textStatus, error) {
                        bootbox.alert(textStatus);
                    }
                });
                return false;
            }
        });
    });
    Droptables_element.chartTabContent.find('.copy_shortcode').unbind('click').on('click', function (e) {
        Droptables_element.chartTabContent.find('.controls[name="shortcode"] input').select();
        document.execCommand('copy');
    });
    Droptables.ChartLength = _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(DropChart.datas);
}

function updateOption(chartData) {
    var $ = jquery;
    //get cell range label to input selected range and add range to handsontable
    var selection = DropChart.helper.getCellRangeLabel(DropChart.cells);
    var cellRangeLabel = Handsontable.helper.spreadsheetColumnLabel(selection[1]) + '' + (selection[0] + 1);
    cellRangeLabel += ":" + Handsontable.helper.spreadsheetColumnLabel(selection[3]) + '' + (selection[2] + 1);

    Droptables_element.chartTabContent.find('.cellRangeLabelAlternate').val(cellRangeLabel);
    Droptables_element.tableContainer.handsontable("selectCell", selection[0], selection[1], selection[2], selection[3]);

    if (typeof chartData.type !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="type"]').find('img').each(function () {
            $(this).removeClass('active');
            if ($(this).attr('alt') === chartData.type) {
                $(this).addClass('active');
            }
        });

        var $dataset_select = Droptables_element.chartTabContent.find('.controls[name="dataset_select"] select');
        var $dataset_color = Droptables_element.chartTabContent.find('.controls[name="dataset_color"] input.minicolors');
        $dataset_select.html("");
        var color, i;
        if (DropChart.type == "Line" || DropChart.type == "Bar" || DropChart.type == "Radar") {
            for (i = 0; i < DropChart.datasets.length; i++) {
                $dataset_select.append('<option value="' + i + '">' + DropChart.datasets[i].label + '</option>');
            }
            $dataset_select.trigger('liszt:updated');
            color = DropChart.config.colors.split(",")[0];
            $dataset_color.minicolors('value', color);
            $dataset_color.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);

            // $dataset_color.wpColorPicker('color', DropChart.config.colors.split(",")[0]);
        } else {
            var chartData = {};
            chartData.datasets = DropChart.datasets;
            chartData.labels = DropChart.labels;

            for (i = 0; i < chartData.labels.length; i++) {
                $dataset_select.append('<option value="' + i + '">' + chartData.labels[i] + '</option>');
            }
            $dataset_select.trigger('liszt:updated');
            color = DropChart.config.pieColors.split(",")[0];
            $dataset_color.minicolors('value', color);
            $dataset_color.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
            // $dataset_color.wpColorPicker('color', DropChart.config.pieColors.split(",")[0]);
        }
    }

    if (typeof DropChart.config.dataUsing !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="dataUsing"] select').val(DropChart.config.dataUsing).change();
    }
    if (typeof DropChart.config.useFirstRowAsLabels !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="useFirstRowAsLabels"] input')
            .val(DropChart.config.useFirstRowAsLabels === true ? 'yes' : 'no').prop("checked", DropChart.config.useFirstRowAsLabels);
    }
    if (typeof DropChart.config.useFirstRowAsGraph !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="useFirstRowAsGraph"] input')
            .val(DropChart.config.useFirstRowAsGraph === true ? 'yes' : 'no').prop("checked", DropChart.config.useFirstRowAsGraph);
    }
    if (typeof DropChart.config.width !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="width"] input').val(DropChart.config.width).change();
    }
    if (typeof DropChart.config.height !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="height"] input').val(DropChart.config.height).change();
    }
    if (typeof DropChart.config.chart_align !== 'undefined') {
        Droptables_element.chartTabContent.find('.controls[name="chart_align"] select').val(DropChart.config.chart_align).change();
        Droptables_element.DroptablesContentChart.css('text-align', DropChart.config.chart_align);
    }
    DropChart.optionsChanged = true;
}

//action option changing
function initChartObserver() {
    if (!table_function_data.allowed_edit) {
        return false;
    }
    var $ = jquery;

    $('#droptable_chart .option_chart').unbind('change').on('change', function (e) {
        if (DropChart.optionsChanged !== true) {
            return;
        }
        var dropChart = DropChart.datas[DropChart.id_chart];

        switch ($(this).parents('.controls').attr('name')) {
            case 'dataUsing':
                dropChart.config.dataUsing = $(this).val();
                // var dataSets = DropChart.functions.getDataSets(DropChart.cells, dropChart.config.dataUsing);
                // DropChart.datasets = addChartStyles(dataSets[0], dropChart.config.colors);  // dataSets[0];
                // if (dropChart.config.useFirstRowAsLabels) {
                //     DropChart.labels = dataSets[1];
                // } else {
                //     DropChart.labels = DropChart.helper.getEmptyArray(dataSets[1].length);
                // }
                DropChart.functions.render(DropChart.id_chart, false, true);
                break;
            case 'useFirstRowAsLabels':
                if ($(this).is(":checked")) {
                    dropChart.config.useFirstRowAsLabels = true;
                } else {
                    dropChart.config.useFirstRowAsLabels = false;
                }
                DropChart.functions.render(DropChart.id_chart, false, true);
                break;
            case 'useFirstRowAsGraph':
                if ($(this).is(":checked")) {
                    dropChart.config.useFirstRowAsGraph = true;
                } else {
                    dropChart.config.useFirstRowAsGraph = false;
                }
                DropChart.functions.render(DropChart.id_chart, false, true);
                break;
            case 'width':
                dropChart.config.width = parseInt($(this).val());
                DropChart.functions.render(DropChart.id_chart, true, true);
                break;
            case 'height':
                dropChart.config.height = parseInt($(this).val());
                DropChart.functions.render(DropChart.id_chart, true, true);
                break;
            case 'chart_align':
                dropChart.config.chart_align = $(this).val();
                DropChart.config.chart_align = $(this).val();
                if (dropChart.config.chart_align !== 'none') {
                    Droptables_element.DroptablesContentChart.css('text-align', dropChart.config.chart_align);
                } else {
                    Droptables_element.DroptablesContentChart.css('text-align', 'left');
                }
                DropChart.functions.save();
                break;
            case 'dataset_select':
                var index = parseInt($(this).val());
                var $dataset_color = Droptables_element.chartTabContent.find('.controls[name="dataset_color"] input.minicolors');
                dropChart.change_dataset_select = true;
                var color;
                if (DropChart.type == "Line" || DropChart.type == "Bar" || DropChart.type == "Radar") {
                    if (dropChart.config.colors.split(",").length > index) {
                        color = dropChart.config.colors.split(",")[index];
                        $dataset_color.minicolors('value', color);
                        $dataset_color.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
                        // $dataset_color.wpColorPicker('color', dropChart.config.colors.split(",")[index]);
                    } else {
                        color ='';
                        $dataset_color.minicolors('value', color);
                        $dataset_color.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
                    }
                } else {
                    if (dropChart.config.pieColors.split(",").length > index) {
                        color = dropChart.config.pieColors.split(",")[index];
                        $dataset_color.minicolors('value', color);
                        $dataset_color.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
                    } else {
                        color ='';
                        $dataset_color.minicolors('value', color);
                        $dataset_color.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
                    }
                }
                break;
            case 'dataset_color':
                var index = parseInt(Droptables_element.chartTabContent.find('.controls[name="dataset_select"] select').val());
                if (DropChart.type == "Line" || DropChart.type == "Bar" || DropChart.type == "Radar") {
                    var colors = dropChart.config.colors.split(",");
                    colors[index] = $(this).val();
                    dropChart.config.colors = colors.join(",");
                    // var dataSets = DropChart.functions.getDataSets(DropChart.cells, dropChart.config.dataUsing);
                    // if (typeof DropChart.config.useFirstRowAsGraph !== 'undefined' && DropChart.config.useFirstRowAsGraph !== true) {//remove first row/column
                    //     dataSets[0].shift();
                    // }
                    // DropChart.datasets = addChartStyles(dataSets[0], dropChart.config.colors);
                } else {
                    var pieColors = dropChart.config.pieColors.split(",");
                    if (pieColors.length <= index) {
                        var maxLabels = DropChart.labels.length;
                        var maxPieColors = pieColors.length;
                        var i;
                        for (i = 0; i < maxLabels; i++) {
                            pieColors[i] = pieColors[i % maxPieColors];
                        }
                    }
                    pieColors[index] = $(this).val();
                    dropChart.config.pieColors = pieColors.join(",");
                }
                if (dropChart.change_dataset_select === true) {
                    dropChart.change_dataset_select = false;
                } else {
                    DropChart.functions.render(DropChart.id_chart, true, true);
                }
                break;
            default:
                break;
        }
    });

    $('#droptable_chart .option_chart').unbind('click').on('click', function (e) {
        if (DropChart.optionsChanged !== true) {
            return;
        }
        var dropChart = DropChart.datas[DropChart.id_chart];

        switch ($(this).parents('.controls').attr('name')) {
            case 'type':
                changeStyleChart($(this).data('id'));
                break;
            case 'changerChart':
                _alternating__WEBPACK_IMPORTED_MODULE_1__.default.affterRangeLabe.call(Droptables_element.chartTabContent, window.Droptables, window.jquery);
                changerRangeChart();
                break;
            default:
                break;
        }
    });
}

function changeStyleChart(charttype_id) {
    var $ = jquery;
    var id_chart = DropChart.id_chart;
    $.ajax({
        url: Droptables.ajaxurl + "index.php?option=com_droptables&view=charttyle&format=json&id=" + charttype_id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
        type: 'POST',
        data: {}
    }).done(function (data) {
        if (typeof (data) === 'object') {
            //local save
            if (data.config !== '') {
                $.extend(DropChart.datas[id_chart].config, $.parseJSON(data.config));
            }
            DropChart.datas[id_chart].type = data.name;

            DropChart.functions.render(id_chart, false, true);
        }
    });
}

function changerRangeChart() {
    var $ = jquery;
    var id_chart = DropChart.id_chart;
    var dataChart = DropChart.datas[id_chart];

    var dataCell = DropChart.functions.validateChartData();
    if (dataCell === false) {
        bootbox.alert(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_CHART_INVALID_DATA_ERROR',
            'Cannot generate chart from those data selection, please make a new data range selection with at least one row or column and some numeric data, thanks!'));
    } else {
        dataChart.data = dataCell;
        DropChart.changer = true;
        DropChart.functions.render(id_chart, false, true);
    }
}

function extractContent(s) {
    var span = document.createElement('span');
    span.innerHTML = s;
    var text = span.textContent || span.innerText;
    span.remove();
    return text;
}

function convertForPie(dataSets, useFirstRowAsLabels, colors, dataUsing) {
    var result = {};
    result.datasets = [];

    if (typeof dataSets.data === 'undefined' || dataSets.data.length < 1) {
        return false;
    }

    var numberLine, countDatasets, dataSet, pieColors, arrayShiftData;

    numberLine = dataSets.data.length;
    countDatasets = dataSets.data[0].length;
    arrayShiftData = typeof dataSets.arrayShiftData !== 'undefined' && dataSets.arrayShiftData ? true : false;

    for (var i = 0; i < numberLine; i++) {
        dataSet = jquery.extend({}, {});

        if (typeof dataSets.graphLabel[i] !== 'undefined' && typeof dataSets.graphLabel[i][0] !== 'undefined' && dataSets.graphLabel[i][0] === '<') {
            dataSet.label = extractContent(dataSets.graphLabel[i]);
        } else {
            dataSet.label = dataSets.graphLabel[i];
        }

        dataSet.currency_symbol = dataSets.currency_symbol[i];
        if (typeof dataSets.data2 !== 'undefined' && typeof dataSets.data2[i] !== 'undefined') {
            dataSet.data_format = dataSets.data2[i];
        } else {
            dataSet.data_format = dataSets.data[i];
        }
        result.labels = jquery.extend([], []);
        pieColors = jquery.extend({}, {});

        if (dataUsing === 'pieColors') {
            dataSet.highlight = [];
            dataSet.backgroundColor = [];
            dataSet.borderColor = [];
            dataSet.pointBackgroundColor = [];
            dataSet.pointColor = [];
            dataSet.pointBorderColor = [];
            dataSet.pointHighlightFill = [];
        }

        for (var j = 0; j < countDatasets; j++) {
            if (!(typeof dataSets.deleteData !== 'undefined'
                && ((arrayShiftData && typeof dataSets.deleteData[j + 1] !== 'undefined' && dataSets.deleteData[j + 1] === numberLine
                    || (!arrayShiftData && typeof dataSets.deleteData[j] !== 'undefined' && dataSets.deleteData[j] === numberLine)))
            )) {//has delete data
                if (typeof dataSet.data === 'undefined') {
                    dataSet.data = [];
                }
                dataSet.data.push(dataSets.data[i][j]);//data da duoc remove arrayShiftData tu truoc
                if (useFirstRowAsLabels) {
                    result.labels.push(dataSets.axisLabels[j]);
                } else {
                    result.labels.push('');
                }

                if (dataUsing === 'pieColors') {
                    pieColors = getStyleSet(j, colors);
                    dataSet.highlight.push(pieColors.highlight);
                    dataSet.backgroundColor.push(pieColors.backgroundColor);
                    dataSet.borderColor.push(pieColors.borderColor);
                    dataSet.pointBackgroundColor.push(pieColors.pointBackgroundColor);
                    dataSet.pointColor.push(pieColors.pointColor);
                    dataSet.pointBorderColor.push(pieColors.pointBorderColor);
                    dataSet.pointHighlightFill.push(pieColors.pointHighlightFill);
                }
            }
        }
        if (dataUsing !== 'pieColors') {
            pieColors = getStyleSet(i, colors);
            dataSet = jquery.extend({}, dataSet, pieColors);
        }
        result.datasets[i] = dataSet;
    }

    return result;
}

function getStyleSet(i, colors) {
    var styleSet = {};

    var color = getColor(i, colors);
    if (color != "") {
        styleSet.highlight = DropChart.helper.ColorLuminance(color, 0.3);
        styleSet.backgroundColor = DropChart.helper.convertHex(color, 70);
        styleSet.borderColor = DropChart.helper.convertHex(color, 80);
        styleSet.pointBackgroundColor = DropChart.helper.convertHex(color, 50);
        styleSet.pointColor = "#fff";
        styleSet.pointHighlightFill = "#fff";
        styleSet.pointBorderColor = DropChart.helper.convertHex(color, 40);
    }

    return styleSet;
}

function getColor(i, colors) {
    var result = "";
    var arrColors = colors.split(",");
    var len = arrColors.length;
    if (len > 0) {
        result = arrColors[i % len];
    }

    return result;
}

function addChartStyles(dataSets, colors) {
    var result = [];
    var dataset, styleSet;

    for (var i = 0; i < dataSets.length; i++) {
        dataset = dataSets[i];
        styleSet = getStyleSet(i, colors);
        jquery.extend(dataset, styleSet);
        result.push(dataset);
    }

    return result;
}

DropChart.functions.addChart = function () {
    if ((typeof Droptables.id !== 'undefined' && Droptables.id !== '') || table_function_data.selectionSize < 2) {
        var $ = jquery;
        var selection = DropChart.functions.validateChartData();
        if (selection === false) {
            bootbox.alert(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_CHART_INVALID_DATA_ERROR',
                'Cannot generate chart from those data selection, please make a new data range selection with at least one row or column and some numeric data, thanks!') + '<img src="' + Droptables.url + '/components/com_droptables/assets/images/Create-chart.gif" style="width: 100%;margin-top: 20px"/>');
            return;
        }

        $.ajax({
            url: Droptables.ajaxurl + "index.php?option=com_droptables&task=chart.add&id_table=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
            type: "POST",
            dataType: "json",
            data: {datas: JSON.stringify(selection)},
            beforeSend: function () {
                Droptables_element.settingTable.find('.ajax_loading').addClass('loadding').removeClass('droptable_hiden');
                Droptables_element.primary_toolbars.find('.new_chart_menu').closest('li').addClass('menu_loading');
            },
            success: function (datas) {
                Droptables_element.settingTable.find('.ajax_loading').removeClass('loadding').addClass('droptable_hiden');
                if (datas.response === true) {
                    var count = $('#list_chart').find('li.chart-menu').length;
                    var data_chart = datas.datas;
                    $('#list_chart').append('<li class="chart-menu" data-id="' + data_chart.id + '"><a>' + data_chart.title + '</a></li>');
                    DropChart.datas[data_chart.id] = {
                        config: DropChart.default,
                        data: $.parseJSON(data_chart.datas),
                        title: data_chart.title,
                        type: "Line",
                    };
                    droptable_chart(true);
                    _functions__WEBPACK_IMPORTED_MODULE_0__.default.showChartOrTable(true, $('#list_chart').find('.chart-menu').eq(count));
                } else {
                    bootbox.alert(datas.response, 'ok');
                }
            },
            error: function (jqxhr, textStatus, error) {
                Droptables_element.settingTable.find('.ajax_loading').removeClass('loadding').addClass('droptable_hiden');
                bootbox.alert(textStatus + " : " + error, 'ok');
            }
        });
    } else {
        bootbox.alert(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_CHART_INVALID_DATA_ERROR',
            'Cannot generate chart from those data selection, please make a new data range selection with at least one row or column and some numeric data, thanks!'), 'Go it');
    }
}

DropChart.functions.render = function (chart_id, re_render, save_chart) {
    var $ = jquery;
    DropChart.id_chart = chart_id;
    var datas = DropChart.datas[chart_id];
    DropChart.cells = datas.data;
    DropChart.type = datas.type;

    try {
        DropChart.config = $.extend({}, DropChart.default, datas.config);
    } catch (e) {
        DropChart.config = $.extend({}, DropChart.default, $.parseJSON(datas.config));
    }

    if (datas.config === null) {
        datas.config = $.extend({}, DropChart.default);
    }

    //destroy old chart version
    if (DropChart.chart) {
        DropChart.chart.clear();
        DropChart.chart.destroy();
    }

    var chartData = {};
    var dataSets = DropChart.functions.getDataSets2(DropChart.cells, DropChart.config.dataUsing);

    var change_dataUsing = false;
    if (typeof dataSets.data === 'undefined' || dataSets.data.length < 1) {
        if (DropChart.config.dataUsing === 'column') {
            DropChart.config.dataUsing = 'row';
            datas.config.dataUsing = 'row';
        } else {
            DropChart.config.dataUsing = 'column';
            datas.config.dataUsing = 'column';
        }

        dataSets = DropChart.functions.getDataSets2(DropChart.cells, DropChart.config.dataUsing);

        // chartData.datasets = addChartStyles(dataSets[0], DropChart.config.colors);
        change_dataUsing = true;
    }

    var chartData;
    switch (DropChart.type) {
        case 'PolarArea':
        case 'Pie':
        case 'Doughnut':
            chartData = convertForPie(dataSets, DropChart.config.useFirstRowAsLabels, DropChart.config.pieColors, 'pieColors');
            break;
        case 'Bar':
        case 'Radar':
        case 'Line':
        default:
            chartData = convertForPie(dataSets, DropChart.config.useFirstRowAsLabels, DropChart.config.colors, 'colors');
            break;
    }

    if (change_dataUsing) {
        Droptables_element.chartTabContent.find('.controls[name="dataUsing"] span.droptable_notice').show();
        setTimeout(function () {
            Droptables_element.chartTabContent.find('.controls[name="dataUsing"] span.droptable_notice').hide();
        }, 2000);
    }

    //hiden all canvas except chart_id
    Droptables_element.DroptablesContentChart.find('.canvas').addClass('droptable_hiden');
    var $canvas = Droptables_element.DroptablesContentChart.find('canvas.droptable_chart_' + chart_id);
    if ($canvas.length < 1 || re_render) {
        $canvas.remove();
        $canvas = $('<canvas class="canvas droptable_chart_' + chart_id + '" width="' + DropChart.config.width + '" height="' + DropChart.config.height + '"   ><canvas>')
            .appendTo(Droptables_element.DroptablesContentChart);
    } else {
        $canvas.width(DropChart.config.width);
        $canvas.height(DropChart.config.height);
    }
    $canvas.removeClass('droptable_hiden');
    var ctx = $canvas.get(0).getContext("2d");

    DropChart.labels = chartData.labels;
    DropChart.datasets = chartData.datasets;
    if (DropChart.datasets.length > 0) {
        DropChart.config.plugins = {};
        DropChart.config.plugins.tooltip = {
            enabled: true,
            callbacks: {
                label: function (tooltipItems) {
                    var label = '';
                    var data = tooltipItems.chart.config._config.data;
                    if (data.useFirstRowAsLabels) {
                        if (data.datasets.length > 1) {
                            label = data.datasets[tooltipItems.datasetIndex].label || '';
                        } else if (tooltipItems.label === '') {
                            label = data.labels[tooltipItems.dataIndex] || '';
                        }

                        if (label) {
                            label += ': ';
                        }
                    }

                    // var dataCell = data.datasets[tooltipItems.datasetIndex].data[tooltipItems.dataIndex];
                    if (typeof data.datasets[tooltipItems.datasetIndex].data_format[tooltipItems.dataIndex] !== 'undefined') {
                        label += data.datasets[tooltipItems.datasetIndex].data_format[tooltipItems.dataIndex];
                    } else {
                        label += data.datasets[tooltipItems.datasetIndex].data[tooltipItems.dataIndex];
                    }
                    return label;
                }
            }
        };
    } else {
        bootbox.alert(Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_CHART_INVALID_DATA_ERROR',
            'Cannot generate chart from those data selection, please make a new data range selection with at least one row or column and some numeric data, thanks!'), 'Go it');
    }

    try {
        chartData.useFirstRowAsLabels = DropChart.config.useFirstRowAsLabels;
        DropChart.config.scaleBeginAtZero = false;//fix the original value of the shaft
        DropChart.config.responsive = false;//fix the original value of the shaft

        var data_config = $.extend({}, DropChart.config);//
        if (typeof data_config.scales !== 'undefined') {
            delete data_config.scales;//fix the chart shows the wrong axes
        }
        switch (DropChart.type) {
            case 'PolarArea':
                DropChart.chart = new Chart(ctx, {
                    type: 'polarArea',
                    data: chartData,
                    options: data_config
                });
                break;

            case 'Pie':
                DropChart.chart = new Chart(ctx, {
                    type: 'pie',
                    data: chartData,
                    options: data_config
                });
                break;

            case 'Doughnut':
                DropChart.chart = new Chart(ctx, {
                    type: 'doughnut',
                    data: chartData,
                    options: data_config
                });
                break;

            case 'Bar':
                DropChart.chart = new Chart(ctx, {
                    type: 'bar',
                    data: chartData,
                    options: data_config
                });
                break;

            case 'Radar':
                DropChart.chart = new Chart(ctx, {
                    type: 'radar',
                    data: chartData,
                    options: data_config
                });
                break;

            case 'Line':
            default:
                DropChart.chart = new Chart(ctx, {
                    type: 'line',
                    data: chartData,
                    options: data_config
                });
                break;
        }

        DropChart.optionsChanged = false;
        //update val of selector to chart option
        if (!re_render) {
            updateOption(datas);
        } else {
            DropChart.optionsChanged = true;
        }
        initChartObserver();
        if (save_chart) {
            DropChart.functions.save();
        }
    } catch (e) {}
}

DropChart.functions.save = function () {
    if (!table_function_data.allowed_edit) {
        return;
    }

    var $ = jQuery;
    var jsonVar = {
        jform: {
            type: DropChart.type,
            config: JSON.stringify(DropChart.config)
        },
        id: DropChart.id_chart
    };

    if (DropChart.changer === true) {
        jsonVar.jform.datas = JSON.stringify(DropChart.cells);
        DropChart.changer = false;
    }
    jsonVar[Droptables.token] = "1";
    var $saving = $('.droptable_top_chart .saving');
    $saving.html(Joomla.JText._('COM_DROPTABLES_TABLES_SAVING', 'Saving...'));
    $saving.animate({'opacity': '1'}, 200);
    $.ajax({
        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=chart.save" + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
        dataType: "json",
        type: "POST",
        data: jsonVar,
        success: function (datas) {
            if (datas.response === true) {
                $saving.html(Joomla.JText._('COM_DROPTABLES_TABLES_SAVED', 'All changes saved')).delay(500).animate({'opacity': '0'}, 200);
            } else {
                $saving.animate({'opacity': '0'}, 200);
                bootbox.alert(datas.response, 'Ok');
            }
        },
        error: function (jqxhr, textStatus, error) {
            $saving.animate({'opacity': '0'}, 200);
            bootbox.alert(textStatus + " : " + error, 'Ok');
        }
    });
}

DropChart.functions.getDataSets = function (cells, dataUsing) {
    DropChart.currency_symbol = typeof Droptables.style.table.currency_symbol === 'undefined'
        ? default_value.currency_symbol
        : Droptables.style.table.currency_symbol;
    DropChart.thousand_symbol = typeof Droptables.style.table.thousand_symbol === 'undefined'
        ? default_value.thousand_symbol
        : Droptables.style.table.thousand_symbol;
    DropChart.decimal_symbol = typeof Droptables.style.table.decimal_symbol === 'undefined'
        ? default_value.decimal_symbol
        : Droptables.style.table.decimal_symbol;


    var result = {};
    var axisLabels = [];
    var deleteLine = [];

    if (!dataUsing) {
        dataUsing = "row";
    }
    var cellsData = DropChart.helper.getRangeData(cells);

    if (cellsData.length === 0) {
        return false;
    }
    if (dataUsing !== "row") {//default get cell data by row then need to change
        cellsData = DropChart.helper.transposeArr(cellsData);
    }

    result.deleteData = [];
    result.data = [];
    result.graphLabel = [];
    result.axisLabels = [];
    result.currency_symbol = [];
    result.arrayShiftData = false;

    var checkCellsHaveNaN, checkCellsHaveNanNull, countCellInLine, cellsData1, deleteData1, currency_symbol, lineData, getStrangeCharacters, j;

    for (var i = 0; i < cellsData.length; i++) {
        checkCellsHaveNaN = 0;
        checkCellsHaveNanNull = 0;
        countCellInLine = cellsData[i].length;
        cellsData1 = jquery.extend([], []);
        deleteData1 = jquery.extend([], []);
        currency_symbol = 0;

        for (var ii = 0; ii < countCellInLine; ii++) {
            getStrangeCharacters = DropChart.helper.getStrangeCharacters(cellsData[i][ii]);
            checkCellsHaveNaN += getStrangeCharacters['NaN'];
            cellsData1[ii] = getStrangeCharacters['value'];

            if (getStrangeCharacters['null_nan'] === 1) {
                deleteData1[ii] = 1;
                checkCellsHaveNanNull++;
            }

            if (getStrangeCharacters['currency_symbol'] === 1) {
                currency_symbol++;
            }
        }

        var line_die = checkCellsHaveNaN === countCellInLine || (countCellInLine > 2 && checkCellsHaveNaN + 2 > countCellInLine);
        if (line_die || i === 0) {//line Have NaN or first line
            axisLabels.push(cellsData[i]);// x-axis
            deleteLine.push(i);//lines to be removed
        }
        if (!line_die && checkCellsHaveNanNull < countCellInLine) {//get this line, that have cell value
            for (j in deleteData1) {
                if (typeof result.deleteData[j] === 'undefined') {
                    result.deleteData[j] = 0;
                }
                result.deleteData[j] += 1;
            }

            result.data.push(cellsData1);//array key 1, 2, 3,...|| in $cellsData1, may contain non-validated cells
            result.graphLabel.push(cellsData[i][0]);//array key 1, 2, 3,...||$value[0] first value

            if (currency_symbol > 1) {
                result.currency_symbol.push(1);
            } else {
                result.currency_symbol.push(-1);
            }
        }
    }

    var numberLine = result.data.length;
    if (numberLine > 0) {
        var useFirstRowAsGraph = typeof DropChart.config.useFirstRowAsGraph !== 'undefined' ? DropChart.config.useFirstRowAsGraph : true;

        if (axisLabels.length > 0) {//can remove
            result.axisLabels = axisLabels[axisLabels.length - 1];
        }

        if (useFirstRowAsGraph === true) {
            for (var i2 = 0; i2 < numberLine; i2++) {
                result.data[i2].shift();
            }
            result.arrayShiftData = true;

            if (typeof result.deleteData[0] !== 'undefined' && result.deleteData[j] !== 0) {
                result.deleteData[0] = 0;
            }

            result.axisLabels.shift();
        }
    }

    return result;
}

DropChart.functions.getDataSets2 = function (cells, dataUsing) {
    DropChart.currency_symbol = typeof Droptables.style.table.currency_symbol === 'undefined'
        ? default_value.currency_symbol
        : Droptables.style.table.currency_symbol;
    DropChart.thousand_symbol = typeof Droptables.style.table.thousand_symbol === 'undefined'
        ? default_value.thousand_symbol
        : Droptables.style.table.thousand_symbol;
    DropChart.decimal_symbol = typeof Droptables.style.table.decimal_symbol === 'undefined'
        ? default_value.decimal_symbol
        : Droptables.style.table.decimal_symbol;


    var result = {};
    var axisLabels = [];
    var deleteLine = [];

    if (!dataUsing) {
        dataUsing = "row";
    }

    result.deleteData = [];
    result.data = [];
    result.data2 = [];
    result.data_raw = [];
    result.data_raw1 = [];
    result.graphLabel = [];
    result.axisLabels = [];
    result.currency_symbol = [];

    if (dataUsing !== "row") {//default get cell data by row then need to change
        cells = DropChart.helper.transposeArr(cells);
    }

    var cell_value, j, checkCellsHaveNaN, countCellInLine, cellsData1, cellsData2, deleteData1, currency_symbol, lineData, getStrangeCharacters;
    for (var i = 0; i < cells.length; i++) {
        checkCellsHaveNaN = 0;
        countCellInLine = cells[i].length;
        cellsData2 = jquery.extend([], []);
        cellsData1 = jquery.extend([], []);
        result.data_raw[i] = jquery.extend([], []);
        result.data_raw1[i] = jquery.extend([], []);
        deleteData1 = jquery.extend([], []);
        currency_symbol = 0;
        lineData = jquery.extend([], cells[i]);

        for (var ii = 0; ii < countCellInLine; ii++) {
            j =  cells[i][ii];
            j = j.split(":");
            cell_value = typeof Droptables.datas[parseInt(j[0])][parseInt(j[1])] !== 'undefined' && Droptables.datas[parseInt(j[0])][parseInt(j[1])] !== null ? Droptables.datas[parseInt(j[0])][parseInt(j[1])] : '';
            cell_value = _customRenderer__WEBPACK_IMPORTED_MODULE_2__.default.render(false, false, parseInt(j[0]), parseInt(j[1]), false, cell_value, 'cellProperties', true);
            result.data_raw[i].push(cell_value[0]);
            result.data_raw1[i].push(cell_value[1]);
            cell_value = DropChart.helper.getStrangeCharacters2(cell_value, typeof cell_value[1] !== 'undefined');
            //[0] value format, [1] float value, [2] Nan, [3] currency_symbol
            checkCellsHaveNaN += cell_value[2];
            cellsData2[ii] = cell_value[0];
            cellsData1[ii] = cell_value[1];

            if (cell_value[2] === 1) {
                deleteData1[ii] = 1;
            }

            if (typeof cell_value[3] !== 'undefined' && cell_value[3] === 1) {
                currency_symbol++;
            }
        }

        if (checkCellsHaveNaN === countCellInLine || (countCellInLine > 2 && checkCellsHaveNaN + 2 > countCellInLine)) {//line Have NaN
            axisLabels.push(cellsData2);
            deleteLine.push(i);
        } else {//get this line, that have cell value
            for (j in deleteData1) {
                if (typeof result.deleteData[j] === 'undefined') {
                    result.deleteData[j] = 0;
                }
                result.deleteData[j] += 1;
            }
            result.data.push(cellsData1);//array key 1, 2, 3,...|| in $cellsData1, may contain non-validated cells
            result.data2.push(cellsData2);//array key 1, 2, 3,...|| in $cellsData1, may contain non-validated cells
            result.graphLabel.push(cellsData2[0]);//array key 1, 2, 3,...||$value[0] first value

            if (currency_symbol > 1) {
                result.currency_symbol.push(1);
            } else {
                result.currency_symbol.push(-1);
            }
        }
    }

    var numberLine = result.data.length;
    if (numberLine > 0) {
        var useFirstRowAsGraph = typeof DropChart.config.useFirstRowAsGraph !== 'undefined' ? DropChart.config.useFirstRowAsGraph : true;
        //if line number > 1 then not get cell is graphLabel else < 1 then get it
        if (numberLine > 1 && result.data_raw.length > 1 && !(result.data_raw.length === 2 && useFirstRowAsGraph !== true)) {//have > 1 line in chart
            for (var i2 = 0; i2 < numberLine; i2++) {
                result.data[i2].shift();
                result.data2[i2].shift();
            }
            result.arrayShiftData = true;

            if (typeof result.deleteData[0] !== 'undefined' && result.deleteData[j] !== 0) {
                result.deleteData[0] = 0;
            }
        }

        if (axisLabels.length > 0) {//useFirstRowAsGraph become useless
            result.axisLabels = axisLabels[0];
        } else {
            if (numberLine > 0) {//axisLabels from $result.data_raw[0] || all line be passed validated
                result.axisLabels = result.data_raw[0];
                if (useFirstRowAsGraph !== true) {
                    result.data.shift();
                    result.data2.shift();
                    result.currency_symbol.shift();
                    result.graphLabel.shift();
                }
            }
        }

        if (typeof result.arrayShiftData !== 'undefined') {
            result.axisLabels.shift();
        }

        for (var j2 in result.deleteData) {//not deleted yet cells not pass
            if (numberLine !== result.deleteData[j2]) {
                result.deleteData[j2] = 0;
            }
        }
    }

    return result;
}

//get valid chart data area
// return: valid data , col indexes, row indexes
DropChart.functions.getValidChartData = function (cellsData) {
    var i, tempIndexes;
    var results = [];
    var resultIndexes = [];
    var rowIndexes = [];
    for (i = 0; i < cellsData[0].length; i++) {
        resultIndexes.push(i);
    }

    for (i = 0; i < cellsData.length; i++) {
        if (DropChart.helper.isValidRow(cellsData[i])) {
            results.push(cellsData[i]);
            rowIndexes.push(i);
            tempIndexes = DropChart.helper.getValidIndexes(cellsData[i]);
            resultIndexes = DropChart.helper.intersection(tempIndexes, resultIndexes);
        }
    }
    var tempArr = [];

    for (i = 0; i < results.length; i++) {
        tempArr = [];
        for (var j = 0; j < tempIndexes.length; j++) {
            tempArr.push(results[i][tempIndexes[j]]);
        }
        results[i] = tempArr;
    }
    return [results, resultIndexes, rowIndexes];
}

DropChart.functions.checkValidRowData = function (array) {
    return !array.some(function (value, index, array) {
        return value !== array[0];
    });
}

DropChart.functions.validateChartData = function () {
    var selection = table_function_data.selection[0], rValid, cValid, emptyRow;
    //no cell selected or only one cell
    if (selection.length == 0 || selection[0] == selection[2] || selection[1] == selection[3]) {
        return false;
    }

    var cellRange = new Array();
    var Cells = Droptables_element.tableContainer.handsontable('getData', selection[0], selection[1], selection[2], selection[3]);
    //Check row
    rValid = DropChart.helper.hasNumbericRow(Cells);
    var rCells;
    if (!rValid) {
        //check column
        rCells = DropChart.helper.transposeArr(Cells);
        cValid = DropChart.helper.hasNumbericRow(rCells);

        if (!cValid) { //ignore first row and column
            cValid = DropChart.helper.hasNumbericRowCol(rCells[0]);
            if (!cValid) {
                cValid = DropChart.helper.hasNumbericRowCol(rCells[1]);
            }
            var subCells = DropChart.helper.removeFirstRowColumn(rCells);
            if (subCells.length <= 0) return false;
        }
    }

    if (rValid || cValid) {
        //read data
        for (var r = 0; r < Cells.length; r++) {
            if (!DropChart.functions.checkValidRowData(Cells[r])) {
                cellRange[r] = new Array();
                for (var c = 0; c < Cells[r].length; c++) {
                    cellRange[r][c] = (selection[0] + r) + ":" + (selection[1] + c);
                }
            }
        }
        var newCellRange = cellRange.filter(function (el) {
            return el != null && el !== '';
        });
        return newCellRange;
    } else {
        return false;
    }
}

//check val of cells to chart of table
DropChart.functions.validateCharts = function (change) {
    var result = true;
    var $ = jQuery;
    var editCell = change[0] + ":" + change[1];

    $.each(DropChart.datas, function (chart_id, chart) {
        if (chart_id) {
            var cells = chart.data;
            if (DropChart.helper.inArrays(editCell, cells)) {
                var cellsData = [];
                for (var i = 0; i < cells.length; i++) {
                    var rowData = [];
                    for (var j = 0; j < cells[i].length; j++) {
                        if (cells[i][j] != editCell) {
                            rowData[j] = _functions__WEBPACK_IMPORTED_MODULE_0__.default.getCellData(cells[i][j]);
                        } else {
                            rowData[j] = change[3];//new value
                        }
                    }
                    cellsData[i] = rowData;
                }

                if (!validateDataForChart(cellsData)) {
                    result = false;
                }
            }
        }
    });

    return result;
}

function validateDataForChart(Cells) {
    var rValid, rCells, cValid, subCells, rsubCells;
    //Check row
    rValid = DropChart.helper.hasNumbericRow(Cells);
    if (!rValid) {
        //check column
        rCells = DropChart.helper.transposeArr(Cells);
        cValid = DropChart.helper.hasNumbericRow(rCells);
        if (!cValid) { //ignore first row and column

            subCells = DropChart.helper.removeFirstRowColumn(rCells);
            if (subCells.length <= 0) return false;

            rValid = DropChart.helper.hasNumbericRow(subCells);
            if (!rValid) {
                rsubCells = DropChart.helper.transposeArr(subCells);
                cValid = DropChart.helper.hasNumbericRow(rsubCells);
            }
        }
    }

    return (rValid || cValid);
}

DropChart.helper = {}

DropChart.helper.getStrangeCharacters2 = function (value) {
    var value1, value0;
    value0 = typeof value[1] !== 'undefined' ? value[1].toString().replaceAll(' ', '') : value[0].replaceAll(' ', '');
    value1 = value0.replace(DropChart.currency_symbol, '');
    value1 = value1.replace(DropChart.thousand_symbol, '');
    value1 = value1.replace(DropChart.decimal_symbol, '.');
    value[1] = value1.replace(/[^0-9|\\.|-]/g, '');//value

    value[2] = 0;//nan
    value[3] = 0;//currency_symbol
    value1 = value1.replace(/[0-9|\\.|,|-| ]/g, '');

    if (value1 !== '' || value[0] === '') {//have strange characters or is null
        value[2] = 1;
    }
    if (value[0] !== '' && (value[0].includes(DropChart.currency_symbol) || arguments[1] === true)) {
        value[3] = 1;
    }

    return value;
}

DropChart.helper.getStrangeCharacters = function (value) {
    var data = [], value1;
    value1 = value.replace(DropChart.currency_symbol, '');
    value1 = value1.replace(DropChart.thousand_symbol, '');
    value1 = value1.replace(DropChart.decimal_symbol, '.');
    data['value'] = value1.replace(/[^0-9|,|-]/g, '');
    data['NaN'] = 0;
    data['null_nan'] = 0;
    data['currency_symbol'] = 0;
    value1 = value1.replace(/[0-9|\\.|,|-| ]/g, '');

    if (value1 !== '') {//have strange characters
        data['NaN'] = 1;
    }

    if (value === '' || value1 !== '') {//is null
        data['null_nan'] = 1;
    }

    if (data['value'] !== '' && value !== '' && value.includes(DropChart.currency_symbol)) {
        data['currency_symbol'] = 1;
    }

    return data;
}

//get index of valid number in the array
DropChart.helper.getValidIndexes = function (arr) {
    var currency_symbol = typeof Droptables.style.table.currency_symbol === 'undefined'
        ? default_value.currency_symbol
        : Droptables.style.table.currency_symbol;
    var thousand_symbol = typeof Droptables.style.table.thousand_symbol === 'undefined'
        ? default_value.thousand_symbol
        : Droptables.style.table.thousand_symbol;

    // var thousand_re = new RegExp(thousand_symbol,"g");
    var thousand_re = new RegExp('[' + thousand_symbol + ']', "g");
    var i, v, x1;
    var result = [];

    for (i = 0; i < arr.length; i++) {

        v = arr[i] ? arr[i].toString() : "";
        x1 = v.replace(currency_symbol, '');
        x1 = x1.replace(thousand_re, '');
        x1 = x1.replace(/[\\.|+|,| ]/g, '');
        x1 = x1.replace(/-/g, '');
        x1 = x1.replace(/[0-9]/g, '');
        if (x1 === '') {
            result.push(i);
        }
    }
    return result;
}

//get intersection values of two array
DropChart.helper.intersection = function (a, b) {
    var rs = [];
    for (var i = 0; i < a.length; i++) {
        if (b.indexOf(a[i]) != -1) {
            rs.push(a[i]);
        }
    }
    return rs;
};


DropChart.helper.isNumbericArray = function (arr) {
    var valid = true;
    for (var c = 0; c < arr.length; c++) {
        if (isNaN(arr[c])) {
            valid = false;
        }
    }

    return valid;
};

DropChart.helper.convertToNumber = function (arr) {
    var result = [];
    for (var c = 0; c < arr.length; c++) {
        // if (!isNaN(arr[c])) {
        if (typeof arr[c] === 'string') {
            arr[c] = _functions__WEBPACK_IMPORTED_MODULE_0__.default.stringReplace(arr[c], false);
        }
        result.push(arr[c]);
        // }
    }
    return result;
};

DropChart.helper.transposeArr = function (arr) {
    if (typeof arr === "undefined" || arr.length === 0) {
        return [];
    }
    return Object.keys(arr[0]).map(function (c) {
        return arr.map(function (r) {
            return r[c];
        });
    });
}
DropChart.helper.inArrays = function (c, cells) {
    var result = false;
    for (var r = 0; r < cells.length; r++) {
        if (cells[r].indexOf(c) > -1) {
            result = true;
        }
    }

    return result;
}


// there is at least 2 number
DropChart.helper.isValidRow = function (arr) {
    var currency_symbol = typeof Droptables.style.table.currency_symbol === 'undefined'
        ? default_value.currency_symbol
        : Droptables.style.table.currency_symbol;
    var thousand_symbol = typeof Droptables.style.table.thousand_symbol === 'undefined'
        ? default_value.thousand_symbol
        : Droptables.style.table.thousand_symbol;

    var thousand_re = new RegExp('[' + thousand_symbol + ']', "g");
    var i, v, x1, count = 0;

    for (i = 0; i < arr.length; i++) {
        v = arr[i] ? arr[i].toString() : "";
        if (v !== '') {
            x1 = v.replace(currency_symbol, '');
            x1 = x1.replace(thousand_re, '');
            x1 = x1.replace(/[\\.|+|,| ]/g, '');
            x1 = x1.replace(/-/g, '');
            x1 = x1.replace(/[0-9]/g, '');
            if (x1 === '') {
                count++;
            }
        }
    }
    return (count > 1);
}

DropChart.helper.hasNumbericRow = function (Cells) {
    var rValid = false;
    if (typeof Cells === "undefined") {
        return false;
    }

    for (var r = 0; r < Cells.length; r++) {
        if (DropChart.helper.isValidRow(Cells[r])) {
            rValid = true;
            break;
        }
    }
    return rValid;
}

// check val int cel in row
DropChart.helper.hasNumbericRowCol = function (Cells) {
    var rValid = true;
    var rNaN = 0;
    if (typeof Cells === "undefined") {
        return false;
    }
    for (var r = 0; r < Cells.length; r++) {
        var valid = true;
        if (typeof (Cells[r]) === 'string' && isNaN(parseInt(_functions__WEBPACK_IMPORTED_MODULE_0__.default.stringReplace(Cells[r], false)))) {
            valid = false;
        }

        if (!valid) {
            rNaN++;
        }
    }

    if (rNaN === Cells.length) {
        rValid = false;
    }
    return rValid;
}

DropChart.helper.getRowData = function (row) {
    var data = [];
    for (var j = 0; j < row.length; j++) {
        data[j] = _functions__WEBPACK_IMPORTED_MODULE_0__.default.getCellData(row[j]);
    }

    return data;
}

DropChart.helper.getRangeData = function (cells) {
    var datas = [];
    for (var i = 0; i < cells.length; i++) {
        datas[i] = DropChart.helper.getRowData(cells[i]);
    }

    return datas;
}

DropChart.helper.getCellRangeLabel = function (cells) {
    var data = [];
    var firstCell = cells[0][0];
    var lastRow = cells[cells.length - 1];
    var lastCell = lastRow[lastRow.length - 1];

    var pos = firstCell.split(":");
    data[0] = parseInt(pos[0]);
    data[1] = parseInt(pos[1]);

    pos = lastCell.split(":");
    data[2] = parseInt(pos[0]);
    data[3] = parseInt(pos[1]);
    return data;
}

DropChart.helper.canSwitchRowCol = function (cellsData) {
    var result = -1;
    var rValid = false;
    var cValid = false;
    if (DropChart.helper.hasNumbericRow(cellsData)) {
        rValid = true;
    }
    var rCellsData = DropChart.helper.transposeArr(cellsData);
    if (DropChart.helper.hasNumbericRow(rCellsData)) {
        cValid = true;
    }

    if (rValid && cValid) {
        result = 3;
    } else if (rValid) {
        result = 2;
    } else if (cValid) {
        result = 1;
    } else {
        // invalid data
        result = -1;
    }

    return result;
}

DropChart.helper.removeFirstRowColumn = function (cells) {
    cells.shift();
    if (cells.length > 0) {
        cells = DropChart.helper.transposeArr(cells);
        cells.shift();
    }

    return cells;
}
DropChart.helper.getEmptyArray = function (len) {
    var result = [];
    for (var i = 0; i < len; i++) {
        result[i] = "    ";
    }
    return result;
}

DropChart.helper.convertHex = function (hex, opacity) {
    hex = hex.replace('#', '');
    var r = parseInt(hex.substring(0, 2), 16);
    var g = parseInt(hex.substring(2, 4), 16);
    var b = parseInt(hex.substring(4, 6), 16);

    return 'rgba(' + r + ',' + g + ',' + b + ',' + opacity / 100 + ')';
}

DropChart.helper.ColorLuminance = function (hex, lum) {

    // validate hex string
    hex = String(hex).replace(/[^0-9a-f]/gi, '');
    if (hex.length < 6) {
        hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2];
    }
    lum = lum || 0;

    // convert to decimal and change luminosity
    var rgb = "#", c, i;
    for (i = 0; i < 3; i++) {
        c = parseInt(hex.substr(i * 2, 2), 16);
        c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
        rgb += ("00" + c).substr(c.length);
    }

    return rgb;
}

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (DropChart);

/***/ }),

/***/ "./site/assets/js/_customRenderer.js":
/*!*******************************************!*\
  !*** ./site/assets/js/_customRenderer.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_functions */ "./site/assets/js/_functions.js");


/*month text and aug calculator cell*/
var F_name = ["january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december"];
var M_name = ["jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sept", "oct", "nov", "dec"];
var l_name = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
var D_name = ["sun", "mon", "tue", "wed", "thu", "fri", "sat"];
var regex2 = new RegExp('([a-zA-Z]+)([0-9]+)');
var regex3 = new RegExp('([a-zA-Z]+)([0-9]+)', 'g');
/* List of supported formulas */
var regex = new RegExp('^=(DATE|DAY|DAYS|DAYS360|AND|OR|XOR|SUM|MULTIPLY|DIVIDE|COUNT|MIN|MAX|AVG|CONCAT|date|day|days|days360|and|or|xor|sum|multiply|divide|count|min|max|avg|concat)\\((.*?)\\)$');
var not_replace = ['DATE','DAY','DAYS','DAYS360','CONCAT'];
var Not_range_function = ['DATE','DAY','DAYS','DAYS360'];

var merge_style_val_cell = function (style_cols, style_rows, Droptables, row, col) {
    var cellStyle = [];
    if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(style_cols, col, 1)) {
        cellStyle[2] = jquery.extend([], style_cols[col][1]);
    }
    if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(style_rows, row, 1)) {
        cellStyle[2] = jquery.extend([], cellStyle[2], style_rows[row][1]);
    }

    if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(Droptables.style,'cells', row + "!" + col, 2)) {
        if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(Droptables.style.cells[row + "!" + col][2], 'tooltip_content')) {
            cellStyle[2].tooltip_content = Droptables.style.cells[row + "!" + col][2].tooltip_content;
            cellStyle[2].tooltip_width = Droptables.style.cells[row + "!" + col][2].tooltip_width;
        }
        if (Droptables.type === 'html' || row == 0) {
            cellStyle[2] = jquery.extend({}, cellStyle[2], Droptables.style.cells[row + "!" + col][2]);
        }
    } else {//if Droptables.style.cells[row + "!" + col] not exist
        if (typeof cellStyle[2] !== 'undefined' && (Droptables.type === 'html' || row == 0)) {
            Droptables.style.cells[row + "!" + col] = [row, col, {}];
            window.Droptables.style.cells[row + '!' + col][2] = jquery.extend({}, cellStyle[2]);
        }
    }
    return cellStyle;
}

/**
 * function render cell when handsontable render, call in handsontable.renderer
 *
 * @param instance
 * @param td             cell element
 * @param row            now number
 * @param col            col number
 * @param prop
 * @param value          cell value
 * @param cellProperties
 * @returns {*}
 */
var render = function (instance, td, row, col, prop, value, cellProperties) {
    var onl_value_cell = false;
    if (typeof Array.prototype.slice.call(arguments, 6)[1] !== "undefined") {
        // onl_value_cell = true;
        onl_value_cell = Array.prototype.slice.call(arguments, 6)[1];
    }
    var Droptables = window.Droptables;
    var function_data = window.table_function_data;
    var css = {};
    var celltype = '', tooltip_content = false;
    if (typeof (Droptables.style.cells) !== 'undefined') {
        //Cells rendering
        var cellStyle = merge_style_val_cell(Droptables.style.cols, Droptables.style.rows, Droptables, row, col);

        if (!onl_value_cell) {
            if (typeof (cellStyle[2]) !== 'undefined') {
                if (typeof cellStyle[2].AlternateColor !== 'undefined' || typeof function_data.allAlternate.default !== 'undefined') {
                    var numberRow = 0;
                    css["background-color"] = '';
                    if (typeof function_data.allAlternate.default !== 'undefined') {

                        if (function_data.allAlternate.header === '') {
                            numberRow = -1;
                        }
                        switch (row) {
                            case 0:
                                if (function_data.allAlternate.header === '') {
                                    css["background-color"] = function_data.allAlternate.even;
                                } else {
                                    css["background-color"] = function_data.allAlternate.header;
                                }
                                break;
                            case Droptables.style.rows.length - 1:
                                if (function_data.allAlternate.footer === '') {
                                    if ((row - parseInt(0 + numberRow)) % 2) {
                                        css["background-color"] = function_data.allAlternate.even;
                                    } else {
                                        css["background-color"] = function_data.allAlternate.old;
                                    }
                                } else {
                                    css["background-color"] = function_data.allAlternate.footer;
                                }
                                break;
                            default:
                                if ((row - parseInt(0 + numberRow)) % 2) {
                                    css["background-color"] = function_data.allAlternate.even;
                                } else {
                                    css["background-color"] = function_data.allAlternate.old;
                                }
                                break;
                        }
                    } else {
                        var value_cell_alternateColor = function_data.oldAlternate[cellStyle[2].AlternateColor];
                        if (typeof value_cell_alternateColor === 'undefined') {
                            if (typeof function_data.changeAlternate[cellStyle[2].AlternateColor] !== 'undefined' || function_data.changeAlternate.length < 1) {
                                cellStyle[2].AlternateColor = function_data.changeAlternate[cellStyle[2].AlternateColor];
                                value_cell_alternateColor = function_data.oldAlternate[cellStyle[2].AlternateColor];
                            }
                        }

                        if (typeof value_cell_alternateColor !== 'undefined' && value_cell_alternateColor !== false && typeof value_cell_alternateColor.selection !== 'undefined') {
                            if (value_cell_alternateColor.header === '') {
                                numberRow = -1;
                            }
                            switch (row) {
                                case parseInt(value_cell_alternateColor.selection[0]):
                                    if (value_cell_alternateColor.header === '') {
                                        css["background-color"] = value_cell_alternateColor.even;
                                    } else {
                                        css["background-color"] = value_cell_alternateColor.header;
                                    }
                                    break;
                                case parseInt(value_cell_alternateColor.selection[2]):
                                    if (value_cell_alternateColor.footer === '') {
                                        if ((row - parseInt(value_cell_alternateColor.selection[0]) + numberRow) % 2) {
                                            css["background-color"] = value_cell_alternateColor.even;
                                        } else {
                                            css["background-color"] = value_cell_alternateColor.old;
                                        }
                                    } else {
                                        css["background-color"] = value_cell_alternateColor.footer;
                                    }
                                    break;
                                default:
                                    if ((row - parseInt(value_cell_alternateColor.selection[0]) + numberRow) % 2) {
                                        css["background-color"] = value_cell_alternateColor.even;
                                    } else {
                                        css["background-color"] = value_cell_alternateColor.old;
                                    }
                                    break;
                            }
                        } else {
                            delete cellStyle[2].AlternateColor;
                            if (typeof Droptables.style.cells[row + "!" + col][2] !== 'undefined' && typeof Droptables.style.cells[row + "!" + col][2].AlternateColor !== 'undefined') {
                                delete Droptables.style.cells[row + "!" + col][2].AlternateColor;
                            }
                        }
                    }
                }

                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_type')) {
                    celltype = cellStyle[2].cell_type;
                } else if (typeof cellStyle[2].cell_type !== 'undefined') {
                    delete cellStyle[2].cell_type;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_background_color')) {
                    css["background-color"] = cellStyle[2].cell_background_color;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_border_top')) {
                    css["border-top"] = cellStyle[2].cell_border_top;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_border_top_start')) {
                    if (0 == row) {
                        css["border-top"] = cellStyle[2].cell_border_top_start;
                    }
                }

                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_border_right')) {
                    css["border-right"] = cellStyle[2].cell_border_right;
                }

                //check merge cell and border right
                if (typeof table_function_data.start_merge_cell_col !== 'undefined' && typeof table_function_data.start_merge_cell_col[col] !== 'undefined') {
                    window.jquery.each(table_function_data.start_merge_cell_col[col], function (index, value) {
                        if (typeof value !== 'undefined') {
                            var start_merge_cell_col = window.Droptables.style.table.mergeSetting[value];
                            if (start_merge_cell_col.rowspan + start_merge_cell_col.row > row && row >= start_merge_cell_col.row) {
                                var end_style = merge_style_val_cell(Droptables.style.cols, Droptables.style.rows, Droptables, row, start_merge_cell_col.col + start_merge_cell_col.colspan - 1);
                                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(end_style, 2, 'cell_border_right')) {
                                    css["border-right"] = end_style[2].cell_border_right;
                                }
                            }
                        }
                    });
                }

                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_border_bottom')) {
                    css["border-bottom"] = cellStyle[2].cell_border_bottom;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_border_bottom_end')) {
                    if (Droptables.style.rows.length - 1 == row) {
                        css["border-bottom"] = cellStyle[2].cell_border_bottom_end;
                    }
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'cell_border_left')) {
                    css["border-left"] = cellStyle[2].cell_border_left;
                }

                delete css["word-wrap"];
                delete css["overflow"];
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle,2,'text_wrapping')) {
                    if (cellStyle[2].text_wrapping === 'normal') {
                        css["word-wrap"] = "normal";
                        css["overflow"] = "visible";
                        css["white-space"] = "nowrap";
                    } else if (cellStyle[2].text_wrapping === 'break-word') {
                        css["word-wrap"] = "break-word";
                        css["overflow"] = "visible";
                    } else if (cellStyle[2].text_wrapping === 'hidden') {
                        css["overflow"] = "hidden";
                        css["white-space"] = "nowrap";
                    }
                }

                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_font_bold') && cellStyle[2].cell_font_bold === true) {
                    css["font-weight"] = "bold";
                } else {
                    delete css["font-weight"];
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_font_italic') && cellStyle[2].cell_font_italic === true) {
                    css["font-style"] = "italic";
                } else {
                    delete css["font-style"];
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_font_underline') && cellStyle[2].cell_font_underline === true) {
                    css["text-decoration"] = "underline";
                } else {
                    delete css["text-decoration"];
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_text_align')) {
                    css["text-align"] = cellStyle[2].cell_text_align;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_vertical_align')) {
                    css["vertical-align"] = cellStyle[2].cell_vertical_align;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_font_family')) {
                    css["font-family"] = cellStyle[2].cell_font_family;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_font_size')) {
                    css["font-size"] = cellStyle[2].cell_font_size + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_font_color')) {
                    css["color"] = cellStyle[2].cell_font_color;
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_padding_left')) {
                    css["padding-left"] = cellStyle[2].cell_padding_left + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_padding_top')) {
                    css["padding-top"] = cellStyle[2].cell_padding_top + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_padding_right')) {
                    css["padding-right"] = cellStyle[2].cell_padding_right + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_padding_bottom')) {
                    css["padding-bottom"] = cellStyle[2].cell_padding_bottom + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_background_radius_left_top')) {
                    css["border-top-left-radius"] = cellStyle[2].cell_background_radius_left_top + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_background_radius_right_top')) {
                    css["border-top-right-radius"] = cellStyle[2].cell_background_radius_right_top + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_background_radius_right_bottom')) {
                    css["border-bottom-right-radius"] = cellStyle[2].cell_background_radius_right_bottom + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(cellStyle, 2, 'cell_background_radius_left_bottom')) {
                    css["border-bottom-left-radius"] = cellStyle[2].cell_background_radius_left_bottom + "px";
                }
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(cellStyle, 2, 'tooltip_content')) {
                    tooltip_content = cellStyle[2].tooltip_content !== '' ? true : false;
                }
            }

            //render style for table
            window.jquery(td).css(css);
            if (Object.keys(css).length > 0) {
                function_data.styleToRender += '.dtr' + row + '.dtc' + col + '{';
                window.jquery.each(css, function (index, value) {
                    function_data.styleToRender += index + ':' + value + ';';
                });
                function_data.styleToRender += '}';
            }
        }
    }

    if (!onl_value_cell) {
        switch (celltype) {
            case 'html':
                var escaped = Handsontable.helper.stringify(value);
                //escaped = strip_tags(escaped, '<div><span><img><em><b><a>'); //be sure you only allow certain HTML tags to avoid XSS threats (you should also remove unwanted HTML attributes)
                td.innerHTML = replace_all_rel_by_abs(escaped);
                // td.innerHTML = escaped;
                window.jquery(td).addClass('isHtmlCell');
                break;
            default:
                window.jquery(td).removeClass('isHtmlCell');
                Handsontable.renderers.TextRenderer.apply(this, arguments);
                break;
        }

        if (tooltip_content) {
            window.jquery(td).addClass('isTooltipContent');
        } else {
            window.jquery(td).removeClass('isTooltipContent');
        }
    }

    /* Cal rendering */
    if (typeof Droptables.style.table.date_formats === 'undefined') {
        Droptables.style.table.date_formats = window.default_value.date_formats;
    }
    var accounting_for_cells = {};
    var createRegExpFormatForCell = {};
    var currency_symbol = '';
    var setFormat_for_cells = {};
    var cell_has_format = 0;

    //not has time format
    [accounting_for_cells, createRegExpFormatForCell, currency_symbol, setFormat_for_cells, cell_has_format] = get_format_for_cell(cellStyle[2], Droptables.style.table, function_data.string_currency_symbols, cell_has_format);

    accounting_for_cells.date_formats = typeof cellStyle[2].date_formats !== 'undefined' && cellStyle[2].date_formats !== false ? cellStyle[2].date_formats : Droptables.style.table.date_formats;

    if (typeof cellStyle[2].date_formats !== 'undefined' && cellStyle[2].date_formats !== '' && cellStyle[2].date_formats !== false) {
        if (typeof cellStyle[2].date_formats_momentjs !== 'undefined' && cellStyle[2].date_formats_momentjs !== '' && cellStyle[2].date_formats_momentjs !== false) {
            accounting_for_cells.date_formats_momentjs = cellStyle[2].date_formats_momentjs;
        } else {
            accounting_for_cells.date_formats_momentjs = _functions__WEBPACK_IMPORTED_MODULE_0__.default.momentjsFormat(accounting_for_cells.date_formats);
        }
    } else if (typeof accounting_for_cells.date_formats !== 'undefined') {
        if (typeof function_data.date_formats_momentjs !== 'undefined' && function_data.date_formats_momentjs !== '') {
            accounting_for_cells.date_formats_momentjs = function_data.date_formats_momentjs;
        } else {
            accounting_for_cells.date_formats_momentjs = _functions__WEBPACK_IMPORTED_MODULE_0__.default.momentjsFormat(Droptables.style.table.date_formats);
        }
    } else {
        accounting_for_cells.date_formats_momentjs = '';
    }

    // if (typeof accounting_for_cells.date_formats !== 'undefined' && cellStyle[2].date_formats !== false) {
    //     accounting_for_cells.date_formats_momentjs = typeof cellStyle[2].date_formats_momentjs !== 'undefined' && cellStyle[2].date_formats_momentjs !== '' ? cellStyle[2].date_formats_momentjs : tableFunction.momentjsFormat(Droptables.style.table.date_formats);
    // } else {
    //     accounting_for_cells.date_formats_momentjs = '';
    // }

    //accounting_for_cells.date_formats_momentjs from cell/table
    if (typeof cellStyle[2].date_formats !== 'undefined' && cellStyle[2].date_formats !== false) {
        createRegExpFormatForCell = _functions__WEBPACK_IMPORTED_MODULE_0__.default.createRegExpFormatForCell(false, accounting_for_cells.date_formats, createRegExpFormatForCell);
    }

    var value_null = value === null || value === '' ? true : false;
    if (typeof (value) === 'string') {
        var value_cell = value;
        var valueNotFormat;
        if (value[0] === '=') {
            value_cell = evaluateFormulas2(td, row, col, value, Droptables, function_data, accounting_for_cells, createRegExpFormatForCell, setFormat_for_cells, cell_has_format, onl_value_cell, cellStyle);
        } else {
            if (value_null) {
                window.jquery(td).text(value);
            }

            if (currency_symbol !== '' && value.replace(currency_symbol, "") === '') {
                value = value.replaceAll(accounting_for_cells.number.thousand, '');
                value = value.replaceAll(accounting_for_cells.number.decimal, '.');
                valueNotFormat = value;

                if (cell_has_format === 1) {
                    value_cell = accounting.formatNumber(value, accounting_for_cells.number.precision,  accounting_for_cells.number.thousand,  accounting_for_cells.number.decimal);
                }
                if (cell_has_format > 1) {
                    value_cell = accounting.formatMoney(value, accounting_for_cells.currency);
                }

                if (onl_value_cell) {
                    valueNotFormat = accounting.formatMoney(value, "", accounting_for_cells.number.precision, typeof Droptables.style.table.thousand_symbol === 'undefined'
                        ? default_value.thousand_symbol
                        : Droptables.style.table.thousand_symbol, typeof Droptables.style.table.decimal_symbol === 'undefined'
                        ? default_value.decimal_symbol
                        : Droptables.style.table.decimal_symbol);
                }

                if (!onl_value_cell && !value_null) {
                    window.jquery(td).text(value_cell);
                }
            }

            if (typeof createRegExpFormatForCell.date_format !== 'undefined'
                && accounting_for_cells.date_formats !== '') {
                value_cell = moment(value, function_data.date_formats_momentjs).format(cellStyle[2].date_formats_momentjs);
                valueNotFormat = value;

                if (!onl_value_cell && !value_null) {
                    window.jquery(td).text(value_cell);
                }
            }
        }

        if (celltype == 'html' && (cell_has_format >= 1 || typeof createRegExpFormatForCell.date_format !== 'undefined')) {
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.getFillArray([[row, col, row, col]], Droptables, {
                date_formats: false,
                date_formats_momentjs: false,
                currency_symbol: false,
                symbol_position: false,
                decimal_symbol: false,
                decimal_count: false,
                thousand_symbol: false
            }, 'style');
            var text = window.jquery(td).text();
            saveData.push({action: 'edit_cell', row: row, col: col, content: text});
        }
        if (onl_value_cell) {
            return typeof value_cell === 'string' ? [value_cell, valueNotFormat] : value_cell;
        }
    }
    window.jquery(td).addClass('dtr' + row + ' dtc' + col);

    if (!onl_value_cell) {
        //add class for lock column of db table
        if (typeof Droptables.style.table.lock_columns !== 'undefined' && Droptables.style.table.lock_columns[col] != 0) {
            window.jquery(td).addClass('droptable_lock_column');
        }

        if (!Droptables.check_super_user) {
            var lock_cell_id = [], not_lock_cell = false;
            if (typeof table_function_data.protect_columns !== 'undefined'
                && typeof table_function_data.protect_columns[col] !== 'undefined') {
                //protect columns
                lock_cell_id.push(table_function_data.protect_columns[col]);
            }
            if (typeof table_function_data.protect_rows !== 'undefined'
                && typeof table_function_data.protect_rows[row] !== 'undefined') {
                //protect rows
                lock_cell_id.push(table_function_data.protect_rows[row]);
            }
            if (typeof Droptables.style.cells[row + "!" + col][2].lock_cell !== 'undefined') {
                lock_cell_id.push(Droptables.style.cells[row + "!" + col][2].lock_cell);
            }
            if (lock_cell_id.length > 0 && typeof lock_cell_id[0] !== 'undefined'
                && typeof table_function_data.lock_ranger_cells_user !== 'undefined') {
                for (var ij in lock_cell_id) {
                    if (table_function_data.lock_ranger_cells_user[lock_cell_id[ij]]) {//allow edit
                        not_lock_cell = true;
                        break;
                    }
                }
                if (!not_lock_cell) {
                    window.jquery(td).addClass('droptable_lock_cells');
                }
            }
        }
    }

    return td;
};

function setFormat_for_cell(cellStyle, cellStyle2, cell_has_format) {
    var setFormat_for_cells = {};
    setFormat_for_cells.thousand_symbol = typeof cellStyle.thousand_symbol !== 'undefined' && cellStyle.thousand_symbol !== false && cell_has_format !== 1 ? cellStyle.thousand_symbol : cellStyle2.thousand_symbol;
    setFormat_for_cells.decimal_count = typeof cellStyle.decimal_count !== 'undefined' && cellStyle.decimal_count !== false && cell_has_format !== 1 ? cellStyle.decimal_count : cellStyle2.decimal_count;
    setFormat_for_cells.decimal_symbol = typeof cellStyle.decimal_symbol !== 'undefined' && cellStyle.decimal_symbol !== false && cell_has_format !== 1 ? cellStyle.decimal_symbol : cellStyle2.decimal_symbol;

    setFormat_for_cells.currency_symbol = typeof cellStyle.currency_symbol !== 'undefined' && cellStyle.currency_symbol !== false && cell_has_format < 2 ? cellStyle.currency_symbol : cellStyle2.currency_symbol;
    setFormat_for_cells.symbol_position = typeof cellStyle.symbol_position !== 'undefined' && cellStyle.symbol_position !== false && cell_has_format < 2 ? cellStyle.symbol_position : cellStyle2.symbol_position;

    return [_functions__WEBPACK_IMPORTED_MODULE_0__.default.setFormat_accounting_for_cells(setFormat_for_cells), setFormat_for_cells];
}

function get_format_for_cell(cellStyle, cellStyle2, string_currency_symbols, cell_has_format) {
    var accounting_for_cells = {};
    var setFormat_for_cells = {};
    var createRegExpFormatForCell = {};
    var currency_symbol = '';

    if ((typeof cellStyle.decimal_count !== 'undefined' && cellStyle.decimal_count !== false)
        || (typeof cellStyle.decimal_symbol !== 'undefined' && cellStyle.decimal_symbol !== false)
        || (typeof cellStyle.currency_symbol !== 'undefined' && cellStyle.currency_symbol !== false)) {

        [accounting_for_cells, setFormat_for_cells] = setFormat_for_cell(cellStyle, cellStyle2, cell_has_format);

        if (typeof setFormat_for_cells.currency_symbol === "undefined") {
            setFormat_for_cells.currency_symbol = false;
        }
        createRegExpFormatForCell = _functions__WEBPACK_IMPORTED_MODULE_0__.default.createRegExpFormatForCell(setFormat_for_cells.currency_symbol, false, {});

        if (typeof cellStyle.currency_symbol !== 'undefined' && cellStyle.currency_symbol !== '' && cellStyle.symbol_position !== false) {
            cell_has_format += 2;
        }
        if (cell_has_format !== 1 && ((typeof cellStyle.decimal_count !== 'undefined' && cellStyle.decimal_count !== false) || (typeof cellStyle.decimal_symbol !== 'undefined' && cellStyle.decimal_symbol !== false))) {
            cell_has_format += 1;
        }

        currency_symbol = new RegExp('[0-9| |\.|\,|\\-|' + (typeof createRegExpFormatForCell.string_currency_symbols !== 'undefined' ? createRegExpFormatForCell.string_currency_symbols : string_currency_symbols) + ']', "g");
    }
    return [accounting_for_cells, createRegExpFormatForCell, currency_symbol, setFormat_for_cells, cell_has_format];
}

// Evaluate formula in cell then set value to td
function evaluateFormulas2 (td, row, col, value, Droptables, function_data, accounting_for_cells, createRegExpFormatForCell, setFormat_for_cells, cell_has_format, onl_value_cell, style_cell) {
    var error = false;
    var result = regex.exec(value);
    var valueReturn = 'NaN';
    var valueNotFormat = 'NaN';
    var cellStyle, format_cell_by_table = null;
    var changeFormatCell = 0;
    var save_change_format = false;

    if (result !== null) {
        var calculation;
        calculation = result[1];
        var check_value_data = true;
        var update_format_second = cell_has_format;
        var update_date_formats_momentjs = accounting_for_cells.date_formats_momentjs;

        var check_has_currency_symbol = false;
        var cell_decimal_symbol = typeof accounting_for_cells.decimal !== 'undefined' ? accounting_for_cells.currency.decimal : Droptables.style.table.decimal_symbol;
        var date_format = typeof createRegExpFormatForCell.date_format !== 'undefined' ? createRegExpFormatForCell.date_format : function_data.date_format;

        var currency_symbol = new RegExp('[0-9| |\.|\,|\\-|' + (typeof createRegExpFormatForCell.string_currency_symbols !== 'undefined' ? createRegExpFormatForCell.string_currency_symbols : function_data.string_currency_symbols) + ']', "g");
        var cells = result[2].split(";");
        var values = [];
        //(A1:A2)(A1:A2;A3)(A1;A3)(A1;123)(A1;A2;A3:A4)(A1:A2;123)(123 > A1; A2) MIN|MAX|AVG|CONCAT
        var ij = 0, i = 0;
        for (ij = 0; ij < cells.length; ij++) {
            var rCells = [];
            var datas = '';
            var data = '';
            var vals = cells[ij].split(":");
            if (vals.length === 1 ) {//single cell
                values[ij] = '';

                var checkVal = vals[0].match(regex3);
                if (checkVal !== null) {
                    i = 0;
                    for (i = 0; i < checkVal.length; i++) {
                        //ex: B1 -> B, 1, B1
                        rCells = regex2.exec(checkVal[i]);
                        if (rCells !== null) {
                            cellStyle = Droptables.style.cells[(rCells[2] - 1) + '!' + (_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertAlpha(rCells[1].toUpperCase()) - 1)];
                            if (changeFormatCell < 1 && cell_has_format < 3
                                && ((typeof cellStyle[2].decimal_count !== 'undefined' && cellStyle[2].decimal_count !== false)
                                    || (typeof cellStyle[2].decimal_symbol !== 'undefined' && cellStyle[2].decimal_symbol !== false)
                                    || (typeof cellStyle[2].currency_symbol !== 'undefined' && cellStyle[2].currency_symbol !== false))
                            ) {
                                changeFormatCell = 1;
                                [accounting_for_cells, createRegExpFormatForCell, currency_symbol, setFormat_for_cells, cell_has_format] = get_format_for_cell(cellStyle[2], setFormat_for_cells, function_data.string_currency_symbols, cell_has_format);
                                if (typeof style_cell !== "undefined") {
                                    if (update_format_second !== 1) {
                                        if (style_cell[2].thousand_symbol_second !== (typeof setFormat_for_cells.thousand_symbol !== 'undefined' ? setFormat_for_cells.thousand_symbol : false)) {
                                            style_cell[2].thousand_symbol_second = typeof setFormat_for_cells.thousand_symbol !== 'undefined' ? setFormat_for_cells.thousand_symbol : false;
                                            save_change_format = true;
                                        }
                                        if (style_cell[2].decimal_count_second !== (typeof setFormat_for_cells.decimal_count !== 'undefined' ? setFormat_for_cells.decimal_count : false)) {
                                            style_cell[2].decimal_count_second = typeof setFormat_for_cells.decimal_count !== 'undefined' ? setFormat_for_cells.decimal_count : false;
                                            save_change_format = true;
                                        }
                                        if (style_cell[2].decimal_symbol_second !== (typeof setFormat_for_cells.decimal_symbol !== 'undefined' ? setFormat_for_cells.decimal_symbol : false)) {
                                            style_cell[2].decimal_symbol_second = typeof setFormat_for_cells.decimal_symbol !== 'undefined' ? setFormat_for_cells.decimal_symbol : false;
                                            save_change_format = true;
                                        }
                                    }
                                    if (update_format_second !== 2) {
                                        if (style_cell[2].currency_symbol_second !== (typeof setFormat_for_cells.currency_symbol !== 'undefined' ? setFormat_for_cells.currency_symbol : false)) {
                                            style_cell[2].currency_symbol_second = typeof setFormat_for_cells.currency_symbol !== 'undefined' ? setFormat_for_cells.currency_symbol : false;
                                            save_change_format = true;
                                        }
                                        if (style_cell[2].symbol_position_second !== (typeof setFormat_for_cells.symbol_position !== 'undefined' ? setFormat_for_cells.symbol_position : false)) {
                                            style_cell[2].symbol_position_second = typeof setFormat_for_cells.symbol_position !== 'undefined' ? setFormat_for_cells.symbol_position : false;
                                            save_change_format = true;
                                        }
                                    }
                                }
                                cell_decimal_symbol = typeof accounting_for_cells.decimal !== 'undefined' ? accounting_for_cells.currency.decimal : setFormat_for_cells.decimal_symbol;
                            }

                            data = jquery(Droptables_element.tableContainer).handsontable('getDataAtCell', rCells[2] - 1, _functions__WEBPACK_IMPORTED_MODULE_0__.default.convertAlpha(rCells[1].toUpperCase()) - 1);

                            if (data !== null && typeof data !== 'undefined') {
                                check_has_currency_symbol = (data.indexOf(function_data.string_currency_symbols) > -1 || check_has_currency_symbol) ? true : false;
                                if (!not_replace.includes(calculation.toUpperCase())) {//replace in some calculation
                                    if (data.replace(currency_symbol, "") === '') {
                                        data = accounting.unformat(data, window.Droptables.style.table.decimal_symbol);
                                    } else {
                                        data = '';
                                    }
                                }
                                if (i === 0) {
                                    datas = vals[0].replace(checkVal[i], data);
                                } else {
                                    datas = datas.replace(checkVal[i], data);
                                }

                                // if (calculation.toUpperCase() === 'AND') {
                                //     console.log(datas);
                                // }
                            } else {
                                datas = data = '';
                            }
                        } else {
                            check_value_data = false;
                        }
                    }
                } else {
                    data = datas = vals[0];
                }
                if (datas !== null) {
                    values[ij] = datas;
                }
            } else {
                if (Not_range_function.includes(calculation.toUpperCase())) {//not set range in some calculation
                    check_value_data = false;
                }
                rCells[0] = regex2.exec(vals[0]);
                rCells[1] = regex2.exec(vals[1]);
                if (rCells[0] !== null && rCells[1] !== null) {
                    cellStyle = Droptables.style.cells[(rCells[0][2] - 1) + '!' + (_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertAlpha(rCells[0][1]) - 1)];

                    if (changeFormatCell < 1 && cell_has_format < 3
                        && ((typeof cellStyle[2].decimal_count !== 'undefined' && cellStyle[2].decimal_count !== false)
                            || (typeof cellStyle[2].decimal_symbol !== 'undefined' && cellStyle[2].decimal_symbol !== false)
                            || (typeof cellStyle[2].currency_symbol !== 'undefined' && cellStyle[2].currency_symbol !== false))
                    ) {
                        changeFormatCell = 1;
                        [accounting_for_cells, createRegExpFormatForCell, currency_symbol, setFormat_for_cells, cell_has_format] = get_format_for_cell(cellStyle[2], setFormat_for_cells, function_data.string_currency_symbols, cell_has_format);
                        if (typeof style_cell !== "undefined") {
                            if (update_format_second !== 1) {
                                if (style_cell[2].thousand_symbol_second !== (typeof setFormat_for_cells.thousand_symbol !== 'undefined' ? setFormat_for_cells.thousand_symbol : false)) {
                                    style_cell[2].thousand_symbol_second = typeof setFormat_for_cells.thousand_symbol !== 'undefined' ? setFormat_for_cells.thousand_symbol : false;
                                    save_change_format = true;
                                }
                                if (style_cell[2].decimal_count_second !== (typeof setFormat_for_cells.decimal_count !== 'undefined' ? setFormat_for_cells.decimal_count : false)) {
                                    style_cell[2].decimal_count_second = typeof setFormat_for_cells.decimal_count !== 'undefined' ? setFormat_for_cells.decimal_count : false;
                                    save_change_format = true;
                                }
                                if (style_cell[2].decimal_symbol_second !== (typeof setFormat_for_cells.decimal_symbol !== 'undefined' ? setFormat_for_cells.decimal_symbol : false)) {
                                    style_cell[2].decimal_symbol_second = typeof setFormat_for_cells.decimal_symbol !== 'undefined' ? setFormat_for_cells.decimal_symbol : false;
                                    save_change_format = true;
                                }
                            }
                            if (update_format_second !== 2) {
                                if (style_cell[2].currency_symbol_second !== (typeof setFormat_for_cells.currency_symbol !== 'undefined' ? setFormat_for_cells.currency_symbol : false)) {
                                    style_cell[2].currency_symbol_second = typeof setFormat_for_cells.currency_symbol !== 'undefined' ? setFormat_for_cells.currency_symbol : false;
                                    save_change_format = true;
                                }
                                if (style_cell[2].symbol_position_second !== (typeof setFormat_for_cells.symbol_position !== 'undefined' ? setFormat_for_cells.symbol_position : false)) {
                                    style_cell[2].symbol_position_second = typeof setFormat_for_cells.symbol_position !== 'undefined' ? setFormat_for_cells.symbol_position : false;
                                    save_change_format = true;
                                }
                            }
                        }
                        cell_decimal_symbol = typeof accounting_for_cells.decimal !== 'undefined' ? accounting_for_cells.currency.decimal : Droptables.style.table.decimal_symbol;
                        cell_decimal_symbol = typeof accounting_for_cells.decimal !== 'undefined' ? accounting_for_cells.currency.decimal : Droptables.style.table.decimal_symbol;
                    }

                    values[ij] = [];
                    rCells = jquery(Droptables_element.tableContainer).handsontable('getData', rCells[0][2] - 1, _functions__WEBPACK_IMPORTED_MODULE_0__.default.convertAlpha(rCells[0][1]) - 1, rCells[1][2] - 1, _functions__WEBPACK_IMPORTED_MODULE_0__.default.convertAlpha(rCells[1][1]) - 1);
                    i = 0;
                    for (i = 0; i < rCells.length; i++) {
                        if (!not_replace.includes(calculation.toUpperCase())) {//replace in some calculation
                            datas = [];
                            for (var j = 0; j < rCells[i].length; j++) {
                                check_has_currency_symbol = ((rCells[i][j] !== null && rCells[i][j].indexOf(window.Droptables.style.table.currency_symbol) > -1) || check_has_currency_symbol) ? true : false;
                                if (rCells[i][j] === null) {
                                    rCells[i][j] = '';
                                }
                                if (rCells[i][j].replace(currency_symbol, "") === '') {
                                    datas[j] = accounting.unformat(rCells[i][j], window.Droptables.style.table.decimal_symbol);
                                } else {
                                    datas[j] = '';
                                }
                                // datas[j] = accounting.unformat(rCells[i][j], Droptables.style.table.decimal_symbol);
                            }
                        } else {
                            datas = rCells[i];
                        }
                        if (datas === null) {
                            values[ij][i] = '';
                        } else {
                            values[ij][i] = datas;
                        }
                    }
                } else {
                    if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.convertDate(date_format, cells[ij].match(/[a-zA-Z0-9|+|-|\\]+/g), true) !== false) {
                        values[ij] = cells[ij];
                    } else {
                        check_value_data = false;
                    }
                }
            }
        }

        //remove format..._second
        if (changeFormatCell < 1 && cell_has_format < 3 && typeof style_cell !== "undefined") {
            if (typeof style_cell[2].thousand_symbol_second !== 'undefined' && style_cell[2].thousand_symbol_second !== false) {
                style_cell[2].thousand_symbol_second = false;
                save_change_format = true;
            }
            if (typeof style_cell[2].decimal_count_second !== 'undefined' && style_cell[2].decimal_count_second !== false) {
                style_cell[2].decimal_count_second = false;
                save_change_format = true;
            }
            if (typeof style_cell[2].decimal_symbol_second !== 'undefined' && style_cell[2].decimal_symbol_second !== false) {
                style_cell[2].decimal_symbol_second = false;
                save_change_format = true;
            }
            if (typeof style_cell[2].currency_symbol_second !== 'undefined' && style_cell[2].currency_symbol_second !== false) {
                style_cell[2].currency_symbol_second = false;
                save_change_format = true;
            }
            if (typeof style_cell[2].symbol_position_second !== 'undefined' && style_cell[2].symbol_position_second !== false) {
                style_cell[2].symbol_position_second = false;
                save_change_format = true;
            }
        }
        if (save_change_format) {
            saveData.push({action: 'style', selection: [[row, col, row, col]], style: style_cell[2]});
        }

        if (check_value_data === true) {
            switch (calculation.toUpperCase()) {
                case 'SUM':
                    valueNotFormat = formulajs.SUM(values);
                    if (check_has_currency_symbol || cell_has_format > 1) {
                        if (typeof accounting_for_cells.currency !== "undefined") {
                            valueReturn = accounting.formatMoney(valueNotFormat, accounting_for_cells.currency);
                        } else {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatMoney(valueNotFormat, format_cell_by_table[0].currency);
                        }
                    } else {
                        if (typeof accounting_for_cells.number !== "undefined") {
                            valueReturn = accounting.formatNumber(valueNotFormat, accounting_for_cells.number);
                        } else {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatNumber(valueNotFormat, format_cell_by_table[0].number);
                        }
                    }

                    break;
                case 'MULTIPLY':
                    valueNotFormat = 1;
                    values = merge_value_from_cells(values);
                    values.map(function (foo) {
                        if (foo !== false) {
                            var number = Number(foo);
                            if (!isNaN(number)) {
                                valueNotFormat = valueNotFormat * number;
                            } else {
                                check_value_data = false;
                            }
                        }
                    });
                    if (!check_value_data) {
                        valueReturn = 'NaN';
                        valueNotFormat = 'NaN';
                    } else {
                        if (check_has_currency_symbol || cell_has_format > 1) {
                            if (typeof accounting_for_cells.currency == "undefined") {
                                format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                                valueReturn = accounting.formatMoney(valueNotFormat, format_cell_by_table[0].currency);
                            } else {
                                valueReturn = accounting.formatMoney(valueNotFormat, accounting_for_cells.currency);
                            }
                        } else {
                            if (typeof accounting_for_cells.number == "undefined") {
                                format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                                valueReturn = accounting.formatNumber(valueNotFormat, format_cell_by_table[0].number);
                            } else {
                                valueReturn = accounting.formatNumber(valueNotFormat, accounting_for_cells.number);
                            }
                        }
                    }
                    break;
                case 'DIVIDE':
                    valueNotFormat = '';
                    values = merge_value_from_cells(values);

                    if (values.length !== 2) {
                        valueReturn = 'NaN';
                        valueNotFormat = 'NaN';
                        check_value_data = false;
                        break;
                    }

                    values[1] = Number(values[1]);

                    if (isNaN(values[1]) || values[1] == 0 ||  values[1] == '') {
                        valueReturn = 'NaN';
                        valueNotFormat = 'NaN';
                        check_value_data = false;
                        break;
                    }

                    values[0] = Number(values[0]);

                    if (isNaN(values[0])) {
                        valueReturn = 'NaN';
                        valueNotFormat = 'NaN';
                        check_value_data = false;
                        break;
                    }

                    valueNotFormat = values[0] / values[1];

                    if (!check_value_data) {
                        valueReturn = 'NaN';
                        valueNotFormat = 'NaN';
                    } else {
                        if (check_has_currency_symbol || cell_has_format > 1) {
                            if (typeof accounting_for_cells.currency == "undefined") {
                                format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                                valueReturn = accounting.formatMoney(valueNotFormat, format_cell_by_table[0].currency);
                            } else {
                                valueReturn = accounting.formatMoney(valueNotFormat, accounting_for_cells.currency);
                            }
                        } else {
                            if (typeof accounting_for_cells.number == "undefined") {
                                format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                                valueReturn = accounting.formatNumber(valueNotFormat, format_cell_by_table[0].number);
                            } else {
                                valueReturn = accounting.formatNumber(valueNotFormat, accounting_for_cells.number);
                            }
                        }
                    }
                    break;
                case 'AND':
                    valueReturn = 'true';
                    values = merge_value_from_cells(values);
                    values.map(function (foo) {
                        valueReturn = valueReturn && parse_boolean_calculation(foo, cell_decimal_symbol);
                    });
                    valueNotFormat = valueReturn;
                    break;
                case 'OR':
                    valueReturn = 'true';
                    values = merge_value_from_cells(values);
                    values.map(function (foo) {
                        valueReturn = valueReturn || parse_boolean_calculation(foo, cell_decimal_symbol);
                    });
                    valueNotFormat = valueReturn;
                    break;
                case 'XOR':
                    valueReturn = 0;
                    values = merge_value_from_cells(values);
                    values.map(function (foo) {
                        valueReturn += Number(parse_boolean_calculation(foo, cell_decimal_symbol));
                    });
                    valueReturn = ((valueReturn % 2) === 1) ? 'true' : 'false';
                    valueNotFormat = valueReturn;
                    break;
                case 'COUNT':
                    valueReturn = 0;
                    var currency_symbol = new RegExp('[ |\.|\,|\\-|' + window.Droptables.style.table.currency_symbol + ']', "g");
                    values = merge_value_from_cells(values);
                    values.map(function (foo) {
                        if (foo !== false) {
                            if (!isNaN(Number(foo)) && foo !== '') {
                                valueReturn = valueReturn + 1;
                            }
                        }
                    });
                    valueNotFormat = valueReturn;
                    break;
                case 'DATE':
                    var data_value = '';
                    if (values.length > 1) {
                        data_value = values.join('/');
                    } else {
                        data_value = values[0];
                    }

                    if (typeof data_value !== 'undefined') {
                        valueReturn = moment(data_value).formatWithJDF(accounting_for_cells.date_formats_momentjs);
                    } else {
                        valueReturn = 'NaN';
                        check_value_data = false;
                    }

                    //convert values --> (string) date pursuant date_format not have timezone
                    // if (values.length === 1) {
                    //     values = values[0].match(/[a-zA-Z0-9|+|-|\\]+/g);
                    // }
                    // var date_string = tableFunction.convertDate(date_format, values, false);
                    // date_string = date_string !== false ? new Date(date_string) : check_value_data = false;
                    //
                    // //convert values --> (string) date pursuant date_format have timezone
                    // var date_string_timezone = tableFunction.convertDate(date_format, values, true);
                    // date_string_timezone = date_string_timezone !== false ? new Date(date_string_timezone) : check_value_data = false;
                    // if (date_string_timezone && date_string_timezone.getDate() > 0 && check_value_data !== false) {
                    //     var format_resultCalc = accounting_for_cells.date_formats.split(/[a-zA-Z|\\]+/g);
                    //     var date = [];
                    //
                    //     date['month'] = date_string.getMonth();
                    //     date['date'] = date_string.getDate();
                    //     date['day'] = date_string.getDay();
                    //     date['year'] = date_string.getUTCFullYear();
                    //
                    //     date['D'] = D_name[date['day']];
                    //     date['l'] = l_name[date['day']];
                    //     date['j'] = date['date'];
                    //     date['d'] = (Number(date['date']) < 10) ? '0' + date['date'] : date['date'];
                    //     date['F'] = F_name[date['month']];
                    //     date['M'] = M_name[date['month']];
                    //     date['n'] = Number(date['month']) + 1;
                    //     date['m'] = (Number(date['month']) < 10) ? '0' + (Number(date['month']) + 1) : Number(date['month']) + 1;
                    //     date['Y'] = date['year'];
                    //     date['y'] = Number(date['year']) % 100;
                    //
                    //     valueReturn = format_resultCalc[0];
                    //     window.jquery.each(date_format, function (i, v) {
                    //         if (v.indexOf("\\") !== -1 || window.jquery.inArray(v, ["a", "A", "g", "G", "h", "H", "i", "s", "T"]) !== -1) {
                    //             date[v] = values[i];
                    //         }
                    //         valueReturn += date[v] + format_resultCalc[i + 1];
                    //     });
                    // } else {
                    //     valueReturn = 'NaN';
                    //     check_value_data = false;
                    // }
                    break;
                case 'DAY':
                    if (typeof values[0] !== 'undefined') {
                        valueNotFormat = values[0];
                        valueReturn = formulajs.DAY(values[0]);
                    }
                    break;
                case 'DAYS':
                    if (typeof values[0] !== 'undefined' && typeof values[1] !== 'undefined') {
                        valueReturn = formulajs.DAYS(values[0], values[1]);
                    }
                    valueNotFormat = valueReturn;
                    break;
                case 'DAYS360':
                    valueReturn = 0;
                    if (check_value_data !== false) {
                        var month = [];
                        var year = [];
                        var days = [];
                        var date1 = 0;
                        values.map(function (foo) {
                            if (foo !== false) {
                                valueReturn++;
                                var number = foo.match(/[a-zA-Z0-9|+|-|\\]+/g);
                                var string_day = _functions__WEBPACK_IMPORTED_MODULE_0__.default.convertDate(date_format, number, true);
                                if (string_day !== false) {
                                    date1 = new Date(string_day);
                                    if (!isNaN(date1.getTime())) {
                                        days[valueReturn] = date1.getDate();
                                        month[valueReturn] = date1.getMonth();
                                        year[valueReturn] = date1.getFullYear();
                                    }
                                }
                            }
                        });
                        if (year.length > 1) {
                            if (year[2] < year[1]) {
                                year[2] = year[1] + year[2];
                                year[1] = year[2] - year[1];
                                year[2] = year[2] - year[1];
                                month[2] = month[1] + month[2];
                                month[1] = month[2] - month[1];
                                month[2] = month[2] - month[1];
                                days[2] = days[1] + days[2];
                                days[1] = days[2] - days[1];
                                days[2] = days[2] - days[1];
                                year[4] = -1;
                            } else {
                                year[4] = 1;
                            }
                            year[3] = 0;

                            for (i = year[1]; i < year[2]; i++) {
                                year[3] += 1;
                            }
                            days[1] = (days[1] === 31) ? 30 : days[1];
                            days[2] = (days[2] === 31) ? 30 : days[2];
                            valueReturn = year[4] * (((year[3] - 1) * 360) + ((13 - month[1]) * 30 - days[1]) + ((month[2] - 1) * 30 + days[2]));
                            check_value_data = !isNaN(valueReturn);
                        } else {
                            valueReturn = 'NaN';
                            check_value_data = false;
                        }
                    } else {
                        valueReturn = 'NaN';
                    }
                    valueNotFormat = valueReturn;
                    break;
                case 'MIN':
                    valueNotFormat = formulajs.MIN(values);
                    if (check_has_currency_symbol || cell_has_format > 1) {
                        if (typeof accounting_for_cells.currency == "undefined") {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatMoney(valueNotFormat, format_cell_by_table[0].currency);
                        } else {
                            valueReturn = accounting.formatMoney(valueNotFormat, accounting_for_cells.currency);
                        }
                    } else {
                        if (typeof accounting_for_cells.number == "undefined") {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatNumber(valueNotFormat, format_cell_by_table[0].number);
                        } else {
                            valueReturn = accounting.formatNumber(valueNotFormat, accounting_for_cells.number);
                        }
                    }
                    break;
                case 'MAX':
                    valueNotFormat = formulajs.MAX(values);
                    if (check_has_currency_symbol || cell_has_format > 1) {
                        if (typeof accounting_for_cells.currency == "undefined") {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatMoney(valueNotFormat, format_cell_by_table[0].currency);
                        } else {
                            valueReturn = accounting.formatMoney(valueNotFormat, accounting_for_cells.currency);
                        }
                    } else {
                        if (typeof accounting_for_cells.number == "undefined") {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatNumber(valueNotFormat, format_cell_by_table[0].number);
                        } else {
                            valueReturn = accounting.formatNumber(valueNotFormat, accounting_for_cells.number);
                        }
                    }
                    break;
                case 'AVG':
                    values = merge_value_from_cells(values);
                    valueNotFormat = formulajs.SUM(values) / values.length;
                    if (check_has_currency_symbol || cell_has_format > 1) {
                        if (typeof accounting_for_cells.currency == "undefined") {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatMoney(valueNotFormat, format_cell_by_table[0].currency);
                        } else {
                            valueReturn = accounting.formatMoney(valueNotFormat, accounting_for_cells.currency);
                        }
                    } else {
                        if (typeof accounting_for_cells.number == "undefined") {
                            format_cell_by_table = setFormat_for_cell({}, Droptables.style.table, cell_has_format);
                            valueReturn = accounting.formatNumber(valueNotFormat, format_cell_by_table[0].number);
                        } else {
                            valueReturn = accounting.formatNumber(valueNotFormat, accounting_for_cells.number);
                        }
                    }
                    break;
                case 'CONCAT':
                    valueReturn = '';
                    values = merge_value_from_cells(values);
                    values.map(function (foo) {
                        valueReturn = valueReturn + '' + foo;
                    });
                    valueNotFormat = valueReturn;
                    break;
            }
        }
    }

    if (check_value_data === true) {
        if (!onl_value_cell) {
            window.jquery(td).text(valueReturn);
        }
    } else {
        function_data.check_value_data = check_value_data;
    }
    return [valueReturn, valueNotFormat];
}


function merge_value_from_cells(values) {
    var value = [];

    values.map(function (foo) {
        if (foo === null) {
            foo = '';
        }
        if (foo !== false) {
            if (typeof foo === 'object') {
                value = value.concat(merge_value_from_cells(foo));
            } else {
                value = value.concat([foo]);
            }
        }
    });

    return value;
}

function parse_boolean_calculation(values, decimal_symbol) {
    var math = values.match(/<=|>=|!=|>|<|=/g);
    var value = true, value1, value2;
    if (math !== null) {
        value1 = values.split(math[0])[0];
        value2 = values.split(math[0])[1];
        value1 = accounting.unformat(value1, decimal_symbol);
        value2 = accounting.unformat(value2, decimal_symbol);
        switch (math[0]) {
            case '<=':
                value = Number(value1) <= Number(value2);
                break;
            case '>=':
                value = Number(value1) >= Number(value2);
                break;
            case '=':
                value = Number(value1) === Number(value2);
                break;
            case '!=':
                value = Number(value1) !== Number(value2);
                break;
            case '<':
                value = Number(value1) < Number(value2);
                break;
            case '>':
                value = Number(value1) > Number(value2);
                break;
        }
    } else {
        value = values === 'true' ? true : false;
    }
    return value;
}

//From http://stackoverflow.com/questions/7544550/javascript-regex-to-change-all-relative-urls-to-absolute
function rel_to_abs(url) {
    /* Only accept commonly trusted protocols:
     * Only data-image URLs are accepted, Exotic flavours (escaped slash,
     * html-entitied characters) are not supported to keep the function fast */
    if (/^(https?|file|ftps?|mailto|javascript):/i.test(url) || /^(data:image\/[^;]{2,9};)/i.test(url)) {
        return url; //Url is already absolute
    }

    var base_url = location.href.match(/^(.+)\/?(?:#.+)?$/)[0] + "/";
    base_url = base_url.replace("/administrator", "");
    if (url.substring(0, 2) === "//")
        return location.protocol + url;
    else if (url.charAt(0) === "/")
        return location.protocol + "//" + location.host + url;
    else if (url.substring(0, 2) === "./")
        url = "." + url;
    else if (/^\s*$/.test(url))
        return ""; //Empty = Return nothing
    else url = "../" + url;

    url = base_url + url;
    while (/\/\.\.\//.test(url = url.replace(/[^\/]+\/+\.\.\//g, "")));

    /* Escape certain characters to prevent XSS */
    url = url.replace(/\.$/, "").replace(/\/\./g, "").replace(/"/g, "%22")
        .replace(/'/g, "%27").replace(/</g, "%3C").replace(/>/g, "%3E");
    return url;
}

function replace_all_rel_by_abs(html) {
    /*HTML/XML Attribute may not be prefixed by these characters (common
     attribute chars.  This list is not complete, but will be sufficient
     for this function (see http://www.w3.org/TR/REC-xml/#NT-NameChar). */
    var att = "[^-a-z0-9:._]";

    var entityEnd = "(?:;|(?!\\d))";
    var ents = {
        " ": "(?:\\s|&nbsp;?|&#0*32" + entityEnd + "|&#x0*20" + entityEnd + ")",
        "(": "(?:\\(|&#0*40" + entityEnd + "|&#x0*28" + entityEnd + ")",
        ")": "(?:\\)|&#0*41" + entityEnd + "|&#x0*29" + entityEnd + ")",
        ".": "(?:\\.|&#0*46" + entityEnd + "|&#x0*2e" + entityEnd + ")"
    };
    /* Placeholders to filter obfuscations */
    var charMap = {};
    var s = ents[" "] + "*"; //Short-hand for common use
    var any = "(?:[^>\"']*(?:\"[^\"]*\"|'[^']*'))*?[^>]*";
    /* ^ Important: Must be pre- and postfixed by < and >.
     *   This RE should match anything within a tag!  */

    /*
     @name ae
     @description  Converts a given string in a sequence of the original
     input and the HTML entity
     @param String string  String to convert
     */
    function ae(string) {
        var all_chars_lowercase = string.toLowerCase();
        if (ents[string]) return ents[string];
        var all_chars_uppercase = string.toUpperCase();
        var RE_res = "";
        for (var i = 0; i < string.length; i++) {
            var char_lowercase = all_chars_lowercase.charAt(i);
            if (charMap[char_lowercase]) {
                RE_res += charMap[char_lowercase];
                continue;
            }
            var char_uppercase = all_chars_uppercase.charAt(i);
            var RE_sub = [char_lowercase];
            RE_sub.push("&#0*" + char_lowercase.charCodeAt(0) + entityEnd);
            RE_sub.push("&#x0*" + char_lowercase.charCodeAt(0).toString(16) + entityEnd);
            if (char_lowercase != char_uppercase) {
                /* Note: RE ignorecase flag has already been activated */
                RE_sub.push("&#0*" + char_uppercase.charCodeAt(0) + entityEnd);
                RE_sub.push("&#x0*" + char_uppercase.charCodeAt(0).toString(16) + entityEnd);
            }
            RE_sub = "(?:" + RE_sub.join("|") + ")";
            RE_res += (charMap[char_lowercase] = RE_sub);
        }
        return (ents[string] = RE_res);
    }

    /*
     @name by
     @description  2nd argument for replace().
     */
    function by(match, group1, group2, group3) {
        /* Note that this function can also be used to remove links:
         * return group1 + "javascript://" + group3; */
        return group1 + rel_to_abs(group2) + group3;
    }

    /*
     @name by2
     @description  2nd argument for replace(). Parses relevant HTML entities
     */
    var slashRE = new RegExp(ae("/"), 'g');
    var dotRE = new RegExp(ae("."), 'g');

    function by2(match, group1, group2, group3) {
        /*Note that this function can also be used to remove links:
         * return group1 + "javascript://" + group3; */
        group2 = group2.replace(slashRE, "/").replace(dotRE, ".");
        return group1 + rel_to_abs(group2) + group3;
    }

    /*
     @name cr
     @description            Selects a HTML element and performs a
     search-and-replace on attributes
     @param String selector  HTML substring to match
     @param String attribute RegExp-escaped; HTML element attribute to match
     @param String marker    Optional RegExp-escaped; marks the prefix
     @param String delimiter Optional RegExp escaped; non-quote delimiters
     @param String end       Optional RegExp-escaped; forces the match to end
     before an occurence of <end>
     */
    function cr(selector, attribute, marker, delimiter, end) {
        if (typeof selector == "string") selector = new RegExp(selector, "gi");
        attribute = att + attribute;
        marker = typeof marker == "string" ? marker : "\\s*=\\s*";
        delimiter = typeof delimiter == "string" ? delimiter : "";
        end = typeof end == "string" ? "?)(" + end : ")(";
        var re1 = new RegExp('(' + attribute + marker + '")([^"' + delimiter + ']+' + end + ')', 'gi');
        var re2 = new RegExp("(" + attribute + marker + "')([^'" + delimiter + "]+" + end + ")", 'gi');
        var re3 = new RegExp('(' + attribute + marker + ')([^"\'][^\\s>' + delimiter + ']*' + end + ')', 'gi');
        html = html.replace(selector, function (match) {
            return match.replace(re1, by).replace(re2, by).replace(re3, by);
        });
    }

    /*
     @name cri
     @description            Selects an attribute of a HTML element, and
     performs a search-and-replace on certain values
     @param String selector  HTML element to match
     @param String attribute RegExp-escaped; HTML element attribute to match
     @param String front     RegExp-escaped; attribute value, prefix to match
     @param String flags     Optional RegExp flags, default "gi"
     @param String delimiter Optional RegExp-escaped; non-quote delimiters
     @param String end       Optional RegExp-escaped; forces the match to end
     before an occurence of <end>
     */
    function cri(selector, attribute, front, flags, delimiter, end) {
        if (typeof selector == "string") selector = new RegExp(selector, "gi");
        attribute = att + attribute;
        flags = typeof flags == "string" ? flags : "gi";
        var re1 = new RegExp('(' + attribute + '\\s*=\\s*")([^"]*)', 'gi');
        var re2 = new RegExp("(" + attribute + "\\s*=\\s*')([^']+)", 'gi');
        var at1 = new RegExp('(' + front + ')([^"]+)(")', flags);
        var at2 = new RegExp("(" + front + ")([^']+)(')", flags);
        if (typeof delimiter == "string") {
            end = typeof end == "string" ? end : "";
            var at3 = new RegExp("(" + front + ")([^\"'][^" + delimiter + "]*" + (end ? "?)(" + end + ")" : ")()"), flags);
            var handleAttr = function (match, g1, g2) {
                return g1 + g2.replace(at1, by2).replace(at2, by2).replace(at3, by2)
            };
        } else {
            var handleAttr = function (match, g1, g2) {
                return g1 + g2.replace(at1, by2).replace(at2, by2)
            };
        }
        html = html.replace(selector, function (match) {
            return match.replace(re1, handleAttr).replace(re2, handleAttr);
        });
    }

    /* <meta http-equiv=refresh content="  ; url= " > */
    cri("<meta" + any + att + "http-equiv\\s*=\\s*(?:\"" + ae("refresh") + "\"" + any + ">|'" + ae("refresh") + "'" + any + ">|" + ae("refresh") + "(?:" + ae(" ") + any + ">|>))", "content", ae("url") + s + ae("=") + s, "i");

    cr("<" + any + att + "href\\s*=" + any + ">", "href");
    /* Linked elements */
    cr("<" + any + att + "src\\s*=" + any + ">", "src");
    /* Embedded elements */

    cr("<object" + any + att + "data\\s*=" + any + ">", "data");
    /* <object data= > */
    cr("<applet" + any + att + "codebase\\s*=" + any + ">", "codebase");
    /* <applet codebase= > */

    /* <param name=movie value= >*/
    cr("<param" + any + att + "name\\s*=\\s*(?:\"" + ae("movie") + "\"" + any + ">|'" + ae("movie") + "'" + any + ">|" + ae("movie") + "(?:" + ae(" ") + any + ">|>))", "value");

    cr(/<style[^>]*>(?:[^"']*(?:"[^"]*"|'[^']*'))*?[^'"]*(?:<\/style|$)/gi, "url", "\\s*\\(\\s*", "", "\\s*\\)");
    /* <style> */
    cri("<" + any + att + "style\\s*=" + any + ">", "style", ae("url") + s + ae("(") + s, 0, s + ae(")"), ae(")"));
    /*< style=" url(...) " > */
    return html;
}


/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
    render,
    evaluateFormulas2
});

/***/ }),

/***/ "./site/assets/js/_droptables.js":
/*!***************************************!*\
  !*** ./site/assets/js/_droptables.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_functions */ "./site/assets/js/_functions.js");
/* harmony import */ var _handsontable__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_handsontable */ "./site/assets/js/_handsontable.js");
/* harmony import */ var _toolbarOptions__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_toolbarOptions */ "./site/assets/js/_toolbarOptions.js");
/* harmony import */ var _charts__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./_charts */ "./site/assets/js/_charts.js");
/* harmony import */ var _alternating__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./_alternating */ "./site/assets/js/_alternating.js");
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */







// jQuery(window).bind('beforeunload', function(){
//     if(!checkTimeOut)
//         return true;
// });

jQuery(document).ready(function ($) {
    function convert_data_table (id) {
        if (parseInt(id) >= 0) {
            $.ajax({
                url: Droptables.ajaxurl + "index.php?option=com_droptables&task=table.updateOldTable&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                type: 'POST',
                dataType: "json",
                data: {
                    'id': id
                },
                success: function (datas) {
                    if (datas.response === true) {
                        if (parseInt(datas.datas) < 0) {
                            setTimeout(function () {
                                $('.convert_tables').remove();
                            }, 3000);
                        } else {
                            convert_data_table(datas.datas);
                        }
                    } else {
                        bootbox.alert('Error while convert table' + ' : ' + datas.datas);
                    }
                },
                error: function (jqxhr, textStatus, error) {
                    bootbox.alert(textStatus);
                }
            });
        }
    }

    if (typeof droptable_update_data !== 'undefined' && parseInt(droptable_update_data) >= 0) {
        convert_data_table(droptable_update_data);
    }

    if (typeof droptable_update_data !== 'undefined' && parseInt(droptable_update_data) == -1) {
        if (parseInt(droptable_update_data) > -2) {
            function convert_data_table_362(id) {
                $.ajax({
                    url: Droptables.ajaxurl + "index.php?option=com_droptables&task=table.updateTable362&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                    type: 'POST',
                    dataType: "json",
                    data: {
                        'id': id
                    },
                    success: function (datas) {
                        if (datas.response === true) {
                            if (parseInt(datas.datas) < 0) {
                                setTimeout(function () {
                                    $('.convert_tables').remove();
                                }, 3000);
                            } else {
                                convert_data_table_362(datas.datas);
                            }
                        } else {
                            bootbox.alert('Error while convert table' + ' : ' + datas.datas);
                        }
                    },
                    error: function (jqxhr, textStatus, error) {
                        bootbox.alert(textStatus);
                    }
                });
            }
            convert_data_table_362(droptable_update_data);
        }
    }

    $('[data-toggle="tooltip"]').tooltip();
    window.jquery = $;

    if (typeof (Droptables) == 'undefined') {
        Droptables = {};
        Droptables.can = {};
        Droptables.can.create = true;
        Droptables.can.edit = true;
        Droptables.can.delete = true;
        Droptables.selection = {};
        Droptables.value_unit_chart = [];
        Droptables.hyperlink = {};
    } else {
        Droptables.value_unit_chart = [];
    }

    Droptables.updateSettings = {};
    Droptables.saveDataDbTable = [];

    window.Droptables_element = {
        wpreview: $('#droptable_toolbars'),
        primary_toolbars: $('#primary_toolbars'),
        mainTabContent: $('#mainTabContent'),
        tableContainer: $('#tableContainer'),
        droptable_popup: $('#droptable_popup'),
        content_popup_hide: $('#content_popup_hide'),

        cellValue: $('#CellValue'),
        settingCells: $('#setting-cells'),
        settingTable: $('#table-setting'),
        nameTable: $('#name-table'),
        alternating_color: $('#alternating_color'),
        editToolTip: $('#editToolTip'),
        edit_html_cell: $('#edit_html_cell'),
        Droptables_edit_html_cell: $('#Droptables_edit_html_cell'),
        saveToolTipbtn: $('#saveToolTipbtn'),
        chartTabContent: $('#chartTabContent'),
        DroptablesContentChart: $('#droptable_chart .droptable_content_chart')
    };

    // $('#droptables_editToolTip').css('')

    //saving all function data
    window.table_function_data = {
        replace_unit: {},
        text_replace_unit: '',
        text_replace_unit_function: '',
        date_format: [],
        check_value_data: true,
        string_currency_symbols: '',
        selectFetch: {},
        allAlternate: {},
        oldAlternate: {},
        changeAlternate: [],
        checkChangeAlternate: [],
        selection: [],
        styleToRender: '',
        content: '',
        needSaveAfterRender: false,
        alternateIndex: '',
        alternateSelection: [],
        save_table_params: [],
        firstRender: false,
        accountingNumber : {}
    };

    /* init menu actions */
    window.default_value = $.extend({}, {
        'use_sortable': '0',
        'default_sortable': '0',
        'default_order_sortable': '1',
        'enable_import_excel': 1,
        'table_align': 'center',
        'responsive_type': 'scroll',
        'table_breakpoint': '980',
        'freeze_col': 0,
        'table_height': 500,
        'style_repeated': 0,
        'freeze_row': 0,
        'enable_filters': 0,
        'enable_pagination': 0,
        'allRowHeight': '',
        'spreadsheet_url': '',
        'spreadsheet_style': 0,
        'cell_types': [],
        'auto_sync': 0,
        'auto_push': 0,
        'download_button': 0,
        'col_types': ["varchar","varchar","varchar","varchar","varchar","varchar","varchar","varchar","varchar","varchar"]
    }, default_value);

    if (typeof idTable !== 'undefined' && idTable !== '') {
        if (!(typeof default_value.enable_import_excel !== 'undefined' && parseInt(default_value.enable_import_excel) === 1)) {
            Droptables_element.primary_toolbars.find('.export_menu').parent().remove();
        }

        if (typeof user_roles !== 'undefined') {
            Droptables.user_roles = user_roles;
        } else {
            Droptables.user_roles = [];
        }

        if (typeof list_rolers_of_user !== 'undefined' && list_rolers_of_user !== null) {
            Droptables.list_rolers_of_user = list_rolers_of_user;
        } else {
            Droptables.list_rolers_of_user = [];
        }
        Droptables.check_super_user = false;
        Droptables.list_rolers_of_user.map(function (roler) {
            if (typeof Droptables.user_roles[roler] !== 'undefined' && Droptables.user_roles[roler] === 'Super Users') {
                Droptables.check_super_user = true;
            }
        });

        var curr_page = window.location.href;
        var cells = curr_page.split("?");
        var new_url;
        if (Droptables.view === 'manage') {
            // option=com_droptables&view=manage
            new_url = cells[0] + "?view=manage";
            if (typeof Droptables.e_name !== 'undefined' && Droptables.e_name !== '') {
                new_url += "&e_name=" + Droptables.e_name;
            }

            $('.back_to_tables').attr({'href': new_url});
        }

        updatepreview(idTable);

        if (Droptables_element.tableContainer.length > 0 && $('#sidebar-wrapper').length > 0) {
            var wh = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            var height_content = wh - $('#header').find('.header-inside').outerHeight() - 15;
            $('#sidebar-wrapper').css({'height' : height_content});
            var el1 = document.querySelector('#sidebar-wrapper');
            SimpleScrollbar.initEl(el1);
        }
    }

    $(document).on("click", "#fetch_browse", function(e) {
        var i = $(e.target).attr("href");

        $(i).css({'display': 'block', 'opacity': 1});

        $(i).find('.btn-close').unbind('click').on('click', function () {
            $(i).css({'display': 'none', 'opacity': 0});
        });
    })
});

function getOwn (position) {
    var userOwn = Droptables.userOwn;
    var data;
    switch (position) {
        case 'edit_cat':
            data = Droptables.userOwn.edit || Droptables.userOwn.editOwn;
            break;
        case 'delete_cat':
            data = Droptables.userOwn.delete;
            break;
        case 'create_cat':
            data = Droptables.userOwn.create;
            break;
        case 'edit':
            data = Droptables.userOwn.table_edit || (Droptables.userOwn.table_editOwn && Droptables.authorTable == Droptables.author);
            break;
        case 'delete':
            data = Droptables.userOwn.table_delete;
            break;
        case 'create':
            data = Droptables.userOwn.table_create;
            break;
        case 'access_db':
            data = Droptables.userOwn.access_db;
            break;
    }

    return data;
}

function checkLightOrDark(color) {
    var r, g, b, hsp;

    if (color.match(/^rgb/)) {
        color = color.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/);
        r = color[1];
        g = color[2];
        b = color[3];
    }
    else {
        color = +("0x" + color.slice(1).replace(color.length < 5 && /./g, '$&$&'));
        r = color >> 16;
        g = color >> 8 & 255;
        b = color & 255;
    }

    hsp = Math.sqrt(
        0.299 * (r * r) +
        0.587 * (g * g) +
        0.114 * (b * b)
    );

    if (hsp>127.5) {
        return 1;
    }
    else {
        return 0;
    }
}

function codemirror_tooltip($) {
    window.CustomEditor = Handsontable.editors.TextEditor.prototype.extend();

    $('.tip').tooltipster({
        theme: 'tooltipster-borderless',
        delay: 100,
        distance: 5,
    });


    window.CustomEditor.prototype.open = function () {
        $(this.TEXTAREA).attr('id', 'editor1');
        var lightOrDark = checkLightOrDark($(this.TEXTAREA).css( "backgroundColor" ));
        if (lightOrDark === 0) {
            $(this.TEXTAREA).css({'color':'#ffffff'});
        } else {
            $(this.TEXTAREA).css({'color':'#000000'});
        }

        if (typeof (Droptables.style.cells[this.row + '!' + this.col]) !== 'undefined'
            && typeof (Droptables.style.cells[this.row + '!' + this.col][2].cell_type) !== 'undefined'
            && Droptables.style.cells[this.row + '!' + this.col][2].cell_type === 'html') {
            // cell_html = true;
            Handsontable.editors.TextEditor.prototype.close.apply(this, arguments);
            // tinyMCE.EditorManager.execCommand('mceRemoveEditor', true, 'html_cell_content');

            if (Droptables_element.tableContainer.height() < 400) {
                $('#tableContainerParent.scrollable').find('.viewport').css({'overflow':'visible'});
            }
            if ($('.handsontableInputHolder').length > 0) {

                $("#btnDroptablesDescription").trigger('click');

                console.log(Handsontable.editors);
                var currentData = Handsontable.editors.TextEditor.prototype.getValue.apply(this, arguments);
                Joomla.editors.instances['droptablesDescription'].setValue(currentData);

            }
            Handsontable.editors.TextEditor.prototype.open.apply(this, arguments);

        } else {
            //close modal
            $("#lean_overlay").fadeOut(200);
            $("#modalDroptablesDescription").hide();
            Handsontable.editors.TextEditor.prototype.open.apply(this, arguments);
        }
    };


    window.CustomEditor.prototype.getValue = function () {
        return Handsontable.editors.TextEditor.prototype.getValue.apply(this, arguments);
    };

    window.CustomEditor.prototype.setValue = function (newValue) {
        return Handsontable.editors.TextEditor.prototype.setValue.apply(this, arguments);
    };

    window.CustomEditor.prototype.close = function () {
        if ($('#mybootstrap').hasClass('joomla30')) {
            $('.modal-backdrop').removeClass('droptable_hiden');
        }
        Droptables_element.mainTabContent.css({'z-index': '9'});

        $('#tableContainerParent.scrollable').find('.viewport').css({'overflow':'hidden'});
        return Handsontable.editors.TextEditor.prototype.close.apply(this, arguments);
    };
}

//Call ajax to get all data of table, add value to Wptm, table_function_data
function updatepreview(id,) {
    /*remove after change theme*/
    var url = Droptables.ajaxurl + "index.php?option=com_droptables&view=table&format=json&id=" + id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert);
    var $ = jquery;
    $.ajax({
        url: url,
        type: "POST",
        data: {},
        dataType: "json",
    }).done(function (data) {
        $('.minicolors-input').minicolors('settings', {
            change: function () {
                jQuery(this).trigger('change');
            }
        }).attr('maxlength', '7');

        //TODO: check user role table
        Droptables.id = id;
        Droptables.title = data.title;
        Droptables.authorTable = data.author;
        jquery('#primary_toolbars').find('.droptable_name_edit').text(Droptables.title);
        /*not change data cell(in db table)*/
        Droptables.type = 'html';
        Droptables.category = data.category;

        /*set height rows variable*/
        Droptables.rowsHeight = {};
        Droptables.table_height = 0;

        Droptables.hyperlink = {};
        if (typeof data.type !== 'undefined') {
            Droptables.type = data.type;
        } else {
            Droptables.type = (typeof data.params.type !== 'undefined') ? data.params.type : Droptables.type;
        }

        if (data.data === '' || data.data === false) {
            delete Droptables.datas;
            if (Droptables.type === 'mysql') {
                Droptables.datas = [
                    [Joomla.JText._('COM_DROPTABLES_LAYOUT_DBTABLES_NO_RESULTS', 'No results found')],
                ];
            } else {
                Droptables.datas = [
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""]
                ];
            }
        } else {
            try {
                if (typeof data.data === 'string') {
                    data.data = JSON.stringify(data.data);
                    data.data = JSON.parse(data.data);
                }
                Droptables.datas = data.data;
            } catch (err) {
                Droptables.datas = [
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""]
                ];
            }
        }

        Droptables.style = data.style;

        Droptables.css = data.css.replace(/\\n/g, "\n");
        // Droptables.style.table.mergeSetting = [];

        if (!(Droptables.style === "" || Droptables.style === null || Droptables.style.length == 0)) {
            if (Droptables.style.table === null) {
                Droptables.style.table = {};
            }
            if (typeof Droptables.style.table !== 'undefined' && typeof Droptables.style.table.headerOption !== 'undefined') {
                Droptables.style.table.headerOption = parseInt(Droptables.style.table.headerOption);
            }
            if (Droptables.style.table.headerOption < 1) {
                Droptables.style.table.headerOption = 1;
            }

            if (typeof Droptables.style.table.hyperlink !== 'undefined') {
                if (typeof Droptables.style.table.hyperlink === 'string') {
                    Droptables.style.table.hyperlink = $.parseJSON(Droptables.style.table.hyperlink);
                }

                $.each(Droptables.style.table.hyperlink, function (index, value) {
                    var rowCol = index.split("!");
                    if(typeof Droptables.datas[rowCol[0]] !== 'undefined' || typeof value.text == 'object') {
                        value.text =  Droptables.datas[rowCol[0]][rowCol[1]];
                        Droptables.datas[rowCol[0]][rowCol[1]] = '<a target="_blank" href="' + value.hyperlink + '">' + value.text + '</a>';
                        Droptables.hyperlink[index] = value;
                    }
                });
            }

            try {
                // if (typeof Droptables.style.table.mergeSetting === 'string') {
                //     Droptables.style.table.mergeSetting = $.parseJSON(Droptables.style.table.mergeSetting);
                // }
                //
                // if (Droptables.style.table.mergeSetting == null || Droptables.style.table.mergeSetting.length < 1) {
                //     Droptables.style.table.mergeSetting = [];
                // }
            } catch (e) {
                Droptables.style.table.mergeSetting = [];
            }
        }

        /*set default table data*/
        if (typeof (Droptables.style) === 'undefined' || Droptables.style === null) {
            $.extend(Droptables, {
                style: {
                    table: {},
                    rows: {},
                    cols: {},
                    cells: {}
                },
                css: ''
            });
        }

        if (typeof (Droptables.style.rows) === 'undefined' || Droptables.style.rows === null) {
            Droptables.style.rows = {};
        }
        var Droptables_number_col = Droptables.datas[0].length;
        if (typeof (Droptables.style.cols) === 'undefined' || Droptables.style.cols === null) {
            Droptables.style.cols = {};
            for (var ii = 0; ii <  Droptables_number_col; ii++) {
                Droptables.style.cols[ii] = [ii, {res_priority: ii}];
            }
        } else {
            for (var ii = 0; ii <  Droptables_number_col; ii++) {
                if (typeof window.Droptables.style.cols[ii] === 'undefined' || window.Droptables.style.cols[ii] === null) {
                    Droptables.style.cols[ii] = [ii, {res_priority: ii}];
                } else  if (typeof window.Droptables.style.cols[ii][1].res_priority === 'undefined') {
                    Droptables.style.cols[ii][1].res_priority =  ii;
                }
            }
        }
        if (typeof (Droptables.style.cells) === 'undefined' || Droptables.style.cells === null) {
            Droptables.style.cells = {};
        }

        _functions__WEBPACK_IMPORTED_MODULE_0__.default.mergeCollsRowsstyleToCells();

        Droptables.style.table = $.extend({}, window.default_value, Droptables.style.table);

        if (typeof table_function_data.auto_sync !== 'undefined') {
            Droptables.style.table.auto_sync = table_function_data.auto_sync;
            Droptables.style.table.spreadsheet_style = table_function_data.spreadsheet_style;
            Droptables.style.table.spreadsheet_url = table_function_data.spreadsheet_url;
            delete table_function_data.auto_sync;
        }

        if (Droptables.style.table.spreadsheet_url !== '' && Droptables.style.table.spreadsheet_url.indexOf("docs.google.com/spreadsheet") === -1) {//when first auto syn after update 2.7.0
            if (table_function_data.auto_sync == 1) {
                Droptables.style.table.excel_auto_sync = 1;
                Droptables.style.table.auto_sync = 0;
                Droptables.style.table.excel_spreadsheet_style = Droptables.style.table.spreadsheet_style;
            }
            Droptables.style.table.excel_url = table_function_data.spreadsheet_url;
            table_function_data.spreadsheet_url = '';
            Droptables.style.table.spreadsheet_url = '';
        }

        if (Droptables.style.table.headerOption > 0 && (typeof Droptables.style.header_data === 'undefined' || Droptables.style.header_data.length < Droptables.style.table.headerOption)) {
            Droptables.style.header_data = [];
            for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                Droptables.style.header_data[j] = Droptables.datas[j];
            }
        }

        window.table_function_data = _functions__WEBPACK_IMPORTED_MODULE_0__.default.createRegExpFormat(table_function_data, Droptables.style.table.currency_symbol, Droptables.style.table.date_format);
        if (typeof Droptables.style.table.date_formats !== 'undefined' && Droptables.style.table.date_formats !== '') {
            window.table_function_data.date_formats_momentjs = _functions__WEBPACK_IMPORTED_MODULE_0__.default.momentjsFormat(Droptables.style.table.date_formats);
        }
        window.Droptables = $.extend({}, window.Droptables, Droptables);

        $('#jform_css').val(Droptables.css);
        $('#jform_css').change();
        _functions__WEBPACK_IMPORTED_MODULE_0__.default.parseCss($, false);

        // tableFunction.setFormat_accounting();

        var handRisize, clearHandRisize;
        window.onresize = function () {
            if (!clearHandRisize) {
                clearTimeout(handRisize);
            }

            clearHandRisize = false;
            handRisize = setTimeout(function () {
                var height = _functions__WEBPACK_IMPORTED_MODULE_0__.default.calculateTableHeight(window.jquery('#droptable_toolbars'));
                jquery(Droptables_element.tableContainer).handsontable('updateSettings', {height: height});
                clearHandRisize = true;
            }, 500);
        };

        if (typeof (Droptables.style.table.alternateColorValue) === 'undefined' || typeof Droptables.style.table.alternateColorValue[0] === 'undefined') {
            var styleRows = null;
            _alternating__WEBPACK_IMPORTED_MODULE_4__.default.setAlternateColor(styleRows, window.Droptables, window.Droptables_element);
        }

        if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(window.table_function_data.oldAlternate) < 1) {
            window.table_function_data.oldAlternate = $.extend({}, Droptables.style.table.alternateColorValue);
        }

        if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(window.table_function_data.allAlternate) < 1) {
            window.table_function_data.allAlternate = $.extend({}, Droptables.style.table.allAlternate);
        }

        //update option table
        _toolbarOptions__WEBPACK_IMPORTED_MODULE_2__.default.updateOptionValTable($, window.Droptables, [0, 0, 0, 0]);

        codemirror_tooltip($);

        $('#list_chart').find('.current_table a').text(Droptables.title);
        if (Droptables.type !== 'html') {
            // Droptables_element.primary_toolbars.find('.Droptables_name_edit').after('<div class="Droptables_warning"><p>' + DroptablesText.notice_msg_table_database + '</p></div>');
            if (Droptables_element.settingTable.find('.table-menu a.source_menu').length > 0) {
                Droptables_element.settingTable.find('.table-menu a.source_menu').parent().show();
            }
            if (Droptables.style.table.allRowHeight < 10 || isNaN(Droptables.style.table.allRowHeight)) {
                Droptables.style.table.allRowHeight = 30;
            }
        } else {
            Droptables_element.settingTable.find('.table-menu a.source_menu').parent().hide();
        }

        //check edit columns, get column key
        if (window.Droptables.type === 'mysql' && typeof data.query_option !== 'undefined') {
            Droptables.query_option = data.query_option;
            if (Droptables.query_option.column_options !== null && Droptables.query_option.column_options.length > 0) {
                table_function_data.columns = [];
                for (var i in Droptables.query_option.column_options) {
                    if (parseInt(Droptables.query_option.column_options[i].canEdit) !== 1 || (Droptables.query_option.column_options[i].table + '.' + Droptables.query_option.column_options[i].Field === Droptables.style.table.priKey)) {
                        table_function_data.columns[i] = {readOnly: true};
                    } else {
                        table_function_data.columns[i] = {readOnly: false}
                    }
                    if (typeof Droptables.style.table.lock_columns !== 'undefined'
                        && Droptables.style.table.lock_columns[i] != 0) {
                        table_function_data.columns[i] = {readOnly: true};
                    }
                    if (Droptables.style.table.priKey === Droptables.query_option.column_options[i].table + '.' + Droptables.query_option.column_options[i].Field) {
                        table_function_data.keyPosition = i;
                    }
                }
            }
        }

        if (typeof Droptables.style.table.lock_ranger_cells !== 'undefined' && Droptables.style.table.lock_ranger_cells.length > 0) {
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.create_ranger_cells_lock(Droptables, table_function_data, null);
        }

        table_function_data.mysqlEdit = Droptables.type !== 'mysql' || (typeof Droptables.style.table.table_editing !== 'undefined' && parseInt(Droptables.style.table.table_editing) === 1);
        if (!table_function_data.mysqlEdit) {
            $('.warnning_edit_db_table').hide();
        }
        table_function_data.allowed_edit = getOwn('edit');
        table_function_data.delete = getOwn('delete');
        table_function_data.access_db = getOwn('access_db');
        Droptables.style.table.mergeSetting = _functions__WEBPACK_IMPORTED_MODULE_0__.default.convertMergeCell();

        /*render table */
        (0,_handsontable__WEBPACK_IMPORTED_MODULE_1__.initHandsontable)(Droptables.datas);

        Droptables_element.primary_toolbars.find('.droptable_name_edit').click(function () {
            if (!$(this).hasClass('editable')) {
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.setText.call(
                    $(this),
                    Droptables_element.primary_toolbars.find('.droptable_name_edit'),
                    '#primary_toolbars .droptable_name_edit',
                    {'url': Droptables.ajaxurl + "index.php?option=com_droptables&task=table.setTitle&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert) + '&title=', 'selected': true}
                );
            }
        });

        $(window).bind('keydown', function(event) {//CTRL + S
            if (!(event.which == 83 && (event.ctrlKey || event.metaKey)) && !(event.which == 19)) return true;
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
            event.preventDefault();
            return false;
        });
    });

    if (typeof default_value.enable_import_excel !== 'undefined' && parseInt(default_value.enable_import_excel) === 1) {
        $("#procExcel").dropzone({
            url: "index.php?option=com_droptables&task=excel.import",
            maxFiles: 1,
            //acceptedFiles: 'xls,xlsx',
            init: function () {
                //Update form action
                this.on("addedfile", function (file) {
                    var dotPos = file.name.lastIndexOf('.') + 1;
                    var ext = file.name.substr(dotPos, file.name.length - dotPos);

                    if (ext !== 'xls' && ext !== 'xlsx') {
                        bootbox.alert('Please choose a file with type of xls or xlsx.');
                        this.options.autoProcessQueue = false;
                        this.removeFile(file);
                        //return false;
                    }
                    else {
                        if (this.options.autoProcessQueue === false) {
                            this.options.autoProcessQueue = true;
                        }
                    }

                });

                this.on("sending", function (file, xhr, formData) {
                    //Add table id to formData
                    $("#jform_id_table").val(Droptables.id);
                    formData.append('id_table', Droptables.id);
                    formData.append('onlydata', Droptables_element.droptable_popup.find("#import_style").val());

                    // Show the total progress bar when upload starts
                    //this.options.uploadprogress(file);
                    Droptables_element.droptable_popup.find(".progress").show();
                    Droptables_element.droptable_popup.find(".progress-bar-success").css('width', 30 + '%');
                    Droptables_element.droptable_popup.find(".progress-bar-success").css('opacity', 1);
                    // And disable the start button
                    //file.previewElement.querySelector(".start").setAttribute("disabled", "disabled");
                });

                this.on("success", function (file, responseText) {
                    Droptables_element.droptable_popup.find(".progress").fadeOut(1000);
                    var responseObj = JSON.parse(responseText);

                    Droptables_element.droptable_popup.find('.colose_popup').trigger('click');
                    if (responseObj.response === true) {
                        if (typeof responseObj.datas.too_large !== 'undefined') {
                            bootbox.confirm(responseObj.datas.msg, function (result) {
                                if (result === true) {
                                    var jsonVar = {
                                        id_table: responseObj.datas.id,
                                        onlydata: responseObj.datas.onlydata,
                                        file: encodeURI(responseObj.datas.file),
                                        ignoreCheck: 1
                                    };
                                    $.ajax({
                                        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=excel.import&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                                        type: 'POST',
                                        data: jsonVar,
                                        success: function (datas) {
                                            location.reload();
                                        }
                                    })
                                } else {
                                    //do nothing
                                }
                            });
                        } else {
                            location.reload();
                        }
                    } else {
                        bootbox.alert(responseObj.response);
                    }
                });

                this.on('complete', function (file) {
                    this.removeFile(file);
                    setTimeout(function () {
                        Droptables_element.droptable_popup.find(".progress-bar-success").css('width', 0);
                    }, 6000);
                });
                // Update the total progress bar
                this.on("uploadprogress", function (file, progress) {
                    Droptables_element.droptable_popup.find(".progress-bar-success").css('width', progress + "%");
                });
            }
        })
    }

    //codemirror
    var myTextArea = document.getElementById("jform_css");
    var myCssEditor = CodeMirror.fromTextArea(myTextArea, {mode: "css", lineNumbers: true});
    var ww = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    var wh = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    if (window.parent) {
        ww = window.parent.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
        wh = window.parent.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    }

    myCssEditor.setSize(ww * 50 / 100, wh - 500);

    Droptables_element.primary_toolbars.find('.custom-menu').leanModal({
        top: typeof Droptables.caninsert !== 'undefined' && Droptables.caninsert === 1 && typeof Droptables.isJoomla30 !== 'undefined' && Droptables.isJoomla30 === 1 ? 50 : 200,
        background: '#ffffff',
        closeButton: '#cancelCssbtn',
        beforeShow: function () {
            var selection = table_function_data.selection;
            var ht = jQuery(Droptables_element.tableContainer).handsontable('getInstance');
            ht.updateSettings({
                cells: function (row, col, prop) {
                    if (selection[0][0] === row && selection[0][1] === col) {
                        var cellProperties = {};

                        cellProperties.readOnly = true;
                        return cellProperties;
                    }
                }
            });
            window.jquery(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][0], selection[0][1]);
        },
        before_colose_modal: function () {
            var selection = table_function_data.selection;

            var ht = jQuery(Droptables_element.tableContainer).handsontable('getInstance');
            ht.updateSettings({
                cells: function (row, col, prop) {
                    if (selection[0][0] === row && selection[0][1] === col) {
                        var cellProperties = {};

                        cellProperties.readOnly = false;
                        return cellProperties;
                    }
                }
            });
            window.jquery(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][0], selection[0][1]);
        },
        modalShow: function () {
            myCssEditor.refresh();
            myCssEditor.focus();
        }
    });

    $(myTextArea).on('change', function () {
        myCssEditor.setValue($(myTextArea).val().replace(/\\n/g, "\n"));
    });

    // myCssEditor.on("blur", function() {
    $("#saveCssbtn").click(function () {
        myCssEditor.save();
        _functions__WEBPACK_IMPORTED_MODULE_0__.default.parseCss($, true);
        $(myTextArea).trigger("propertychange");
        //close leanModal
        $("#lean_overlay").fadeOut(200);
        $("#droptable_customCSS").css({"display": "none"})
    });

    $(document).on('click', '.search-open-btn', function (e) {
        var btn = $(this);
        var search_menu = btn.closest('.search-menu');
        if (!search_menu.hasClass("open")) {
            search_menu.addClass("open");
            $('.search-menu #dp-form-search').focus()
        }
    });
    $(document).on('mouseup', function (e) {
        var container = $(".search-menu");
        // if the target of the click isn't the container nor a descendant of the container
        if (!container.is(e.target) && container.has(e.target).length === 0 && container.hasClass("open")) {
            container.removeClass("open");
        }
    });
    Droptables_element.editToolTip.leanModal({
        top: 100, left: 50, background: '#ffffff', closeButton: '#cancelToolTipbtn', modalShow: function () {
            var $tooltip_content = $('#tooltip_content');
            $('#tooltip_content_ifr')[0].contentWindow.focus();
            if ($tooltip_content.length > 0 && typeof Joomla.editors.instances['tooltip_content'] !== "undefined") {
                Joomla.editors.instances['tooltip_content'].setValue($tooltip_content.val());
            }
        }
    });

    $("#droptable_editToolTip").find('.colose_popup').unbind('click').on('click', function () {
        $('#cancelToolTipbtn').trigger('click');
    });

    Droptables_element.saveToolTipbtn.click(function () {
       // var newTooltipContent = CKEDITOR.instances.tooltip_content.getData();
        var newTooltipContent =   Joomla.editors.instances['tooltip_content'].getValue();
        var $tooltip_content = $('#tooltip_content');
        $tooltip_content.val(newTooltipContent);
        $tooltip_content.trigger("change");
        //close leanModal
        $("#lean_overlay").fadeOut(200);

        $("#droptable_editToolTip").css({"display": "none"});
        $('#edit_toolTip').trigger('change');
    })

    $("#btnDroptablesDescription").leanModal({
        top: 100, left: 50, background: '#ffffff', closeButton: '#btnCancelCellHtml', modalShow: function () {
            $('#droptablesDescription_ifr')[0].contentWindow.focus();
        }
    });

    if (typeof Droptables.droptable_read_excel_message !== 'undefined') {
        bootbox.alert(
            Joomla.JText._('COM_DROPTABLES_IMPORT_FINISHED'
            , 'Import is finished!') + '<br/>' +
            Joomla.JText._('COM_DROPTABLES_ERROR_READER_EXCEL'
            , ' Note that the import tool wasn\'t able to read some cell data and therefore have removed some values. Cells concerned:') +
        Droptables.droptable_read_excel_message);
    }
}

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
    updatepreview
});

/***/ }),

/***/ "./site/assets/js/_functions.js":
/*!**************************************!*\
  !*** ./site/assets/js/_functions.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _droptables__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_droptables */ "./site/assets/js/_droptables.js");
/* harmony import */ var _handsontable__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_handsontable */ "./site/assets/js/_handsontable.js");
/* harmony import */ var _alternating__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_alternating */ "./site/assets/js/_alternating.js");
// import alternating from "./_alternating"




var F_name = ["january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december"];
var M_name = ["jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sept", "oct", "nov", "dec"];
var l_name = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
var D_name = ["sun", "mon", "tue", "wed", "thu", "fri", "sat"];

//mer rows, columns style to cells style
function mergeCollsRowsstyleToCells() {
    var $ = window.jquery;
    var style = $.extend({}, window.Droptables.style);
    $.each(style.cols, function (col, cValue) {
        $.each(style.rows, function (row, rValue) {
            var styleCell = {};
            if (typeof (window.Droptables.style.cells[row + '!' + col]) === 'undefined') {
                window.Droptables.style.cells[row + '!' + col] = [row, col, {}];
            }
            if (typeof (style.rows[row]) !== 'undefined' && style.rows[row] !== null && Object.keys(style.rows[row][1]).length !== 0) {
                styleCell =  $.extend({}, styleCell, rValue[1]);
            }
            if (typeof (style.cols[col]) !== 'undefined' && style.cols[col] !== null && Object.keys(style.cols[col][1]).length !== 0) {
                styleCell =  $.extend({}, styleCell, cValue[1]);
            }
            window.Droptables.style.cells[row + '!' + col][2] = $.extend({}, styleCell, window.Droptables.style.cells[row + '!' + col][2]);
        });
    });
}

//create string_currency_symbols, replace_unit, text_replace_unit, date_format RegExp string
function createRegExpFormat(table_function_data, currency_symbol, date_formats) {
    if (currency_symbol !== false) {
        table_function_data.string_currency_symbols = currency_symbol.replace(/ /g, "");
        // create string reg currency symbols
        table_function_data.replace_unit = new RegExp('[' + table_function_data.string_currency_symbols.replace(/,/g, "|") + ']', "g");

        // create string reg have not currency symbols
        table_function_data.text_replace_unit = '[^a-zA-Z|' + table_function_data.string_currency_symbols.replace(/,/g, "|^") + ']';
        table_function_data.text_replace_unit = new RegExp(table_function_data.text_replace_unit, "g");
        table_function_data.text_replace_unit_function = new RegExp('[^ |' + table_function_data.string_currency_symbols.replace(/,/g, "|^") + ']', "g");
    }
    if (date_formats !== false) {
        table_function_data.date_format = date_formats.match(/[a-zA-Z|\\]+/g);
    }
    return table_function_data;
}

//create string_currency_symbols, replace_unit, text_replace_unit, date_format RegExp string
function createRegExpFormatForCell(currency_symbol, date_formats, cell_function_data) {
    if (currency_symbol !== false) {
        cell_function_data.string_currency_symbols = currency_symbol.replace(/ /g, "");
        // create string reg currency symbols
        cell_function_data.replace_unit = new RegExp('[' + cell_function_data.string_currency_symbols.replace(/,/g, "|") + ']', "g");

        // create string reg have not currency symbols
        cell_function_data.text_replace_unit = '[^a-zA-Z|' + cell_function_data.string_currency_symbols.replace(/,/g, "|^") + ']';
        cell_function_data.text_replace_unit = new RegExp(cell_function_data.text_replace_unit, "g");
        cell_function_data.text_replace_unit_function = new RegExp('[^ |' + cell_function_data.string_currency_symbols.replace(/,/g, "|^") + ']', "g");
    }
    if (date_formats !== false) {
        cell_function_data.date_format = date_formats.match(/[a-zA-Z|\\]+/g);
    }
    return cell_function_data;
}

function parseCss($, hasSaveData) {
    var parser = new (less.Parser);
    var content = '#mainTabContent .handsontable .ht_master .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_top .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_bottom .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_left .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '#mainTabContent .handsontable .ht_clone_top_left_corner .wtHider .wtSpreader .htCore tbody {' + $('#jform_css').val() + '}';
    content += '.reset {background-color: rgb(238, 238, 238);border-bottom-color: rgb(204, 204, 204);border-bottom-style: solid;border-bottom-width: 1px;border-collapse: collapse;border-left-color: rgb(204, 204, 204);border-left-style: solid;border-left-width: 1px;border-right-color: rgb(204, 204, 204);border-right-style: solid;border-right-width: 1px;border-top-color: rgb(204, 204, 204);border-top-style: solid;border-top-width: 1px;box-sizing: border-box;color: rgb(34, 34, 34);display: table-cell;empty-cells: show;font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;font-size: 13px;font-weight: normal;line-height: 21px;outline-width: 0px;overflow-x: hidden;overflow-y: hidden;padding-bottom: 0px;padding-left: 4px;padding-right: 4px;padding-top: 0px;text-align: center;vertical-align: top;white-space: nowrap;position: relative;}';
    content += '#mainTabContent .handsontable .ht_master .wtHider .wtSpreader .htCore tbody tr th {.reset() !important;}';
    // content += '#mainTabContent .handsontable .ht_master .wtHider .wtSpreader .htCore tbody tr th {border: unset !important;}';

    parser.parse(content, function (err, tree) {
        if (err) {
            //Here we can throw the erro to the user
            return false;
        } else {
            Droptables.css = $('#jform_css').val();
            if ($('#headCss').length === 0) {
                $('head').append('<style id="headCss"></style>');
            }
            $('#headCss').text(tree.toCSS());
            if (hasSaveData) {
                saveChanges(true);
            }
            return true;
        }
    });
}

function setFormat_accounting() {
    var data = {};
    data.thousand_symbol = Droptables.style.table.thousand_symbol;
    data.symbol_position = Droptables.style.table.symbol_position;
    data.decimal_symbol = Droptables.style.table.decimal_symbol;
    data.decimal_count = Droptables.style.table.decimal_count;
    data.currency_symbol = Droptables.style.table.currency_symbol;

    accounting.settings = {
        currency: {
            symbol : data.currency_symbol,   // default currency symbol is '$'
            format: data.symbol_position == 1 ? "%v %s" : "%s %v", // controls output: %s = symbol, %v = value/number (can be object: see below)
            decimal : data.decimal_symbol,  // decimal point separator
            thousand: data.thousand_symbol,  // thousands separator
            precision : typeof data.decimal_count !== 'undefined' ? data.decimal_count : 0   // decimal places
        },
        number: {
            decimal : data.decimal_symbol,  // decimal point separator
            thousand: data.thousand_symbol,  // thousands separator
            precision : typeof data.decimal_count !== 'undefined' ? data.decimal_count : 0   // decimal places
        }
    };
}

function setFormat_accounting_for_cells(setFormat_accounting_for_cells_raw) {
    return {
        currency: {
            symbol : setFormat_accounting_for_cells_raw.currency_symbol,   // default currency symbol is '$'
            format: setFormat_accounting_for_cells_raw.symbol_position == 1 ? "%v%s" : "%s%v", // controls output: %s = symbol, %v = value/number (can be object: see below)
            decimal : setFormat_accounting_for_cells_raw.decimal_symbol,  // decimal point separator
            thousand: setFormat_accounting_for_cells_raw.thousand_symbol,  // thousands separator
            precision : typeof setFormat_accounting_for_cells_raw.decimal_count !== 'undefined' ? setFormat_accounting_for_cells_raw.decimal_count : 0   // decimal places
        },
        number: {
            decimal : setFormat_accounting_for_cells_raw.decimal_symbol,  // decimal point separator
            thousand: setFormat_accounting_for_cells_raw.thousand_symbol,  // thousands separator
            precision : typeof setFormat_accounting_for_cells_raw.decimal_count !== 'undefined' ? setFormat_accounting_for_cells_raw.decimal_count : 0   // decimal places
        }
    };
}

function calculateTableHeight(topElement) {
    var top, paddingBottom;

    if (jquery('#mybootstrap').hasClass('joomla4')) {
        top = topElement.outerHeight() + 20;
        paddingBottom = typeof Droptables.caninsert !== 'undefined' && Droptables.caninsert == 1 ? 55 : 10;
    } else {
        top = topElement.outerHeight() + 85;
        paddingBottom = typeof Droptables.caninsert !== 'undefined' && Droptables.caninsert == 1 ? -10 : 10;
    }

    if (jquery('body.com_droptables').find('header.header').length > 0) {
        top += jquery('body.com_droptables').find('header.header').outerHeight();
    }

    var windownHeight = jquery(window).height();
    var height = windownHeight - top - paddingBottom;
    return height;
}

// check for existence of nested object key
// example: var test = {level1:{level2:{level3:'level3'}} };
// checkObjPropertyNested(test, 'level1', 'level2', 'level3'); // true
function checkObjPropertyNested(obj /*, level1, level2, ... levelN*/) {
    var args = Array.prototype.slice.call(arguments, 1);
    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i])) {
            return false;
        }
        obj = obj[args[i]];
    }
    return true;
}

// check for existence of nested object key and check value not empty
// example: var test = {level1:{level2:{level3:'level3'}} };
// checkObjPropertyNestedNotEmpty(test, 'level1', 'level2', 'level3'); // true
function checkObjPropertyNestedNotEmpty(obj /*, level1, level2, ... levelN*/) {
    var args = Array.prototype.slice.call(arguments, 1);

    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i]) || !obj[args[i]]) {
            return false;
        }
        obj = obj[args[i]];
    }
    return true;
}

//Code from http://stackoverflow.com/questions/9905533/convert-excel-column-alphabet-e-g-aa-to-number-e-g-25
var convertAlpha = function (val) {
    var base = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', i, j, result = 0;

    for (i = 0, j = val.length - 1; i < val.length; i += 1, j -= 1) {
        result += Math.pow(base.length, j) * (base.indexOf(val[i]) + 1);
    }

    return result;
};


// Convert date in date_format to the format: m/d/Y /a/t g:i A
// example: number -> array(2016,03,26)
function convertDate(date_format, number, timezone) {
    var date_array = [];
    number = (!!number) ? number : [];
    if (date_format.length !== number.length) {
        return false;
    }
    if (typeof timezone === 'undefined') {
        timezone = true;
    }
    for (var n = 0; n < date_format.length; n++) {
        number[n] = (!!number[n]) ? number[n] : '';
        if (date_format[n] === 'd' || date_format[n] === 'j') {
            date_array[2] = (number[n] !== '') ? number[n] : '';
        } else if (date_format[n] === 'S' || date_format[n] === 'jS' || date_format[n] === 'dS') {
            date_array[2] = number[n].match(/[0-9]+/g);
        } else if (date_format[n] === 'm' || date_format[n] === 'n') {
            date_array[1] = number[n];
        } else if (date_format[n] === 'F') {
            date_array[1] = F_name.indexOf(number[n].toLowerCase()) + 1;
        } else if (date_format[n] === 'M') {
            date_array[1] = M_name.indexOf(number[n].toLowerCase()) + 1;
        } else if (date_format[n].toLowerCase() === 'y') {
            date_array[3] = number[n];
        } else if (date_format[n].toLowerCase() === 'g' || date_format[n].toLowerCase() === 'h') {
            date_array[4] = Number(number[n]);
        } else if (date_format[n].toLowerCase() === 'ga' || date_format[n].toLowerCase() === 'ha') {
            date_array[4] = number[n].match(/[0-9]+/g);
            date_array[4] = (number[n].toLowerCase().match(/[a-z]+/g) === 'am') ? date_array[4] : date_array[4] + 12;
        } else if (date_format[n].toLowerCase() === 'a') {
            date_array[7] = number[n];
        } else if (date_format[n].toLowerCase() === 'i' || date_format[n].toLowerCase() === 'ia') {
            date_array[5] = number[n].match(/[0-9]+/g);
        } else if (date_format[n].toLowerCase() === 's' || date_format[n].toLowerCase() === 'sa') {
            date_array[6] = number[n].match(/[0-9]+/g);
        } else if (date_format[n] === 'T') {
            date_array[8] = number[n];
        } else if (date_format[n] === 'r') {
            if (M_name.indexOf(number[2].toLowerCase()) + 1 > 0) {
                date_array[1] = M_name.indexOf(number[2].toLowerCase()) + 1;
            } else {
                date_array[1] = F_name.indexOf(number[2].toLowerCase()) + 1;
            }
            return date_array[1] + '/' + number[1] + '/' + number[3] + ' ' + number[4] + ':' + number[5] + ':' + number[6] + ' ' + number[7];
        }
    }
    date_array[4] = (!!date_array[4]) ? date_array[4] : 0;
    date_array[5] = (!!date_array[5]) ? date_array[5] : '00';
    date_array[6] = (!!date_array[6]) ? date_array[6] : '00';
    date_array[7] = (!!date_array[7]) ? ' ' + date_array[7] : '';
    date_array[8] = (!!date_array[8]) ? ' ' + date_array[8] : '';
    date_array[8] = (timezone === true) ? ' ' + date_array[8] : '';

    if (date_array[7] !== 'undefined' && date_array[7] !== '' && date_array[4] > 12) {
        date_array[4] = date_array[4] - 12;
    }
    if (date_array[1] === 0 || date_array[2] > 31 || date_array[1] > 12) {
        return false;
    }
    return date_array[1] + '/' + date_array[2] + '/' + date_array[3] + ' ' + date_array[4] + ':' + date_array[5] + ':' + date_array[6] + date_array[7] + date_array[8];
}


/**
 * convert cell data by column type
 *
 * @param position cell position
 * @param value    New value
 * @returns {string|boolean}
 */
function cell_type_to_column (position, value) {
    if ((Droptables.type !== 'mysql' && typeof Droptables.style.table.col_types[position[1]] !== 'undefined')
        || (typeof Droptables.query_option !== 'undefined' && typeof Droptables.query_option.column_options[position[1]] !== 'undefined')) {
        if (value === null) {
            value = '';
        }
        var type_column;
        if (Droptables.type === 'mysql' && typeof Droptables.query_option.column_options !== 'undefined' && typeof Droptables.query_option.column_options[position[1]] !== 'undefined') {
            type_column = Droptables.query_option.column_options[position[1]].Type;
        } else {
            type_column = Droptables.style.table.col_types[position[1]];
        }
        var data = validate_type_cell(type_column, value);
        return data;
    }
    return true;
}


function validate_type_cell (type_column, value) {
    var date_string;
    var length = value.length;
    switch (type_column.toUpperCase()) {
        case 'INT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -2147483648 && parseInt(value) > 2147483647) {
                return false;
            }
            break;
        case 'SMALLINT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -32768 && parseInt(value) > 32767) {
                return false;
            }
            break;
        case 'TINYINT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -128 && parseInt(value) > 127) {
                return false;
            }
            break;
        case 'MEDIUMINT':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            if (parseInt(value) < -8368608 && parseInt(value) > 8368607) {
                return false;
            }
            break;
        case 'bigint unsigned':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9]+/g, '') !== '') {
                return false;
            }
            break;
        case 'DECIMAL(16,4)':
            if (value === '') {
                value = '0';
            }
            if (value.replace(/[ |0-9|.]+/g, '') !== '') {
                return false;
            }
            break;

        case 'DATE':
            if (value !== '') {
                date_string = convertDate(["Y", "m", "d"], value.match(/[a-zA-Z0-9|+|-|\\]+/g), true);
                if (date_string === false) {
                    return false;
                }
                if (date_string === '00-00-0000') {
                    return '0000-00-00';
                }
                var date_string1 = new Date(date_string);
                if (isNaN(date_string1.getTime())) {
                    return false;
                }
                return date_string1.getFullYear() + '-' + ((date_string1.getMonth() < 10) ? '0' + (date_string1.getMonth() + 1) : date_string1.getMonth() + 1) + '-' + date_string1.getDate();
            } else {
                return '0000-00-00';
            }
            break;
        case 'DATETIME':
            if (value !== '') {
                date_string = convertDate(["Y", "m", "d", "h", "i", "s"], value.match(/[a-zA-Z0-9|+|-|\\]+/g), true);
                if (date_string === false) {
                    return false;
                }
                if (date_string === '00/00/0000 0:00:00 ') {
                    return '0000-00-00 00:00:00';
                }
                date_string = new Date(date_string);
                if (isNaN(date_string.getTime())) {
                    return false;
                }
                return date_string.getFullYear() + '-' + ((date_string.getMonth() < 10) ? '0' + (date_string.getMonth() + 1) : date_string.getMonth() + 1) + '-' + date_string.getDate() + ' ' + date_string.getHours() + ':' + date_string.getMinutes() + ':' + date_string.getSeconds();
            } else {
                return '0000-00-00 00:00:00';
            }
            break;
        case 'TIME':
            if (value !== '') {
                date_string = convertDate(["H", "m", "S"], value.match(/[a-zA-Z0-9|+|-|\\]+/g), true);
                if (date_string === false) {
                    return false;
                }
                if (date_string === '00-00-00 ') {
                    return '00:00:00';
                }
                date_string = new Date(date_string);
                if (isNaN(date_string.getTime())) {
                    return false;
                }
                return date_string.getHours() + ':' + date_string.getMinutes() + ':' + date_string.getSeconds();
            } else {
                return '00:00:00';
            }
            break;
        case 'TIMESTAMP':
            if (value !== '') {
                if (isNaN(value) || parseInt(value) < 0) {
                    return false;
                }
                date_string = (new Date(value)).getTime() > 0;

                if (date_string === false) {
                    return false;
                }

                return value;
            }
            break;

        case 'VARCHAR':
            if (length > 255) {
                return false;
            }
            break;
        case 'TEXT':
            if (length > 65500) {
                return false;
            }
            break;
        case 'LONGTEXT':
            if (length > 4294967294) {
                return false;
            }
            break;
        case 'MEDIUMTEXT':
            if (length > 16777214) {
                return false;
            }
            break;
        case 'CHAR':
            if (length > 255) {
                return false;
            }
            break;
        case 'FLOAT':
            if (value === '') {
                value = '0';
            }
            if (isNaN(parseFloat(value))) {
                return false;
            }
            break;
        default:
            return value;
            break;
    }
    return value;
}

/**
 * change cells value when add function in toolbar
 *
 * @param selection
 * @param values
 * @param keyColum
 */
function change_value_cells(selection, values, keyColum) {
    table_function_data.data_argument = [];
    var i, j, jj, value;
    if (selection === null) {
        selection = table_function_data.selection;
    }

    for (jj = 0; jj < table_function_data.selectionSize; jj++) {
        for (i = selection[jj][0]; i <= selection[jj][2]; i++) {
            for (j = selection[jj][1]; j <= selection[jj][3]; j++) {
                if (Array.isArray(values)) {
                    value = values[i][keyColum.replace('%key', j)];
                    table_function_data.data_argument.push([i, j, value, 'droptables_change_value_after_set_columns_types']);
                } else {
                    value = values;
                    table_function_data.data_argument.push([i, j, value]);
                }
                Droptables.datas[i][j] = value;
            }
        }
    }

    if (table_function_data.changeTheme) {
        _droptables__WEBPACK_IMPORTED_MODULE_0__.default.updatepreview(Droptables.id);
    }
    if (table_function_data.data_argument.length < 5) {//if cells number < 5 then setDataAtCell() is more performance
        window.jquery(window.Droptables_element.tableContainer).data('handsontable').setDataAtCell(table_function_data.data_argument, 'setDataAtCell');
    } else {
        window.jquery(window.Droptables_element.tableContainer).data('handsontable').loadData(Droptables.datas);
    }
}

//add, change style for column, rows, cells
function getFillArray(selection, Droptables, value) {
    var i, ij, ik, first_cell;
    if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
        for (i = 0; i < table_function_data.selectionSize; i++) {
            first_cell = false;
            if (selection[i][0] < 1) {
                first_cell = true;
            }
            for (ik = selection[i][1]; ik <= selection[i][3]; ik++) {
                Droptables.style.cols = fillArray(Droptables.style.cols, value, ik);
                if (first_cell) {
                    Droptables.style.cells = fillArray(Droptables.style.cells, value, 0, ik);
                }
            }
        }
    } else {
        for (i = 0; i < table_function_data.selectionSize; i++) {
            for (ij = selection[i][0]; ij <= selection[i][2]; ij++) {
                for (ik = selection[i][1]; ik <= selection[i][3]; ik++) {
                    Droptables.style.cells = fillArray(Droptables.style.cells, value, ij, ik);
                }
            }
        }
    }

    var action = Array.prototype.slice.call(arguments, 3);
    var save_data = false;
    if (action.length === 0) {
        action = 'style';
    } else {
        if (action.length > 1) {
            save_data = action[1];
        }
        if (action.length > 2) {
            action[2].call();
        }
        action = action[0];
    }

    if (saveData.length > 0) {
        var old_saveData = saveData[saveData.length - 1];
        var checkRangeStyleExists = false;
        if (action === old_saveData.action) {
            for (i = 0; i < table_function_data.selectionSize; i++) {
                if (old_saveData.selection[i][0] == selection[i][0] &&
                    old_saveData.selection[i][1] == selection[i][1] &&
                    old_saveData.selection[i][2] == selection[i][2] &&
                    old_saveData.selection[i][3] == selection[i][3]) {
                    checkRangeStyleExists = true;
                }
            }
        }

        if (checkRangeStyleExists) {
            old_saveData.style = window.jquery.extend(old_saveData.style, value);
        } else {
            if (droptablesCheckSize(value) > 0) {
                saveData.push({action: action, selection: selection, style: value});
                if (save_data) {
                    saveChanges(true);
                }
            }
        }
    } else {
        if (droptablesCheckSize(value) > 0) {
            saveData.push({action: action, selection: selection, style: value});
            if (save_data) {
                saveChanges(true);
            }
        }
    }
}

function droptablesCheckSize (obj) {
    var size = 0,
        key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

//update new value for array
function fillArray(array, val, val1, val2) {
    if (typeof (val2) === 'undefined') {
        if (typeof (val1) !== 'undefined') {
            if (typeof (array[val1]) !== 'undefined') {
                array[val1][1] = window.jquery.extend(array[val1][1], val);
            } else {
                array[val1] = [val1, {}];
                array[val1][1] = val;
            }
        } else {
            array = window.jquery.extend(array, val);
        }
    } else {
        if (typeof (array[val1 + "!" + val2]) !== 'undefined') {
            array[val1 + "!" + val2][2] = window.jquery.extend(array[val1 + "!" + val2][2], val);
        } else {
            array[val1 + "!" + val2] = [val1, val2, {}];
            array[val1 + "!" + val2][2] = val;
        }
    }
    return array;
}

// set value for an html input element from cellStyle object
function updateParamFromStyleObject(styleObj, prop, that, defaultValue, callback) {
    if (checkObjPropertyNested(styleObj, prop)) {
        that.val(styleObj[prop] === false ? defaultValue : styleObj[prop]);
    } else {
        that.val(defaultValue);
    }
    if (typeof callback !== 'undefined') {
        callback.call(that);
    }
}

// set value for an html switch-button element from Style object
function updateSwitchButtonFromStyleObject(styleObj, prop, that, defaultValue, callback) {
    if (checkObjPropertyNested(styleObj, prop)) {
        defaultValue = styleObj[prop];
    }
    that.val(defaultValue == 1 ? 'yes' : 'no').prop("checked", defaultValue == 1);

    if (typeof callback !== 'undefined') {
        callback.call(that);
    }
}

// set value for an html input element from cellStyle object
function updateParamFromStyleObjectSelectBox(styleObj, prop, that, defaultValue, callback, multiple_select) {
    if (styleObj !== '') {
        if (checkObjPropertyNested(styleObj, prop)) {
            defaultValue = styleObj[prop];
        }
    }
    defaultValue += '';
    that.data('value', defaultValue);
    var text = '';
    if (multiple_select) {
        jquery.each(defaultValue.split('|'), function (i, v) {
            if (text !== '') {
                text += ',' + that.find('li[data-value="' + v + '"]').text();
            } else {
                text += that.find('li[data-value="' + v + '"]').text();
            }
        })
    } else if (that.find('li[data-value="' + defaultValue + '"]').length > 0) {
        text += that.find('li[data-value="' + defaultValue + '"]').text();
    }

    that.prev('.droptable_select_box_before').text(text === '' ? defaultValue : text).data('value', defaultValue);
    if (typeof callback !== 'undefined' && callback !== null) {
        callback.call(that);
    }
}

//get size of cell selected when open change height, row popup
function getSizeCells($, Droptables, cells) {
    if (Droptables.type === 'mysql') {
        updateParamFromStyleObject(Droptables.style.rows[0][1], 'height', $('#cell_row_height'), '30');
    } else {
        if (checkObjPropertyNested(Droptables.style.rows, cells[0], 1, 'height')) {
            $('#cell_row_height').val(Droptables.style.rows[cells[0]][1].height);
        }
    }

    if (checkObjPropertyNested(Droptables.style.cols, cells[1], 1, 'width')) {
        $('#cell_col_width').val(Droptables.style.cols[cells[1]][1].width);
    }
    if (checkObjPropertyNested(Droptables.style.table, 'allRowHeight')) {
        $('#all_cell_row_height').val(Droptables.style.table.allRowHeight);
    }
}

//convert droptables's dateformat to momentjs's dateformat
function momentjsFormat(value) {
    value = value.replaceAll("M", "MMM");
    value = value.replaceAll("n", "M");
    value = value.replaceAll("F", "MMMM");
    value = value.replaceAll("m", "MM");

    value = value.replaceAll("D", "ddd");
    let date = new RegExp('(\\b)d(?!d)', "g");
    value = value.replaceAll(date, "DD");
    value = value.replaceAll("j", "D");
    value = value.replaceAll("z", "DDDD");
    value = value.replaceAll("l", "dddd");
    value = value.replaceAll("S", "Do");
    value = value.replaceAll("N", "e");

    value = value.replaceAll("w", "do");
    value = value.replaceAll("W", "w");

    value = value.replaceAll("Y", "YYYY");
    value = value.replaceAll("o", "Y");
    value = value.replaceAll("y", "YY");


    value = value.replaceAll("h", "hh");
    value = value.replaceAll("g", "h");
    value = value.replaceAll("H", "HH");
    value = value.replaceAll("G", "H");

    value = value.replaceAll("i", "mm");
    value = value.replaceAll("s", "ss");
    value = value.replaceAll("T", "z");
    return value;
}

/*print getSelect cell to element*/
function getSelectedVal(dataSelect, selectRange) {
    var valueRange = '';

    if (dataSelect[1] > 25) {
        valueRange += String.fromCharCode(97) + String.fromCharCode(97 + dataSelect[1] - 26);
    } else {
        if (dataSelect[1] !== false) {
            valueRange += String.fromCharCode(97 + dataSelect[1]);
        }
    }
    if (dataSelect[0] !== false) {
        valueRange += dataSelect[0] + 1;
    }

    valueRange += ':';


    if (dataSelect[3] > 25) {
        valueRange += String.fromCharCode(97) + String.fromCharCode(97 + dataSelect[3] - 26);
    } else {
        if (dataSelect[3] !== false) {
            valueRange += String.fromCharCode(97 + dataSelect[3]);
        }
    }
    if (dataSelect[2] !== false) {
        valueRange += dataSelect[2] + 1;
    }

    if (typeof selectRange !== 'undefined') {
        selectRange.val(valueRange);
    } else {
        return valueRange;
    }
}

function status_noti (status, text) {
    var $ = window.jquery;
    var status_e = $('#savedInfoTable');
    if (status === 1) {
        status_e = $('#savedInfoTable');
    } else {
        status_e = $('#saveErrorTable');
    }
    status_e.html(text);
    var position = window.jquery('#setting-cells').offset();
    setTimeout(function () {
        status_e.animate({'opacity': '0.8', 'top': position.top - 35}, 500).delay(2000).animate({'opacity': '0', 'top': '-45px'}, 1000);
    }, 1000);
}

function setText ($name_edit, press_enter_selector, obj) {
    unbindall();
    /*select rename table*/
    var oldTitle = $name_edit.text();
    var droptable_name_edit = document.querySelector('.rename.droptable_name_edit');
    $name_edit.attr('contentEditable', true).focus();

    $name_edit.not('.editable').bind('click.mm', hstop); //let's click on the editable object
    jquery(press_enter_selector).bind('keydown.mm', enterKey); //let's press enter to validate new title'
    jquery('*').not('.droptable_name_edit').bind('click.mm', houtside);

    // $name_edit.addClass('editable');
    if (obj.selected) {
        $name_edit.trigger('click.mm');
    }

    function unbindall(reselectCell) {
        $name_edit.not('.editable').unbind('click.mm', hstop);  //let's click on the editable object
        jquery(press_enter_selector).unbind('keydown.mm', enterKey); //let's press enter to validate new title'
        jquery('*').not('.droptable_name_edit').unbind('click.mm', houtside);
        $name_edit.attr('contentEditable', false);

        if (reselectCell && typeof table_function_data.selection[0][1] !== 'undefined') {//reselect cell after enter/esc name table
            var selection = window.jquery(Droptables_element.tableContainer).handsontable('getSelected');
            window.jquery(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][0], selection[0][1]);
        }
    }

    //Validation
    function hstop(e) {
        event.stopPropagation();
        $name_edit.addClass('editable');
        if (droptable_name_edit !== null) {
            droptable_name_edit.focus();
        }
        return false;
    }

    function enterKey(e) {
        e.stopImmediatePropagation();
        if (e.which == 13) {
            e.preventDefault();
            $name_edit.removeClass('editable');
            updateTitle($name_edit.text(), jquery);
            unbindall(true);
        }
        if (e.which == 27) {
            e.preventDefault();
            $name_edit.text(oldTitle);
            $name_edit.removeClass('editable');
            unbindall(true);
        }
        $name_edit.removeClass('rename');
    }

    function houtside(e) {
        if ($name_edit.hasClass('editable') && !$name_edit.hasClass('rename')) {
            $name_edit.removeClass('editable');
            updateTitle($name_edit.text(), jquery);
            unbindall(true);
            $name_edit.removeClass('rename');
        }
        return false;
    }

    function updateTitle(title, $) {
        if (!table_function_data.allowed_edit) {
            return false;
        }

        if (oldTitle === title) {
            return false;
        }

        if (title.trim() !== '' && typeof obj.url !== 'undefined') {
            obj.url += title;
            $.ajax({
                url: obj.url,
                type: "POST",
                data: {},
                dataType: "json",
                beforeSend: function () {
                    Droptables_element.settingTable.find('.droptable_saving').removeClass('droptable_hiden');
                },
                success: function (datas) {
                    if (datas.response === true) {
                        $name_edit.text(title);
                        if ($('.pwrapper').hasClass('droptable_hiden')) {
                            $('#list_chart').find('.chart-menu.active a').text(title);
                        } else {
                            $('#list_chart').find('.current_table a').text(title);
                        }
                        if (typeof obj.action !== 'undefined') {
                            obj.action(title);
                        }
                        Droptables_element.settingTable.find('.droptable_saving').addClass('droptable_hiden');

                        setTimeout(function () {
                            localStorage.setItem('droptables_change_table_name', JSON.stringify({'id': Droptables.id,'title': title, 'modified_time': datas.datas.modified_time}));

                            Droptables_element.settingTable.find('.droptable_saved').removeClass('droptable_hiden');
                            Droptables_element.settingTable.find('.droptable_saved').animate({'opacity': '1'}, 500).delay(500).animate({
                                'opacity': '0'
                            }, 500);
                        }, 500);
                    } else {
                        $name_edit.text(oldTitle);
                        bootbox.alert(datas.response);
                    }
                },
                error: function (jqxhr, textStatus, error) {
                    $name_edit.text(oldTitle);
                    bootbox.alert(textStatus);
                }
            });
        } else {
            $name_edit.text(oldTitle);
            return false;
        }
        $name_edit.css('white-space', 'normal');
        setTimeout(function () {
            $name_edit.css('white-space', '');
        }, 200);
    }
};

function pullDims(Droptables, $) {
    var args = Array.prototype.slice.call(arguments, 1);
    var cols = [];
    var rows = [];
    var row, lengthRows, lengthCols, col;

    // get count of Droptables.style.rows
    if (typeof Droptables.style.rows.length !== 'undefined') {
        lengthRows = Droptables.style.rows.length;
    } else {
        lengthRows = Object.keys(Droptables.style.rows).length;
    }

    for (row = 0; row < lengthRows; row++) {
        if (checkObjPropertyNested(Droptables.style.rows[row], 1, 'height')) {
            rows[row] = Droptables.style.rows[row][1].height;
        } else if (Droptables.type === 'mysql' && typeof Droptables.style.table.allRowHeight !== 'undefined' && Droptables.style.table.allRowHeight !== '') {
            rows[row] = Droptables.style.table.allRowHeight;
        } else {
            rows[row] = null;
        }
    }

    // get count of Droptables.style.cols
    if (typeof Droptables.style.cols.length !== 'undefined') {
        lengthCols = Droptables.style.cols.length;
    } else {
        lengthCols = Object.keys(Droptables.style.cols).length;
    }

    for (col = 0; col < lengthCols; col++) {
        if (checkObjPropertyNested(Droptables.style.cols[col], 1, 'width')) {
            cols[col] = Droptables.style.cols[col][1].width;
        } else {
            cols[col] = null;
        }
    }
    Droptables.updateSettings.manualColumnResize = $.extend([], cols);
    Droptables.updateSettings.rowHeights = $.extend([], rows);

    if (typeof args[1] === 'undefined' || args[1] === true) {
        delete Droptables.updateSettings.manualColumnResize;
        delete Droptables.updateSettings.manualRowResize;
        Droptables_element.tableContainer.handsontable('updateSettings', {'manualColumnResize': cols});
        Droptables_element.tableContainer.handsontable('updateSettings', {'manualRowResize': rows});
        /*different from wptm, haven't found a reason to use manualRowResize*/
        // Droptables_element.tableContainer.('updateSettings', {'manualRowResize': rows});
    }
}

/*time out auto save*/
var autosaveNotification;
var getSaveAjax;

function cleanHandsontable () {
    Droptables_element.primary_toolbars.find('#undo_cell').removeClass('active').addClass('no_active');
    Droptables_element.primary_toolbars.find('#redo_cell').removeClass('active').addClass('no_active');
    setTimeout(function () {
        jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.clear();
    }, 500);
}


function getLinkSync (link, type, warningDisplay) {
    var data = {};
    switch (type) {
        case 'excel':
            if (link.indexOf("docs.google.com/spreadsheet") !== -1 && warningDisplay) {
                bootbox.alert(Joomla.JText._('COM_DROPTABLES_TABLES_ERROR_IMPORT', 'Your path is incorrect, please enter the link again, thanks!'));
                Droptables.style.table.excel_url = '';
                return false;
            }
            data.auto_sync = Droptables.style.table.excel_auto_sync != '1' ? 0 : 1;
            data.spreadsheet_style = Droptables.style.table.excel_spreadsheet_style != '1' ? 0 : 1;
            data.url = encodeURI(link);
            break;
        case 'spreadsheet':
            var end_link = link.split('?');
            var end_link0 = end_link[0].slice(-7);
            if (link.indexOf("docs.google.com/spreadsheet") === -1 && end_link0.match(/html|csv|pdf|xlsx/gi) === null && (typeof end_link[1] !== "undefined" && end_link[1].match(/sharing|html|csv|pdf|xlsx/gi) === null) && warningDisplay) {
                bootbox.alert(Joomla.JText._('COM_DROPTABLES_TABLES_ERROR_LINK_GG', 'Please double check the Google Sheet access configuration, cannot get the data.'));
                Droptables.style.table.spreadsheet_url = '';
                return false;
            }
            data.auto_sync = Droptables.style.table.auto_sync != '1' ? 0 : 1;
            data.spreadsheet_style = Droptables.style.table.spreadsheet_style != '1' ? 0 : 1;
            data.url = encodeURI(link);
            break;
    }

    return data;
}


function saveChanges(autosave, ajaxCallback) {
    var $ = window.jquery;
    if (!table_function_data.allowed_edit) {
        return false;
    }

    Droptables.saveDataDbTable = [];

    //check save calculate date
    if (window.table_function_data.check_value_data === false) {
        setTimeout(function () {
            $('#saveErrorTable').animate({'top': '+=75px', 'opacity': '1'}, 500).delay(2000).animate({
                'top': '-=75px',
                'opacity': '0'
            }, 1000);
        }, 1000);
        window.table_function_data.check_value_data = true;
        return;
    }

    if ((typeof autosave == 'undefined' && !enable_autosave) || autosave === false) {
        checkTimeOut = false;
        return;
    }
    if (!checkTimeOut) {
        clearTimeout(getSaveAjax);
    }

    checkTimeOut = false;

    var delay_time = enable_autosave ? 5000 : 0;

    if (autosave === true) {
        delay_time = 100;
    }

    getSaveAjax = setTimeout(function () {
        /*check have the change Alternate*/
        // if (droptablesCheckSize((window.table_function_data.checkChangeAlternate) > 0) {
        //     window.Droptables.style.cells = $.extend({}, alternating.reAlternateColor());
        // }


        //fix style.cols length
        var cols_length = droptablesCheckSize(window.Droptables.style.cols)
        if (cols_length > window.Droptables.max_Col) {
            var newCols = {}
            for (var ii = 0; ii < window.Droptables.max_Col; ii++) {
                newCols[ii] = window.Droptables.style.cols[ii];

                if (window.Droptables.max_Col === ii + 1) {
                    window.Droptables.style.cols = $.extend({}, newCols);
                }
            }
        }

        var save_data;

        if (window.Droptables.style.table.mergeSetting.length > 0) {//update header option by merger cells
            var i;
            var maxHeader = window.Droptables.headerOption;
            for (i = 0; i < window.Droptables.style.table.mergeSetting.length; i++) {
                var mergeSetting = window.Droptables.style.table.mergeSetting[i];
                maxHeader = (mergeSetting.row < maxHeader && mergeSetting.row + mergeSetting.rowspan > maxHeader) ? mergeSetting.row + mergeSetting.rowspan : maxHeader;
            }

            if (maxHeader > window.Droptables.headerOption) {
                saveData.push({
                    action: 'set_header_option',
                    value: maxHeader
                });
                window.Droptables.headerOption = maxHeader;

                if (Droptables.style.table.freeze_row > 0) {
                    $(Droptables_element.tableContainer).handsontable('updateSettings', {fixedRowsTop: maxHeader});
                }
            }
        }
        if (typeof table_function_data.colsSetType !== 'undefined') {
            saveData.push({
                action: 'set_columns_types',
                value: table_function_data.colsSetType
            });
            delete table_function_data.colsSetType;
        }

        if (table_function_data.save_table_params.length > 0) {
            save_data = JSON.stringify(table_function_data.save_table_params);
        } else {
            if (typeof table_function_data.create_col_after_paste !== 'undefined' && table_function_data.create_col_after_paste.length > 0) {
                saveData = table_function_data.create_col_after_paste.concat(saveData)
                table_function_data.create_col_after_paste = []
            }
            save_data = JSON.stringify(saveData)
        }

        var params = !(window.Droptables.type !== 'html') ? $.extend(window.Droptables.style.table, {
            "mergeSetting": reConvertMergeCell(),
            "hyperlink": JSON.stringify(window.Droptables.hyperlink),
            "headerOption": window.Droptables.headerOption
        }) : $.extend(window.Droptables.style.table, {"mergeSetting": reConvertMergeCell(), "headerOption": 1});

        if (typeof params.cell_types !== 'undefined') {
            params = $.extend({}, params, {
                "cell_types": JSON.stringify(params.cell_types)
            });
        }
        if (typeof params.col_types !== 'undefined') {
            params = $.extend({}, params, {
                "col_types": JSON.stringify(params.col_types)
            });
        }
        if (typeof params.mergeSetting !== 'undefined') {
            params = $.extend({}, params, {
                "mergeSetting": JSON.stringify(params.mergeSetting)
            });
        }
        if (typeof params.alternateColorValue !== 'undefined') {
            params = $.extend({}, params, {
                "alternateColorValue": JSON.stringify(params.alternateColorValue)
            });
        }

        var jsonVar = {
            jform: {
                datas: save_data,
                style: JSON.stringify({'cols': window.Droptables.style.cols, 'rows': window.Droptables.style.rows}),
                css: window.Droptables.css,
                header_data: Droptables.style.header_data,
                params: params,
                count: {'countRows': $(window.Droptables_element.tableContainer).handsontable('countRows'), 'countCols': $(window.Droptables_element.tableContainer).handsontable('countCols')}
            },
            id: window.Droptables.id
        };

        if (typeof window.Droptables.syn_hash !== 'undefined' && window.Droptables.syn_hash !== '') {
            jsonVar.jform.syn_hash = window.Droptables.syn_hash;
        }

        window.Droptables.style = cleanStyle(window.Droptables.style, $(window.Droptables_element.tableContainer).handsontable('countRows'), $(window.Droptables_element.tableContainer).handsontable('countCols'));
        window.table_function_data.old_slection = window.table_function_data.selection;

        $.ajax({
            url: Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.save' + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
            type: "POST",
            data: jsonVar,
            dataType: "json",
            beforeSend: function () {
                Droptables_element.settingTable.find('.droptable_saving').removeClass('droptable_hiden');
                Droptables_element.settingTable.find('.saveErrorTable').addClass('droptable_hiden');
                window.table_function_data.firstRender = false;
            },
            success: function (datas) {
                if (datas.response === true) {
                    Droptables_element.settingTable.find('.saveErrorTable').addClass('droptable_hiden');
                    Droptables_element.settingTable.find('.droptable_saving').addClass('droptable_hiden');
                    Droptables_element.settingTable.find('.droptable_saved').removeClass('droptable_hiden');
                    Droptables_element.settingTable.find('.droptable_saved').animate({'opacity': '1'}, 500).delay(500).animate({
                        'opacity': '0'
                    }, 500);

                    if (datas.datas === 'reload') {
                        location.reload();
                    }

                    //empty data in saveData
                    if (table_function_data.save_table_params.length > 0) {
                        table_function_data.save_table_params = [];
                    } else {
                        saveData = [];
                    }
                    update_after_save(datas.datas);
                    if (typeof ajaxCallback !== 'undefined' && ajaxCallback === 'render') {
                        setTimeout(function () {
                            $(window.Droptables_element.tableContainer).handsontable('render');
                        }, 500);
                    }

                    setTimeout(function () {
                        Droptables_element.settingTable.find('.droptable_saved').addClass('droptable_hiden');
                    }, 1500);
                } else {
                    bootbox.alert(datas.response);
                    Droptables_element.settingTable.find('.saveErrorTable').removeClass('droptable_hiden');
                    setTimeout(function () {
                        Droptables_element.settingTable.find('.saveErrorTable').addClass('droptable_hiden');
                    }, 1000);
                }
                window.table_function_data.firstRender = true;
            },
            error: function (jqxhr, textStatus, error) {
                bootbox.alert(textStatus);
            }
        });

        checkTimeOut = true;
        Droptables.style.table.mergeSetting = convertMergeCell();
    }, delay_time);
}

function updateDataAndParamsTable() {
    var url = Droptables.ajaxurl + "index.php?option=com_droptables&view=table&format=json&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert);
    var $ = jquery;
    $.ajax({
        url: url,
        type: "POST",
        data: {},
        dataType: "json",
    }).done(function (data) {
        if (data.datas === '' || data.datas === false) {
            delete Droptables.datas;
            Droptables.datas = [
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""],
                ["", "", "", "", "", "", "", "", "", ""]
            ];
        } else {
            try {
                if (typeof data.data === 'string') {
                    data.data = JSON.stringify(data.data);
                    data.data = JSON.parse(data.data);
                }
                Droptables.datas = data.data;
            } catch (err) {
                Droptables.datas = [
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""],
                    ["", "", "", "", "", "", "", "", "", ""]
                ];
            }
        }
        // reConvertMergeCell()
        Droptables.style = data.style;

        if (data.params === "" || data.params === null || data.params.length == 0) {
            Droptables.style.table.mergeSetting = [];
            Droptables.style.table.headerOption = 1;
        } else {
            if (typeof Droptables.style.table.lock_ranger_cells !== 'undefined' && Droptables.style.table.lock_ranger_cells.length > 0) {
                create_ranger_cells_lock(Droptables, table_function_data, null);
            }
            if (typeof (data.params) == 'string') {
                data.params = $.parseJSON(data.params);
            }

            if (typeof data.params.headerOption !== 'undefined') {
                Droptables.style.table.headerOption = parseInt(data.params.headerOption);
            } else {
                Droptables.style.table.headerOption = 1;
            }
            if (Droptables.style.table.headerOption > 0
                && (typeof Droptables.style.header_data === 'undefined'
                    || Droptables.style.header_data.length < Droptables.style.table.headerOption)
            ) {
                Droptables.style.header_data = [];
                for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                    Droptables.style.header_data[j] = Droptables.datas[j];
                }
            }

            Droptables.style.table.mergeSetting = convertMergeCell();
            window.jquery(window.Droptables_element.tableContainer).data('handsontable').loadData(Droptables.datas);
        }
        Droptables_element.mainTabContent.removeClass('loading_ajax');
    })
    return false;
}

function update_after_save (datas) {
    if (typeof datas.type !== 'undefined') {
        jquery.each(datas.type, function (i, v) {
            switch (i) {
                case "reload_table":
                    updateDataAndParamsTable();
                    break;
                case "set_columns_types":
                    var selected = [];

                    jquery.each(window.table_function_data.old_slection, function (i, v) {
                        if (typeof Droptables.style.table.headerOption !== 'undefined') {
                            if (v[0] < parseInt(Droptables.style.table.headerOption)) {
                                v[0] = parseInt(Droptables.style.table.headerOption);
                            }
                        }
                        selected[i] = v;
                    });
                    change_value_cells(selected, v, 'col%key');
                    break;
                case "update_cells_type":
                    var value = jquery.parseJSON(v);

                    Droptables.style.table.cell_types = jquery.extend([], value);

                    break;
                case "update_params":
                    var params = jquery.parseJSON(v);
                    if (typeof params.style.table.headerOption !== 'undefined') {
                        Droptables.style.table.headerOption = parseInt(params.style.table.headerOption);
                    } else {
                        Droptables.style.table.headerOption = 1;
                    }
                    try {
                        Droptables.style.table.mergeSetting = jquery.parseJSON(params.mergeSetting);
                        if (Droptables.style.table.mergeSetting == null) {
                            Droptables.style.table.mergeSetting = [];
                        }
                    } catch (e) {
                        Droptables.style.table.mergeSetting = [];
                    }

                    //not update header_data, it was updated
                    if (typeof params.header_data !== 'undefined') {
                        delete params.header_data;
                    }

                    window.Droptables.style.table = jquery.extend({}, params);
                    break;
            }
        });
    }
    if (typeof table_function_data.fetch_data !== 'undefined') {
        fetchSpreadsheet(table_function_data.fetch_data);
    }
}

function loading(e) {
    e.addClass('dploadingcontainer');
    e.append('<div class="dploading"></div>');
}
function rloading(e) {
    e.removeClass('dploadingcontainer');
    e.find('div.dploading').remove();
}

function deleteRowDbTable(table, field, id_row) {
    var url = Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.deleteRowDbTable';
    Droptables_element.mainTabContent.addClass('loading_ajax');

    jquery.ajax({
        url: url,
        data: {
            id_table: Droptables.id,
            value: id_row,
            field: field,
            table: table
        },
        type: 'POST',
        success: function (datas) {
            datas = JSON.parse(datas);
            if (datas.response === true) {
                updateDataAndParamsTable();
            } else {
                bootbox.alert(datas.response);
            }
        },
        error: function (jqxhr, textStatus, error) {
            bootbox.alert(textStatus);
        }
    })
}

function createRowDbTable (dbtable, list_value) {
    var url = Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.createRowDbTable';
    Droptables_element.mainTabContent.addClass('loading_ajax');
    jquery.ajax({
        url: url,
        data: {
            id: Droptables.id,
            data: list_value,
            dbtable: dbtable
        },
        type: 'POST',
        success: function (datas) {
            datas = JSON.parse(datas);
            if (datas.response === true) {
                updateDataAndParamsTable();
            } else {
                bootbox.alert(datas.response);
            }
        },
        error: function (jqxhr, textStatus, error) {
            bootbox.alert(textStatus);
        }
    })
}

function fetchSpreadsheet(obj) {
    loading(Droptables_element.wpreview);

    var auto_sync, spreadsheet_style, url;
    var $close_popup = Droptables_element.droptable_popup.find('.colose_popup');
    var loader = Droptables_element.droptable_popup.find('.lds-ring');
    var popup_notification = Droptables_element.droptable_popup.find('.popup_notification');
    var data;

    if (obj.type === 'spreadsheet') {
        data = getLinkSync(Droptables.style.table.spreadsheet_url, 'spreadsheet', true);
        if (!data) {
            return false;
        }
    } else if (obj.type === 'excel') {
        data = getLinkSync(Droptables.style.table.excel_url, 'excel', true);
        if (!data) {
            return false;
        }
    } else {
        return false;
    }

    var jsonVar = {
        spreadsheet_url: data.url,
        id: Droptables.id,
        sync: data.auto_sync,
        syncType: obj.type,
        style: data.spreadsheet_style
    };
    delete table_function_data.fetch_data;

    jquery.ajax({
        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=excel.fetchSpreadsheet&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
        type: "POST",
        data: jsonVar,
        beforeSend: function() {
            loader.removeClass('droptable_hiden');
            popup_notification.addClass('droptable_hiden');
        },
        success: function (datas) {
            loader.addClass('droptable_hiden');
            var result = jQuery.parseJSON(datas);
            if (result.response === true) {
                if (obj.type === 'spreadsheet') {
                    // table_function_data.auto_sync = result.datas.sync;
                    table_function_data.spreadsheet_style = result.datas.style;
                    table_function_data.spreadsheet_url = Droptables.style.table.spreadsheet_url;
                } else if(obj.type === 'excel') {
                    if (typeof result.datas.style !== 'undefined') {
                        // table_function_data.excel_auto_sync = result.datas.sync;
                        table_function_data.excel_spreadsheet_style = result.datas.style;
                        table_function_data.excel_url = Droptables.style.table.excel_url;
                    }
                }
                popup_notification.html('<span class="noti_success">'+Joomla.JText._('COM_DROPTABLES_ERROR_FETCH_EXCEL', 'Data has been fetched')+'</span>');
                if (typeof result.datas.error !== 'undefined' && result.datas.error !== '') {
                    popup_notification.html('<span class="noti_false">'+result.datas.error+'</span>');
                    popup_notification.removeClass('droptable_hiden');
                } else {
                    popup_notification.removeClass('droptable_hiden');
                    $close_popup.trigger('click');
                }
                location.reload();
            } else {
                popup_notification.html('<span class="noti_false" style="font-size: 14px; color: red">'+result.response+'</span>');
                popup_notification.removeClass('droptable_hiden');
                setTimeout(function () {
                    location.reload();
                }, 5000);
            }
        },
        error: function (jqxhr, textStatus, error) {
            popup_notification.html('<span class="noti_false">'+Joomla.JText._('COM_DROPTABLES_ERROR_FETCH_EXCEL', 'Data has been fetched')+'</span>');
            popup_notification.removeClass('droptable_hiden');
            rloading(Droptables_element.wpreview);
        }
    });
}

function convertMergeCell() {//convert to value in js
    var mergeCell = [];
    let mergeSetting = typeof Droptables.style.table.mergeSetting === 'string' ? JSON.parse(Droptables.style.table.mergeSetting) : Droptables.style.table.mergeSetting;
    if (typeof mergeSetting !== 'undefined' && mergeSetting.length > 0) {
        for (var i = 0; i < mergeSetting.length; i++) {
            mergeCell.push({'col': parseInt(mergeSetting[i][2]),
                'colspan': parseInt(mergeSetting[i][3]),
                'row': parseInt(mergeSetting[i][0]),
                'rowspan': parseInt(mergeSetting[i][1])
            });
        }
    }
    return mergeCell;
}

function reConvertMergeCell() {//convert to value in db
    var mergeCell = [];
    if (typeof Droptables.style.table.mergeSetting !== 'undefined' && Droptables.style.table.mergeSetting.length > 0) {
        for (var i = 0; i < Droptables.style.table.mergeSetting.length; i++) {
            mergeCell.push([Droptables.style.table.mergeSetting[i].row,
                Droptables.style.table.mergeSetting[i].rowspan,
                Droptables.style.table.mergeSetting[i].col,
                Droptables.style.table.mergeSetting[i].colspan
            ]);
        }
    }
    return mergeCell;
}

/*render data table, cells, rows, cols*/
function cleanStyle(style, nbRows, nbCols) {
    for (var col in style.cols) {
        if (!style.cols[col] || style.cols[col][0] >= nbCols) {
            delete style.cols[col];
        }
    }
    for (var row in style.rows) {
        if (!style.rows[row] || style.rows[row][0] >= nbRows) {
            delete style.rows[row];
        }
    }
    for (var cell in style.cells) {
        if (style.cells[cell][0] >= nbRows || style.cells[cell][1] >= nbCols) {
            delete style.cells[cell];
        }
    }
    var propertiesPos, cells;
    for (var obj in style) {
        if (obj == 'table') {
            continue;
        }
        for (cells in style[obj]) {
            if (!(typeof style[obj][cells] === 'undefined' || style[obj][cells] === null)) {
                propertiesPos = style[obj][cells].length - 1;
                for (var property in style[obj][cells][propertiesPos]) {
                    if (style[obj][cells][propertiesPos][property] === null) {
                        delete style[obj][cells][propertiesPos][property];
                    }
                }
            } else {
                delete style[obj][cells];
            }
        }
    }
    return style;
}

//add row height, col width for Droptables.style
function pushDims($, Droptables) {
    //get value height rows
    var rows = $(window.Droptables_element.tableContainer).handsontable('countRows');
    var i = 0;
    var value = 0;
    for (i = 0; i < rows; i++) {
        value = $(window.Droptables_element.tableContainer).handsontable('getRowHeight', i);
        if (Droptables.type === 'html') {
            if (!value || value === 0) {
                if (typeof (Droptables.style.rows[i]) !== 'undefined' && typeof (Droptables.style.rows[i][1].height) !== 'undefined') {
                    value = parseInt(Droptables.style.rows[i][1].height);
                }
                if (value === null) {
                    value = 22;
                }
            }
        } else { //type mysql
            if (checkObjPropertyNestedNotEmpty(Droptables.style.rows[i], 1, 'height')) { //Row height is set
                value = parseInt(Droptables.style.rows[i][1].height);
            } else {
                value = null; //if aviation height is set then height === null
            }
        }

        Droptables.style.rows = fillArray(Droptables.style.rows, {height: parseInt(value)}, i);
        value = 0;
    }
    //get value width columns
    var cols = $(window.Droptables_element.tableContainer).handsontable('countCols');
    Droptables.max_Col = cols;
    Droptables.max_row = rows;

    Droptables.style.table.width = 0;
    var valueCols = 0;
    for (i = 0; i < cols; i++) {
        valueCols = $(window.Droptables_element.tableContainer).handsontable('getColWidth', i);
        if (!valueCols || valueCols === 0) {
            if (typeof (Droptables.style.cols[i]) !== 'undefined' && Droptables.style.cols[i] !== null && (typeof (Droptables.style.cols[i][1].width) !== 'undefined')) {
                valueCols = parseInt(Droptables.style.cols[i][1].width);
            } else {
                valueCols = null;
            }
        }
        if (!valueCols || valueCols === 0) {
            valueCols = 100;
        }

        Droptables.style.cols = fillArray(Droptables.style.cols, {width: parseInt(valueCols)}, i);

        Droptables.style.table.width += parseInt(valueCols);
        valueCols = 0;
    }
}


// Build column selection for default sort parameter
function default_sortable(tableData) {
    var $ = window.jquery;
    if (tableData && typeof tableData[0] !== 'undefined') {
        var $jform_default_sortable = $('#content_popup_hide').find('.select_columns');
        var $jform_reponsive_table = $('#content_popup_hide').find('#responsive_table table tbody');
        var $jform_column_type_table = $('#content_popup_hide').find('#column_type_table table tbody');
        var $columnsSortType = $('#content_popup_hide').find('.columnsSortType');

        $jform_default_sortable.contents('li').remove();
        $jform_reponsive_table.html('');
        $jform_column_type_table.html('');
        $columnsSortType.contents('.columnSortItem:not(.droptable_hiden)').remove();

        var html = '';
        var html2 = '';
        var column_type_html = '';
        var ii = 0;

        var responsive_priority = '';
        for (var number = 0; number < (window.Droptables.max_Col > 12 ? window.Droptables.max_Col : 12); number++) {
            responsive_priority += '<li data-value="' + number + '">' + number + '</li>\n';
        }

        $.each(tableData[0], function (i, e) {
            var table_headers = $(window.Droptables_element.tableContainer).handsontable('getColHeader');
            var header = table_headers[i];

            var $columnSortItemDefault = $columnsSortType.find('.columnSortItem.droptable_hiden').clone();
            $columnSortItemDefault.removeClass('droptable_hiden');
            $columnSortItemDefault.find('.column_name').data('value', ii).text('Column ' + header + ' : ').attr('data-value', ii);
            $columnSortItemDefault.appendTo($columnsSortType);

            html += '<li data-value="' + ii + '">' + header + '</li>';

            html2 += '<tr data-col="' + ii + '">';
            html2 += '<td><label>' + header + '</label></td>';
            html2 += '<td><span class="responsive_priority popup_select mb-0 droptable_select_box_before"></span><ul class="droptable_select_box">\n'
                + responsive_priority +
                '</ul></td>';
            html2 += '</tr>';

            column_type_html += '<tr data-col="' + ii + '">';
            column_type_html += '<td><label>' + header + '</label></td>';
            column_type_html += '<td><span class="column_type popup_select mb-0 droptable_select_box_before"></span><ul class="droptable_select_box">\n' +
                '                        <li data-value="varchar">varchar</li>\n' +
                '                        <li data-value="int">integer</li>\n' +
                '                        <li data-value="float">float</li>\n' +
                '                        <li data-value="date">date</li>\n' +
                '                        <li data-value="datetime">datetime</li>\n' +
                '                        <li data-value="text">text</li>\n' +
                '                    </ul></td>';
            column_type_html += '</tr>';
            ii++;
        });
        $(html).appendTo($jform_default_sortable);
        $jform_default_sortable.trigger("liszt:updated");
        $(html2).appendTo($jform_reponsive_table);
        $jform_reponsive_table.trigger("liszt:updated");
        $(column_type_html).appendTo($jform_column_type_table);
        $jform_column_type_table.trigger("liszt:updated");
    }
}

function updateStyleAutofill (start_rangess, new_range, direction) {
    var respectively = [], data_respectively;
    var maxRange = [start_rangess[2] - start_rangess[0] + 1, start_rangess[3] - start_rangess[1] + 1];

    for (var i = new_range[0]; i <= new_range[2]; i++) {//rows
        for (var j = new_range[1]; j <= new_range[3]; j++) {//cols
            respectively[0] = i - new_range[0] > maxRange[0]
                ? ((i - new_range[0]) % maxRange[0]) + start_rangess[0]
                : i - new_range[0] + start_rangess[0];
            respectively[1] = j - new_range[1] > maxRange[1]
                ? ((j - new_range[1]) % maxRange[1]) + start_rangess[1]
                : j - new_range[1] + start_rangess[1];
            //update cell hyperlink
            if (typeof Droptables.hyperlink[i + '!' + j] !== 'undefined') {
                delete Droptables.hyperlink[i + '!' + j];
            }
            if (typeof Droptables.hyperlink[respectively[0] + '!' + respectively[1]] !== 'undefined') {
                data_respectively = Droptables.hyperlink[respectively[0] + '!' + respectively[1]];
                Droptables.hyperlink[i + '!' + j] = {};
                Droptables.hyperlink[i + '!' + j].hyperlink = data_respectively.hyperlink;
                Droptables.hyperlink[i + '!' + j].text = data_respectively.text;
            }

            //update cell type and col type
            var selection = {'0': [i,j,i,j]};
            if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined'
                && Droptables.style.cells[i + '!' + j][2].cell_type === 'html') {
                Droptables.style.cells[i + '!' + j][2].cell_type = null;
                saveData.push({action: 'set_cells_type', selection: selection, style: {cell_type: null}});
                window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, '']);
            } else if (typeof Droptables.style.cells[i + '!' + j] === 'undefined' || typeof Droptables.style.cells[i + '!' + j][2] === 'undefined') {
                Droptables.style.cells[i + '!' + j] = [i, j, {}];
            }

            if (typeof Droptables.style.cells[respectively[0] + '!' + respectively[1]] !== 'undefined'
                && Droptables.style.cells[respectively[0] + '!' + respectively[1]][2].cell_type === 'html') {
                Droptables.style.cells[i + '!' + j][2].cell_type = 'html';
                saveData.push({action: 'set_cells_type', selection: selection, style: {cell_type: 'html'}});
                window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, 'html']);

                if (typeof Droptables.style.table.col_types !== 'undefined'
                    && Droptables.style.table.col_types[j] !== 'text') {
                    Droptables.style.table.col_types[j] = 'text';
                    if (typeof table_function_data.colsSetType === 'undefined') {
                        table_function_data.colsSetType = {};
                    }
                    table_function_data.colsSetType[j] = 'text';
                }
            }
        }
    }
}

//convert value of calculation by format selected
function formatSymbols(resultCalc, decimal_count, thousand_symbols, decimal_symbols, symbol_position, value_unit) {
    decimal_count = parseInt(decimal_count);
    if (typeof resultCalc === 'undefined') {
        return;
    }
    var negative = resultCalc < 0 ? "-" : "",
        i = parseInt(resultCalc = Math.abs(+resultCalc || 0).toFixed(decimal_count), 10) + "",
        j = (j = i.length) > 3 ? j % 3 : 0;

    resultCalc = (j ? i.substr(0, j) + thousand_symbols : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand_symbols) + (decimal_count ? decimal_symbols + Math.abs(resultCalc - i).toFixed(decimal_count).slice(2) : "");

    resultCalc = Number(symbol_position) === 0
        ? ((negative === "-") ? negative + value_unit : value_unit) + resultCalc
        : negative + resultCalc + ' ' + value_unit;

    return resultCalc;
};

//Toggle between the charts and the table
function showChartOrTable(showChart, $chart) {
    if (showChart) {//show chart
        if (jquery('#droptable_chart .droptable_rightcol').find('.ss-content').length < 1) {
            var el2 = document.querySelector('#droptable_chart .droptable_rightcol');
            SimpleScrollbar.initEl(el2);
        }
        jquery('#droptable_chart').removeClass('droptable_hiden');
        jquery('.pwrapper').addClass('droptable_hiden');
        $chart.trigger('click');
        jquery('#list_chart').find('.current_table').unbind('click').on('click', showChartOrTable.bind(this, false));
    } else {//show table
        // if (jquery('#inserttable').length > 0) {
        //     Wptm.chart_active = 0;
        //     if (!jquery('#inserttable').hasClass('not_change_type')) {
        //         jquery('#inserttable').data('type', 'table').attr('data-type', 'table').text(insert_table);
        //     }
        //     jquery('#inserttable').removeClass("no_click");
        // }
        jquery('#droptable_chart').addClass('droptable_hiden');
        jquery('.pwrapper').removeClass('droptable_hiden');
        Droptables_element.tableContainer.handsontable('render');
    }
    jquery('#over_loadding_open_chart').hide();
    Droptables_element.primary_toolbars.find('.menu_loading').closest('li').removeClass('menu_loading');
    Droptables_element.settingTable.find('.ajax_loading').removeClass('loadding').addClass('droptable_hiden');
}

function getCellData(cellPos) {
    var pos = cellPos.split(":");
    var value = Droptables_element.tableContainer.handsontable('getDataAtCell', parseInt(pos[0]), parseInt(pos[1]));

    return value;
}

//replace string by decimal_symbol value and thousand_symbol value in calculation cell
function stringReplace(arr, unit) {
    var thousand_symbol = (!Droptables.style.table.thousand_symbol) ? default_value.thousand_symbol : Droptables.style.table.thousand_symbol;
    var decimal_symbol = (!Droptables.style.table.decimal_symbol) ? default_value.decimal_symbol : Droptables.style.table.decimal_symbol;
    if (typeof arr === 'number') {
        return arr;
    }
    var thousand_re = new RegExp('[' + thousand_symbol + ']', "g");
    // var thousand_re = new RegExp(thousand_symbol,"g");
    if (typeof arr !== 'undefined' && arr !== '' && arr !== null) {
        if (unit === true) {
            if (typeof arr !== 'string') {
                arr = arr.toString();
            }
            arr = arr.replace(table_function_data.text_replace_unit, "");
        } else {
            arr = arr.replace(table_function_data.replace_unit, "");
            arr = arr.replace(thousand_re, "");
            // arr = (thousand_symbol === ',') ? arr.replace(/,/g, "") : (thousand_symbol === '.' ? arr.replace(/\./g, "") : arr);
            arr = (decimal_symbol === ',') ? arr.replace(/,/g, ".") : arr;
        }
    } else {
        arr = '';
    }
    return arr;
}

function isSameArray(array1, array2) {
    return array1.length === array2.length && array1.every(function (element, index) {
        return element === array2[index];
    });
}
function convertStringToNumber (val) {
    var base = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', i, j, result = 0;

    for (i = 0, j = val.length - 1; i < val.length; i += 1, j -= 1) {
        result += Math.pow(base.length, j) * (base.indexOf(val[i]) + 1);
    }

    return result;
}
//add res priority of columns to set resposive priority popup
function responsive_col(Droptables) {
    var col = this.val();
    if (typeof (Droptables.style.cols) !== 'undefined' && typeof (Droptables.style.cols[col]) !== 'undefined' && typeof (Droptables.style.cols[col][1]) !== 'undefined' && typeof (Droptables.style.cols[col][1].res_priority) !== 'undefined') {
        var res_priority = Droptables.style.cols[col][1].res_priority;

        this.siblings('#responsive_priority').val(res_priority);
    } else {

        this.siblings('#responsive_priority').val(0);
    }
    this.siblings('#responsive_priority').trigger('liszt:updated');
}

function checkCellsOptionsValidate(selection, parametor, value) {
    var i, j;
    if (typeof arguments[3] !== 'undefined') {
        j = arguments[3];
        for (i = 0; i < j.length; i++) {
            if (typeof j[i][parametor] !== 'undefined' && j[i][parametor] == value) {
                return true;
            }
        }
    } else if (selection.length > 0) {
        for (i = selection[0][0]; i <= selection[0][2]; i++) {
            for (j = selection[0][1]; j <= selection[0][3]; j++) {
                if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined' && typeof Droptables.style.cells[i + '!' + j][2] !== 'undefined'){
                    if (typeof Droptables.style.cells[i + '!' + j][2][parametor] !== 'undefined' && Droptables.style.cells[i + '!' + j][2][parametor] == value) {
                        return true;
                    }
                }
            }
        }
    }
    return false;
}

function deleteFormatCells(selection) {
    if (selection.length > 0) {
        var i, j;
        for (i = selection[0][0]; i <= selection[0][2]; i++) {
            for (j = selection[0][1]; j <= selection[0][3]; j++) {
                if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined' && typeof Droptables.style.cells[i + '!' + j][2] !== 'undefined'){
                    if (typeof Droptables.style.cells[i + '!' + j][2].date_formats !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].date_formats = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].date_formats_momentjs !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].date_formats_momentjs = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].currency_symbol !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].currency_symbol = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].symbol_position !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].symbol_position = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].decimal_symbol !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].decimal_symbol = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].decimal_count !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].decimal_count = false;
                    }
                    if (typeof Droptables.style.cells[i + '!' + j][2].thousand_symbol !== 'undefined') {
                        Droptables.style.cells[i + '!' + j][2].thousand_symbol = false;
                    }
                }
            }
        }
    }
}

function check_cell_readOnly_mysql(row, col, cellProperties) {
    if (table_function_data.allowed_edit) {
        cellProperties.readOnly = false;
        if (row >= 1) {
            if (!table_function_data.mysqlEdit) {
                cellProperties.readOnly = true;
            } else {
                if (typeof Droptables.style.table.lock_columns !== 'undefined' && Droptables.style.table.lock_columns[col] != 0) {
                    cellProperties.readOnly = true;
                }
                if (typeof table_function_data.columns !== 'undefined' && table_function_data.columns[col].readOnly) {
                    cellProperties.readOnly = true;
                }
            }
        }
    } else {
        cellProperties.readOnly = true;
    }

    return cellProperties;
}

//table_function_data.allowed_edit && table_function_data.mysqlEdit
function check_cell_readOnly(row, col, prop) {
    var cellProperties = {};

    if (window.Droptables.type === 'mysql') {
        // console.log(Droptables);
        cellProperties = check_cell_readOnly_mysql(row, col, cellProperties);
    }

    if (!Droptables.check_super_user) {
        var lock_cell_id = [], not_lock_cell = false;
        if (typeof table_function_data.protect_columns !== 'undefined'
            && typeof table_function_data.protect_columns[col] !== 'undefined') {
            //protect columns
            lock_cell_id.push(table_function_data.protect_columns[col]);
        }
        if (typeof table_function_data.protect_rows !== 'undefined'
            && typeof table_function_data.protect_rows[col] !== 'undefined') {
            //protect rows
            lock_cell_id.push(table_function_data.protect_rows[row]);
        }
        if (typeof Droptables.style.cells[row + "!" + col] !== 'undefined' && typeof Droptables.style.cells[row + "!" + col][2].lock_cell !== 'undefined') {
            lock_cell_id.push(Droptables.style.cells[row + "!" + col][2].lock_cell);
        }
        if (lock_cell_id.length > 0 && typeof lock_cell_id[0] !== 'undefined'
            && typeof table_function_data.lock_ranger_cells_user !== 'undefined') {
            for (var ij in lock_cell_id) {
                if (table_function_data.lock_ranger_cells_user[lock_cell_id[ij]]) {//allow edit
                    not_lock_cell = true;
                    break;
                }
            }
            if (!not_lock_cell) {
                cellProperties.readOnly = true;
            }
        }
    }

    return cellProperties;
}

function create_ranger_cells_lock (Droptables, table_function_data, update_rangers) {
    var lock_ranger_cells_user;
    // table_function_data.ranger_cells_lock_top = '';
    // table_function_data.ranger_cells_lock_left = '';
    // table_function_data.ranger_cells_lock_right = '';
    // table_function_data.ranger_cells_lock_bottom = '';
    table_function_data.lock_ranger_cells_user = [];
    table_function_data.protect_columns = [];
    table_function_data.protect_rows = [];
    // table_function_data.render_first_cell_protect_has_icon = [];

    if (typeof Droptables.style.table.lock_ranger_cells_user == 'undefined') {
        Droptables.style.table.lock_ranger_cells_user = [];
    }

    var ij, enable_lock, value;
    if (typeof Droptables.style.table.lock_ranger_cells === 'undefined' || Droptables.style.table.lock_ranger_cells.length < 1) {
        return false;
    }

    if (update_rangers !== null) {
        var current_rangers = [];
        var current_ranger_cells_user = [];
    }

    var i;

    for (i = 0; i < Droptables.style.table.lock_ranger_cells.length; i++) {
        // table_function_data.render_first_cell_protect_has_icon[i] = true;
        enable_lock = false;
        table_function_data.lock_ranger_cells_user[i] = false;
        if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
            lock_ranger_cells_user = Droptables.style.table.lock_ranger_cells_user[i].split('|');
            lock_ranger_cells_user.map(function(v) {
                if (Droptables.list_rolers_of_user.includes(parseInt(v))) {
                    table_function_data.lock_ranger_cells_user[i] = true;
                }
            });
            // if (lock_ranger_cells_user.indexOf(Droptables_userRoles) !== -1) {//ok edit
            //     table_function_data.lock_ranger_cells_user[i] = true;
            // } else if (!Droptables_administrator) {
            //     enable_lock = true;
            // }
        }

        value = Droptables.style.table.lock_ranger_cells[i].replace(/[ ]+/g, "").toUpperCase();
        var arrayRange = value.split(":");

        var check_value = 0;
        if (arrayRange[0].replace(/[ |A-Za-z]+/g, "") === '') {
            check_value = 1;//value A:B
        } else if (arrayRange[0].replace(/[ |1-9]+/g, "") === '') {
            check_value = 2;//value 8:9
        }

        var selection = [];
        if (check_value === 0) {
            if (typeof arrayRange[1] == 'undefined') {
                arrayRange[1] = arrayRange[0];
            }
            selection.push(parseInt(arrayRange[0].split(/[ |A-Za-z]+/g)[1]) - 1);
            selection.push(convertStringToNumber(arrayRange[0].split(/[ |1-9]+/g)[0]) - 1);
            selection.push(parseInt(arrayRange[1].split(/[ |A-Za-z]+/g)[1]) - 1);
            selection.push(convertStringToNumber(arrayRange[1].split(/[ |1-9]+/g)[0]) - 1);

            if (update_rangers !== null) {
                if (update_rangers.type === 'create_row') {
                    if (selection[0] >= update_rangers.index) {//rows >= index
                        if (selection[2] >= update_rangers.amount + update_rangers.index) {//index + amount <= after_col
                            selection[2] = selection[2] + update_rangers.amount;
                            selection[0] = update_rangers.amount + update_rangers.index >= selection[0] ? selection[0] : (selection[0] + update_rangers.amount);
                        } else {//index + amount > after_col
                            selection[2] = selection[2] + update_rangers.amount;
                        }
                    } else if (selection[0] < update_rangers.index && selection[2] >= update_rangers.index) {//row < index < after_row
                        selection[2] = selection[2] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_row') {
                    if (selection[0] >= update_rangers.index) {//rows >= index
                        if (update_rangers.amount + update_rangers.index >= selection[2]) {//remove all index + amount >= after_rows
                            continue;
                        }
                        if ((update_rangers.amount + update_rangers.index) >= selection[0]
                            && (update_rangers.amount + update_rangers.index) < selection[2]) {//index <= rows <= index + amount < after_rows
                            selection[0] = update_rangers.index;
                            selection[2] = selection[2] - update_rangers.amount;
                        } else {//index + amount < rows
                            selection[0] = selection[0] - update_rangers.amount;
                            selection[2] = selection[2] - update_rangers.amount;
                        }
                    } else if (selection[0] < update_rangers.index && selection[2] >= update_rangers.index) {//rows < index < after_rows
                        selection[2] = update_rangers.amount + update_rangers.index >= selection[2] ? (update_rangers.index - 1) : (selection[2] - update_rangers.amount);
                    }
                }
                if (update_rangers.type === 'add_col') {
                    if (selection[1] > update_rangers.index) {//col >= index
                        if (selection[3] >= update_rangers.amount + update_rangers.index) {//index + amount <= after_col
                            selection[3] = selection[3] + update_rangers.amount;
                            selection[1] = update_rangers.amount + update_rangers.index >= selection[1] ? selection[1] : (selection[1] + update_rangers.amount);
                        } else {//index + amount > after_col
                            selection[3] = selection[3] + update_rangers.amount;
                        }
                    } else if (selection[1] < update_rangers.index && selection[3] >= update_rangers.index) {//row < index < after_row
                        selection[3] = selection[3] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_col') {
                    if (selection[1] >= update_rangers.index) {//col >= index
                        if (update_rangers.amount + update_rangers.index >= selection[3]) {//remove all index + amount >= after_col
                            continue;
                        }
                        if ((update_rangers.amount + update_rangers.index) >= selection[1]
                            && (update_rangers.amount + update_rangers.index) < selection[3]) {//index <= col <= index + amount < after_col
                            selection[1] = update_rangers.index;
                            selection[3] = selection[3] - update_rangers.amount;
                        } else {//index + amount < col
                            selection[1] = selection[1] - update_rangers.amount;
                            selection[3] = selection[3] - update_rangers.amount;
                        }
                    } else if (selection[1] < update_rangers.index && selection[3] >= update_rangers.index) {//col < index < after_col
                        selection[3] = update_rangers.amount + update_rangers.index >= selection[3] ? (update_rangers.index - 1) : (selection[3] - update_rangers.amount);
                    }
                }

                current_rangers.push(getSelectedVal(selection));
                if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
                    current_ranger_cells_user.push(Droptables.style.table.lock_ranger_cells_user[i]);
                }
            }

            for (ij = selection[0]; ij <= selection[2]; ij++) {//row
                for (var ij2 = selection[1]; ij2 <= selection[3]; ij2++) {
                    if (typeof Droptables.style.cells[ij + '!' + ij2] !== 'undefined') {
                        Droptables.style.cells[ij + '!' + ij2][2] = window.jquery.extend(Droptables.style.cells[ij + '!' + ij2][2], {lock_cell: i});
                    }
                }
            }
        } else if (check_value === 1) {//columns
            selection.push(convertStringToNumber(arrayRange[0].split(/[ |1-9]+/g)[0]) - 1);
            selection.push(convertStringToNumber(arrayRange[1].split(/[ |1-9]+/g)[0]) - 1);

            if (update_rangers !== null) {
                if (update_rangers.type === 'add_col') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        selection[1] = selection[1] + update_rangers.amount;
                        selection[0] = update_rangers.amount + update_rangers.index >= selection[0] ? selection[0] : (selection[0] + update_rangers.amount);
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//row < index < after_row
                        selection[1] = selection[1] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_col') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        if (update_rangers.amount + update_rangers.index >= selection[1]) {//remove all
                            continue;
                        }
                        if (update_rangers.amount + update_rangers.index < selection[0]) {
                            selection[0] = selection[0] - update_rangers.amount;
                            selection[1] = selection[1] - update_rangers.amount;
                        } else {
                            selection[0] = update_rangers.index;
                            selection[1] = selection[1] - update_rangers.amount - update_rangers.index;
                        }
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//col < index < after_col
                        selection[1] = update_rangers.amount + update_rangers.index >= selection[1] ? (update_rangers.index - 1) : (selection[1] - update_rangers.amount);
                    }
                }

                current_rangers.push(getSelectedVal([false, selection[0], false, selection[1]]));
                if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
                    current_ranger_cells_user.push(Droptables.style.table.lock_ranger_cells_user[i]);
                }
            }

            for (ij = selection[0]; ij <= selection[1]; ij++) {
                table_function_data.protect_columns[ij] = i;
            }
        } else {//rows
            selection.push(parseInt(arrayRange[0].split(/[ |A-Za-z]+/g)[0]) - 1);
            selection.push(parseInt(arrayRange[1].split(/[ |A-Za-z]+/g)[0]) - 1);

            if (update_rangers !== null) {
                if (update_rangers.type === 'create_row') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        selection[1] = selection[1] + update_rangers.amount;
                        selection[0] = update_rangers.amount + update_rangers.index >= selection[0] ? selection[0] : (selection[0] + update_rangers.amount);
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//row < index < after_row
                        selection[1] = selection[1] + update_rangers.amount;
                    }
                }
                if (update_rangers.type === 'delete_row') {
                    if (selection[0] >= update_rangers.index) {//col >= index
                        if (update_rangers.amount + update_rangers.index >= selection[1]) {//remove all
                            continue;
                        }
                        if (update_rangers.amount + update_rangers.index < selection[0]) {
                            selection[0] = selection[0] - update_rangers.amount;
                            selection[1] = selection[1] - update_rangers.amount;
                        } else {
                            selection[0] = update_rangers.index;
                            selection[1] = selection[1] - update_rangers.amount - update_rangers.index;
                        }
                    }
                    if (selection[0] < update_rangers.index && selection[1] >= update_rangers.index) {//col < index < after_col
                        selection[1] = update_rangers.amount + update_rangers.index >= selection[1] ? (update_rangers.index - 1) : (selection[1] - update_rangers.amount);
                    }
                }

                current_rangers.push(getSelectedVal([selection[0], false, selection[1], false]));
                if (typeof Droptables.style.table.lock_ranger_cells_user[i] !== 'undefined') {
                    current_ranger_cells_user.push(Droptables.style.table.lock_ranger_cells_user[i]);
                }
            }

            for (ij = selection[0]; ij <= selection[1]; ij++) {
                table_function_data.protect_rows[ij] = i;
            }
        }
    };

    if (update_rangers !== null) {
        Droptables.style.table.lock_ranger_cells = jquery.extend([], current_rangers);
        Droptables.style.table.lock_ranger_cells_user = jquery.extend([], current_ranger_cells_user);
        // render_css_lock(Droptables, table_function_data);
    }
}

function render_css_lock(Droptables, table_function_data) {
    var column_i;
    var css_lock_columns = '';
    var $droptable_add_css_lock_columns = document.getElementById('droptable_add_css_lock_columns');

    // if (typeof Droptables.style.table.lock_columns !== 'undefined') {
    //     for (column_i in Droptables.style.table.lock_columns) {
    //         if (Droptables.style.table.lock_columns[column_i] != 0) {
    //             column_i = parseInt(column_i);
    //             css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + ') {position: relative;} ';
    //             css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + '):after {content: "lock";} ';
    //         }
    //     }
    // }

    if (typeof Droptables.style.table.lock_columns !== 'undefined') {
        for (column_i in Droptables.style.table.lock_columns) {
            if (Droptables.style.table.lock_columns[column_i] != 0) {
                column_i = parseInt(column_i);
                css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + ') {position: relative;} ';
                css_lock_columns += ' .handsontable table thead th:nth-child(' + (column_i + 2) + '):after {content: "lock";} ';
            }
        }
    }

    setTimeout(function () {
        if (css_lock_columns !== '') {
            $droptable_add_css_lock_columns.innerHTML = css_lock_columns;
            $droptable_add_css_lock_columns.cssText = css_lock_columns;
        }
    }, 100);
}

function check_collide_two_range(selection1, selection2) {
    if ((Math.abs(selection1[0] - selection2[0]) < Math.abs(selection1[2] - selection1[0] + selection2[2] - selection2[0]) / 2)
        && (Math.abs(selection1[1] - selection2[1]) < Math.abs(selection1[3] - selection1[1] + selection2[3] - selection2[1]) / 2)
    ) {
        return true;
    }
    return false;
}

function changeValue(oldValue, index, amount, lengths, LeftRight, copyHeightRow) {
    var i;
    var new_data = {};
    if (LeftRight) {//left
        for (i = index; i < lengths; i++) {
            if (typeof new_data[i + amount] === 'undefined') {
                new_data[i + amount] = [i + amount, {}];
            }

            new_data[i + amount][1] = oldValue[i][1];
            if (i + 1 === lengths) {
                var return_data = jquery.extend({}, oldValue, new_data);
                return return_data;
            }
        }
    } else {//right
        for (i = index; i < lengths + amount; i++) {
            if (typeof new_data[i] === 'undefined') {
                new_data[i] = [i, {}];
            }

            if (!copyHeightRow) {
                new_data[i][1] = jquery.extend({}, oldValue[i - amount][1]);
            }

            if ((i + 1) === (lengths + amount)) {
                return jquery.extend({}, oldValue, new_data);
            }
        }
    }
}

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
    mergeCollsRowsstyleToCells,
    createRegExpFormat,
    createRegExpFormatForCell,
    parseCss,
    setFormat_accounting,
    setFormat_accounting_for_cells,
    calculateTableHeight,
    checkObjPropertyNested,
    convertAlpha,
    convertDate,
    cell_type_to_column,
    validate_type_cell,
    change_value_cells,
    getFillArray,
    fillArray,
    updateParamFromStyleObject,
    updateSwitchButtonFromStyleObject,
    updateParamFromStyleObjectSelectBox,
    getSizeCells,
    momentjsFormat,
    getSelectedVal,
    setText,
    pullDims,
    cleanHandsontable,
    updateStyleAutofill,
    droptablesCheckSize,
    getLinkSync,
    saveChanges,
    convertMergeCell,
    reConvertMergeCell,
    cleanStyle,
    pushDims,
    default_sortable,
    checkObjPropertyNestedNotEmpty,
    formatSymbols,
    showChartOrTable,
    getCellData,
    isSameArray,
    stringReplace,
    convertStringToNumber,
    responsive_col,
    checkCellsOptionsValidate,
    deleteFormatCells,
    status_noti,
    deleteRowDbTable,
    createRowDbTable,
    check_cell_readOnly_mysql,
    check_cell_readOnly,
    create_ranger_cells_lock,
    render_css_lock,
    check_collide_two_range,
    changeValue
});

/***/ }),

/***/ "./site/assets/js/_handsontable.js":
/*!*****************************************!*\
  !*** ./site/assets/js/_handsontable.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "initHandsontable": () => (/* binding */ initHandsontable)
/* harmony export */ });
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_functions */ "./site/assets/js/_functions.js");
/* harmony import */ var _customRenderer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_customRenderer */ "./site/assets/js/_customRenderer.js");
/* harmony import */ var _toolbarOptions__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_toolbarOptions */ "./site/assets/js/_toolbarOptions.js");
/* harmony import */ var _charts__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./_charts */ "./site/assets/js/_charts.js");





/**
 * Set position for html cell editer popup
 *
 * @param checkScroll Check whether to perform
 * @returns {boolean}
 */
function afterScrollEditors (checkScroll) {
    var handsontableInputHolder = Droptables_element.tableContainer.find('.handsontableInputHolder');
    if (checkScroll === true && (handsontableInputHolder.hasClass('droptables_set_top') || handsontableInputHolder.hasClass('droptables_set_left'))) {
        var position = handsontableInputHolder.position();

        var $table = Droptables_element.tableContainer.find('.wtHider');

        if (handsontableInputHolder.hasClass('droptables_set_top')) {
            var tdOffsetTop = handsontableInputHolder.data('tdOffsetTop');
            var outerHeight = handsontableInputHolder.outerHeight();
            var heightTable = Droptables_element.tableContainer.outerHeight() > $table.outerHeight() ? Droptables_element.tableContainer.outerHeight() : $table.outerHeight();
            var new_top = tdOffsetTop + outerHeight - heightTable + 10;

            if (new_top > 0) {
                handsontableInputHolder.css({top: position.top - new_top});
            }
        }
        if (handsontableInputHolder.hasClass('droptables_set_left')) {
            var tdOffsetLeft = handsontableInputHolder.data('tdOffsetLeft');
            var outerWidth = handsontableInputHolder.outerWidth();
            var widthTable = Droptables_element.tableContainer.outerWidth() > $table.outerWidth() ? Droptables_element.tableContainer.outerWidth() : $table.outerWidth();
            var new_left = tdOffsetLeft + outerWidth - widthTable + 10;

            if (new_left > 0) {
                handsontableInputHolder.css({left: position.left - new_left});
            }
        }
    }
    return false;
}

function initHandsontable(datas) {
    var checkScroll = false;
    var autoScroll;
    Droptables = window.Droptables;
    var modifyRow = null;
    var totalRows = datas.length;
    var copyHeightRow = false;

    window.Droptables_element.tableContainer.handsontable({
        data: datas,
        startRows: 5,
        startCols: 5,
        editor: window.CustomEditor,
        search: true,
        renderAllRows: false,
        fillHandle: (Droptables.userOwn.edit && Droptables.type === 'html') ? {
            autoInsertRow:false,
        } : false,
        modifyAutofillRange: function (startArea, entireArea) {//entireArea is start ranger
            var directionFill = -1;//-1 is not fill, 0 is top, 1 is bottom, 2 is left, 3 is right
            var new_range = [startArea[0], startArea[1], startArea[2], startArea[3]];

            if (startArea[0] !== entireArea[0]) {
                directionFill = 0;
                new_range[2] = entireArea[0] - 1;
            } else if (startArea[2] !== entireArea[2]) {
                directionFill = 1;
                new_range[0] = entireArea[2] + 1;
            } else if (startArea[1] !== entireArea[1]) {
                directionFill = 2;
                new_range[3] = entireArea[1] - 1;
            } else if (startArea[3] !== entireArea[3]) {
                directionFill = 3;
                new_range[1] = entireArea[3] + 1;
            }

            if (directionFill > -1) {
                //update cell type, hyperlink
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.updateStyleAutofill(entireArea, new_range, directionFill);
            }
        },
        copyPaste: window.Droptables.type !== 'mysql',
        beforePaste: (data, coords) => {
            console.log(data, coords)
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true)
            //vcl, asynchronous
        },
        beforeCopy: (data, coords) => {
            var selection = table_function_data.selection[0];
            table_function_data.copyData = [];
            table_function_data.copyWidthCols = [];
            table_function_data.copyTypeCols = [];
            table_function_data.copyHeightRows = [];
            table_function_data.copyMergeCells = [];
            table_function_data.copyDataSelection = [selection[2] - selection[0], selection[3] - selection[1]];
            table_function_data.copyHeightRow = [];
            table_function_data.createCellWhenCopy = [];
            jquery.map(window.Droptables.style.rows, function (v) {
                table_function_data.copyHeightRow.push(v[1].height);
            });

            var i2 = 0, j2;
            for (var i = selection[0]; i <= selection[2]; i++) {//row
                j2 = 0;

                for (var j = selection[1]; j <= selection[3]; j++) {
                    if (typeof Droptables.style.cells[i + '!' + j] !== 'undefined') {
                        table_function_data.copyData[i2 + '!' + j2] = window.jquery.extend({}, Droptables.style.cells[i + '!' + j][2]);

                        if (typeof Droptables.newSelect !== 'undefined') {
                            if (Droptables.newSelect === 'row' && typeof Droptables.style.rows[i][1] !== 'undefined') {
                                table_function_data.copyHeightRows[i2 + '!'] = Droptables.style.rows[i][1].height;
                            }

                            if (Droptables.newSelect === 'col' && typeof Droptables.style.cols[j][1] !== 'undefined') {
                                table_function_data.copyWidthCols[j2 + '!'] = Droptables.style.cols[j][1].width;
                                table_function_data.copyTypeCols[j2 + '!'] = Droptables.style.table.col_types[j];
                            }
                        }
                        delete table_function_data.copyData[i2 + '!' + j2].lock_cell;
                        delete table_function_data.copyData[i2 + '!' + j2].height;
                        delete table_function_data.copyData[i2 + '!' + j2].width;
                        delete table_function_data.copyData[i2 + '!' + j2].AlternateColor;
                    }
                    j2++;
                }
                i2++
            }

            console.log(table_function_data.copyTypeCols)
            //check merge cells
            jquery.map(Droptables.style.table.mergeSetting, function (v) {
                if (v.col >= selection[1] && v.row >= selection[0]) {
                    if ((v.col + v.colspan - 1) <= selection[3] && (v.row + v.rowspan - 1) <= selection[2]) {
                        table_function_data.copyMergeCells[(v.row - selection[0]) + '!' + (v.col - selection[1])] = [v.rowspan - 1, v.colspan - 1];
                    }
                }
            });
        },
        afterCopy: function (data, coords) {
        },
        afterPaste: function (data, coords) {
        },
        colHeaders: true,
        rowHeaders: true,
        autoRowSize: false,
        autoColSize: false,
        renderer: _customRenderer__WEBPACK_IMPORTED_MODULE_1__.default.render,
        height: _functions__WEBPACK_IMPORTED_MODULE_0__.default.calculateTableHeight(window.jquery('#droptable_toolbars')),
        afterInit: function () {
            _charts__WEBPACK_IMPORTED_MODULE_3__.default.functions.loadCharts();
            Droptables_element.tableContainer.handsontable("selectCell", 0, 0, 0, 0);
            window.table_function_data.allowed_save = true;

            _functions__WEBPACK_IMPORTED_MODULE_0__.default.render_css_lock(Droptables, table_function_data);
        },
        beforeRender: function (isForced) {
            window.table_function_data.styleToRender = '';
        },
        beforeChange: function (changes, source) {
            if (source === 'auto_convert_data') {
                return;
            }
            var paste_start = [changes[0][0], changes[0][1]];
            var paste_x = 0, paste_y = 0, before_next_row;
            copyHeightRow = false;
            var updateSettings = {};
            var cols_selected = [];
            var number_cols = changes.length / (changes[changes.length - 1][0] - changes[0][0] + 1);
            var mergeCellsSetting = jquery.extend([], window.Droptables.style.table.mergeSetting);

            table_function_data.createCellWhenCopy = [];

            for (var i = 0; i < changes.length; i++) {
                before_next_row = false;
                if ((i + 1) % number_cols === 0) {
                    before_next_row = true;
                }
                var optionsCell = changes[i];

                //paste style options cells
                if (source === 'CopyPaste.paste' && typeof table_function_data.copyDataSelection !== "undefined" && table_function_data.copyDataSelection[0] >= 0) {
                    if (optionsCell[0] - paste_start[0] > table_function_data.copyDataSelection[0]) {//row
                        paste_y = 0;
                    }
                    if (optionsCell[1] - paste_start[1] > table_function_data.copyDataSelection[1]) {//col
                        paste_x = 0;
                    }
                    if (typeof (window.Droptables.style.cells[optionsCell[0] + '!' + optionsCell[1]]) === 'undefined') {
                        window.Droptables.style.cells[optionsCell[0] + '!' + optionsCell[1]] = [optionsCell[0], optionsCell[1], {}];
                        table_function_data.createCellWhenCopy[optionsCell[0] + '!' + optionsCell[1]] = optionsCell[0] + '!' + optionsCell[1];
                    }
                    if (table_function_data.copyData[paste_y + '!' + paste_x].cell_type === 'html') {
                        setTimeout((optionsCell) => {
                            saveData.push({action: 'set_cells_type', selection: [[optionsCell[0], optionsCell[1], optionsCell[0], optionsCell[1]]], style: {cell_type: 'html'}});
                        }, 300, optionsCell);
                    } else {
                        if (window.Droptables.style.cells[optionsCell[0] + '!' + optionsCell[1]][2].cell_type === 'html') {
                            setTimeout((optionsCell) => {
                                saveData.push({action: 'set_cells_type', selection: [[optionsCell[0], optionsCell[1], optionsCell[0], optionsCell[1]]], style: {cell_type: null}});
                            }, 300, optionsCell);
                        }
                    }
                    let AlternateColor = window.Droptables.style.cells[optionsCell[0] + '!' + optionsCell[1]][2].AlternateColor;
                    window.Droptables.style.cells[optionsCell[0] + '!' + optionsCell[1]][2] = window.jquery.extend({}, {AlternateColor}, table_function_data.copyData[paste_y + '!' + paste_x]);

                    if (typeof table_function_data.copyHeightRows !== 'undefined' && table_function_data.copyHeightRows[paste_y + '!'] > 0) {
                        if (typeof (window.Droptables.style.rows[optionsCell[0]]) === 'undefined') {
                            window.Droptables.style.rows[optionsCell[0]] = [optionsCell[0], {}];
                        }
                        window.Droptables.style.rows[optionsCell[0]][1].height = table_function_data.copyHeightRows[paste_y + '!'];
                        table_function_data.copyHeightRow[optionsCell[0]] = table_function_data.copyHeightRows[paste_y + '!'];
                        copyHeightRow = true;
                    }
                    if (typeof table_function_data.copyWidthCols !== 'undefined' && table_function_data.copyWidthCols[paste_x + '!'] > 0) {
                        if (typeof (window.Droptables.style.cols[optionsCell[1]]) === 'undefined') {
                            window.Droptables.style.cols[optionsCell[1]] = [optionsCell[1], {}];
                            window.Droptables.style.cols[optionsCell[1]][1].res_priority = 0;
                        }
                        window.Droptables.style.cols[optionsCell[1]][1].width = table_function_data.copyWidthCols[paste_x + '!'];
                    }

                    if (typeof table_function_data.copyTypeCols !== 'undefined' && table_function_data.copyTypeCols[paste_x + '!']) {
                        Droptables.style.table.col_types[optionsCell[1]] = 'text';
                        cols_selected[optionsCell[1]] = 'text';
                    }

                    if (typeof table_function_data.copyMergeCells !== 'undefined' && typeof table_function_data.copyMergeCells[paste_y + '!' + paste_x] !== 'undefined') {
                        mergeCellsSetting.push({
                            col: optionsCell[1],
                            colspan: table_function_data.copyMergeCells[paste_y + '!' + paste_x][1] + 1,
                            row: optionsCell[0],
                            rowspan: table_function_data.copyMergeCells[paste_y + '!' + paste_x][0] + 1
                        });

                        updateSettings.mergeCells = mergeCellsSetting;
                    }

                    setTimeout((optionsCell, changes, i, updateSettings, copyHeightRow) => {
                        saveData.push({action: 'style',
                            selection: [[optionsCell[0], optionsCell[1], optionsCell[0], optionsCell[1]]],
                            style: window.Droptables.style.cells[optionsCell[0] + '!' + optionsCell[1]][2]
                        });

                        if (i + 1 === changes.length) {
                            if (copyHeightRow) {
                                updateSettings.manualRowResize = table_function_data.copyHeightRow;
                            }

                            if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(updateSettings) > 0) {
                                Droptables_element.tableContainer.handsontable('updateSettings', updateSettings);
                            }
                        }
                    }, 300, optionsCell, changes, i, updateSettings, copyHeightRow);
                    paste_x++;

                    if (i + 1 === changes.length) {
                        if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(cols_selected) > 0) {
                            if (saveData[0] && saveData[0].action === 'create_col_after_paste') {
                                saveData.splice(1, 0, {
                                    action: 'set_columns_types_copy',
                                    value: cols_selected
                                });
                            } else {
                                saveData.unshift({
                                    action: 'set_columns_types_copy',
                                    value: cols_selected
                                });
                            }
                        }
                    }

                    if (before_next_row) {
                        paste_y++;
                        paste_x = 0;
                    }
                }

                //check validate chart
                if (jquery('#list_chart').find('.chart-menu').length > 0) {//check chart exist
                    if (!_charts__WEBPACK_IMPORTED_MODULE_3__.default.functions.validateCharts(optionsCell)) {
                        bootbox.alert(Joomla.JText._('COM_DROPTABLES_CHANGE_INVALID_CHART_DATA', 'Invalid chart data'));
                        return false;
                    }
                }
            }
        },
        afterRender: function (isForced) {
            var parser = new (less.Parser);
            var Droptables = window.Droptables;
            var $ = window.jquery;

            window.table_function_data.content = '#mainTabContent .handsontable .ht_master .htCore {' + window.table_function_data.styleToRender + '}';
            if (Droptables.style.table.responsive_type == 'scroll' && Droptables.style.table.freeze_row) {
                window.table_function_data.content += ' #mainTabContent .handsontable .ht_clone_top .htCore {' + window.table_function_data.styleToRender + '}';
            }
            if (Droptables.style.table.responsive_type == 'scroll' && Droptables.style.table.freeze_col) {
                window.table_function_data.content += ' #mainTabContent .handsontable .ht_clone_left .htCore {' + window.table_function_data.styleToRender + '}';
            }
            if (Droptables.style.table.responsive_type == 'scroll' && Droptables.style.table.freeze_row && Droptables.style.table.freeze_col) {
                window.table_function_data.content += ' #mainTabContent .handsontable .ht_clone_corner .htCore {' + window.table_function_data.styleToRender + '}';
            }

            parser.parse(window.table_function_data.content, function (err, tree) {
                if (err) {
                    //Here we can throw the erro to the user
                    return false;
                } else {
                    Droptables.css = $('#jform_css').val();
                    if ($('#headMainCss').length === 0) {
                        $('head').append('<style id="headMainCss"></style>');
                    }
                    $('#headMainCss').text(tree.toCSS());
                    return true;
                }
            });
            if ($('#content_popup_hide').find('select.select_columns option').length < 1) {
                // Build column selection for default sort parameter
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.default_sortable(window.Droptables.datas);
            }
            //set Droptables.style.rows , Droptables.style.cols value
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.pushDims($, Droptables);

            if (table_function_data.needSaveAfterRender === true) {
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges();
                table_function_data.needSaveAfterRender = false;
            }

            Droptables.style.table.class_name && $('#tableContainer').addClass(Droptables.style.table.class_name);
        },
        afterChange: function (change, source) {//play when change content cell
            table_function_data.copyWidthCols = [];
            if (source === 'CopyPaste.paste') {
                table_function_data.createCellWhenCopy = [];
                table_function_data.copyHeightRows = [];
                table_function_data.copyHeightRow = [];
            }
            // console.log(change, source)
            if (typeof table_function_data.data_argument !== 'undefined' && source === 'loadData') {
                source = 'edit';
                change = jquery.extend([], table_function_data.data_argument);
            }

            //fix handsontable merge cells remove data of cells
            var i;

            if ((source === 'MergeCells' || source === 'populateFromArray')&& typeof change.length !== 'undefined') {
                for (i = 0; i < change.length; i++) {
                    if (change[i][2] !== null && change[i][3] === null) {
                        Droptables.datas[change[i][0]][change[i][1]] = change[i][2];
                    }
                }
            }
            if (source === 'populateFromArray' && change.length > 0 && change[0][2] === change[0][3]) {
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
            }

            if (source === 'loadData' || source === 'populateFromArray' || !table_function_data.allowed_edit) {
                return; //don't save this change
            }
            var action = ['CopyPaste.paste', 'edit', 'UndoRedo.undo', 'UndoRedo.redo', 'Autofill.fill', 'setDataAtCell'];

            //validate data cells when mergeCells
            if (change) {
                var notSaveData;
                var editHeader = false;
                var mysql_column_edit, mysql_column_key;
                for (i = 0; i < change.length; i++) {
                    if (Droptables.type === 'mysql' && !table_function_data.mysqlEdit && change[i][0] != 0) {
                        break;
                    }

                    if (action.includes(source)) {
                        notSaveData = true;
                        if (typeof change[i][3] === 'undefined' || change[i][3] === 'droptables_change_value_after_set_columns_types') {
                            change[i][3] = change[i][2];//loadData when edit cells > 5ommit
                            notSaveData = false;
                        }
                        if (change[i][3] === change[i][4]) {
                            notSaveData = false;
                        }

                        var optionsCell = change[i];

                        if (typeof Droptables.style.table.headerOption == 'undefined' || optionsCell[0] >= Droptables.style.table.headerOption) {//check cell in table header
                            if (typeof optionsCell[3] !== 'undefined' && optionsCell[3] !== null) {
                                var value = _functions__WEBPACK_IMPORTED_MODULE_0__.default.cell_type_to_column(optionsCell, optionsCell[3]);
                                var value_change;
                                if (value === false) {
                                    Droptables_element.mainTabContent.find('td.dtr' + optionsCell[0] + '.dtc' + optionsCell[1]).addClass('invalid_data');
                                    bootbox.alert('The value of the cell does not match the column format. For example, and integer format cannot contain letters.');
                                    return;
                                } else {
                                    Droptables_element.mainTabContent.find('td.dtr' + optionsCell[0] + '.dtc' + optionsCell[1]).removeClass('invalid_data');
                                    if (value !== true) {
                                        if (notSaveData) {
                                            if (Droptables.type !== 'mysql' || optionsCell[0] === 0) {
                                                saveData.push({action: 'edit_cell', row: optionsCell[0], col: optionsCell[1], content: value});
                                            } else if (typeof Droptables.query_option !== 'undefined' && Droptables.query_option.column_options !== null && typeof Droptables.query_option.column_options[optionsCell[1]] !== "undefined") {
                                                if (optionsCell[2] !== value) {
                                                    mysql_column_edit = Droptables.query_option.column_options[optionsCell[1]].table + '.' + Droptables.query_option.column_options[optionsCell[1]].Field;
                                                    mysql_column_key = Droptables.query_option.column_options[table_function_data.keyPosition].table + '.' + Droptables.query_option.column_options[table_function_data.keyPosition].Field;
                                                    value_change = Droptables.datas[optionsCell[0]][table_function_data.keyPosition];
                                                    Droptables.saveDataDbTable.push({
                                                        action: 'edit_cell_mysql',
                                                        row: optionsCell[0],
                                                        col: optionsCell[1],
                                                        content: value,
                                                        id: Droptables.datas[optionsCell[0]][table_function_data.keyPosition],
                                                        column: mysql_column_edit,
                                                        column_key: mysql_column_key
                                                    });
                                                }
                                            }
                                            if (Droptables.style.table.headerOption > 0 && optionsCell[0] < Droptables.style.table.headerOption) {
                                                Droptables.style.header_data[optionsCell[0]][optionsCell[1]] = value;
                                            }
                                        }
                                        if (value !== optionsCell[3]) {//has convert cell value
                                            jquery(Droptables_element.tableContainer).handsontable('setDataAtCell', optionsCell[0], optionsCell[1], value, 'auto_convert_data');
                                        }
                                    } else {
                                        if (notSaveData) {
                                            if (Droptables.type !== 'mysql' || optionsCell[0] === 0) {
                                                saveData.push({action: 'edit_cell', row: optionsCell[0], col: optionsCell[1], content: optionsCell[3]});
                                            } else if (typeof Droptables.query_option !== 'undefined' && Droptables.query_option.column_options !== null && typeof Droptables.query_option.column_options[optionsCell[1]] !== "undefined") {
                                                if (optionsCell[2] !== optionsCell[3]) {
                                                    mysql_column_edit = Droptables.query_option.column_options[optionsCell[1]].table + '.' + Droptables.query_option.column_options[optionsCell[1]].Field;
                                                    mysql_column_key = Droptables.query_option.column_options[table_function_data.keyPosition].table + '.' + Droptables.query_option.column_options[table_function_data.keyPosition].Field;
                                                    value_change = Droptables.datas[optionsCell[0]][table_function_data.keyPosition];
                                                    Droptables.saveDataDbTable.push({
                                                        action: 'edit_cell_mysql',
                                                        row: optionsCell[0],
                                                        col: optionsCell[1],
                                                        content: optionsCell[3],
                                                        id: Droptables.datas[optionsCell[0]][table_function_data.keyPosition],
                                                        column: mysql_column_edit,
                                                        column_key: mysql_column_key
                                                    });
                                                }
                                            }
                                            if (Droptables.style.table.headerOption > 0 && optionsCell[0] < Droptables.style.table.headerOption) {
                                                Droptables.style.header_data[optionsCell[0]][optionsCell[1]] = optionsCell[3];
                                            }
                                        }
                                    }
                                }
                            }
                        } else {
                            editHeader = true;
                            if (notSaveData) {
                                if (Droptables.type !== 'mysql' || optionsCell[0] === 0) {
                                    saveData.push({action: 'edit_cell', row: optionsCell[0], col: optionsCell[1], content: optionsCell[3]});
                                } else if (Droptables.type === 'mysql' && typeof Droptables.query_option !== 'undefined' && Droptables.query_option.column_options !== null && typeof Droptables.query_option.column_options[optionsCell[1]] !== "undefined") {
                                    if (optionsCell[2] !== optionsCell[3]) {
                                        mysql_column_edit = Droptables.query_option.column_options[optionsCell[1]].table + '.' + Droptables.query_option.column_options[optionsCell[1]].Field;
                                        mysql_column_key = Droptables.query_option.column_options[table_function_data.keyPosition].table + '.' + Droptables.query_option.column_options[table_function_data.keyPosition].Field;
                                        value_change = Droptables.datas[optionsCell[0]][table_function_data.keyPosition];
                                        Droptables.saveDataDbTable.push({
                                            action: 'edit_cell_mysql',
                                            row: optionsCell[0],
                                            col: optionsCell[1],
                                            content: optionsCell[3],
                                            id: Droptables.datas[optionsCell[0]][table_function_data.keyPosition],
                                            column: mysql_column_edit,
                                            column_key: mysql_column_key
                                        });
                                    }
                                }
                                if (Droptables.style.table.headerOption > 0 && optionsCell[0] < Droptables.style.table.headerOption) {
                                    Droptables.style.header_data[optionsCell[0]][optionsCell[1]] = optionsCell[3];
                                }
                            }
                        }
                    }
                }
            }

            // clearTimeout(tableFunction.autosaveNotification);

            //change[0][2] & change[0][3] === undefined when edit html cell
            if (action.includes(source) && typeof change[0] !== 'undefined' && !(typeof change[0][2] === 'undefined' && typeof change[0][3] === 'undefined')) {
                table_function_data.needSaveAfterRender = (change[0][2] !== change[0][3] || source ==='setDataAtCell') ? true : false;
            }

            if (change && Droptables.type === 'mysql' && notSaveData && Droptables.saveDataDbTable.length > 0) {//mysql table edited
                if (typeof value !== 'undefined' || editHeader) {
                    saveData = saveData.concat(Droptables.saveDataDbTable);
                    Droptables_element.mainTabContent.addClass('loading_ajax');
                    Droptables.saveDataDbTable = [];
                    _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                }
                table_function_data.needSaveAfterRender = false;
            }

            //update merge cells when autofill
            if ('Autofill.fill' === source) {
                // tableFunction.cleanHandsontable();
                updateMergeCells(true);
            } else {
                setTimeout(function () {
                    if (jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.isUndoAvailable()) {
                        Droptables_element.primary_toolbars.find('#undo_cell').addClass('active');
                    } else {
                        Droptables_element.primary_toolbars.find('#undo_cell').removeClass('active');
                    }
                    if (jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.isRedoAvailable()) {
                        Droptables_element.primary_toolbars.find('#redo_cell').addClass('active');
                    } else {
                        Droptables_element.primary_toolbars.find('#redo_cell').removeClass('active');
                    }
                }, 100);
            }

            if (table_function_data.needSaveAfterRender === true) {
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges();
                table_function_data.needSaveAfterRender = false;
            }
        },
        afterCreateRow: function (index, amount) {
            var selector = table_function_data.selection[table_function_data.selectionSize - 1];
            var $ = jquery;
            var Droptables = window.Droptables;
            var above = selector[0] === index ? true : false;//check above/below

            if (typeof (Droptables.style.cells) !== 'undefined') {
                var newCells = {};
                var cell, i, cells;

                for (cell in Droptables.style.cells) {
                    cells = Droptables.style.cells[cell];

                    if (cells[0] < index) {//rows < index
                        newCells[cell] = $.extend([], cells);
                    }
                    if (cells[0] >= index) {//rows >= index
                        if (typeof table_function_data.createCellWhenCopy !== 'undefined' && typeof table_function_data.createCellWhenCopy[cell] !== 'undefined') {
                            newCells[cell] = $.extend([], cells);
                        } else {
                            newCells[parseInt(cells[0] + amount) + '!' + cells[1]]
                                = [cells[0] + amount, cells[1], $.extend({}, cells[2])];
                        }
                    }
                    if (cells[0] <= selector[2] && selector[0] <= cells[0]) {//new rows copy style of selector
                        if (typeof table_function_data.createCellWhenCopy !== 'undefined' && typeof table_function_data.createCellWhenCopy[cell] !== 'undefined') {
                            newCells[cell] = $.extend([], cells);
                        } else {
                            newCells[parseInt(cells[0] - selector[0] + index) + '!' + cells[1]]
                                = [parseInt(cells[0] - selector[0] + index), cells[1], $.extend({}, cells[2])];
                        }
                    }
                }
                Droptables.style.cells = $.extend({}, newCells);

                if (typeof Droptables.style.table.alternateColorValue !== 'undefined') {
                    //update style.table.alternateColorValue by index, amount
                    var alternateColorValue = Droptables.style.table.alternateColorValue;
                    for (i in alternateColorValue) {
                        if (alternateColorValue[i] !== false) {
                            if (above) {//above
                                if (alternateColorValue[i].selection[0] >= index + amount) {
                                    // alternateColorValue > new rows
                                    alternateColorValue[i].selection[0] = alternateColorValue[i].selection[0] + amount;
                                    alternateColorValue[i].selection[2] = alternateColorValue[i].selection[2] + amount;
                                }
                                if (alternateColorValue[i].selection[0] < index + amount && alternateColorValue[i].selection[2] >= index) {
                                    alternateColorValue[i].selection[2] = alternateColorValue[i].selection[2] + amount;
                                }
                            } else {//below
                                if (alternateColorValue[i].selection[0] >= index) {
                                    // alternateColorValue > new rows
                                    alternateColorValue[i].selection[0] = alternateColorValue[i].selection[0] + amount;
                                    alternateColorValue[i].selection[2] = alternateColorValue[i].selection[2] + amount;
                                }
                                if (alternateColorValue[i].selection[0] < index && alternateColorValue[i].selection[2] >= selector[0]) {
                                    alternateColorValue[i].selection[2] = alternateColorValue[i].selection[2] + amount;
                                }
                            }
                        }
                    }
                }
            }

            // if (typeof (Droptables.style.rows) !== 'undefined') {
            //     // index, amount
            //     var new_data = $.extend({}, Droptables.style.rows);
            //     var jj;
            //     if (selector[0] === index) {//left
            //         for (jj = index; jj < tableFunction.droptablesCheckSize(Droptables.style.rows); jj++) {
            //             new_data[jj + amount] = [jj + amount, {}];
            //             new_data[jj + amount][1] = $.extend({}, Droptables.style.rows[jj][1]);
            //         }
            //     } else {
            //         for (jj = index; jj < tableFunction.droptablesCheckSize(Droptables.style.rows) + amount; jj++) {
            //             new_data[jj] = [jj, {}];
            //             new_data[jj][1] = $.extend({}, Droptables.style.rows[jj - amount][1]);
            //         }
            //     }
            //
            //     Droptables.style.rows = $.extend({}, new_data);
            // }

            saveData.push({action: 'create_row', index: index, amount: amount, above: above});

            //remove tooltip in new cells created
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.getFillArray([[index, 0, index + amount - 1, Droptables.max_Col - 1]], Droptables, {tooltip_content: null});

            if (typeof (Droptables.style.rows) !== 'undefined') {
                let rows = _functions__WEBPACK_IMPORTED_MODULE_0__.default.changeValue(
                    Droptables.style.rows,
                    index,
                    amount,
                    Droptables.max_row,
                    selector[0] === index,
                    copyHeightRow
                );
                if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(rows) > 0)
                    Droptables.style.rows = $.extend({}, {}, rows)
            }

            if (parseInt(Droptables.style.table.headerOption) > 0) {
                delete Droptables.style.header_data;
                Droptables.style.header_data = [];
                for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                    Droptables.style.header_data[j] = Droptables.datas[j];
                }
            }

            // update merged row index and get tableFunction.saveChanges();
            setTimeout(function () {
                updateMergeCells(window.table_function_data.firstRender);
            }, 200)
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.create_ranger_cells_lock(Droptables, table_function_data, {type: 'create_row', index: index, amount: amount});

            _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
        },
        afterRemoveRow: function (index, amount) {
            var selector = table_function_data.selection[table_function_data.selectionSize - 1];
            var $ = jquery;
            var Droptables = window.Droptables;
            if (typeof (Droptables.style.cells) !== 'undefined') {
                var newCells = {};
                var cell, i, cells;

                for (cell in Droptables.style.cells) {
                    cells = Droptables.style.cells[cell];
                    if (cells[0] > index + amount - 1) {
                        newCells[parseInt(cells[0] - amount) + '!' + cells[1]]
                            = [cells[0] - amount, cells[1], $.extend({}, cells[2])];
                    }
                    if (cells[0] < index) {
                        newCells[cell]
                            = [cells[0], cells[1], $.extend({}, cells[2])];
                    }
                }
                Droptables.style.cells = $.extend({}, newCells);

                if (typeof Droptables.style.table.alternateColorValue !== 'undefined') {//update Droptables.style.table.alternateColorValue by index, amount
                    var alternateColorValue = Droptables.style.table.alternateColorValue;
                    for (i in alternateColorValue) {
                        if (alternateColorValue[i].selection[2] >= index && alternateColorValue[i].selection[2] <= (index + amount - 1)) {
                            alternateColorValue[i].selection[2] = index - 1;//selection[2] in selector
                        }
                        if (alternateColorValue[i].selection[2] >= index + amount) {
                            alternateColorValue[i].selection[2] = alternateColorValue[i].selection[2] - amount;//selection[2] > selector
                        }
                        if (alternateColorValue[i].selection[0] >= index && alternateColorValue[i].selection[0] < (index + amount)) {
                            alternateColorValue[i].selection[0] = index;//selection[0] in selector
                        }
                        if (alternateColorValue[i].selection[0] >= index + amount) {
                            alternateColorValue[i].selection[0] = alternateColorValue[i].selection[0] - amount;//selection[0] > selector
                        }
                        if (alternateColorValue[i].selection[0] > alternateColorValue[i].selection[2]) {//alternateColor in selector
                            delete alternateColorValue[i];
                        }
                    }
                }
            }

            if (typeof (Droptables.style.rows) !== 'undefined') {
                // index, amount
                var new_data = $.extend({}, Droptables.style.rows);
                var jj;
                for (jj = index; jj < _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(Droptables.style.rows); jj++) {
                    if (typeof (Droptables.style.rows[jj + amount]) !== 'undefined') {
                        new_data[jj] = [jj, {}];
                        new_data[jj][1] = $.extend({}, Droptables.style.rows[jj][1]);
                    } else {
                        delete new_data[jj];
                    }
                }
                Droptables.style.rows = $.extend({}, new_data);
            }

            //remove col in header table
            if (parseInt(Droptables.style.table.headerOption) > 0) {
                delete Droptables.style.header_data;
                Droptables.style.header_data = [];
                for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                    Droptables.style.header_data[j] = Droptables.datas[j];
                }
            }

            saveData.push({action: 'del_row', index: index, amount: amount, old_rows: $(Droptables_element.tableContainer).handsontable('countRows') + amount});
            // update merged row index and get tableFunction.saveChanges();
            updateMergeCells(window.table_function_data.firstRender);
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.create_ranger_cells_lock(Droptables, table_function_data, {type: 'delete_row', index: index, amount: amount});
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
        },
        afterCreateCol: function (index, amount) {
            var selector = table_function_data.selection[table_function_data.selectionSize - 1];
            var $ = jquery;
            var Droptables = window.Droptables;
            var left = selector[1] === index ? true : false;//check insert left/right
            var createColsWhenPaste = false;

            if (typeof (Droptables.style.cells) !== 'undefined') {
                var newCells = {};
                var cell, i, cells;

                for (cell in Droptables.style.cells) {
                    cells = Droptables.style.cells[cell];
                    if (cells[1] >= index) {//cols >= index
                        if (typeof table_function_data.createCellWhenCopy !== 'undefined' && typeof table_function_data.createCellWhenCopy[cell] !== 'undefined') {
                            newCells[cell] = $.extend([], cells);
                            createColsWhenPaste = true;
                        } else {
                            newCells[cells[0] + '!' + parseInt(cells[1] + amount)]
                                = [cells[0], cells[1] + amount, $.extend({}, cells[2])];
                        }
                    }
                    if (cells[1] < index) {//cols < index
                        newCells[cell]
                            = [cells[0], cells[1], $.extend({}, cells[2])];
                    }
                    if (cells[1] <= selector[3] && selector[1] <= cells[1]) {//new cols copy style of selector
                        if (typeof table_function_data.createCellWhenCopy !== 'undefined' && typeof table_function_data.createCellWhenCopy[cell] !== 'undefined') {
                            newCells[cell] = $.extend([], cells);
                            createColsWhenPaste = true;
                        } else {
                            newCells[cells[0] + '!' + parseInt(cells[1] - selector[1] + index)]
                                = [cells[0], parseInt(cells[1] - selector[1] + index), $.extend({}, cells[2])];
                        }
                    }
                }
                Droptables.style.cells = $.extend({}, newCells);

                if (typeof Droptables.style.table.alternateColorValue !== 'undefined') {//update Droptables.style.table.alternateColorValue by index, amount
                    var alternateColorValue = Droptables.style.table.alternateColorValue;
                    for (i in alternateColorValue) {
                        if (alternateColorValue[i] !== false) {
                            if (left) {//insert left
                                if (alternateColorValue[i].selection[1] >= index) { // alternateColorValue > new rows
                                    alternateColorValue[i].selection[1] = alternateColorValue[i].selection[1] + amount;
                                    alternateColorValue[i].selection[3] = alternateColorValue[i].selection[3] + amount;
                                }
                                if (alternateColorValue[i].selection[1] < index && alternateColorValue[i].selection[3] >= index) {
                                    alternateColorValue[i].selection[3] = alternateColorValue[i].selection[3] + amount;
                                }
                            } else {//insert right
                                if (alternateColorValue[i].selection[1] >= index) { // alternateColorValue > new rows
                                    alternateColorValue[i].selection[1] = alternateColorValue[i].selection[1] + amount;
                                    alternateColorValue[i].selection[3] = alternateColorValue[i].selection[3] + amount;
                                }
                                if (alternateColorValue[i].selection[1] < index && alternateColorValue[i].selection[3] >= index) {
                                    alternateColorValue[i].selection[3] = alternateColorValue[i].selection[3] + amount;
                                }
                            }
                        }
                    }
                }
            }

            if (createColsWhenPaste) {
                if (typeof table_function_data.create_col_after_paste === 'undefined') {
                    table_function_data.create_col_after_paste = []
                }
                table_function_data.create_col_after_paste.push({action: 'create_col_after_paste', index: index, amount: amount, left: left});
            } else {
                saveData.push({action: 'create_col', index: index, amount: amount, left: left});
            }
            //remove tooltip in new cells created
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.getFillArray([[0, index, Droptables.max_row - 1, index + amount - 1]], Droptables, {tooltip_content: null});


            if (typeof (Droptables.style.cols) !== 'undefined') {
                // index, amount
                var new_data = $.extend({}, Droptables.style.cols);
                var jj;
                if (selector[1] === index) {//left
                    for (jj = index; jj < _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(Droptables.style.cols); jj++) {
                        new_data[jj + amount] = [jj + amount, {}];
                        new_data[jj + amount][1] = $.extend({}, Droptables.style.cols[jj][1]);
                    }
                } else {
                    for (jj = index; jj < _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(Droptables.style.cols) + amount; jj++) {
                        new_data[jj] = [jj, {}];
                        new_data[jj][1] = $.extend({}, Droptables.style.cols[jj - amount][1]);
                    }
                }

                Droptables.style.cols = $.extend({}, new_data);
            }

            for (var i = index; i <= (index + amount - 1) ; i++) {
                if (createColsWhenPaste) {
                    Droptables.style.table.col_types.splice(i, 0, 'text');
                } else {
                    Droptables.style.table.col_types.splice(i, 0, 'varchar');
                }
            }

            if (parseInt(Droptables.style.table.headerOption) > 0) {
                delete Droptables.style.header_data;
                Droptables.style.header_data = [];
                for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                    Droptables.style.header_data[j] = Droptables.datas[j];
                }
            }

            // Build column selection for default sort parameter
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.default_sortable(window.Droptables.datas);

            window.jquery(Droptables_element.tableContainer).handsontable('render');

            // update merged row index and get tableFunction.saveChanges();
            setTimeout(function () {
                updateMergeCells(window.table_function_data.firstRender, true);
            }, 100);
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.create_ranger_cells_lock(Droptables, table_function_data, {type: 'add_col', index: index, amount: amount});
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
        },
        afterRemoveCol: function (index, amount) {
            var selector = table_function_data.selection[table_function_data.selectionSize - 1];
            var $ = jquery;
            var Droptables = window.Droptables;
            if (typeof (Droptables.style.cells) !== 'undefined') {
                var newCells = {};
                var cell, i, cells;

                for (cell in Droptables.style.cells) {
                    cells = Droptables.style.cells[cell];
                    if (cells[1] > index + amount - 1) {
                        newCells[cells[0] + '!' + parseInt(cells[1] - amount)]
                            = [cells[0], cells[1] - amount, $.extend({}, cells[2])];
                    }
                    if (cells[1] < index) {
                        newCells[cell]
                            = [cells[0], cells[1], $.extend({}, cells[2])];
                    }
                }
                Droptables.style.cells = $.extend({}, newCells);

                if (typeof Droptables.style.table.alternateColorValue !== 'undefined') {//update Droptables.style.table.alternateColorValue by index, amount
                    var alternateColorValue = Droptables.style.table.alternateColorValue;
                    for (i in alternateColorValue) {
                        if (alternateColorValue[i].selection[3] >= index && alternateColorValue[i].selection[3] <= (index + amount - 1)) {
                            alternateColorValue[i].selection[3] = index - 1;//selection[3] in selector
                        }
                        if (alternateColorValue[i].selection[3] >= index + amount) {
                            alternateColorValue[i].selection[3] = alternateColorValue[i].selection[3] - amount;//selection[3] > selector
                        }
                        if (alternateColorValue[i].selection[1] >= index && alternateColorValue[i].selection[1] < (index + amount)) {
                            alternateColorValue[i].selection[1] = index;//selection[0] in selector
                        }
                        if (alternateColorValue[i].selection[1] >= index + amount) {
                            alternateColorValue[i].selection[1] = alternateColorValue[i].selection[1] - amount;//selection[0] > selector
                        }
                        if (alternateColorValue[i].selection[1] > alternateColorValue[i].selection[3]) {//alternateColor in selector
                            delete alternateColorValue[i];
                        }
                    }
                }
            }

            if (typeof (Droptables.style.cols) !== 'undefined') {
                // index, amount
                var new_data = $.extend({}, Droptables.style.cols);
                var jj;
                for (jj = index; jj < _functions__WEBPACK_IMPORTED_MODULE_0__.default.droptablesCheckSize(Droptables.style.cols); jj++) {
                    if (typeof (Droptables.style.cols[jj + amount]) !== 'undefined' && Droptables.style.cols[jj + amount] !== null) {
                        new_data[jj] = [jj, {}];
                        new_data[jj][1] = $.extend({}, Droptables.style.cols[jj][1]);
                    } else {
                        delete new_data[jj];
                    }
                }
                Droptables.style.cols = $.extend({}, new_data);
            }

            for (var i = (index + amount - 1); i >= index ; i--) {
                Droptables.style.table.col_types.splice(i, 1);
            }

            //remove col in header table
            if (parseInt(Droptables.style.table.headerOption) > 0) {
                delete Droptables.style.header_data;
                Droptables.style.header_data = [];
                for (var j = 0; j < Droptables.style.table.headerOption; j++) {
                    Droptables.style.header_data[j] = Droptables.datas[j];
                }
            }

            // Build column selection for default sort parameter
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.default_sortable(window.Droptables.datas);
            jquery(Droptables_element.tableContainer).data('handsontable').render();
            saveData.push({action: 'del_col', index: index, amount: amount, old_columns: $(Droptables_element.tableContainer).handsontable('countCols') + amount});

            updateMergeCells(window.table_function_data.firstRender);
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.create_ranger_cells_lock(Droptables, table_function_data, {type: 'delete_col', index: index, amount: amount});
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
        },
        afterColumnResize: function (col, width) {
            _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges();
        },
        beforeRowResize: function (currentRow, newSize, isDoubleClick) {
            if (modifyRow !== null) {//currentRow is current size row
                Droptables.style.rows[modifyRow][1].height = newSize;
            }
        },
        modifyRow: function (row) {
            modifyRow = row;
        },
        afterRowResize: function (row1, height) {
            Droptables.style.rows[row1][1].height = height;

            _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges();
        },
        afterSelection: function (r, c, r2, c2, preventScrolling, selectionLayerLevel) {
            if (table_function_data.checkCellValueChange !== false && typeof table_function_data.cellValueChange !== 'undefined') {
                _functions__WEBPACK_IMPORTED_MODULE_0__.default.change_value_cells(table_function_data.checkCellValueChange, Droptables_element.cellValue.val());
            }
            _toolbarOptions__WEBPACK_IMPORTED_MODULE_2__.default.loadSelection(window.jquery, window.Droptables, [r, c, r2, c2]);
            Droptables.max_row = Droptables.datas.length;
            Droptables.max_Col = Droptables.datas[0].length;

            if (typeof Droptables.datas[Droptables.max_row - 1] !== 'undefined') {
                var max_col_2 = Droptables.datas[Droptables.max_row - 1].length;
                Droptables.max_Col = Droptables.max_Col < max_col_2 ? max_col_2 : Droptables.max_Col;
            }
            if (r * r2 == 0 && (r2 + r) == (Droptables.max_row - 1)) {
                Droptables.newSelect = 'col';
            } else if (c * c2 == 0 && (c2 + c) == Droptables.max_Col - 1) {
                Droptables.newSelect = 'row';
            } else {
                delete Droptables.newSelect;
            }
        },
        afterScrollHorizontally: function () {
            //change position of Editors when ScrollHorizontally
            checkScroll = true;
            clearTimeout(autoScroll);
            autoScroll = setTimeout(function () {
                checkScroll = afterScrollEditors(checkScroll);
            }, 200);
        },
        afterScrollVertically: function () {
            //change position of Editors when ScrollHorizontally
            checkScroll = true;
            clearTimeout(autoScroll);
            autoScroll = setTimeout(function () {
                checkScroll = afterScrollEditors(checkScroll);
            }, 200);
        },
        afterMergeCells: function (cellRange, mergeParent, auto) {
            updateMergeCells(window.table_function_data.firstRender);
        },
        afterUnmergeCells: function (cellRange, auto) {
            updateMergeCells(window.table_function_data.firstRender);
        },
        colWidths: function (index) {
            if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNested(window.Droptables.style, 'cols', index, 1, 'width')) {
                return window.Droptables.style.cols[index][1].width;
            } else if (typeof window.Droptables.style.cols === 'object' && (typeof window.Droptables.style.cols[index] === 'undefined' || typeof window.Droptables.style.cols[index][1].width === 'undefined')) {
                return 100;
            }
        },
        rowHeights: function (index) {
            if (_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkObjPropertyNestedNotEmpty(window.Droptables.style, 'rows', index, 1, 'height')) {
                return window.Droptables.style.rows[index][1].height;
            } else {
                // Table rows is large than 1000, set default row height to 30
                if (totalRows >= 1000) {
                    return 30;
                }
                var h;
                if (typeof Droptables.style.table.allRowHeight !== 'undefined' && Droptables.style.table.allRowHeight !== '') {
                    h = Droptables.style.table.allRowHeight;
                } else {
                    h = window.Droptables_element.tableContainer.find('.ht_master .htCore tbody tr').eq(index).height();
                }
                return h;
            }
        },
        fixedRowsTop: (Droptables.style.table.responsive_type == 'scroll' && parseInt(Droptables.style.table.freeze_row) > 0) ? Droptables.style.table.headerOption : 0,
        fixedColumnsLeft: (Droptables.style.table.responsive_type == 'scroll') ? parseInt(Droptables.style.table.freeze_col) : 0,
        manualColumnResize: table_function_data.allowed_edit,
        manualRowResize: table_function_data.allowed_edit,
        outsideClickDeselects: false,
        columnSorting: false,
        undo: true,
        mergeCells: Droptables.style.table.mergeSetting,
        readOnly: !(table_function_data.allowed_edit && table_function_data.mysqlEdit),
        // readOnly: false,
        selectionMode: typeof table_function_data.mysqlEdit !== 'undefined' && table_function_data.mysqlEdit ? 'single' : 'range',
        columns: typeof table_function_data.columns !== 'undefined' ? table_function_data.columns : undefined,
        beforeKeyDown: function (e) {
            var evtobj = window.event? event : e;

            if (evtobj.keyCode == 90 && (evtobj.ctrlKey || evtobj.metaKey)) {//undo
                if (!evtobj.shiftKey) {
                    if (!jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.isUndoAvailable()) {
                        _functions__WEBPACK_IMPORTED_MODULE_0__.default.status_noti(1, Joomla.JText._('COM_DROPTABLES_SOME_ACTION_CANT_BE_DONE', "Some actions can't be done due to the Technical Problem") + '!');
                    }
                }
                if (evtobj.shiftKey) {
                    if (!jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.isRedoAvailable()) {
                        _functions__WEBPACK_IMPORTED_MODULE_0__.default.status_noti(1, Joomla.JText._('COM_DROPTABLES_SOME_ACTION_CANT_BE_DONE', "Some actions can't be done due to the Technical Problem") + '!');
                    }
                }
            }
        },
        cells: function(row, col, prop) {
            return _functions__WEBPACK_IMPORTED_MODULE_0__.default.check_cell_readOnly(row, col, prop);
            // var cellProperties = {};

            // if (window.Droptables.type === 'mysql') {
            //     if (row < 1) {
            //         cellProperties.readOnly = false;
            //     }

                // if (Droptables.table_editing != '1' && row >= 1) {
                //     cellProperties.readOnly = true;
                // }
            // }

            // return cellProperties;
        },
        contextMenu: (table_function_data.allowed_edit && window.Droptables.type === 'html')
            ? {
                items: {
                    "cut": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_CUT', 'Cut'),
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "copy": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_COPY', 'Copy'),
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        },
                    },
                    // "paste": {
                    //     key: 'paste',
                    //     name: 'Paste',
                    //     disabled: function() {
                    //         return clipboardCache.length === 0;
                    //     },
                    //     callback: function() {
                    //         var plugin = this.getPlugin('copyPaste');
                    //
                    //         this.listen();
                    //         plugin.paste(clipboardCache);
                    //     }
                    // },
                    "remove": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_REMOVE', 'Remove'),
                        key: 'remove',
                        submenu: {
                            items: [
                                {
                                    key: "remove:remove_row",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_REMOVE_ROW', 'Remove row'),
                                    callback: function (key, selection, clickEvent) {
                                        var selection = table_function_data.selection;
                                        var i;
                                        for (i = 0; i < table_function_data.selectionSize; i++) {
                                            if (selection[i][2] != null || selection[i][0] != selection[i][2]) {
                                                window.Droptables_element.tableContainer.handsontable('alter', 'remove_row', selection[i][0], selection[i][2] - selection[i][0] + 1);
                                            } else {
                                                window.Droptables_element.tableContainer.handsontable('alter', 'remove_row', selection[i][0]);
                                            }
                                        }
                                    },
                                },
                                {
                                    key: "remove:remove_col",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_REMOVE_COL', 'Remove col'),
                                    callback: function (key, options) {
                                        var selection = table_function_data.selection;
                                        var i;
                                        for (i = 0; i < table_function_data.selectionSize; i++) {
                                            if (selection[i][3] != null || selection[i][1] != selection[i][3]) {
                                                window.Droptables_element.tableContainer.handsontable('alter', 'remove_col', selection[i][1], selection[i][3] - selection[i][1] + 1);
                                            } else {
                                                window.Droptables_element.tableContainer.handsontable('alter', 'remove_col', selection[i][1]);
                                            }
                                        }
                                    },
                                },
                                {
                                    key: "remove:remove_cell_format",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_REMOVE_CELL_FORMAT', 'Remove cell format'),
                                    callback: function (key, selection, clickEvent) {
                                        _functions__WEBPACK_IMPORTED_MODULE_0__.default.getFillArray(table_function_data.selection, Droptables, {
                                            date_formats: false,
                                            date_formats_momentjs: false,
                                            currency_symbol: false,
                                            symbol_position: false,
                                            decimal_symbol: false,
                                            decimal_count: false,
                                            thousand_symbol: false
                                        }, 'style', true, function () {
                                            window.jquery(Droptables_element.tableContainer).handsontable('render');
                                        });
                                    },
                                    hidden: function () {//hiden when has html cell
                                        if (table_function_data.selectionSize > 0) {
                                            if (!_functions__WEBPACK_IMPORTED_MODULE_0__.default.checkCellsOptionsValidate(table_function_data.selection, 'cell_type', 'html')) {
                                                return false;
                                            }
                                        }
                                        return true;
                                    }
                                },
                                {
                                    key: "remove:remove_alternating_color",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_REMOVE_ALTERNATING_COLOR', 'Remove automatic styling'),
                                    callback: function (key, selection, clickEvent) {
                                        var i, ij, ik, alternateColorCell, selection_cell = null;
                                        for (i = 0; i < table_function_data.selectionSize; i++) {
                                            if (selection_cell !== null) {
                                                break;
                                            }
                                            for (ij = table_function_data.selection[i][0]; ij <= table_function_data.selection[i][2]; ij++) {
                                                if (selection_cell !== null) {
                                                    break;
                                                }
                                                for (ik = table_function_data.selection[i][1]; ik <= table_function_data.selection[i][3]; ik++) {
                                                    if (typeof Droptables.style.cells[ij + "!" + ik] !== 'undefined' && typeof Droptables.style.cells[ij + "!" + ik][2].AlternateColor !== 'undefined') {
                                                        alternateColorCell = parseInt(Droptables.style.cells[ij + "!" + ik][2].AlternateColor);
                                                        if (typeof Droptables.style.table.alternateColorValue[alternateColorCell] !== 'undefined' && typeof Droptables.style.table.alternateColorValue[alternateColorCell].selection !== 'undefined') {
                                                            selection_cell = Droptables.style.table.alternateColorValue[alternateColorCell].selection;
                                                            Droptables_element.tableContainer.handsontable("selectCell", selection_cell[0], selection_cell[1], selection_cell[2], selection_cell[3]);
                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (selection_cell !== null) {
                                            bootbox.confirm(Joomla.JText._('COM_DROPTABLES_TABLES_WARNING_REMOVE_ALTERNATING_COLOR',
                                                'Are you sure you want to remove all the table automatic styling?'), function (result) {
                                                if (result) {
                                                    table_function_data.oldAlternate[alternateColorCell] = false;
                                                    Droptables.style.table.alternateColorValue[alternateColorCell] = false;
                                                    setTimeout(function () {
                                                        saveData.push({action: 'deleteStyle', selection: table_function_data.selection, style: 'AlternateColor'});
                                                        Droptables_element.droptable_popup.find('.colose_popup').trigger('click');
                                                        _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true, 'render');
                                                    }, 100);
                                                } else {
                                                    Droptables_element.droptable_popup.find('.colose_popup').trigger('click');
                                                }
                                                ;
                                            });
                                        }
                                    },
                                    hidden: function () {//hiden when has html cell
                                        if (table_function_data.selectionSize > 0) {
                                            return false;
                                        }
                                        return true;
                                    }
                                }],
                        },
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "---------": {},
                    "rows_size": {
                        name: function () {
                            if (typeof Droptables.newSelect !== 'undefined') {
                                var selectSize = table_function_data.selection[table_function_data.selectionSize - 1];
                                if (Droptables.newSelect === 'row') {
                                    if (selectSize[0] !== selectSize[2]) {
                                        return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_ROW', 'Resize row') + 's ' + (selectSize[0] + 1) + '-' + (selectSize[2] + 1) + '</span>';
                                    }
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_ROW', 'Resize row') + '</span>';
                                } else {
                                    if (selectSize[1] !== selectSize[3]) {
                                        return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_COL', 'Resize column') + 's ' + String.fromCharCode(65 + selectSize[1]) + '-' + String.fromCharCode(65 + selectSize[3]) + '</span>';
                                    }
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_COL', 'Resize column') + '</span>';
                                }
                            }
                        },
                        callback: function (key, selection, clickEvent) {
                            if (Droptables.newSelect === 'row') {
                                Droptables_element.primary_toolbars.find('.table_option[name="resize_row"]').trigger('click');
                            } else {
                                Droptables_element.primary_toolbars.find('.table_option[name="resize_column"]').trigger('click');
                            }
                            return true;
                        },
                        hidden: function () {
                            if (typeof Droptables.newSelect !== 'undefined' && Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "insert": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_INSERT', 'Insert'),
                        key: 'insert',
                        submenu: {
                            items: [
                                {
                                    key: "insert:row_above",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_INSERT_ABOVE', 'Insert rows above'),
                                    callback: function (key, options) {
                                        var selection = table_function_data.selection[table_function_data.selectionSize - 1];
                                        if (selection[2] != null || selection[0] != selection[2]) {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_row', selection[0], selection[2] - selection[0] + 1);
                                        } else {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_row', selection[0]);
                                        }
                                    },
                                    hidden: function () {
                                        if (Droptables.max_Col > 0) {
                                            return false;
                                        }
                                        return true;
                                    }
                                },
                                {
                                    key: "insert:row_below",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_INSERT_BELOW', 'Insert rows below'),
                                    callback: function (key, options) {
                                        var selection = table_function_data.selection[table_function_data.selectionSize - 1];
                                        if (selection[2] != null || selection[0] != selection[2]) {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_row', selection[2] + 1, selection[2] - selection[0] + 1);
                                        } else {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_row', selection[2] + 1);
                                        }
                                    },
                                    hidden: function () {
                                        if (Droptables.max_Col > 0) {
                                            return false;
                                        }
                                        return true;
                                    }
                                },
                                {
                                    key: "insert:col_left",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_INSERT_LEFT', 'Insert column left'),
                                    callback: function (key, options) {
                                        var selection = table_function_data.selection[table_function_data.selectionSize - 1];
                                        if (selection[3] != null || selection[1] != selection[3]) {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_col', selection[1], selection[3] - selection[1] + 1);
                                        } else {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_col', selection[1]);
                                        }
                                    },
                                    hidden: function () {
                                        if (Droptables.max_row > 0) {
                                            return false;
                                        }
                                        return true;
                                    }
                                },
                                {
                                    key: "insert:col_right",
                                    name: Joomla.JText._('COM_DROPTABLES_TABLES_INSERT_RIGHT', 'Insert column right'),
                                    callback: function (key, options) {
                                        var selection = table_function_data.selection[table_function_data.selectionSize - 1];
                                        if (selection[3] != null || selection[1] != selection[3]) {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_col', selection[3] + 1, selection[3] - selection[1] + 1);
                                        } else {
                                            window.Droptables_element.tableContainer.handsontable('alter', 'insert_col', selection[3] + 1);
                                        }
                                    },
                                    hidden: function () {
                                        if (Droptables.max_row > 0) {
                                            return false;
                                        }
                                        return true;
                                    }
                                }],
                        }
                    },
                    "undo": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_UNDO', 'Undo'),
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "redo": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_REDO', 'Redo'),
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "mergeCells": {
                        // name: DroptablesContext.merge,
                    },
                    "protect_range": {
                        name: function () {
                            return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_PROTECT_RANGE', 'Protect range') + '</span>';
                        },
                        callback: function (key, selections, clickEvent) {
                            Droptables_element.primary_toolbars.find('.table_option[name="lock_ranger_cells"]').trigger('click');
                            return true;
                        },
                        hidden: function () {
                            if (Droptables.check_super_user) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "Add tooltip": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_TOOLTIP', 'Tooltip'),
                        callback: function (key, selection, clickEvent) {
                            Droptables_element.editToolTip.trigger('click');
                        },
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row < 1 || !(typeof default_value.enable_tooltip !== 'undefined' && parseInt(default_value.enable_tooltip) === 1)) {
                                return true;
                            }
                            if (table_function_data.selectionSize > 1
                                || (table_function_data.selection[0][2] - table_function_data.selection[0][0] > 0
                                    || table_function_data.selection[0][3] - table_function_data.selection[0][1] > 0)) {
                                return true;
                            }
                            return false;
                        }
                    },
                    "Column type": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_COL_TYPE', 'Column type'),
                        key: 'column_type',
                        submenu: {
                            items: [
                                {
                                    key: "column_type:varchar",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && (table_function_data.type_column_selected === 'varchar' || table_function_data.type_column_selected.toLowerCase() === 'varchar(255)')) {
                                            return '<span class="selected">VARCHAR</span>';
                                        } else {
                                            return '<span>VARCHAR</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'varchar';
                                                        Droptables.style.table.col_types[i] = 'varchar';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });
                                    },
                                },
                                {
                                    key: "column_type:int",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && table_function_data.type_column_selected === 'int') {
                                            return '<span class="selected">INTEGER</span>';
                                        } else {
                                            return '<span>INTEGER</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'int';
                                                        Droptables.style.table.col_types[i] = 'int';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });
                                    },
                                },
                                {
                                    key: "column_type:float",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && table_function_data.type_column_selected === 'float') {
                                            return '<span class="selected">FLOAT</span>';
                                        } else {
                                            return '<span>FLOAT</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'float';
                                                        Droptables.style.table.col_types[i] = 'float';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });

                                    },
                                },
                                {
                                    key: "column_type:date",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && table_function_data.type_column_selected === 'date') {
                                            return '<span class="selected">DATE</span>';
                                        } else {
                                            return '<span>DATE</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'date';
                                                        Droptables.style.table.col_types[i] = 'date';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });

                                    },
                                },
                                {
                                    key: "column_type:datetime",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && table_function_data.type_column_selected === 'datetime') {
                                            return '<span class="selected">DATETIME</span>';
                                        } else {
                                            return '<span>DATETIME</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'datetime';
                                                        Droptables.style.table.col_types[i] = 'datetime';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });

                                    },
                                },
                                {
                                    key: "column_type:text",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && table_function_data.type_column_selected === 'text') {
                                            return '<span class="selected">TEXT</span>';
                                        } else {
                                            return '<span>TEXT</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'text';
                                                        Droptables.style.table.col_types[i] = 'text';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });

                                    },
                                },
                                {
                                    key: "column_type:mediumtext",
                                    name: function () {
                                        if (typeof table_function_data.type_column_selected !== 'undefined' && table_function_data.type_column_selected === 'mediumtext') {
                                            return '<span class="selected">MEDIUMTEXT</span>';
                                        } else {
                                            return '<span>MEDIUMTEXT</span>';
                                        }
                                    },
                                    callback: function (key, options) {
                                        bootbox.confirm(Joomla.JText._('COM_DROPTABLES_ALERT_CHANGE_COLUMN_TYPE'), function (result) {
                                            if (result === true) {
                                                var cols_selected = [];
                                                var i, jj;
                                                for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                                                    for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {
                                                        cols_selected[i] = 'mediumtext';
                                                        Droptables.style.table.col_types[i] = 'mediumtext';
                                                    }
                                                }

                                                // saveData.push({action: 'set_column_type', cols: unique_cols_selected, type: 'varchar'});
                                                saveData.push({
                                                    action: 'set_columns_types',
                                                    value: cols_selected
                                                });
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.cleanHandsontable();
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                            }
                                        });

                                    },
                                },
                            ]
                        },
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row < 1) {
                                return true;
                            }
                            if (table_function_data.selectionSize > 1 || table_function_data.selection[0][3] - table_function_data.selection[0][1] > 0) {
                                return true;
                            }
                            return false;
                        }
                    },
                    "hide_column": {
                        name: function () {
                            if (typeof Droptables.newSelect !== 'undefined' && Droptables.newSelect === 'col') {
                                var selection = table_function_data.selection;
                                if (typeof Droptables.style.cols[selection[0][1]] !== 'undefined'
                                    && Droptables.style.cols[selection[0][1]] !== null
                                    && typeof Droptables.style.cols[selection[0][1]][1].hide_column !== 'undefined'
                                    && Droptables.style.cols[selection[0][1]][1].hide_column == 1) {
                                    return '<span class="selected">' + Joomla.JText._('COM_DROPTABLES_TABLES_HIDE_COL', 'Hide column on front-end') + '</span>';
                                } else {
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_HIDE_COL', 'Hide column on front-end') + '</span>';
                                }
                            }
                        },
                        callback: function (key, selection, clickEvent) {
                            if (Droptables.newSelect === 'col') {
                                var selection = table_function_data.selection;
                                if (typeof Droptables.style.cols[selection[0][1]] !== 'undefined' && Droptables.style.cols[selection[0][1]] !== null) {
                                    if (typeof Droptables.style.cols[selection[0][1]][1].hide_column !== 'undefined' && Droptables.style.cols[selection[0][1]][1].hide_column == 1) {
                                        Droptables.style.cols = _functions__WEBPACK_IMPORTED_MODULE_0__.default.fillArray(Droptables.style.cols, {hide_column: 0}, selection[0][1]);
                                    } else {
                                        Droptables.style.cols = _functions__WEBPACK_IMPORTED_MODULE_0__.default.fillArray(Droptables.style.cols, {hide_column: 1}, selection[0][1]);
                                    }
                                }
                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
                                return true;
                            }
                            return true;
                        },
                        hidden: function () {
                            var selection = table_function_data.selection;
                            if (typeof Droptables.newSelect === 'undefined' || Droptables.newSelect !== "col" || selection[0][3] - selection[0][1] >= 1) {
                                return true;
                            }
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    }
                }
            }
            : {
                items: {
                    "hide_column": {
                        name: function () {
                            if (typeof Droptables.newSelect !== 'undefined' && Droptables.newSelect === 'col') {
                                var selection = table_function_data.selection;
                                if (typeof Droptables.style.cols[selection[0][1]] !== 'undefined'
                                    && Droptables.style.cols[selection[0][1]] !== null
                                    && typeof Droptables.style.cols[selection[0][1]][1].hide_column !== 'undefined'
                                    && Droptables.style.cols[selection[0][1]][1].hide_column == 1) {
                                    return '<span class="selected">' + Joomla.JText._('COM_DROPTABLES_TABLES_HIDE_COL', 'Hide column on front-end') + '</span>';
                                } else {
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_HIDE_COL', 'Hide column on front-end') + '</span>';
                                }
                            }
                        },
                        callback: function (key, selection, clickEvent) {
                            if (Droptables.newSelect === 'col') {
                                var selection = table_function_data.selection;
                                if (typeof Droptables.style.cols[selection[0][1]] !== 'undefined' && Droptables.style.cols[selection[0][1]] !== null) {
                                    if (typeof Droptables.style.cols[selection[0][1]][1].hide_column !== 'undefined' && Droptables.style.cols[selection[0][1]][1].hide_column == 1) {
                                        Droptables.style.cols = _functions__WEBPACK_IMPORTED_MODULE_0__.default.fillArray(Droptables.style.cols, {hide_column: 0}, selection[0][1]);
                                    } else {
                                        Droptables.style.cols = _functions__WEBPACK_IMPORTED_MODULE_0__.default.fillArray(Droptables.style.cols, {hide_column: 1}, selection[0][1]);
                                    }
                                }
                                return true;
                            }
                            return true;
                        },
                        hidden: function () {
                            if (typeof Droptables.query_option === 'undefined') {
                                return true;
                            }
                            var selection = table_function_data.selection;
                            if (typeof Droptables.newSelect === 'undefined' || Droptables.newSelect !== "col" || selection[0][3] - selection[0][1] >= 1) {
                                return true;
                            }
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "remove_alternating_color": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_REMOVE_ALTERNATING_COLOR', 'Remove automatic styling'),
                        callback: function (key, selection, clickEvent) {
                            _functions__WEBPACK_IMPORTED_MODULE_0__.default.fillArray(table_function_data, {allAlternate: {}});
                            _functions__WEBPACK_IMPORTED_MODULE_0__.default.fillArray(Droptables.style.table, {allAlternate: {}});
                            window.Droptables_element.tableContainer.handsontable('render');
                            _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true, 'render');
                        },
                        hidden: function () {
                            if (typeof table_function_data.allAlternate !== 'undefined' && typeof table_function_data.allAlternate.even !== 'undefined') {
                                return false;
                            }
                            return true;
                        }
                    },
                    "delete_row_dbtable": {
                        name: function () {
                            if (typeof Droptables.newSelect !== 'undefined') {
                                if (Droptables.newSelect === 'row') {
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_DELETE_ROW', 'Delete Row') + '</span>';
                                }
                            }
                        },
                        callback: function (key, selection, clickEvent) {
                            if (Droptables.newSelect === 'row') {
                                if (typeof Droptables.query_option.columns_list !== "undefined") {
                                    var not_create = false;
                                    var warning_craete = Joomla.JText._('COM_DROPTABLES_JS_WARNING_DELETE_DB_TABLE');

                                    if (Droptables.query_option.tables_list.length > 1) {
                                        not_create = true;
                                        warning_craete = Joomla.JText._('COM_DROPTABLES_JS_WARNING_DELETE_MULTIPLE_DB_TABLE');
                                    }

                                    var selection = table_function_data.selection;
                                    if (not_create) {
                                        bootbox.alert(warning_craete);
                                        return true;
                                    } else if (typeof selection[0] !== 'undefined') {
                                        bootbox.confirm(warning_craete, function (result) {
                                            if (result === true) {
                                                var id_row = Droptables.datas[selection[0][0]][table_function_data.keyPosition];
                                                var field = Droptables.query_option.column_options[table_function_data.keyPosition].Field;
                                                var table_name = Droptables.query_option.column_options[table_function_data.keyPosition].table;
                                                _functions__WEBPACK_IMPORTED_MODULE_0__.default.deleteRowDbTable(table_name, field, id_row);
                                            } else {
                                                return true;
                                            }
                                        });
                                    }
                                }
                                return true;
                            }
                            return true;
                        },
                        hidden: function () {
                            if (typeof Droptables.query_option === 'undefined') {
                                return true;
                            }
                            var selection = table_function_data.selection;
                            if (typeof Droptables.newSelect === 'undefined' || Droptables.newSelect !== "row" || selection[0][2] - selection[0][0] >= 1 || !table_function_data.mysqlEdit) {
                                return true;
                            }
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "create_row_dbtable": {
                        name: function () {
                            if (typeof Droptables.newSelect !== 'undefined') {
                                if (Droptables.newSelect === 'row') {
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_CREATE_ROW', 'Create Row') + '</span>';
                                }
                            }
                        },
                        callback: function (key, selection, clickEvent) {
                            if (Droptables.newSelect === 'row') {
                                var popup = {
                                    'html': Droptables_element.content_popup_hide.find('#create_row_dbtable'),
                                    'showAction': function () {
                                        return true;
                                    },
                                    'submitAction': function () {
                                        if (typeof Droptables.query_option.columns_list !== "undefined") {
                                            var list_value = {};
                                            var dbtable = '';
                                            var not_create = false;
                                            var warning_create = '';
                                            window.jquery.each(Droptables.query_option.columns_list, function (i, v) {
                                                if (v.canEdit == 1) {
                                                    var value = Droptables_element.droptable_popup.find('input.table_column[data-column-name="' + v.table + '.' + v.Field + '"]').val();
                                                    var validate = _functions__WEBPACK_IMPORTED_MODULE_0__.default.validate_type_cell(
                                                        v.Type,
                                                        value
                                                    );
                                                    // if (!(typeof list_value[v.table] !== 'undefined')) {
                                                    //     list_value[v.table] = {};
                                                    // }
                                                    // list_value[v.table][v.Field] = value;
                                                    list_value[v.Field] = value;
                                                    dbtable = v.table;
                                                    if (Droptables.query_option.tables_list.length > 1) {
                                                        not_create = true;
                                                        warning_create = Joomla.JText._('COM_DROPTABLES_JS_WARNING_CREATE_MULTIPLE_DB_TABLE');
                                                    } else {
                                                        if (!validate && v.Null !== 'YES') {
                                                            not_create = true;
                                                            warning_create = Joomla.JText._('COM_DROPTABLES_JS_WARNING_CREATE_DB_TABLE');
                                                        }
                                                    }
                                                }

                                                if (Droptables.query_option.columns_list.length == i + 1) {
                                                    if (not_create) {
                                                        bootbox.alert(warning_create);
                                                        return true;
                                                    } else {
                                                        _functions__WEBPACK_IMPORTED_MODULE_0__.default.createRowDbTable(dbtable, list_value);
                                                        Droptables_element.droptable_popup.find('.colose_popup').trigger('click');
                                                        return true;
                                                    }
                                                }
                                            });
                                        }
                                        return true;
                                    },
                                    'cancelAction': function () {
                                        return true;
                                    }
                                };
                                _toolbarOptions__WEBPACK_IMPORTED_MODULE_2__.default.droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                            }
                            return true;
                        },
                        hidden: function () {
                            if (typeof Droptables.query_option === 'undefined') {
                                return true;
                            }
                            if (typeof Droptables.newSelect === 'undefined' || Droptables.newSelect !== "row" || !table_function_data.mysqlEdit) {
                                return true;
                            }
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "rows_size": {
                        name: function () {
                            if (typeof Droptables.newSelect !== 'undefined') {
                                var selectSize = table_function_data.selection[table_function_data.selectionSize - 1];
                                if (Droptables.newSelect === 'row') {
                                    if (selectSize[0] !== selectSize[2]) {
                                        return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_ROW', 'Resize row') + 's ' + (selectSize[0] + 1) + '-' + (selectSize[2] + 1) + '</span>';
                                    }
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_ROW', 'Resize row') + '</span>';
                                } else {
                                    if (selectSize[1] !== selectSize[3]) {
                                        return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_COL', 'Resize column') + 's ' + String.fromCharCode(65 + selectSize[1]) + '-' + String.fromCharCode(65 + selectSize[3]) + '</span>';
                                    }
                                    return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_RESIZE_COL', 'Resize column') + '</span>';
                                }
                            }
                        },
                        callback: function (key, selection, clickEvent) {
                            if (Droptables.newSelect === 'row') {
                                Droptables_element.primary_toolbars.find('.table_option[name="resize_row"]').trigger('click');
                            } else {
                                Droptables_element.primary_toolbars.find('.table_option[name="resize_column"]').trigger('click');
                            }
                            return true;
                        },
                        hidden: function () {
                            if (typeof Droptables.newSelect === 'undefined' || (Droptables.newSelect !== "row" && Droptables.newSelect !== "col")) {
                                return true;
                            }
                            if (Droptables.max_Col * Droptables.max_row > 0) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "protect_range": {
                        name: function () {
                            return '<span>' + Joomla.JText._('COM_DROPTABLES_TABLES_PROTECT_RANGE', 'Protect range') + '</span>';
                        },
                        callback: function (key, selections, clickEvent) {
                            Droptables_element.primary_toolbars.find('.table_option[name="lock_ranger_cells"]').trigger('click');
                            return true;
                        },
                        hidden: function () {
                            if (Droptables.check_super_user) {
                                return false;
                            }
                            return true;
                        }
                    },
                    "Add tooltip": {
                        name: Joomla.JText._('COM_DROPTABLES_TABLES_TOOLTIP', 'Tooltip'),
                        callback: function (key, selection, clickEvent) {
                            Droptables_element.editToolTip.trigger('click');
                        },
                        hidden: function () {
                            if (Droptables.max_Col * Droptables.max_row < 1 || !(typeof default_value.enable_tooltip !== 'undefined' && parseInt(default_value.enable_tooltip) === 1)) {
                                return true;
                            }
                            if (table_function_data.selectionSize > 1
                                || (table_function_data.selection[0][2] - table_function_data.selection[0][0] > 0
                                    || table_function_data.selection[0][3] - table_function_data.selection[0][1] > 0)) {
                                return true;
                            }
                            return false;
                        }
                    }
                }
            }
    })

    window.Droptables_element.tableContainer.find('.ht_clone_top_left_corner').unbind('click').on('click', function () {
        var max_col = parseInt(Droptables.max_Col) > 0 ? Droptables.max_Col : Droptables.datas[0].length;
        var max_row = parseInt(Droptables.max_row) > 0 ? Droptables.max_row : Droptables.datas.length;
        jquery(Droptables_element.tableContainer).handsontable("selectCells", [[0, 0, max_row - 1, max_col - 1]]);
    });

    // search key
    Droptables_element.primary_toolbars.find('.search-menu').find('#dp-form-search').unbind('keydown.mm').bind('keydown.mm', function (event) {
        event.stopImmediatePropagation();
        if (event.keyCode === 13) {
            Droptables_element.primary_toolbars.find('.search-menu').find('.search_table').trigger('click');
        } else if (jquery(this).val() === '') {
            Droptables_element.primary_toolbars.find('.search-menu').find('.search_table').trigger('click');
        }
    });

    Droptables_element.primary_toolbars.find('.search-menu').find('#dp-form-search').bind('click.search', (e) => {
        event.stopPropagation();
        Droptables_element.primary_toolbars.find('.search-menu').find('#dp-form-search').focus();
        return false;
    });

    Droptables_element.primary_toolbars.find('.search-menu').find('.search_table').click(function (e) {
        jquery(this).parent().addClass('open');
        Droptables_element.primary_toolbars.find('.search-menu').find('#dp-form-search').trigger('click.search');
        var textSearch = Droptables_element.primary_toolbars.find('.search-menu').find('#dp-form-search');
        var queryResult = jquery(Droptables_element.tableContainer).data('handsontable').getPlugin('search').query(textSearch.val());
       jquery(Droptables_element.tableContainer).data('handsontable').render();
    });

    Droptables_element.primary_toolbars.find('.search-menu').find('.reload_search').click(function () {
        Droptables_element.primary_toolbars.find('.search-menu').find('#dp-form-search').val('');
        var queryResult = jquery(Droptables_element.tableContainer).data('handsontable').getPlugin('search').query('');
        jquery(Droptables_element.tableContainer).data('handsontable').render();
        jquery(this).parents('.search-menu').removeClass("open");
    });

    /*select menu option function*/
    _toolbarOptions__WEBPACK_IMPORTED_MODULE_2__.default.selectOption();

    /*more function Eg: rename table*/
    window.Droptables_element.primary_toolbars.find('.droptable_name_edit').text(window.Droptables.title);
}


/*
* Function update mergecells when change rows and cols
* */
function updateMergeCells(firstRender) {
    window.Droptables.style.table.mergeSetting = [];
    var ht = jquery(Droptables_element.tableContainer).handsontable('getInstance');
    var mergeSetting = ht.getPlugin('mergeCells').mergedCellsCollection;
    var i = 0;

    if (mergeSetting.mergedCells.length < 1) {//save
        // tableFunction.saveChanges();
    }
    table_function_data.start_merge_cell_col = {};

    for (i = 0; i < mergeSetting.mergedCells.length; i++) {
        window.Droptables.style.table.mergeSetting.push({
            col: mergeSetting.mergedCells[i].col,
            colspan: mergeSetting.mergedCells[i].colspan,
            row: mergeSetting.mergedCells[i].row,
            rowspan: mergeSetting.mergedCells[i].rowspan
        });
        if (typeof table_function_data.start_merge_cell_col[mergeSetting.mergedCells[i].col] == 'undefined') {
            table_function_data.start_merge_cell_col[mergeSetting.mergedCells[i].col] = [];
        }
        table_function_data.start_merge_cell_col[mergeSetting.mergedCells[i].col][mergeSetting.mergedCells[i].row] = i;
    }

    if (table_function_data.allowed_save) {
        // tableFunction.saveChanges(table_function_data.allowed_save);
    }
    var args = Array.prototype.slice.call(arguments, 1);
    if (typeof args[1] === 'undefined' || args[1] === true) {
        _functions__WEBPACK_IMPORTED_MODULE_0__.default.saveChanges(true);
    }
}



/***/ }),

/***/ "./site/assets/js/_toolbarOptions.js":
/*!*******************************************!*\
  !*** ./site/assets/js/_toolbarOptions.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _droptables__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_droptables */ "./site/assets/js/_droptables.js");
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_functions */ "./site/assets/js/_functions.js");
/* harmony import */ var _customRenderer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_customRenderer */ "./site/assets/js/_customRenderer.js");
/* harmony import */ var _charts__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./_charts */ "./site/assets/js/_charts.js");
/* harmony import */ var _alternating__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./_alternating */ "./site/assets/js/_alternating.js");






//Control functions when select table items
const selectOption = function () {
    var Droptables_element = window.Droptables_element;
    var popupOption = {};
    var render = false;
    var autoRender;
    var check_saving;
    var new_col_types = [];
    var changed_cols = [];

    if (!table_function_data.allowed_edit) {
        return false;
    }

    if (Droptables.max_Col * Droptables.max_row < 1) {
        return false;
    }

    custom_select_box.call(window.jquery('#setting-cells .droptable_select_box_before'), window.jquery);

    Droptables_element.primary_toolbars.find('.table_option:not(.menu_loading)').unbind('change click').on('change click', function (e) {
        var function_data = window.table_function_data;
        var Droptables = window.Droptables;
        var $ = window.jquery;

        if ($(this).parent('li.no_active').length > 0) {
            return false;
        }
        var selection = {};
        selection = table_function_data.selection;

        var popup = $.extend({}, {});
        var html = '';
        //for undo
        // var oldStyle = JSON.parse(JSON.stringify(Wptm.style));
        //for mergecells
        // var ht = Droptables_element.tableContainer.handsontable('getInstance');

        /*click cell*/
        switch ($(this).attr('name')) {
            case 'rename_menu':
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.setText.call(
                    $(this),
                    Droptables_element.primary_toolbars.find('.droptable_name_edit'),
                    '#primary_toolbars .droptable_name_edit',
                    {'url': Droptables.ajaxurl + "index.php?option=com_droptables&task=table.setTitle&id=" + Droptables.id + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert) + '&title=', 'selected': true}
                );
                break;
            case 'new_table_menu':
                if (createNewTable($)) {
                    return true;
                }
                break;
            case 'save_menu':
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                break;
            case 'export_menu':
                // if (Wptm.type == 'mysql') {
                //     return false;
                // }
                html = '';
                html += '<div class="control-group">';
                html += '<div  class="popup_top border_top">';
                html += '<span>' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL', 'Export excel') + ' :</span>';
                html += '</div>';
                html += '<span class="popup_select style_export droptable_select_box_before" data-value="1">' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL_DATA_STYLE', 'Data + styles') + '</span>';
                html += '<ul class="droptable_select_box">';
                html += '<li data-value="1">' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL_DATA_STYLE', 'Data + styles') + '</li>';
                html += '<li data-value="0">' + Joomla.JText._('COM_DROPTABLES_EXPORT_EXCEL_ONLY', 'Data only') + '</li>';
                html += '</ul>';
                html += '<div style="margin-top: 10px"><input type="button" class="droptables_button droptables_done" value="Export excel" id="export_excel"></div>';
                html += '</div>';
                popup = {
                    'html': $(html),
                    'selector': {'export_excel': '.style_export'},
                    'showAction': function () {
                        custom_select_box.call(this.find('.style_export'), $);
                    },
                    'option': {'export_excel': 1},
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, false);

                //Export-excel
                $('#export_excel').bind('click', function (e) {
                    var format = default_value.export_excel_format;
                    var url = Droptables.ajaxurl + 'index.php?option=com_droptables&task=excel.export&id=' + Droptables.id + '&format_excel=' + format + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert);
                    url = url + '&onlydata=' + popup.option['export_excel'];

                    $.fileDownload(url, {
                        failCallback: function (html, url) {
                            bootbox.alert(html);
                        }
                    });
                });
                break;
            case 'source_menu':
                if (table_function_data.access_db) {
                    var curr_page = window.location.href;
                    var cells = curr_page.split("?");
                    var new_url;
                    if (parseInt(Droptables.caninsert) > 0) {
                        new_url = cells[0] + '?option=com_droptables&task=dbtable.display&view=droptables&id_table=' + idTable + '&noheader=1&caninsert=1&tmpl=component';
                    } else {
                        if (Droptables.view === 'manage') {
                            new_url = cells[0] + "?option=com_droptables&view=manage&task=dbtable.display&id_table=" + idTable;
                        } else {
                            new_url = cells[0] + '?option=com_droptables&task=dbtable.display&id_table=' + idTable;
                        }
                    }
                    window.location = new_url;
                }
                break;
            case 'access_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#access_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('.droptable_done').addClass('droptable_blu');
                        this.find('.droptable_cancel').addClass('droptable_grey');

                        if (typeof Droptables.authorTable !== 'undefined' && parseInt(Droptables.authorTable) > 0) {
                            this.find('#jform_role_table').val(parseInt(Droptables.authorTable)).change();
                        }

                        return true;
                    },
                    'submitAction': function () {
                        var author = this.find('#jform_role_table').val();
                        if (parseInt(author) > 0 && parseInt(author) !== parseInt(Droptables.authorTable)) {//change own category
                            $.ajax({
                                url: Droptables.ajaxurl + 'index.php?option=com_droptables&task=table.setUser&id=' + Droptables.id + '&user=' + author + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                                dataType: "json",
                                type: "POST",
                                data: {},
                                beforeSend: function () {
                                    Droptables_element.settingTable.find('.droptable_saving').removeClass('droptable_hiden');
                                },
                                success: function (datas) {
                                    if (datas.response === true) {
                                        Droptables.authorTable = author;
                                    } else {
                                        bootbox.alert(datas.response, 'Ok');
                                    }
                                    Droptables_element.settingTable.find('.droptable_saving').addClass('droptable_hiden');
                                },
                                error: function (jqxhr, textStatus, error) {
                                    bootbox.alert(textStatus + " : " + error, 'Ok');
                                }
                            });
                        }
                        this.siblings('.colose_popup').trigger('click');
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'select_theme_menu':
                if (Droptables.type == 'mysql') {
                    return false;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#table_styles'),
                    'showAction': function () {
                        var image_hover_url = '';
                        var $image_hover = '';
                        var $image_height = 0;
                        var max_size_window = {};
                        max_size_window.height = $('#wrapper').outerHeight();
                        max_size_window.width = $('#wrapper').outerWidth();
                        Droptables_element.droptable_popup.find('#table_styles li').mousemove(function(e) {
                            var x = e.clientX;
                            var y = e.clientY;
                            var upside = 0;

                            if (image_hover_url !== $(this).data('image')) {
                                $('#wrapper').find('.full_image').remove();
                                image_hover_url = $(this).data('image');
                                $image_hover = $('<img class="full_image" style="width:500px" src="' + image_hover_url + '">');
                                $('#wrapper').append($image_hover);
                            }

                            if (max_size_window.width < (x + 500)) {
                                upside += 2;
                            }

                            if ($image_hover.outerHeight() > 400) {
                                $image_height = 400;
                                $image_hover.css({height: 400, width: 'auto'});
                            } else {
                                $image_height = $image_hover.outerHeight();
                            }
                            if (max_size_window.height < (y + $image_height)) {
                                upside++;
                            }

                            if (upside === 3) {
                                $image_hover.css({ top: y - $image_height - 20, left: x - 520});
                            } else if(upside === 2 ) {
                                $image_hover.css({ top: y, left: x  - 520});
                            } else if(upside === 1 ) {
                                $image_hover.css({ top: y - $image_height - 20, left: x  + 20});
                            } else {
                                $image_hover.css({ top: y, left: x  + 20});
                            }
                        }).mouseout(function(e) {
                            $('#wrapper').find('.full_image').remove();
                            image_hover_url = '';
                            image_hover_url = '';
                        });
                    },
                    'cancelAction': function () {
                        Droptables_element.droptable_popup.find('#table_styles li').unbind('mousemove');
                        $('#wrapper').find('.full_image').remove();
                        return true;
                    }
                };

                droptables_popup(false, Droptables_element.droptable_popup, popup, true);

                Droptables_element.droptable_popup.find('#table_styles a').click(function (e) {
                    e.preventDefault();
                    var cellsData = $(Droptables_element.tableContainer).handsontable('getData');
                    var ret = true;
                    var nbCols = 0;
                    var id = $(this).data('id');

                    //check table data exist
                    $.each(cellsData, function (index, value) {
                        nbCols = value.length;
                        $.each(value, function (i, v) {
                            if (v && v.toString().trim() !== '') {
                                ret = false;
                                return false;
                            }
                        });
                    });
                    change_theme(ret, id, cellsData);
                })
                break;
            case 'alternate_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#alternating_color'),
                    'showAction': function () {
                        var selection, reSelection, valueRange;
                        valueRange = ''
                        if (Droptables.type === 'mysql') {
                            $(Droptables_element.tableContainer).handsontable("selectAll");
                            selection = $.extend([], function_data.selection[0]);
                        } else {
                            if (typeof function_data.selection === 'undefined' || function_data.selection === undefined || function_data.selection === false) { //if unselected cells
                                var i;
                                if (droptablesCheckSize(function_data.oldAlternate) < 1 || typeof Droptables.style.table.alternateColorValue === 'undefined') {
                                    selection = [0, 0, _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(Droptables.style.cols) - 1, _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(Droptables.style.rows) - 1];
                                    valueRange = 'a1:';
                                    //remove undefined cols in array
                                    var cols = [];
                                    for (i = 0; i < _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(Droptables.style.cols); i++) {
                                        if (typeof Droptables.style.cols[i] !== 'undefined' && Droptables.style.cols[i] !== undefined && Droptables.style.cols[i] !== null) {
                                            cols[i] = Droptables.style.cols[i];
                                        }
                                    }
                                    Droptables.style.cols = cols;

                                    valueRange += String.fromCharCode(97 + _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(Droptables.style.cols) - 1);
                                    valueRange += _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(Droptables.style.rows);
                                }
                            } else {
                                selection = $.extend([], function_data.selection[0]);
                                // check if selecting more than 3 rows then process
                                var selection_rows = selection[2] - selection[0];
                                if (selection_rows >= 2) {
                                    if (_functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(function_data.oldAlternate) >= 1 || typeof Droptables.style.table.alternateColorValue !== 'undefined') {
                                        for (var i = 0; i < _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(function_data.oldAlternate); i++) {
                                            var oldAlternateData = function_data.oldAlternate[i];
                                            if (oldAlternateData !== false && typeof oldAlternateData !== 'undefined' && typeof oldAlternateData.selection !== 'undefined') {
                                                var isSameSelection = _functions__WEBPACK_IMPORTED_MODULE_1__.default.isSameArray(selection, oldAlternateData.selection);
                                                if (isSameSelection) {
                                                    var colorData = oldAlternateData.default.split('|');
                                                    var dftAlternateHeader = colorData[0];
                                                    var dftAlternateTile1 = colorData[1];
                                                    var dftAlternateTile2 = colorData[2];
                                                    var dftAlternateFooter = colorData[3];
                                                    var currTile = this.find('.pane-color-tile[data-tile-header="' + dftAlternateHeader + '"][data-tile-1="' + dftAlternateTile1 + '"][data-tile-2="' + dftAlternateTile2 + '"][data-tile-footer="' + dftAlternateFooter + '"]');
                                                    currTile.addClass('active');
                                                    if (oldAlternateData.header !== '') {
                                                        this.find('.banding-header-checkbox').trigger('click');
                                                    }
                                                    if (oldAlternateData.footer !== '') {
                                                        this.find('.banding-footer-checkbox').trigger('click');
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        if (function_data.selectionSize > 0) {
                            selection = $.extend([], function_data.selection[0]);
                            for (i = 0; i < function_data.selectionSize; i++) {
                                if (function_data.selection[i][0] < selection[0]) {
                                    selection[0] = function_data.selection[i][0];
                                }
                                if (function_data.selection[i][1] < selection[1]) {
                                    selection[1] = function_data.selection[i][1];
                                }
                                if (function_data.selection[i][2] > selection[2]) {
                                    selection[2] = function_data.selection[i][2];
                                }
                                if (function_data.selection[i][3] > selection[3]) {
                                    selection[3] = function_data.selection[i][3];
                                }
                            }
                            valueRange += String.fromCharCode(97 + selection[1]) + (selection[0] + 1)
                                + ':' + String.fromCharCode(97 + selection[3]) + (selection[2] + 1);
                        }

                        if (valueRange !== '') {
                            this.find('.cellRangeLabelAlternate').val(valueRange);
                            this.find('#get_select_cells').trigger('click');
                        }

                        this.find('.formatting_style .pane-color-tile').on('click', (e) => {
                            var that = $(e.currentTarget);
                            //check exist selector and
                            selection = $.extend([], function_data.selection[0]);

                            if (typeof selection[1] !== 'undefined' && Math.abs(selection[0] - selection[2]) > 1) {
                                if (Droptables.type === 'mysql') { //alternate for all cell
                                    function_data.allAlternate = {};
                                    function_data.allAlternate.even = that.data('tile-1');
                                    function_data.allAlternate.old = that.data('tile-2');
                                    function_data.allAlternate.header = that.data('tile-header');
                                    function_data.allAlternate.footer = that.data('tile-footer');
                                    function_data.allAlternate.default = '' + function_data.allAlternate.header + '|' + function_data.allAlternate.even + '|' + function_data.allAlternate.old + '|' + function_data.allAlternate.footer;

                                    if (this.find('.banding-header-checkbox:checked').length < 1) {
                                        function_data.allAlternate.header = '';
                                    }

                                    if (this.find('.banding-footer-checkbox:checked').length < 1) {
                                        function_data.allAlternate.footer = '';
                                    }
                                    _alternating__WEBPACK_IMPORTED_MODULE_4__.default.renderCell();
                                } else {
                                    var count = _alternating__WEBPACK_IMPORTED_MODULE_4__.default.setNumberAlternate(selection, function_data.oldAlternate);

                                    /*create/reset oldAlternate[count]*/
                                    function_data.oldAlternate[count] = {};
                                    function_data.oldAlternate[count].selection = selection;
                                    function_data.oldAlternate[count].even = that.data('tile-1');
                                    function_data.oldAlternate[count].old = that.data('tile-2');
                                    function_data.oldAlternate[count].header = that.data('tile-header');
                                    function_data.oldAlternate[count].footer = that.data('tile-footer');

                                    function_data.oldAlternate[count].default = '' + function_data.oldAlternate[count].header + '|' + function_data.oldAlternate[count].even + '|' + function_data.oldAlternate[count].old + '|' + function_data.oldAlternate[count].footer;

                                    if (this.find('.banding-header-checkbox:checked').length < 1) {
                                        function_data.oldAlternate[count].header = '';
                                    }

                                    if (this.find('.banding-footer-checkbox:checked').length < 1) {
                                        function_data.oldAlternate[count].footer = '';
                                    }
                                    _alternating__WEBPACK_IMPORTED_MODULE_4__.default.selectAlternatingColor(function_data.oldAlternate, selection, count),
                                        _alternating__WEBPACK_IMPORTED_MODULE_4__.default.renderCell();
                                }

                                this.find('.pane-color-tile.active').removeClass('active');
                                that.addClass('active');
                            }
                            return false;
                        });

                        this.find('.banding-header-footer-checkbox-wrapper input').on('click', (e) => {
                            selection = $.extend([], function_data.selection[0]);
                            if (typeof selection[1] !== 'undefined' && Math.abs(selection[0] - selection[2]) > 1) {
                                if (Droptables.type === 'mysql') { //alternate for all cell
                                    if (typeof function_data.allAlternate.default !== 'undefined') {
                                        var defaultStyle = function_data.allAlternate.default.split("|");

                                        if (this.find('.banding-header-checkbox:checked').length > 0) {
                                            function_data.allAlternate.header = defaultStyle[0];
                                        } else {
                                            function_data.allAlternate.header = '';
                                        }

                                        if (this.find('.banding-footer-checkbox:checked').length > 0) {
                                            function_data.allAlternate.footer = defaultStyle[3];
                                        } else {
                                            function_data.allAlternate.footer = '';
                                        }
                                        _alternating__WEBPACK_IMPORTED_MODULE_4__.default.renderCell();
                                    }
                                } else {
                                    var oldCount = _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(function_data.oldAlternate);
                                    var count = _alternating__WEBPACK_IMPORTED_MODULE_4__.default.setNumberAlternate(selection, function_data.oldAlternate);
                                    if (oldCount !== count) {
                                        var defaultStyle = [];
                                        if (typeof function_data.oldAlternate[count].default !== 'undefined') {
                                            defaultStyle = function_data.oldAlternate[count].default.split("|");
                                        } else {
                                            if (this.find('.pane-color-tile.active').length > 0) {
                                                defaultStyle[0] = this.find('.pane-color-tile.active').find('.pane-color-tile-header').data('value');
                                                defaultStyle[3] = this.find('.pane-color-tile.active').find('.pane-color-tile-footer').data('value');
                                            } else {
                                                defaultStyle[0] = function_data.oldAlternate[count].header;
                                                defaultStyle[3] = function_data.oldAlternate[count].footer;
                                            }
                                        }
                                        if (this.find('.banding-header-checkbox:checked').length > 0) {
                                            function_data.oldAlternate[count].header = defaultStyle[0];
                                        } else {
                                            function_data.oldAlternate[count].header = '';
                                        }

                                        if (this.find('.banding-footer-checkbox:checked').length > 0) {
                                            function_data.oldAlternate[count].footer = defaultStyle[3];
                                        } else {
                                            function_data.oldAlternate[count].footer = '';
                                        }

                                        function_data.oldAlternate[count].default = '' + defaultStyle[0] + '|' + function_data.oldAlternate[count].even + '|' + function_data.oldAlternate[count].old + '|' + defaultStyle[3];

                                        _alternating__WEBPACK_IMPORTED_MODULE_4__.default.selectAlternatingColor(function_data.oldAlternate, selection, count),
                                            _alternating__WEBPACK_IMPORTED_MODULE_4__.default.renderCell();
                                    }
                                }
                            }
                            return true;
                        });

                        this.find('#alternate_color_done').click((e) => {
                            e.preventDefault();
                            _alternating__WEBPACK_IMPORTED_MODULE_4__.default.applyAlternate.call(this);
                        });
                        return true;
                    },
                    'cancelAction': function () {
                        if (_functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(function_data.checkChangeAlternate) > 0) {
                            if (Droptables.type === 'mysql') { //alternate for all cell
                                function_data.allAlternate = {};
                            } else {
                                Droptables.style.cells = $.extend({}, _alternating__WEBPACK_IMPORTED_MODULE_4__.default.reAlternateColor());
                                function_data.oldAlternate = $.extend({}, Droptables.style.table.alternateColorValue);
                            }

                            _alternating__WEBPACK_IMPORTED_MODULE_4__.default.renderCell();
                        }
                        return true;
                    }
                };
                if (Droptables.type === 'mysql') {
                    droptables_popup(false, Droptables_element.droptable_popup, popup, true, false);
                } else {
                    droptables_popup(false, Droptables_element.droptable_popup, popup, true, true);
                }
                break;
            case 'resize_column':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#column_size_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        var selection = table_function_data.selection;
                        var change_selected = false;
                        for (var i = 0; i < selection.length; i++) {
                            if (Droptables.newSelect === 'col') {
                                if (selection[i][0] !== 0 || selection[i][2] !== Droptables.max_row - 1) {
                                    table_function_data.selection.splice(i, 1);
                                    change_selected = true;
                                }
                            }
                        }

                        this.find('#jform_row_height-lbl').closest('.control-group').addClass('droptable_hiden');
                        this.find('.popup_top span').text(Joomla.JText._('COM_DROPTABLES_TABLES_COLUMN_WIDTH_START', 'Resize columns'));
                        if (table_function_data.selectionSize > 1) {
                            this.find('#jform_col_width-lbl').text(Joomla.JText._('COM_DROPTABLES_TABLES_COLUMN_WIDTH_START', 'Resize columns'));
                        }

                        if (table_function_data.selectionSize < 2) {
                            if (selection[0][1] !== selection[0][3]) {//columns
                                var text = [];
                                if (selection[0][1] > 25) {
                                    text[0] = String.fromCharCode(65) + String.fromCharCode(65 + selection[0][1] - 26);
                                } else {
                                    text[0] = String.fromCharCode(65 + selection[0][1]);
                                }
                                if (selection[0][3] > 25) {
                                    text[1] = String.fromCharCode(65) + String.fromCharCode(65 + selection[0][3] - 26);
                                } else {
                                    text[1] = String.fromCharCode(65 + selection[0][3]);
                                }
                                this.find('#jform_col_width-lbl')
                                    .text(Joomla.JText._('COM_DROPTABLES_TABLES_COLUMN_WIDTH_START', 'Resize columns') + ': ' + text[0] + '-' + text[1]);
                            }
                        }
                        var endCell = [selection[table_function_data.selectionSize - 1][2], selection[table_function_data.selectionSize - 1][3]];
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSizeCells($, Droptables, endCell);

                        this.find('.cellRangeLabelAlternate').addClass('select_column').data('text_change', '#jform_col_width-lbl');
                        if (change_selected) {
                            $(Droptables_element.tableContainer).handsontable("selectCells", table_function_data.selection);
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSelectedVal(table_function_data.selection[selection.length - 1], this.find('.cellRangeLabelAlternate'));
                        }
                        return true;
                    },
                    'submitAction': function () {
                        var col_width_val = this.find('#cell_col_width').val();
                        var selection = table_function_data.selection;
                        var i = -1;
                        var ii = 0;
                        if (typeof selection !== 'undefined' && selection !== undefined && table_function_data.selectionSize > 0) {
                            for (ii = 0; ii < table_function_data.selectionSize; ii++) {
                                for (i = selection[ii][1]; i <= selection[ii][3]; i++) {
                                    if (typeof Droptables.style.cols[i] === 'undefined' ||  Droptables.style.cols[i] === null) {
                                        Droptables.style.cols[i] = [i, {width: parseInt(col_width_val)}];
                                    }
                                    Droptables.style.cols[i][1].width = parseInt(col_width_val);
                                }
                            }
                            i++;
                        }
                        if (i !== -1) { //have changing
                            table_function_data.needSaveAfterRender = true;
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.pullDims(Droptables, $);
                        }

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    },
                    'cancelAction': function () {
                        Droptables_element.droptable_popup.find('.content').contents().remove();
                        return true;
                    }
                };
                if (Droptables.type === 'mysql') {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, false);
                } else {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, true);
                }
                break;
            case 'resize_row':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#column_size_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        var selection = table_function_data.selection;
                        var change_selected = false;
                        for (var i = 0; i < selection.length; i++) {
                            if (Droptables.newSelect === 'row') {
                                if (selection[i][1] !== 0 || selection[i][3] !== Droptables.max_Col - 1) {
                                    table_function_data.selection.splice(i, 1);
                                    change_selected = true;
                                }
                            }
                        }

                        this.find('#jform_col_width-lbl').closest('.control-group').addClass('droptable_hiden');
                        this.find('.popup_top span').text(Joomla.JText._('COM_DROPTABLES_TABLES_ROW_HEIGHT_START', 'Resize rows'));
                        if (Droptables.type === 'mysql') {
                            this.find('#all_cell_row_height').closest('.control-group').removeClass('droptable_hiden');
                            this.find('#jform_row_height-lbl').text(Joomla.JText._('COM_DROPTABLES_TABLES_SELECTROW_HEIGHT_START', 'Row height (header):'));
                            this.find('#all_cell_row_height').val(Droptables.style.table.allRowHeight);
                        } else {
                            if (table_function_data.selectionSize > 1) {
                                this.find('#jform_row_height-lbl').text(Joomla.JText._('COM_DROPTABLES_TABLES_SELECTROW_HEIGHT_START', 'Selected rows '));
                            } else {
                                if (selection[0][0] !== selection[0][2]) {//rows
                                    this.find('#jform_row_height-lbl')
                                        .text(Joomla.JText._('COM_DROPTABLES_TABLES_ROW_HEIGHT_START', 'Resize rows') + ': ' + (selection[0][0] + 1) + '-' + (selection[0][2] + 1));
                                }
                            }
                        }

                        var endCell = [selection[table_function_data.selectionSize - 1][2], selection[table_function_data.selectionSize - 1][3]];
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSizeCells($, Droptables, endCell);

                        this.find('.cellRangeLabelAlternate').addClass('select_row').data('text_change', '#jform_row_height-lbl')
                        if (change_selected) {
                            $(Droptables_element.tableContainer).handsontable("selectCells", table_function_data.selection);
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSelectedVal(table_function_data.selection[selection.length - 1], this.find('.cellRangeLabelAlternate'));
                        }
                        return true;
                    },
                    'submitAction': function () {
                        var row_height_val = parseInt(this.find('#cell_row_height').val());
                        var selection = table_function_data.selection;
                        var i = -1;
                        var ii = 0;
                        if (typeof selection !== 'undefined' && selection !== undefined && table_function_data.selectionSize > 0) {
                            for (ii = 0; ii < table_function_data.selectionSize; ii++) {
                                for (i = selection[ii][0]; i <= selection[ii][2]; i++) {
                                    if (Droptables.type !== 'mysql') {
                                        if (typeof Droptables.style.rows[i] === 'undefined') {
                                            Droptables.style.rows[i] = [i, {height: row_height_val}];
                                        }
                                        Droptables.style.rows[i][1].height = row_height_val;
                                    }
                                }
                            }

                            if (Droptables.type === 'mysql') {
                                var all_row_height_val = this.find('#all_cell_row_height').val();
                                Droptables.style.rows[0][1].height = row_height_val;
                                Droptables.style.table = _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.table, {allRowHeight: parseFloat(all_row_height_val)});
                            }
                            i++;
                        }
                        if (i !== -1) { //have changing
                            table_function_data.needSaveAfterRender = true;
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.pullDims(Droptables, $);
                        }

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    },
                    'cancelAction': function () {
                        Droptables_element.droptable_popup.find('.content').contents().remove();
                        return true;
                    }
                };
                if (Droptables.type === 'mysql') {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, false);
                } else {
                    droptables_popup(true, Droptables_element.droptable_popup, popup, true, true);
                }
                break;
            case 'header_option_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#header_option'),
                    'showAction': function() {
                        var length = -1;
                        for (var i = 4; i > 0; i--) {
                            if (typeof Droptables.datas[i] !== 'undefined') {
                                for (var ii = 0; ii < Droptables.datas[i].length; ii++) {
                                    if (Droptables.datas[i][ii] !== '') {
                                        length = i;
                                        break;
                                    }
                                }
                            }
                            if (length > -1) {
                                break;
                            }
                        }
                        this.find('#number_first_rows').next().find('li[data-value=' + (length + 1) + ']').nextAll().hide();
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'headerOption', this.find('#number_first_rows').next('.droptable_select_box'), length + 1 > 0 ? 1 : 0);
                        if (Droptables.type == 'mysql') {
                            this.find('#number_first_rows').addClass('no_active');
                        } else {
                            custom_select_box.call(this.find('#number_first_rows'), $);
                        }
                        //freeze_row
                        var freeze_row = parseInt(Droptables.style.table.freeze_row) > 0 ? 1 : 0;
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject({'freeze_row': freeze_row}, 'freeze_row', this.find('#freeze_row'), '0');
                    },
                    'submitAction': function () {
                        if (Droptables.type !== 'mysql') {
                            if (this.find('#number_first_rows').data('value') !== '') {
                                if (this.find('#number_first_rows').data('value') != Droptables.style.table.headerOption) {
                                    saveData.push({
                                        action: 'set_header_option',
                                        value: this.find('#number_first_rows').data('value')
                                    });
                                }
                                Droptables.style.table.headerOption = parseInt(this.find('#number_first_rows').data('value'));
                            }
                        }


                        Droptables.style.table.freeze_row = this.find("#freeze_row").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.freeze_row > 0) {
                            $(Droptables_element.tableContainer).handsontable('updateSettings', {fixedRowsTop: Droptables.style.table.headerOption});
                        } else {
                            $(Droptables_element.tableContainer).handsontable('updateSettings', {fixedRowsTop: 0});
                        }
                        Droptables.style.header_data = Droptables.datas.slice(0, Droptables.style.table.headerOption);

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        this.siblings('.colose_popup').trigger('click');

                        return true;
                    },
                    'cancelAction': function () {
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'sort_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#sortable_table'),
                    'option': {
                        'sort_columns': {},
                    },
                    'showAction': function () {
                        var that = this;
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'use_sortable', this.find('#use_sortable'), '0');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'default_order_sortable', this.find('#default_order_sortable').next('.droptable_select_box'), '');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'default_sortable', this.find('#default_sortable').next('.droptable_select_box'), '');

                        custom_select_box.call(this.find('#default_order_sortable'), $);
                        custom_select_box.call(this.find('#default_sortable'), $);

                        let sort_column = [];
                        $.each(this.find('.columnSortItem:not(.droptable_hiden)'), function (i, v) {
                            let column = $(v).find('.column_name').data('value');
                            sort_column[column] = {};
                            var sort_type_default = (Droptables.style.table.col_types && Droptables.style.table.col_types[column])
                                ? ((Droptables.style.table.col_types[column] === 'varchar' || Droptables.style.table.col_types[column] === 'text')
                                    ? 'string'
                                    : ((Droptables.style.table.col_types[column] === 'int' || Droptables.style.table.col_types[column] === 'float')
                                        ? 'number'
                                        : 'date'))
                                : 'string';

                            if (Droptables.style.cols[column][1]) {
                                sort_column[column] = $.extend({}, Droptables.style.cols[column][1]);
                                if (!sort_column[column].sort_type) {
                                    sort_column[column].sort_type = sort_type_default;
                                }
                                if (!(typeof sort_column[column].sort_format !== 'undefined' && sort_column[column].sort_type)) {
                                    sort_column[column].sort_format = sort_column[column].sort_type === 'date' ? Droptables.style.table.date_format : ''
                                }
                            } else {
                                sort_column[column] = {'res_priority': 1, 'sort_format': '', 'sort_type': sort_type_default, 'width': 80};
                            }
                            popup.option.sort_columns[column] = $.extend({}, sort_column[column]);
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(sort_column[column], 'sort_type', $(v).find('.select_sort_type'), 'string');
                            $(v).find('.sort_format').val(sort_column[column].sort_format || '');

                            if (sort_column[column].sort_type !== 'date') {
                                $(v).find('.sort_format').addClass('readonly').prop('readonly', true);
                            }

                            custom_select_box.call($(v).find('.sort_type'), $, function () {
                                let sort_type = this.data('value');
                                popup.option.sort_columns[column] = popup.option.sort_columns[column] || sort_column[column];
                                popup.option.sort_columns[column].sort_type = sort_type;

                                if (sort_type === 'date') {
                                    popup.option.sort_columns[column].sort_format = popup.option.sort_columns[column].sort_format || Droptables.style.table.date_format;
                                    $(v).find('.sort_format').val(popup.option.sort_columns[column].sort_format).removeClass('readonly').prop('readonly', false);
                                } else {
                                    popup.option.sort_columns[column].sort_format = '';
                                    $(v).find('.sort_format').val('').addClass('readonly').prop('readonly', true);
                                }
                            });

                            $(v).find('.sort_format').unbind('change').on('change', function (e) {
                                popup.option.sort_columns[column] = popup.option.sort_columns[column] || sort_column[column];
                                popup.option.sort_columns[column].sort_type = 'date';
                                popup.option.sort_columns[column].sort_format = $(e.target).val();
                            })
                        })

                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.use_sortable = this.find("#use_sortable").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.use_sortable == 1) {
                            Droptables_element.primary_toolbars.find('.sort_menu').parent().addClass('selected');
                        } else {
                            Droptables_element.primary_toolbars.find('.sort_menu').parent().removeClass('selected');
                        }

                        if (this.find('#default_order_sortable').data('value') !== '') {
                            Droptables.style.table.default_order_sortable = this.find('#default_order_sortable').data('value');
                        }
                        Droptables.style.table.default_sortable = this.find('#default_sortable').data('value');

                        $.each(popup.option.sort_columns, function (i, v) {
                            Droptables.style.cols[i][1] = $.extend({}, v);
                        });

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'download_button_menu':
                if ($(this).parent().hasClass('selected')) {
                    Droptables.style.table.download_button = 0;
                    $(this).parent().removeClass('selected');
                } else {
                    Droptables.style.table.download_button = 1;
                    $(this).parent().addClass('selected');
                }
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                break;
            case 'filters_menu':
                if ($(this).parent().hasClass('selected')) {
                    Droptables.style.table.enable_filters = 0;
                    $(this).parent().removeClass('selected');
                } else {
                    Droptables.style.table.enable_filters = 1;
                    $(this).parent().addClass('selected');
                }
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                break;
            case 'column_type_menu':
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.default_sortable(window.Droptables.datas);
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#column_type_table'),
                    'showAction': function () {
                        var col_types = Droptables.style.table.col_types;

                        this.find('tbody tr').each(function () {
                            var i = $(this).data('col');
                            col_types[i] = typeof col_types[i] !== 'undefined' ? col_types[i].toLowerCase() === 'varchar(255)' ? 'varchar' : col_types[i].toLowerCase() : 'varchar';
                            if (Droptables.type === 'mysql') {
                                $(this).find('.droptable_select_box_before').addClass('no_active').text(col_types[i]);
                            } else {
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(col_types, i, $(this).find('.droptable_select_box'), 'varchar');
                                custom_select_box.call($(this).find('.column_type'), $);
                            }
                        });
                    },
                    'submitAction': function () {
                        var cols_selected = [];
                        if (Droptables.type !== 'mysql') {
                            this.find('tbody tr').each(function () {
                                var i = $(this).data('col');
                                var that = $(this).find('.droptable_select_box_before');
                                if (that.data('value') !== '') {
                                    if (that.data('value') != Droptables.style.table.col_types[i]) {
                                        cols_selected[i] = that.data('value');
                                    }
                                    Droptables.style.table.col_types[i] = that.data('value');
                                }
                            });

                            if (cols_selected.length > 0) {
                                saveData.push({
                                    action: 'set_columns_types',
                                    value: cols_selected
                                });
                            }
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.cleanHandsontable();
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        }
                        this.siblings('.colose_popup').trigger('click');

                        return true;
                    },
                    'cancelAction': function () {
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'responsive_menu':
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.default_sortable(window.Droptables.datas);
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#responsive_table'),
                    'selector': {
                        'responsive_type': '#responsive_type',
                        'table_breakpoint': '.table_breakpoint',
                        'table_height': '.table_height',
                        'freeze_col': '#freeze_col',
                        'responsive_col': '#responsive_col',
                        'style_repeated': '#style_repeated',
                        'responsive_priority': '#responsive_priority'
                    },
                    'option': {
                        'responsive_type': Droptables.style.table.responsive_type,
                        'freeze_col': Droptables.style.table.freeze_col,
                        'table_height': Droptables.style.table.table_height,
                        'style_repeated': Droptables.style.table.style_repeated,
                        'table_breakpoint': Droptables.style.table.table_breakpoint,
                    },
                    'showAction': function () {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(popup.option, 'responsive_type', this.find('#responsive_type').next('.droptable_select_box'), 'scroll');
                        custom_select_box.call(this.find('#responsive_type'), $);

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(popup.option, 'freeze_col', this.find('#freeze_col').next('.droptable_select_box'), '0');
                        custom_select_box.call(this.find('#freeze_col'), $);

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(popup.option, 'style_repeated', this.find('#style_repeated').next('.droptable_select_box'), '0');
                        custom_select_box.call(this.find('#style_repeated'), $);

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(popup.option, 'table_height', this.find('.table_height'), '0');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(popup.option, 'table_breakpoint', this.find('.table_breakpoint'), '980');

                        this.find('table tr .responsive_priority').each(function () {
                            custom_select_box.call($(this), $);
                        });

                        popup.inputAction.call(this, 'responsive_type');
                        check_saving = false;
                    },
                    'submitAction': function () {
                        Droptables.style.table.responsive_type = this.find('#responsive_type').data('value');
                        Droptables.style.table.freeze_col = this.find("#freeze_col").data('value');
                        Droptables.style.table.style_repeated = this.find("#style_repeated").data('value');
                        Droptables.style.table.table_height = popup.option.table_height;
                        Droptables.style.table.table_breakpoint = popup.option.table_breakpoint;
                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    },
                    'inputAction': function (selector) {
                        if (selector === 'responsive_type') {
                            if (popup.option.responsive_type === 'scroll') {
                                this.find('.hiding').hide();
                                this.find('.repeatedHeader').hide();
                                this.find('.scrolling').show();
                            }

                            if (popup.option.responsive_type === 'repeatedHeader') {
                                this.find('.hiding').hide();
                                this.find('.scrolling').hide();
                                this.find('.repeatedHeader').show();
                                $(Droptables_element.tableContainer).handsontable('updateSettings', {
                                    manualColumnFreeze: false,
                                    fixedColumnsLeft: 0
                                });
                            }

                            if (popup.option.responsive_type === 'hideCols') {
                                this.find('.hiding').show();
                                this.find('.scrolling').hide();
                                this.find('.repeatedHeader').hide();

                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.responsive_col.call(this.find('#responsive_col'), Droptables);
                            }
                        }

                        //scrolling
                        if (selector === 'freeze_col') {
                            if (parseInt(popup.option.freeze_col) === 0) {
                                $(Droptables_element.tableContainer).handsontable('updateSettings', {
                                    manualColumnFreeze: false,
                                    fixedColumnsLeft: 0
                                });
                            } else {
                                $(Droptables_element.tableContainer).handsontable('updateSettings', {
                                    manualColumnFreeze: true,
                                    fixedColumnsLeft: popup.option.freeze_col
                                });
                            }
                        }

                        for (var i = 0; i < _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(Droptables.style.cols); i++) {
                            if(typeof Droptables.style.cols[i] !== 'undefined' && Droptables.style.cols[i] !== null) {
                                var col_priority = typeof Droptables.style.cols[i][1].res_priority !== 'undefined' ? Droptables.style.cols[i][1].res_priority: 0;
                                if (typeof col_priority !== 'undefined') {
                                    var curr_col = Droptables_element.droptable_popup.find('table tbody tr').eq(i);
                                    curr_col.find('.responsive_priority').text(col_priority).data('value', col_priority);
                                }
                            }
                        }
                        $('.responsive_priority').unbind('change').on('change', (e) => {
                            var col = $(e.target).closest('tr').data('col');

                            if (typeof Droptables.style.cols[col] !== 'undefined' && Droptables.style.cols[col] !== null && $(e.target).val() !== Droptables.style.cols[col].res_priority) {
                                check_saving = true;
                            }
                            Droptables.style.cols = _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cols, {res_priority: $(e.target).data('value')}, col);
                        });
                        setTimeout(() => {
                            if ($(this).parent().height() < $(this).height()) {
                                $(this).parent().addClass('droptables_scroll');
                            } else {
                                $(this).parent().removeClass('droptables_scroll');
                            }
                        }, 200);
                    },
                    'cancelAction': function () {
                        for (var key in popup.option) {
                            if (popup.option[key] !== Droptables.style.table[key]) {
                                check_saving = false;
                                break;
                            }
                        }
                        if (check_saving) {
                            Droptables.style.table = $.extend({}, Droptables.style.table, popup.option), _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges();
                        }
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'pagination_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#pagination_table'),
                    'showAction': function () {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'enable_pagination', this.find('#enable_pagination'), '0');

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'limit_rows', this.find('#limit_rows').next('.droptable_select_box'), 0);
                        custom_select_box.call(this.find('#limit_rows'), $);

                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.limit_rows = this.find('#limit_rows').data('value');
                        Droptables.style.table.enable_pagination = this.find("#enable_pagination").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.enable_pagination == 1) {
                            Droptables_element.primary_toolbars.find('.pagination_menu').parent().addClass('selected');
                        } else {
                            Droptables_element.primary_toolbars.find('.pagination_menu').parent().removeClass('selected');
                        }
                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'date_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#date_menu'),
                    'inputEnter': true,
                    'render': true,
                    'showAction': function () {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'date_formats', this.find('#date_format'), '');

                        this.find('.select_date_format li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var date_format = $(e.currentTarget).addClass('active').data('value');
                            if (typeof date_format !== 'undefined' && date_format !== '') {
                                this.find('#date_format').val(date_format);
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (this.find('#date_format').val() !== '') {
                            Droptables.style.table.date_formats = this.find('#date_format').val();
                            function_data.date_formats_momentjs = _functions__WEBPACK_IMPORTED_MODULE_1__.default.momentjsFormat(Droptables.style.table.date_formats);
                        }

                        function_data = _functions__WEBPACK_IMPORTED_MODULE_1__.default.createRegExpFormat(function_data, false, Droptables.style.table.date_formats);
                        table_function_data.needSaveAfterRender = true;
                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'date_menu_cell':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#date_menu_cell'),
                    'inputEnter': true,
                    'render': true,
                    'showAction': function () {
                        this.find('#popup_done').val(Joomla.JText._('COM_DROPTABLES_APPLY', 'Apply'));
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'date_formats', this.find('#date_format'), '');

                        this.find('.select_date_format li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var date_format = $(e.currentTarget).addClass('active').data('value');
                            if (typeof date_format !== 'undefined' && date_format !== '') {
                                this.find('.date_formats').val(date_format);
                            }
                        });

                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('.date_formats').val() !== 'undefined') {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {
                                date_formats: this.find('.date_formats').val(),
                                // use_format: this.find("#use_format").is(":checked") ? 1 : 0,
                                date_formats_momentjs: _functions__WEBPACK_IMPORTED_MODULE_1__.default.momentjsFormat(this.find('.date_formats').val())});
                        }

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'lock_ranger_cells':
                if (!Droptables.check_super_user) {
                    break;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#lock_ranger_cells'),
                    'inputEnter': true,
                    'render': true,
                    'current_rangers': null,
                    'current_rangers_user': null,
                    'showAction': function () {
                        this.find('#jform_role_can_edit_lock').next('.droptable_select_box').prepend(this.find('#jform_role_can_edit_lock').next('.droptable_select_box').find('.root'));
                        var current_rangers_user_default = this.find('.droptable_select_box').find('li:first').data('value');
                        custom_select_box.call(this.find('#jform_role_can_edit_lock'), $, null, true);
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox('', 0, this.find('#jform_role_can_edit_lock').next('.droptable_select_box'),  current_rangers_user_default, null, true);

                        // wptm_element.wptm_popup.find('.content .control-group:first').after(window.wptm_element.content_popup_hide.find('#select_cells').clone());
                        var function_data = window.table_function_data;
                        if (typeof function_data.selection !== 'undefined' && function_data.selection[0] !== undefined && _functions__WEBPACK_IMPORTED_MODULE_1__.default.droptablesCheckSize(function_data.selection[0]) > 0) {
                            var selection = function_data.selection[0];
                            if (selection[0] == 0 && selection[2] == Droptables.max_row - 1) {
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSelectedVal([false, selection[1], false, selection[3]], this.find('.cellRangeLabelAlternate'));
                            } else {
                                if (selection[1] == 0 && selection[3] == Droptables.max_Col - 1) {
                                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSelectedVal([selection[0], false, selection[2], false], this.find('.cellRangeLabelAlternate'));
                                } else {
                                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSelectedVal(selection, this.find('.cellRangeLabelAlternate'));
                                }
                            }
                        }

                        this.find('#get_select_cells').val(Joomla.JText._('COM_DROPTABLES_TABLES_SAVE_RANGE', 'Save range'));

                        var current_ranger = null;
                        if (typeof Droptables.style.table.lock_ranger_cells !== 'undefined') {
                            $.each(Droptables.style.table.lock_ranger_cells, (i, v) => {
                                if (v !== '') {
                                    var $lock_ranger_cell = this.find('.select_lock_ranger_cells').find('.droptable_hiden').clone();
                                    $lock_ranger_cell.removeClass('droptable_hiden');
                                    $lock_ranger_cell.attr('data-value', v).find('.label_text').text(v);
                                    this.find('.select_lock_ranger_cells').append($lock_ranger_cell);
                                }
                            });
                        } else {
                            Droptables.style.table.lock_ranger_cells = [];
                        }
                        if (typeof Droptables.style.table.lock_ranger_cells_user == 'undefined') {
                            Droptables.style.table.lock_ranger_cells_user = [];
                        }
                        popup.current_rangers = jquery.extend([], Droptables.style.table.lock_ranger_cells);
                        popup.current_rangers_user = jquery.extend([], Droptables.style.table.lock_ranger_cells_user);

                        this.find('.cellRangeLabelAlternate').unbind('keyup').on('click', function (e) {
                            e.preventDefault();
                            return false;
                        });
                        var select_ranger = () => {
                            //select
                            this.find('.select_lock_ranger_cells').find('.nfd-format-pill:not(.droptable_hiden)').unbind('click').on('click', (e) => {
                                if (!$(e.target).hasClass('delete_range')) {
                                    $(e.currentTarget).siblings('.nfd-format-pill.active').removeClass('active');
                                    current_ranger = popup.current_rangers.indexOf($(e.currentTarget).find('.label_text').text());
                                    this.find('.cellRangeLabelAlternate').val(popup.current_rangers[current_ranger]);
                                    _alternating__WEBPACK_IMPORTED_MODULE_4__.default.affterRangeLabe.call(this, window.Droptables, window.jquery);
                                    $(e.currentTarget).addClass('active');
                                    // jform_role_can_edit_lock
                                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(popup.current_rangers_user, current_ranger, this.find('#jform_role_can_edit_lock').next('.droptable_select_box'), current_rangers_user_default, null, true);

                                    // this.find('#popup_done').addClass('not_active');
                                }
                            });

                            //delete
                            this.find('.select_lock_ranger_cells').find('.nfd-format-pill:not(.droptable_hiden) .delete_range').unbind('click').on('click', (e) => {
                                e.preventDefault();
                                var $li = $(e.currentTarget).parents('.nfd-format-pill');
                                current_ranger = popup.current_rangers.indexOf($li.data('value'));

                                if ($li.hasClass('active')) {
                                    $li.removeClass('active');
                                    this.find('.cellRangeLabelAlternate').val('');
                                }
                                $li.remove();

                                popup.current_rangers.splice(current_ranger, 1);
                                popup.current_rangers_user.splice(current_ranger, 1);
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox('', current_ranger, this.find('#jform_role_can_edit_lock').next('.droptable_select_box'),  current_rangers_user_default, null, true);

                                // this.find('#popup_done').removeClass('not_active');
                            });
                        }

                        //apply
                        this.find('#get_select_cells').unbind('click').on('click', () => {
                            _alternating__WEBPACK_IMPORTED_MODULE_4__.default.affterRangeLabe.call(this, window.Droptables, window.jquery);
                            var ranger = this.find('.cellRangeLabelAlternate').val();

                            if (ranger !== '') {
                                var value = ranger.replace(/[ ]+/g, "").toUpperCase();
                                var arrayRange = value.split(":");
                                if (arrayRange.length < 2) {
                                    ranger += ':' + ranger;
                                } else if (arrayRange.length > 2) {
                                    return false;
                                }
                                var data_role_can_edit_lock = this.find('#jform_role_can_edit_lock').data('value');
                                if (current_ranger == null) {//new
                                    this.find('.nfd-format-pill.active').removeClass('active');
                                    var $lock_ranger_cell1 = this.find('.select_lock_ranger_cells').find('.droptable_hiden').clone();
                                    $lock_ranger_cell1.removeClass('droptable_hiden').addClass('active');
                                    $lock_ranger_cell1.attr('data-value', ranger).find('.label_text').text(ranger);
                                    this.find('.select_lock_ranger_cells').append($lock_ranger_cell1);
                                    popup.current_rangers.push(ranger);
                                    popup.current_rangers_user.push(data_role_can_edit_lock === '' ? current_rangers_user_default : data_role_can_edit_lock);
                                } else {
                                    this.find('.select_lock_ranger_cells').find('.nfd-format-pill.active').attr('data-value', ranger).find('.label_text').text(ranger);
                                    popup.current_rangers[current_ranger] = ranger;
                                    popup.current_rangers_user[current_ranger] = data_role_can_edit_lock === '' ? current_rangers_user_default : data_role_can_edit_lock;
                                }
                            }
                            // this.find('#popup_done').removeClass('not_active');

                            this.find('.cellRangeLabelAlternate').val('');
                            this.find('.nfd-format-pill.active').removeClass('active');
                            current_ranger = null;
                            select_ranger();
                        });

                        select_ranger();

                        return true;
                    },
                    'submitAction': function () {
                        this.find('#get_select_cells').trigger('click');
                        setTimeout( () => {
                            Droptables.style.table.lock_ranger_cells = jquery.extend([], popup.current_rangers);
                            Droptables.style.table.lock_ranger_cells_user = jquery.extend([], popup.current_rangers_user);
                            this.siblings('.colose_popup').trigger('click');
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        }, 200);
                        return true;
                    },
                    'cancelAction': function () {
                        Droptables.style.table.lock_ranger_cells = jquery.extend([], popup.current_rangers);
                        Droptables.style.table.lock_ranger_cells_user = jquery.extend([], popup.current_rangers_user);
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, false);
                break;
            case 'curency_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#curency_menu'),
                    'render': true,
                    'inputEnter': true,
                    'selector': {
                        'symbol_position': '#symbol_position'
                    },
                    'option': {
                        'symbol_position': Droptables.style.table.symbol_position
                    },
                    'showAction': function () {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'currency_symbol', this.find('#currency_symbol'), '');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(Droptables.style.table, 'symbol_position', this.find('#symbol_position').next('.droptable_select_box'), '');
                        custom_select_box.call(this.find('#symbol_position'), $);

                        this.find('.select_curency_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var currency_symbol = $(e.currentTarget).addClass('active').data('currency_sym');
                            if (typeof currency_symbol !== 'undefined' && currency_symbol !== '') {
                                this.find('#currency_symbol').val(currency_symbol);
                            }

                            var symbol_position = $(e.currentTarget).data('symbol_position');
                            if (typeof symbol_position !== 'undefined' && symbol_position !== '') {
                                this.find('#symbol_position').data('value', symbol_position).text(symbol_position == 1 ? 'After': 'Before').change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (this.find('#currency_symbol').val() !== '') {
                            Droptables.style.table.currency_symbol = this.find('#currency_symbol').val();
                        }
                        function_data = _functions__WEBPACK_IMPORTED_MODULE_1__.default.createRegExpFormat(function_data, Droptables.style.table.currency_symbol, false);

                        Droptables.style.table = $.extend({}, Droptables.style.table, popup.option);
                        table_function_data.needSaveAfterRender = true;
                        // tableFunction.setFormat_accounting();

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'curency_menu_cell':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#curency_menu_cell'),
                    'render': true,
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('#popup_done').val(Joomla.JText._('COM_DROPTABLES_APPLY', 'Apply'));
                        custom_select_box.call(this.find('.symbol_position'), $);

                        this.find('.select_curency_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var currency_symbol = $(e.currentTarget).addClass('active').data('currency_sym');
                            if (typeof currency_symbol !== 'undefined' && currency_symbol !== '' && currency_symbol !== false) {
                                this.find('.currency_symbol').val(currency_symbol);
                            }

                            var symbol_position = $(e.currentTarget).data('symbol_position');
                            if (typeof symbol_position !== 'undefined' && symbol_position !== '' && symbol_position !== false) {
                                this.find('.symbol_position').data('value', symbol_position).text(symbol_position == 1 ? 'After': 'Before').change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('.currency_symbol').val() !== 'undefined') {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {currency_symbol: this.find('.currency_symbol').val(),currency_symbol_second: null});
                        }

                        if (typeof this.find('.symbol_position').data('value') !== 'undefined' && this.find('.symbol_position').data('value') !== '') {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {symbol_position: this.find('.symbol_position').data('value'), symbol_position_second: null});
                        }

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'decimal_menu':
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#decimal_menu'),
                    'render': true,
                    'inputEnter': true,
                    'showAction': function () {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'thousand_symbol', this.find('#thousand_symbol'), '');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'decimal_symbol', this.find('#decimal_symbol'), '');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'decimal_count', this.find('#decimal_count'), '');
                        this.find('.select_decimal_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var thousand_symbol = $(e.currentTarget).addClass('active').data('thousand_symbol');
                            if (typeof thousand_symbol !== 'undefined') {
                                this.find('#thousand_symbol').val(thousand_symbol).change();
                            }

                            var decimal_symbol = $(e.currentTarget).data('decimal_symbol');
                            if (typeof decimal_symbol !== 'undefined') {
                                this.find('#decimal_symbol').val(decimal_symbol).change();
                            }

                            var decimal_count = $(e.currentTarget).data('decimal_count');
                            if (typeof decimal_count !== 'undefined' && decimal_count !== '') {
                                this.find('#decimal_count').val(decimal_count).change();
                            } else {
                                this.find('#decimal_count').val(0).change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('#decimal_symbol').val() !== 'undefined') {
                            Droptables.style.table.decimal_symbol = this.find('#decimal_symbol').val();
                        }
                        if (typeof this.find('#decimal_count').val() !== 'undefined') {
                            Droptables.style.table.decimal_count = this.find('#decimal_count').val() == '' ? 0: this.find('#decimal_count').val();
                        }
                        if (typeof this.find('#thousand_symbol').val() !== 'undefined') {
                            Droptables.style.table.thousand_symbol = this.find('#thousand_symbol').val();
                        }
                        table_function_data.needSaveAfterRender = true;
                        // tableFunction.setFormat_accounting();

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'decimal_menu_cell':
                if (Droptables.type === 'mysql') {
                    return true;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#decimal_menu_cell'),
                    'render': true,
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('#popup_done').val(Joomla.JText._('COM_DROPTABLES_APPLY', 'Apply'));
                        this.find('.select_decimal_menu li').unbind('click').on('click', (e) => {
                            $(e.currentTarget).siblings('.active').removeClass('active');
                            var thousand_symbol = $(e.currentTarget).addClass('active').data('thousand_symbol');
                            if (typeof thousand_symbol !== 'undefined' && thousand_symbol !== false) {
                                this.find('.thousand_symbol').val(thousand_symbol).change();
                            }

                            var decimal_symbol = $(e.currentTarget).data('decimal_symbol');
                            if (typeof decimal_symbol !== 'undefined' && decimal_symbol !== false) {
                                this.find('.decimal_symbol').val(decimal_symbol).change();
                            }

                            var decimal_count = $(e.currentTarget).data('decimal_count');
                            if (typeof decimal_count !== 'undefined' && decimal_count !== '' && decimal_count !== false) {
                                this.find('.decimal_count').val(decimal_count).change();
                            } else {
                                this.find('.decimal_count').val(0).change();
                            }
                        });
                        return true;
                    },
                    'submitAction': function () {
                        if (typeof this.find('.decimal_symbol').val() !== 'undefined') {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {decimal_symbol: this.find('.decimal_symbol').val(), decimal_symbol_second: null});
                        }
                        if (typeof this.find('.decimal_count').val() !== 'undefined') {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {decimal_count: this.find('.decimal_count').val() == '' ? 0: this.find('.decimal_count').val(), decimal_count_second: null});
                        }
                        if (typeof this.find('.thousand_symbol').val() !== 'undefined') {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {thousand_symbol: this.find('.thousand_symbol').val(), thousand_symbol_second: null});
                        }

                        this.siblings('.colose_popup').trigger('click');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);

                        return true;
                    }
                };
                droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'google_sheets_menu':
                if (Droptables.type == 'mysql') {
                    return false;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#google_sheets_menu'),
                    'showAction': function () {
                        this.find('#fetch_browse').hide();
                        this.find('#jform_excel_url-lbl').hide();
                        this.find('#import_style').parent().hide();
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'auto_sync', this.find('#auto_sync'), '0');
                        // tableFunction.updateSwitchButtonFromStyleObject(Droptables.style.table, 'download_button', this.find('#download_button'), '0');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'spreadsheet_style', this.find('#spreadsheet_style'), '0');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'auto_push', this.find('#auto_push'), '0');

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'spreadsheet_url', this.find('#spreadsheet_url'), '');
                        check_saving = 0;

                        this.find('#fetch_google').unbind('click').on('click', (e) => {
                            Droptables.style.table.spreadsheet_url = this.find("#spreadsheet_url").val();
                            if (Droptables.style.table.spreadsheet_url === '' || Droptables.style.table.spreadsheet_url === undefined) {
                                return false;
                            }

                            Droptables.style.table.spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;
                            Droptables.style.table.auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                            if (Droptables.style.table.auto_sync === 1) {
                                Droptables.style.table.excel_auto_sync = 0;
                            }

                            Droptables.style.table.auto_push = this.find("#auto_push").is(":checked") ? 1 : 0;

                            // Droptables.style.table.download_button = this.find("#download_button").is(":checked") ? 1 : 0;

                            var data = {'type': 'spreadsheet'};
                            table_function_data.fetch_data = data;

                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                            return true;
                        });
                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.spreadsheet_url = this.find("#spreadsheet_url").val();

                        Droptables.style.table.spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;

                        Droptables.style.table.auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.auto_sync === 1) {
                            Droptables.style.table.excel_auto_sync = 0;
                        }

                        Droptables.style.table.auto_push = this.find("#auto_push").is(":checked") ? 1 : 0;

                        // Droptables.style.table.download_button = this.find("#download_button").is(":checked") ? 1 : 0;
                        check_saving = 1;

                        if (this.find('#google_url').val() !== '') {
                            Droptables.syn_hash = this.find('#google_url').val();
                        }

                        this.siblings('.colose_popup').trigger('click');
                        return true;
                    },
                    'cancelAction': function () {
                        if (check_saving === 1) {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        }
                        return true;
                    },
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'synchronization_menu':
                if (Droptables.type == 'mysql') {
                    return false;
                }
                popup = {
                    'html': Droptables_element.content_popup_hide.find('#google_sheets_menu'),
                    'inputEnter': true,
                    'showAction': function () {
                        this.find('#google_url').parent().hide();
                        this.find('#jform_spreadsheet_url-lbl').hide();
                        // this.find("#download_button").closest('.control-group').hide();
                        this.find("#auto_push").closest('.push-notification-group').hide();

                        if (typeof default_value.enable_import_excel !== 'undefined'
                            && default_value.enable_import_excel == '1') {
                            this.find('#google_sheets_menu .control-group').eq(0).before(Droptables_element.content_popup_hide.find('#import_excel'));
                            this.find('#google_sheets_menu').addClass('excel_syn');
                        }
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'excel_auto_sync', this.find('#auto_sync'), '0');
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateSwitchButtonFromStyleObject(Droptables.style.table, 'excel_spreadsheet_style', this.find('#spreadsheet_style'), '0');

                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(Droptables.style.table, 'excel_url', this.find('#spreadsheet_url'), '');
                        check_saving = 0;

                        this.find('#fetch_google').unbind('click').on('click', (e) => {
                            Droptables.style.table.excel_url = this.find("#spreadsheet_url").val();
                            if (Droptables.style.table.excel_url === '' || Droptables.style.table.excel_url === undefined) {
                                return false;
                            }

                            Droptables.style.table.excel_spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;
                            Droptables.style.table.excel_auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                            if (Droptables.style.table.excel_auto_sync === 1) {
                                Droptables.style.table.auto_sync = 0;
                            }

                            var data = {'type': 'excel'};
                            table_function_data.fetch_data = data;

                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                            return true;
                        });

                        custom_select_box.call(this.find('#import_style'), $);
                        return true;
                    },
                    'submitAction': function () {
                        Droptables.style.table.excel_auto_sync = this.find("#auto_sync").is(":checked") ? 1 : 0;
                        if (Droptables.style.table.excel_auto_sync === 1) {
                            Droptables.style.table.auto_sync = 0;
                        }
                        Droptables.style.table.excel_spreadsheet_style = this.find("#spreadsheet_style").is(":checked") ? 1 : 0;

                        Droptables.style.table.excel_url = this.find("#spreadsheet_url").val();

                        check_saving = 1;
                        this.siblings('.colose_popup').trigger('click');
                        return true;
                    },
                    'cancelAction': function () {
                        this.find('#import_excel').appendTo(Droptables_element.content_popup_hide);
                        if (check_saving === 1) {
                            _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                        }
                        return true;
                    }
                };
                droptables_popup(false, Droptables_element.droptable_popup, popup, true, false, true);
                break;
            case 'new_chart_menu':
                _charts__WEBPACK_IMPORTED_MODULE_3__.default.functions.addChart();
                break;
            case 'view_chart_menu':
                if (Droptables.ChartLength > 0) {
                    Droptables_element.settingTable.find('.ajax_loading').addClass('loadding').removeClass('droptable_hiden');
                    $(this).closest('li').addClass('menu_loading');
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.showChartOrTable(true, jquery('#list_chart').find('.chart-menu').eq(0));
                } else {
                    var text = Joomla.JText._('COM_DROPTABLES_VIEW_DROPTABLES_NO_CHART_CREATE', 'No charts have been created for this table, sorry.');
                    bootbox.alert(text);
                }
                break;
            case 'editToolTip':
                var content = $('#tooltip_content').val();

                if (content !== '') {
                    Droptables_element.tableContainer.find('tbody td.current').addClass('isTooltipContent');
                } else {
                    Droptables_element.tableContainer.find('tbody td.current').removeClass('isTooltipContent');
                }

                if (typeof content !== 'undefined') {
                    var i, j;
                    var selection = table_function_data.selection[0];
                    var width = $('#tooltip_width').val();
                    for (i = selection[0]; i <= selection[2]; i++) {
                        for (j = selection[1]; j <= selection[3]; j++) {
                            if (width !== '') {
                                Droptables.style.cells = _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {
                                    tooltip_content: content,
                                    tooltip_width: width
                                }, i, j);
                            } else {
                                Droptables.style.cells = _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {tooltip_content: content}, i, j);
                            }
                            if (i == selection[2] && j == selection[3]) {
                                saveData.push({action: 'style', selection: table_function_data.selection, style: {
                                        tooltip_content: content,
                                        tooltip_width: width
                                    }});
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges();
                            }
                        }
                    }
                }
                break;
        }

        return false;
    });

    //select option in sub-menu(first top menu)
    Droptables_element.primary_toolbars.find('.has_sub_menu ul li').on('change click', function () {
        if (!table_function_data.allowed_edit) {
            return false;
        }

        var function_data = window.table_function_data;
        Droptables = window.Droptables;
        var $ = window.jquery;
        var option_name = $(this).parents('.sub-menu').siblings('.table_option');
        switch (option_name.attr('name')) {
            case 'align_menu':
                Droptables.style.table.table_align = $(this).attr('name').toString();
                $(this).siblings('.selected').removeClass('selected');
                $(this).addClass('selected');
                break;
        }
        return true;
    });

    Droptables_element.primary_toolbars.find('.minicolors-input').unbind('change').on('change', function (e) {
        e.preventDefault();

        render = second_menu.call(this, render);
        clearTimeout(autoRender);

        autoRender = setTimeout(function () {
            if (render === true) {
                table_function_data.needSaveAfterRender = true;
                window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
            }
            render = false;
        }, 300);
    });

    Droptables_element.primary_toolbars.find('a.cell_option').unbind('click').on('click', function (e) {
        e.preventDefault();

        render = second_menu.call(this, render);
        clearTimeout(autoRender);

        autoRender = setTimeout(function () {
            if (render === true) {
                table_function_data.needSaveAfterRender = true;
                window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
            }
            render = false;
        }, 300);
    });

    Droptables_element.primary_toolbars.find('.cell_option').unbind('change').on('change', function (e) {
        e.preventDefault();

        render = second_menu.call(this, render);
        clearTimeout(autoRender);

        autoRender = setTimeout(function () {
            if (render === true) {
                table_function_data.needSaveAfterRender = true;
                window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
            }
            render = false;
        }, 300);
    });

    //select calculator function
    Droptables_element.primary_toolbars.find('.calculater_function').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (Droptables.type !== 'html') {
            return;
        }
        var $ = window.jquery;

        var selection = $.extend({}, table_function_data.selection);
        var calculater = $(this).data('calculater');

        _functions__WEBPACK_IMPORTED_MODULE_1__.default.change_value_cells(selection, '=' + calculater + '()');
        var CellValue = document.getElementById('CellValue');

        Droptables_element.cellValue.focus().val('=' + calculater + '()');

        if (CellValue) {
            if (typeof CellValue.setSelectionRange === 'function') {
                var x = calculater.length + 2;
                CellValue.setSelectionRange(x, x);
            }
            Droptables_element.cellValue.click();
        }
    });

    //change value cells by #CellValue
    Droptables_element.cellValue.on('keyup', function (e) {
        if (Droptables_element.cellValue.val() !== table_function_data.cellValueChange) {
            table_function_data.checkCellValueChange = table_function_data.selection;
        } else {
            table_function_data.checkCellValueChange = false;
        }

        if (e.keyCode === 13 && Droptables.type == 'html') {
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.change_value_cells(table_function_data.selection, Droptables_element.cellValue.val());
            var $ = window.jquery;
            var selection = table_function_data.selection;
            table_function_data.checkCellValueChange = false;
            if (typeof selection[1] === 'undefined'
                && typeof selection[0][2] !== 'undefined'
                && selection[0][0] === selection[0][2]
                && selection[0][1] === selection[0][3]) {
                if (typeof Droptables.datas[selection[0][0] + 1] === 'undefined') {
                    $(Droptables_element.tableContainer).handsontable("selectCell", 0, selection[0][1] + 1, 0, selection[0][3] + 1);
                } else {
                    $(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0] + 1, selection[0][1], selection[0][2] + 1, selection[0][3]);
                }
            }
        }

        return true;
    });
};

/**
 * Update status item in table_menu by cell seletoed
 *
 * @param $
 * @param Droptables
 * @param selection
 */
function updateOptionValTable($, Droptables, selection) {
    if (_functions__WEBPACK_IMPORTED_MODULE_1__.default.checkObjPropertyNested(Droptables.style, 'table')) {
        var styleTable = Droptables.style.table;
        var Droptables_element = window.Droptables_element;
        var selector;
        $.each(styleTable, function (index, value) {
            switch (index) {
                case 'enable_filters':
                    selector = Droptables_element.settingTable.find('.filters_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'download_button':
                    selector = Droptables_element.settingTable.find('.download_button_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'enable_pagination':
                    selector = Droptables_element.settingTable.find('.pagination_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'use_sortable':
                    selector = Droptables_element.settingTable.find('.sort_menu');
                    if (value === 1 || value === '1') {
                        selector.parent().addClass('selected');
                    } else {
                        selector.parent().removeClass('selected');
                    }
                    break;
                case 'table_align':
                    if (value !== '') {
                        selector = Droptables_element.settingTable.find('.align_menu').siblings('.sub-menu').find('li[name="' + value + '"]');
                        selector.siblings('li.selected').removeClass('selected');
                        selector.addClass('selected');
                    }
                    break;
                case 'col_types':
                    if (typeof table_function_data.selection[0] !== 'undefined') {
                        var first_column_selected = table_function_data.selection[0][1];
                        if (typeof value[first_column_selected] !== 'undefined') {
                            table_function_data.type_column_selected = value[first_column_selected];
                        }
                    }
                    break;
                default:
                    break;
            }
        });
    } else {

    }
}

/**
 * Update status item in cell_menu and table_menu by cell selected
 *
 * @param $
 * @param Droptables
 * @param selection Cell selected
 *
 * @returns {boolean}
 */
var loadSelection = function ($, Droptables, selection) {
    selection = getSelector();
    if (!selection) {
        return true;
    }
    //show value cell to #CellValue when selector a cell
    var size_selection = table_function_data.selectionSize - 1;
    if (selection[size_selection][0] === selection[size_selection][2] && selection[size_selection][1] === selection[size_selection][3]) {
        Droptables_element.cellValue.val(Droptables.datas[selection[size_selection][0]][selection[size_selection][1]]);
        table_function_data.cellValueChange = Droptables.datas[selection[size_selection][0]][selection[size_selection][1]];
    } else {
        Droptables_element.cellValue.val('');
        table_function_data.cellValueChange = '';
    }
    table_function_data.checkCellValueChange = false;

    //set value option by selection
    updateOptionValTable($, Droptables, selection);

    updateOptionValCell($, Droptables, selection);
    //Todo: populate jform_responsive_col

    return true;
}

/**
 * add value for table_function_data.selection and table_function_data.selectionSize
 *
 * @returns {*}
 */
var getSelector = function () {
    var selection = [];
    // if (typeof selection === 'undefined' || selection === undefined || !selection) {
    selection = window.jquery(window.Droptables_element.tableContainer).handsontable('getSelected');//get all cells selected ex:[[0,0,1,9],[3,0,3,9]]
    // }
    if (typeof selection[0] !== 'undefined' && !Array.isArray(selection[0])) {
        selection = [window.jquery(window.Droptables_element.tableContainer).handsontable('getSelected')];
    }
    if (selection !== false && typeof selection !== 'undefined' && selection.length > 0) {
        //check when handsontable('getSelected') return array[0] = array;
        window.table_function_data.selectionSize = selection.length;
        for (var i = 0; i < table_function_data.selectionSize; i++) {
            if (selection[i][0] > selection[i][2]) {
                selection[i] = [selection[i][2], selection[i][3], selection[i][0], selection[i][1]];
            }
            if (selection[i][1] > selection[i][3]) {
                selection[i] = [selection[i][0], selection[i][3], selection[i][2], selection[i][1]];
            }
        }
        window.table_function_data.selection = selection;
    } else {
        window.table_function_data.selection = false;
        window.table_function_data.selectionSize = 0;
    }
    return selection;
}

/**
 * Update status item in cell_menu by cell seletoed
 *
 * @param $
 * @param Droptables
 * @param selection
 */
function updateOptionValCell($, Droptables, selection) {
    var colsStyle = Droptables.style.cols;
    var cellsStyle = Droptables.style.cells;
    var rowsStyle = Droptables.style.rows;
    var size_selection = table_function_data.selectionSize - 1;
    if (size_selection < 0) {//not cell selected
        return;
    }

    var endCell = [selection[size_selection][2], selection[size_selection][3]];
    var end_cell = selection[size_selection][2] + '!' + selection[size_selection][3];

    if (!_functions__WEBPACK_IMPORTED_MODULE_1__.default.checkObjPropertyNested(Droptables.style, 'cells')) {//fix when Droptables.style.cells not exist
        Droptables.style.cells = {};
    }

    window.table_function_data.selectOption = true;//if == true then not click function
    var cell_style = {};

    if (typeof colsStyle[selection[size_selection][3]] !== 'undefined') {
        cell_style = $.extend({}, colsStyle[selection[size_selection][3]][1]);
    }
    if (typeof rowsStyle[selection[size_selection][2]] !== 'undefined') {
        cell_style = $.extend({}, cell_style, rowsStyle[selection[size_selection][2]][1]);
    }

    if (_functions__WEBPACK_IMPORTED_MODULE_1__.default.checkObjPropertyNested(Droptables.style, 'cells', end_cell, 2)) {
        if (_functions__WEBPACK_IMPORTED_MODULE_1__.default.checkObjPropertyNestedNotEmpty(cellsStyle[end_cell][2], 'tooltip_content')) {
            cell_style.tooltip_content = cellsStyle[end_cell][2].tooltip_content;
            cell_style.tooltip_width = cellsStyle[end_cell][2].tooltip_width;
        }
        if ((Droptables.type === 'html' || selection[size_selection][2] === 0) && typeof cellsStyle[end_cell] !== 'undefined') {
            cell_style = $.extend({}, cell_style, cellsStyle[end_cell][2]);
        }
    } else {//fix when Droptables.style.cells[endCell] not exist
        _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {});
    }

    if (_functions__WEBPACK_IMPORTED_MODULE_1__.default.checkCellsOptionsValidate(table_function_data.selection, 'cell_type', 'html')) {//hide cell formats
        Droptables_element.settingTable.find('a.date_menu_cell').parent('li').addClass('no_active');
        Droptables_element.settingTable.find('a.curency_menu_cell').parent('li').addClass('no_active');
        Droptables_element.settingTable.find('a.decimal_menu_cell').parent('li').addClass('no_active');
    } else {
        Droptables_element.settingTable.find('a.date_menu_cell').parent('li').removeClass('no_active');
        Droptables_element.settingTable.find('a.curency_menu_cell').parent('li').removeClass('no_active');
        Droptables_element.settingTable.find('a.decimal_menu_cell').parent('li').removeClass('no_active');
    }

    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'thousand_symbol', Droptables_element.content_popup_hide.find('#decimal_menu_cell').find('.thousand_symbol'), '');
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'decimal_symbol', Droptables_element.content_popup_hide.find('#decimal_menu_cell').find('.decimal_symbol'), '');
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'decimal_count', Droptables_element.content_popup_hide.find('#decimal_menu_cell').find('.decimal_count'), '');

    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'currency_symbol', Droptables_element.content_popup_hide.find('#curency_menu_cell').find('.currency_symbol'), '');
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(cell_style, 'symbol_position', Droptables_element.content_popup_hide.find('#curency_menu_cell').find('.symbol_position').next('.droptable_select_box'), '');

    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'date_formats', Droptables_element.content_popup_hide.find('#date_menu_cell').find('.date_formats'), Droptables.style.table.date_formats);
    // tableFunction.updateSwitchButtonFromStyleObject(cell_style, 'use_format', Droptables_element.content_popup_hide.find('#date_menu_cell').find('.use_format'), 1);

    //tooltip
    var $tooltip_content = $('#tooltip_content');
    if ($tooltip_content.length > 0) {
        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'tooltip_width', $('#tooltip_width'), 0);
        _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'tooltip_content', $('#tooltip_content'), "");
    }

    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObjectSelectBox(cell_style, 'cell_font_family', Droptables_element.primary_toolbars.find('#cell_font_family'), 'inherit');
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_font_size', Droptables_element.primary_toolbars.find('#cell_font_size'), 13);
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_font_bold', Droptables_element.primary_toolbars.find('#cell_format_bold'), false, function () {
        active_table_option(this);
    });

    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_font_underline', Droptables_element.primary_toolbars.find('#cell_format_underlined'), false,
        function () {
            active_table_option(this);
        }
    );
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_font_italic', Droptables_element.primary_toolbars.find('#cell_format_italic'), false,
        function () {
            active_table_option(this);
        }
    );
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_background_color', Droptables_element.primary_toolbars.find('#cell_background_color'), '',
        function () {
            if (typeof cell_style.cell_background_color !== "undefined") {
                var color = cell_style.cell_background_color;
                $('#cell_background_color').minicolors('value', color);
                this.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
            }
        }
    );
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_font_color', Droptables_element.primary_toolbars.find('#cell_font_color'), '',
        function () {
            var color = cell_style.cell_font_color;
            $('#cell_font_color').minicolors('value', color);
            this.parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', color);
        }
    );

    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'text_wrapping', Droptables_element.primary_toolbars.find('#text_wrapping'), 'text_wrapping', function () {
        var value = (typeof cell_style.text_wrapping === 'undefined' || cell_style.text_wrapping === 'break-word')
            ? 'wrap_cell' : (cell_style.text_wrapping === 'normal' ? 'overflow_cell' : 'clip_cell');
        Droptables_element.primary_toolbars.find('a[name="overflow_cell"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="wrap_cell"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="clip_cell"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="' + value + '"]').addClass('active');
    });
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_text_align', Droptables_element.primary_toolbars.find('#cell_text_align'), 'left', function () {
        var value = typeof cell_style.cell_text_align === 'undefined' ? '' : cell_style.cell_text_align;

        Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="format_align_' + value + '"]').addClass('active');
    });
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_vertical_align', Droptables_element.primary_toolbars.find('#cell_vertical_align'), 'middle', function () {
        var value = typeof cell_style.cell_vertical_align === 'undefined' ? cell_style.cell_vertical_align = 'top' : cell_style.cell_vertical_align;

        Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').removeClass('active');
        Droptables_element.primary_toolbars.find('a[name="vertical_align_' + value + '"]').addClass('active');
    });
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cell_style, 'cell_type', Droptables_element.primary_toolbars.find('#cell_type'), '', function () {
        var value = cell_style.cell_type;
        if (typeof value === 'undefined' || value === '' || value === null) {
            Droptables_element.primary_toolbars.find('#cell_type').removeClass('active');
        } else {
            Droptables_element.primary_toolbars.find('#cell_type').addClass('active');
        }
    });
    Droptables_element.primary_toolbars.find('#cell_border').find('a').each(function () {
        $(this).removeClass('active');
    });

    var mergeCellRanger = {
        'col': selection[size_selection][1],
        'colspan': selection[size_selection][3] - selection[size_selection][1] + 1,
        'row': selection[size_selection][0],
        'rowspan': selection[size_selection][2] - selection[size_selection][0] + 1
    };
    if (Droptables.style.table.mergeSetting.some(function (mergeSetting) {
        return mergeSetting.col === mergeCellRanger.col && mergeSetting.row === mergeCellRanger.row;
    })) {
        Droptables_element.primary_toolbars.find('#merge_cell').addClass('active');
    } else {
        Droptables_element.primary_toolbars.find('#merge_cell').removeClass('active');
    }

    window.table_function_data.selectOption = false;
    //get size(height, width) end cells
    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSizeCells($, Droptables, endCell);
}

function active_table_option(that) {
    if (that.val() === true) {
        that.addClass('active');
    } else {
        that.removeClass('active');
    }
}

/**
 * Create custom select box
 *
 * @param $
 * @param select_function cell function when click select
 */
function custom_select_box ($, select_function, multiple) {
    $(this).on('click', function (e) {
        var $that = $(this);
        var old_value;

        $('#mybootstrap').find('.droptable_select_box').each(function () {
            $(this).hide();
            $(this).siblings('.show').removeClass('show');
        });
        var position = $(this).position();

        if ($(this).hasClass('show')) {
            $(this).next().hide();
            $(this).removeClass('show');
            $(document).unbind('click.droptable_select_box');
            return;
        }

        $that.addClass('show');
        var $select = $(this).next().css({top: position.top + 40, left: position.left, 'min-width': $that.outerWidth()}).show();

        if (multiple) {
            $select.find('li input').prop("checked", false);
            old_value = $that.data('value').split('|');
            $.each(old_value, function (i, v) {
                $select.find('li:not(.data-none)[data-value="' + v + '"]').find('input').prop("checked", true);
            })
        } else {
            old_value = $that.data('value');
        }


        $select.find('li').unbind('click').on('click', function (e) {
            var text = '', data = '';
            var li_tag = $(this);
            if (multiple) {
                if ($(e.target).is('input')) {
                    li_tag = $(e.target).parent();
                } else if(li_tag.find('input').length > 0) {
                    li_tag.find('input').prop("checked", !li_tag.find('input').is(":checked"));
                }
            }
            if (!multiple || li_tag.hasClass('data-none')) {
                text = li_tag.text();
                data = li_tag.data('value');
            } else {
                $select.find('li:not(.data-none)').each(function (i, e) {
                    if ($(e).find('input').is(":checked")) {
                        if (data !== '') {
                            text += ',' + $(e).text();
                            data += '|' + $(e).data('value');
                        } else {
                            text += $(e).text();
                            data += $(e).data('value');
                        }
                    }
                });
            }
            $select.data('value', data).change();
            $that.val(data).text(text).data('value', data).change();

            if (typeof select_function !== 'undefined' && select_function !== null) {
                select_function.call(li_tag);
            }
            if (!multiple || li_tag.hasClass('data-none')) {
                $('#mybootstrap').find('.droptable_select_box').hide();
            }
        });

        $(document).bind('click.droptable_select_box', (e) => {
            if (!$(e.target).is($(this)) && !(!!multiple && $(e.target).parents('.droptable_select_box').length > 0)) {
                $select.hide();
                $that.removeClass('show');
                $(document).unbind('click.droptable_select_box');
            }
        });
    });
}

//event change value option in cell_menu
function second_menu(render, name) {
    if (!table_function_data.allowed_edit) {
        return false;
    }

    if (table_function_data.selectOption) {
        return false;
    }

    var Droptables = window.Droptables;
    var $ = window.jquery;
    var value;
    var parentLi = $(this).parents('.cells_option');
    var i;
    table_function_data.option_selected_mysql = '';

    var selection = $.extend({}, table_function_data.selection);

    if (Droptables.type === 'mysql') {
        for (i = 0; i < table_function_data.selectionSize; i++) {
            if (selection[i][0] + selection[i][2] !== 0) {//not cell in header
                selection[i][0] = selection[i][0] > 0 ? 1 : selection[i][0];
                selection[i][2] = Droptables.datas.length - 1;
                table_function_data.option_selected_mysql = jquery(this).attr('name');
            }
        }
    }

    if (typeof selection[0][1] === 'undefined') {
        return;
    }

    switch ($(this).attr('name')) {
        case 'undo_cell':
            if ($(this).hasClass('active')) {
                jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.undo()
                render = true;
            } else {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.status_noti(1, Joomla.JText._('COM_DROPTABLES_SOME_ACTION_CANT_BE_DONE', "Some actions can't be done due to the Technical Problem") + '!');
            }
            break;
        case 'redo_cell':
            if ($(this).hasClass('active')) {
                jquery(Droptables_element.tableContainer).handsontable('getInstance').undoRedo.redo()
                render = true;
            } else {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.status_noti(1, Joomla.JText._('COM_DROPTABLES_SOME_ACTION_CANT_BE_DONE', "Some actions can't be done due to the Technical Problem") + '!');
            }
            break;
        case 'cell_font_family':
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_font_family: $(this).data('value')});
            render = true;
            break;
        case 'cell_font_size':
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_font_size: $(this).val()});
            render = true;
            break;
        case 'cell_format_bold':
            if (parentLi.find('.active').length < 1) {
                value = true;
                parentLi.find('.cell_option').addClass('active');
            } else {
                value = false;
                parentLi.find('.active').removeClass('active');
            }

            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_font_bold: value});
            render = true;
            break;
        case 'cell_font_underline':
            if (parentLi.find('.active').length < 1) {
                value = true;
                parentLi.find('.cell_option').addClass('active');
            } else {
                value = false;
                parentLi.find('.active').removeClass('active');
            }
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_font_underline: value});
            render = true;
            break;
        case 'cell_font_italic':
            if (parentLi.find('.active').length < 1) {
                value = true;
                parentLi.find('.cell_option').addClass('active');
            } else {
                value = false;
                parentLi.find('.active').removeClass('active');
            }
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_font_italic: value});
            render = true;
            break;
        case 'cell_background_color':
            value = $(this).val();
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_background_color: value});
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', value);
            render = true;
            break;
        case 'cell_font_color':
            value = $(this).val();
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_font_color: value});
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', value);
            render = true;
            break;
        case 'format_align_left':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_text_align: 'left'});
            render = true;
            break;
        case 'format_align_center':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_text_align: 'center'});
            render = true;
            break;
        case 'format_align_right':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').removeClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_text_align: 'right'});
            render = true;
            break;
        case 'format_align_justify':
            Droptables_element.primary_toolbars.find('a[name="format_align_left"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_center"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_right"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="format_align_justify"]').addClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_text_align: 'justify'});
            render = true;
            break;
        case 'vertical_align_bottom':
            Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').removeClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_vertical_align: 'bottom'});
            render = true;
            break;
        case 'vertical_align_middle':
            Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').addClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').removeClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_vertical_align: 'middle'});
            render = true;
            break;
        case 'vertical_align_top':
            Droptables_element.primary_toolbars.find('a[name="vertical_align_bottom"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_middle"]').removeClass('active');
            Droptables_element.primary_toolbars.find('a[name="vertical_align_top"]').addClass('active');
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_vertical_align: 'top'});
            render = true;
            break;
        case 'overflow_cell':
            Droptables_element.primary_toolbars.find('#wrap_cell').removeClass('active');
            Droptables_element.primary_toolbars.find('#clip_cell').removeClass('active');
            if (Droptables_element.primary_toolbars.find('#overflow_cell').hasClass('active')) {
                Droptables_element.primary_toolbars.find('#overflow_cell').removeClass('active');
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {text_wrapping: false});
            } else {
                Droptables_element.primary_toolbars.find('#overflow_cell').addClass('active');
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {text_wrapping: "normal"});
            }

            render = true;
            break;
        case 'wrap_cell':
            Droptables_element.primary_toolbars.find('#overflow_cell').removeClass('active');
            Droptables_element.primary_toolbars.find('#clip_cell').removeClass('active');
            if (Droptables_element.primary_toolbars.find('#wrap_cell').hasClass('active')) {
                Droptables_element.primary_toolbars.find('#wrap_cell').removeClass('active');
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {text_wrapping: false});
            } else {
                Droptables_element.primary_toolbars.find('#wrap_cell').addClass('active');
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {text_wrapping: "break-word"});
            }
            render = true;
            break;
        case 'clip_cell':
            Droptables_element.primary_toolbars.find('#overflow_cell').removeClass('active');
            Droptables_element.primary_toolbars.find('#wrap_cell').removeClass('active');
            if (Droptables_element.primary_toolbars.find('#clip_cell').hasClass('active')) {
                Droptables_element.primary_toolbars.find('#clip_cell').removeClass('active');
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {text_wrapping: false});
            } else {
                Droptables_element.primary_toolbars.find('#clip_cell').addClass('active');
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {text_wrapping: "hidden"});
            }
            render = true;
            break;
        case 'padding_border':
            var popup;

            popup = {
                'html': Droptables_element.content_popup_hide.find('#padding_border'),
                'showAction': function () {
                    var size_selection = table_function_data.selectionSize - 1;
                    var cellStyle = window.Droptables.style.cells[selection[size_selection][0] + '!' + selection[size_selection][1]][2];

                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_padding_left', this.find('#jform_cell_padding_left'), 0);
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_padding_top', this.find('#jform_cell_padding_top'), 0);
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_padding_right', this.find('#jform_cell_padding_right'), 0);
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_padding_bottom', this.find('#jform_cell_padding_bottom'), 0);

                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_background_radius_left_top', this.find('#jform_cell_background_radius_left_top'), 0);
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_background_radius_right_top', this.find('#jform_cell_background_radius_right_top'), 0);
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_background_radius_right_bottom', this.find('#jform_cell_background_radius_right_bottom'), 0);
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.updateParamFromStyleObject(cellStyle, 'cell_background_radius_left_bottom', this.find('#jform_cell_background_radius_left_bottom'), 0);

                    this.find('.observeChanges').unbind('change').on('change', (e) => {
                        var name = $(e.currentTarget).attr('name');
                        var value = $(e.currentTarget).val();
                        switch (name) {
                            case 'jform[jform_cell_padding_left]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_padding_left: value});
                                break;
                            case 'jform[jform_cell_padding_top]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_padding_top: value});
                                break;
                            case 'jform[jform_cell_padding_right]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_padding_right: value});
                                break;
                            case 'jform[jform_cell_padding_bottom]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_padding_bottom: value});
                                break;
                            case 'jform[jform_cell_background_radius_left_top]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_background_radius_left_top: value});
                                break;
                            case 'jform[jform_cell_background_radius_right_top]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_background_radius_right_top: value});
                                break;
                            case 'jform[jform_cell_background_radius_right_bottom]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_background_radius_right_bottom: value});
                                break;
                            case 'jform[jform_cell_background_radius_left_bottom]':
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_background_radius_left_bottom: value});
                                break;
                        }
                    });
                    return true;
                },
                'submitAction': function () {
                    this.siblings('.colose_popup').trigger('click');
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges();
                    return true;
                },
                'cancelAction': function () {
                    window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
                    return true;
                }
            };
            droptables_popup(true, Droptables_element.droptable_popup, popup, true, false, true);
            break;
        case 'cell_type':
            if (Droptables.type !== 'mysql') {
                if (parentLi.find('.active').length < 1) {
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_type: 'html'}, "set_cells_type");
                    window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, 'html']);

                    parentLi.find('.cell_option').addClass('active');

                    // add cell type == text for column selected
                    var i, jj, ii;
                    var cols_selected = [];

                    for (jj = 0; jj < table_function_data.selectionSize; jj++) {
                        for (i = table_function_data.selection[jj][1]; i <= table_function_data.selection[jj][3]; i++) {//column
                            cols_selected[i] = 'text';
                            if (!(typeof Droptables.style.table.col_types[i] !== 'undefined' && Droptables.style.table.col_types[i] === 'text')) {
                                _functions__WEBPACK_IMPORTED_MODULE_1__.default.cleanHandsontable();
                            }
                            Droptables.style.table.col_types[i] = 'text';
                            for (ii = table_function_data.selection[jj][0]; ii <= table_function_data.selection[jj][2]; ii++) {//row
                                _customRenderer__WEBPACK_IMPORTED_MODULE_2__.default.render(null, window.jquery('.dtr' + ii + '.dtc' + i), ii, i, null, Droptables.datas[ii][i], false);
                            }
                        }
                    }

                    saveData.push({
                        action: 'set_columns_types',
                        value: cols_selected
                    });

                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.saveChanges(true);
                } else {
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_type: null}, "set_cells_type");
                    window.Droptables.style.table.cell_types.push([selection[0][0], selection[0][1], selection[0][2] - selection[0][0] + 1, selection[0][3] - selection[0][1] + 1, '']);

                    parentLi.find('.active').removeClass('active');
                }
                render = true;
            }
            break;
        case 'border_color':
            value = $(this).val();
            // tableFunction.getFillArray(selection, Droptables, {cell_font_color: value});
            $(this).parents('.minicolors-position-left').find('.minicolors-swatch-color').css('color', value);
            border_cell(selection, Droptables, 'color', render);
            render = true;
            break;
        case 'border_all':
            if ($(this).hasClass('active')) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_left: ''});
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_top: ''});
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_right: ''});
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_bottom: ''});

                $(this).removeClass('active');
            } else {
                border_cell(selection, Droptables, 'position', 'cell_border_left', 'cell_border_top', 'cell_border_right', 'cell_border_bottom');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_top':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][0], selection[i][1], selection[i][0], selection[i][3]];
            }
            var parameter;
            if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
                parameter = 'cell_border_top_start';
            } else {
                parameter = 'cell_border_top';
            }
            if ($(this).hasClass('active')) {
                var x = {};
                x[parameter] = '';
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(border_selection, Droptables, x);
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', parameter);
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_bottom':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][2], selection[i][1], selection[i][2], selection[i][3]];
            }
            var parameter;
            if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
                parameter = 'cell_border_bottom_end';
            } else {
                parameter = 'cell_border_bottom';
            }
            if ($(this).hasClass('active')) {
                var x = {};
                x[parameter] = '';
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(border_selection, Droptables, x);
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', parameter);
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_left':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][0], selection[i][1], selection[i][2], selection[i][1]];
            }
            if ($(this).hasClass('active')) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(border_selection, Droptables, {cell_border_left: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_left');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_right':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                border_selection[i] = [selection[i][0], selection[i][3], selection[i][2], selection[i][3]];
            }
            if ($(this).hasClass('active')) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(border_selection, Droptables, {cell_border_right: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_right');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_horizontal':
            var border_selection = {};

            for (i = 0; i < table_function_data.selectionSize; i++) {
                if (selection[i][0] === selection[i][2]) {
                    return false;
                } else {
                    border_selection[i] = [selection[i][0], selection[i][1], selection[i][2] - 1, selection[i][3]];
                }
            }

            if ($(this).hasClass('active')) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(border_selection, Droptables, {cell_border_bottom: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_bottom');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_clear':
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_left: ''});
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_top: ''});
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_right: ''});
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_bottom: ''});

            if (table_function_data.option_selected_mysql !== '' && typeof table_function_data.option_selected_mysql !== 'undefined') {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_top_start: ''});
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, {cell_border_bottom_end: ''});
            }

            // Get cells range above selection
            var topCellsSelections = {};
            Object.keys(selection).map(function(key, index) {
                var x = selection[key][0] - 1 > 0 ? selection[key][0] - 1 : 0;
                topCellsSelections[key] = [x, selection[key][1], x, selection[key][3]];
            });
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(topCellsSelections, Droptables, {cell_border_bottom: ''});

            var leftCellsSelections = {};
            var fillLeftCells = true;
            Object.keys(selection).map(function(key, index) {
                var y = selection[key][1] - 1 > 0 ? selection[key][1] - 1 : 0;
                leftCellsSelections[key] = [selection[key][0], y, selection[key][2], y];
                if (parseInt(selection[key][1]) === 0) {
                    fillLeftCells = false;
                }
            });
            if (fillLeftCells) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(leftCellsSelections, Droptables, {cell_border_right: ''});
            }

            render = true;
            break;
        case 'border_vertical':
            var border_selection = {};
            for (i = 0; i < table_function_data.selectionSize; i++) {
                if (selection[i][1] === selection[i][3]) {
                    return false;
                } else {
                    border_selection[i] = [selection[i][0], selection[i][1], selection[i][2], selection[i][3] - 1];
                }
            }

            if ($(this).hasClass('active')) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(border_selection, Droptables, {cell_border_right: ''});
                $(this).removeClass('active');
            } else {
                border_cell(border_selection, Droptables, 'position', 'cell_border_right');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_inner':
            var new_selection = [];
            new_selection['bottom'] = [];
            new_selection['right'] = [];
            for (i = 0; i < table_function_data.selectionSize; i++) {
                new_selection['bottom'][i] = $.extend([], selection[i]);
                new_selection['right'][i] = $.extend([], selection[i]);
                if (selection[i][1] === selection[i][3]) {
                    return false;
                } else {
                    new_selection['right'][i][3] = selection[i][3] - 1;
                }
                if (selection[i][0] === selection[i][2]) {
                    return false;
                } else {
                    new_selection['bottom'][i][2] = selection[i][2] - 1;
                }
            }
            if ($(this).hasClass('active')) {
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(new_selection['right'], Droptables, {cell_border_right: ''});
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(new_selection['bottom'], Droptables, {cell_border_bottom: ''});
                $(this).removeClass('active');
            } else {
                border_cell(new_selection['bottom'], Droptables, 'position', 'cell_border_bottom');
                border_cell(new_selection['right'], Droptables, 'position', 'cell_border_right');
                $(this).addClass('active');
            }
            render = true;
            break;
        case 'border_outer':
            var val, ij, ik;
            if ($(this).hasClass('active')) {
                $(this).removeClass('active');
                val = 'no_active';
            } else {
                $(this).addClass('active');
                val = 'active';
            }
            $.map(selection, function (v) {
                if (val === 'no_active') {
                    for (ij = v[0]; ij <= v[2]; ij++) {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_right: ''}, ij, v[1] - 1);//before cell
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_right: ''}, ij, v[3]);
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_left: ''}, ij, v[3] + 1);//after cell
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_left: ''}, ij, v[1]);
                    }
                    for (ik = v[1]; ik <= v[3]; ik++) {
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_top: ''}, v[2] + 1, ik);
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_top: ''}, v[0], ik);
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_bottom: ''}, v[0] - 1, ik);
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.fillArray(Droptables.style.cells, {cell_border_bottom: ''}, v[2], ik);
                    }
                } else {
                    border_cell([[v[0], v[3], v[2], v[3]]], Droptables, 'position', 'cell_border_right');
                    border_cell([[v[0], v[1], v[2], v[1]]], Droptables, 'position', 'cell_border_left');
                    border_cell([[v[2], v[1], v[2], v[3]]], Droptables, 'position', 'cell_border_bottom');
                    border_cell([[v[0], v[1], v[0], v[3]]], Droptables, 'position', 'cell_border_top');
                }
            });

            render = true;
            break;
        case 'border_width':
            border_cell(selection, Droptables, 'border_width', render);
            render = true;
            break;
        case 'border_solid':
            $(this).siblings('.border_style.active').removeClass('active');
            $(this).addClass('active');
            border_cell(selection, Droptables, 'border_style', render);

            render = true;
            break;
        case 'border_dashed':
            $(this).siblings('.border_style.active').removeClass('active');
            $(this).addClass('active');
            border_cell(selection, Droptables, 'border_style', render);

            render = true;
            break;
        case 'border_dotted':
            $(this).siblings('.border_style.active').removeClass('active');
            $(this).addClass('active');
            border_cell(selection, Droptables, 'border_style', render);

            render = true;
            break;
        // case 'border_width_1':
        //     $(this).siblings('.border_width.active').removeClass('active');
        //     $(this).addClass('active');
        //
        //     render = true;
        //     break;
        // case 'border_width_2':
        //     $(this).siblings('.border_width.active').removeClass('active');
        //     $(this).addClass('active');
        //
        //     render = true;
        //     break;
        // case 'border_width_3':
        //     $(this).siblings('.border_width.active').removeClass('active');
        //     $(this).addClass('active');
        //
        //     render = true;
        //     break;
        case 'merge_cell':
            if (Droptables.type !== 'mysql') {
                if ((selection[0][3] - selection[0][1] + selection[0][2] - selection[0][0]) < 1) {
                    return false;
                }
                if (table_function_data.selectionSize > 1) {//if selection > 1 when not merge and select selection[0]
                    $(Droptables_element.tableContainer).handsontable("selectCell", selection[0][0], selection[0][1], selection[0][2], selection[0][3]);
                    return false;
                }
                if ($(this).hasClass('active')) {
                    $(Droptables_element.tableContainer).handsontable('getInstance').getPlugin('mergeCells').unmergeSelection();
                    $(this).removeClass('active');
                } else {
                    $(Droptables_element.tableContainer).handsontable('getInstance').getPlugin('mergeCells').mergeSelection();
                    $(this).addClass('active');
                }
            }
            break;
    }
    return render;
}

function createNewTable($) {
    if (!table_function_data.allowed_edit) {
        return false;
    }

    if (!Droptables.userOwn.create) {
        bootbox.alert(Joomla.JText._('COM_DROPTABLES_ERROR_PERMISSION_CREATE_NEW_TABLE', 'You don\'t have permission to create new tables'), 'ok');
        return false;
    }

    var id_category = Droptables.category;
    var curr_page = window.location.href;
    var cells = curr_page.split("?");

    $.ajax({
        url: Droptables.ajaxurl + "index.php?option=com_droptables&task=table.add&id_category=" + id_category + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
        type: "POST",
        dataType: "json",
        success: function (datas) {
            if (datas.response === true) {
                var new_url = cells[0] + '?option=com_droptables&id_table=' + datas.datas.id;
                window.open(new_url);
                return true;
            } else {
                bootbox.alert(datas.response, 'Ok');
                return false;
            }
        },
        error: function (jqxhr, textStatus, error) {
            bootbox.alert(textStatus + " : " + error, 'Ok');
            return false;
        }
    });
}

/**
 * Convert border value for cell
 *
 * @param selection Selected cells
 * @param Droptables
 */
function border_cell(selection, Droptables) {
    var border_color = Droptables_element.primary_toolbars.find('#border_color').val();
    if (typeof border_color === 'undefined' || border_color === '') {
        border_color = 'rgba(214, 214, 214, 1)';
    }

    var cell_border_style = 'solid';
    switch (Droptables_element.primary_toolbars.find('#cell_border_style a.border_style.active').attr('name')) {
        case 'border_solid':
            cell_border_style = 'solid';
            break;
        case 'border_dashed':
            cell_border_style = 'dashed';
            break;
        case 'border_dotted':
            cell_border_style = 'dotted';
            break;
    }

    var width = '1';
    var cell_border_width = Droptables_element.primary_toolbars.find('#cell_border_width').val();
    width = cell_border_width !== '' ? cell_border_width : '1';
    var position = [];
    if (arguments[2] !== 'position') {
        position = Droptables_element.primary_toolbars.find('#cell_border > div > a.cell_option.active').each(function () {
            second_menu.call(jquery(this), arguments[3], 're_active');
        });
        return false;
    } else {
        position = Array.prototype.slice.call(arguments, 3);
    }

    position.map(function (foo) {
        var value = {};
        value[foo] = '' + width + 'px ' + cell_border_style + ' ' + border_color;
        switch (foo) {
            case 'cell_border_top':
                // Get cells range above selection
                var topCellsSelections = {};
                var topCellsSelections2;
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, value);
                Object.keys(selection).map(function(key, index) {
                    if (selection[key][0] > 0) {
                        var x = selection[key][0] - 1;
                        topCellsSelections[key] = [x, selection[key][1], x, selection[key][3]];
                    }
                    if (selection[key][0] <= Droptables.headerOption && selection[key][2] >= Droptables.headerOption) {
                        topCellsSelections2 = {};
                        topCellsSelections2[key] = [Droptables.headerOption, selection[key][1], Droptables.headerOption, selection[key][3]];
                        _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(topCellsSelections2, Droptables, {'cell_border_top': ''});
                    }
                });
                if (typeof topCellsSelections[0] !== 'undefined') {
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(topCellsSelections, Droptables, {cell_border_bottom: '' + width + 'px ' + cell_border_style + ' ' + border_color});
                }
                break;
            case 'cell_border_left':
                // Get cells range left selection
                var leftCellsSelections = {};
                var fillLeftCells = true;
                Object.keys(selection).map(function(key, index) {
                    var y = selection[key][1] - 1 > 0 ? selection[key][1] - 1 : 0;
                    if (parseInt(selection[key][1]) === 0) {
                        fillLeftCells = false;
                    }
                    leftCellsSelections[key] = [selection[key][0], y, selection[key][2], y];
                });
                if (fillLeftCells) {
                    _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(leftCellsSelections, Droptables, {cell_border_right: '' + width + 'px ' + cell_border_style + ' ' + border_color});
                }
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, value);
                break;
            default:
                _functions__WEBPACK_IMPORTED_MODULE_1__.default.getFillArray(selection, Droptables, value);
                break;
        }
    });
}

function set_height_popup() {

}

/*
popup and action for this
droptables_popup     #droptables_popup
popup          object data popup
clone          check clone content in popup
selector_cells get selector cells to popup window
submit_button  get submit button to popup window
arguments[5]   updateOptionValCell
*/
function droptables_popup(update_option_cell, droptables_popup, popup, clone, selector_cells, submit_button) {
    if (update_option_cell === true) {
        var selection = getSelector();
        updateOptionValCell(jquery, Droptables, selection);
    }

    droptables_popup.find('.content').contents().remove();
    var over_popup = droptables_popup.siblings('#over_popup');
    var that;
    if (!clone) {
        that = droptables_popup.find('.content').append(popup.html);
    } else {
        that = droptables_popup.find('.content').append(popup.html.clone());
    }

    if (selector_cells === true) {
        droptables_popup.find('.content .popup_top').after(window.Droptables_element.content_popup_hide.find('#select_cells').clone());
        var function_data = window.table_function_data;
        if (typeof function_data.selection !== 'undefined' && function_data.selection[0] !== undefined && function_data.selection[0].length > 0) {
            _functions__WEBPACK_IMPORTED_MODULE_1__.default.getSelectedVal(function_data.selection[0], that.find('.cellRangeLabelAlternate'));
        }
    }

    if (submit_button === true) {
        that.find('>div').append(window.Droptables_element.content_popup_hide.find('#submit_button').clone());
    }
    droptables_popup.animate({'opacity': '1'}, 10);

    droptables_popup.show();
    over_popup.show();

    that.find('.tooltipster').tooltipster({
        theme: 'tooltipster-borderless',
        delay: 100,
        maxWidth: 300,
    });

    //selection cells
    that.find('#get_select_cells').unbind('click').on('click', function () {
        _alternating__WEBPACK_IMPORTED_MODULE_4__.default.affterRangeLabe.call(that, window.Droptables, window.jquery);
        that.find('.cellRangeLabelAlternate').val();
    });
    that.find('.cellRangeLabelAlternate').on('keyup', function (e) {
        if (e.which == 13) {
            _alternating__WEBPACK_IMPORTED_MODULE_4__.default.affterRangeLabe.call(that, window.Droptables, window.jquery);
        }
    });

    /*action when show popup*/
    if (typeof popup.showAction !== 'undefined') {
        popup.showAction.call(that);
    }

    /*action selector*/
    if (typeof popup.selector !== 'undefined') {
        var select = select_input_popup.bind(popup, that);
        select();
    }

    /*action enter input*/
    if (popup.inputEnter) {
        that.find('input').on('keyup', function (e, i) {
            if (e.keyCode === 13) {
                if (typeof popup.submitAction !== 'undefined') {
                    popup.submitAction.call(that);
                } else {
                    jquery(this).trigger('change');
                }
                droptables_popup.find('.colose_popup').trigger('click');
            }
            return true;
        });
    }

    /*click done button*/
    that.find('#popup_done').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (typeof popup.submitAction !== 'undefined') {
            popup.submitAction.call(that);
        }
        return false;
    });

    /*click cancel button*/
    that.find('#popup_cancel').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (typeof popup.cancelAction !== 'undefined') {
            droptables_popup.animate({'opacity': '0'}, 10);
            popup.cancelAction.call(that);
        }
        setTimeout(function () {
            droptables_popup.hide();
            over_popup.hide();
        }, 200);
        return false;
    });

    //action colose
    droptables_popup.find('.colose_popup').unbind('click').on('click', function (e) {
        e.preventDefault();
        if (typeof popup.cancelAction !== 'undefined') {
            droptables_popup.animate({'opacity': '0'}, 10);
            popup.cancelAction.call(that);
        }

        if (typeof popup.render !== 'undefined' && popup.render === true) {
            window.jquery(window.Droptables_element.tableContainer).data('handsontable').render();
        }

        setTimeout(function () {
            droptables_popup.hide();
            over_popup.hide();
        }, 200);
        return false;
    });
    over_popup.unbind('click').on('click', function (e) {
        e.preventDefault();
        droptables_popup.find('.colose_popup').trigger('click');
        return false;
    });

    //set top for popup
    //droptables_popup.css('top', (over_popup.outerHeight() - droptables_popup.outerHeight()) / 2);

    return false;
}

/**
 * Selector Control function in popup
 *
 * @param that Wptm_popup.find('.content')
 */
var select_input_popup = function (that) {
    if (typeof this.selector !== 'undefined') {
        window.jquery.each(this.selector, (i, e) => {
            that.find(e).change((e) => {
                if (typeof this.option[i] !== 'undefined') {
                    this.option[i] = window.jquery(e.currentTarget).val();
                }
                if (typeof this.inputAction !== 'undefined') {
                    this.inputAction.call(that, i);
                }
            });
        });
    }
}

function change_theme(ret, id, cellsData) {
    var $ = window.jquery;

    bootbox.confirm(Joomla.JText._('COM_DROPTABLES_JS_WARNING_CHANGE_THEME', 'Warning - all data and styles will be removed & replaced on theme switch'), function (result) {
        if (result) {
            $.ajax({
                url: Droptables.ajaxurl + "index.php?option=com_droptables&view=style&format=json&id=" + id + "&id-table=" + Droptables.id
                    + "&front=" + (typeof Droptables.front_end !== 'undefined' ? Droptables.front_end : Droptables.caninsert),
                type: 'POST',
                dataType: 'json',
                data: {}
            }).done(function (data) {
                if (typeof (data) === 'object') {
                    location.reload();
                } else {
                    bootbox.alert(data, Joomla.JText._('Ok'));
                }
                $('#droptable_popup').find('.colose_popup').trigger('click');
            });
        } else {
            $('#droptable_popup').find('.colose_popup').trigger('click');
        }
    });
}

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({selectOption, loadSelection, updateOptionValTable, droptables_popup});

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	__webpack_require__("./site/assets/js/_alternating.js");
/******/ 	__webpack_require__("./site/assets/js/_charts.js");
/******/ 	__webpack_require__("./site/assets/js/_customRenderer.js");
/******/ 	__webpack_require__("./site/assets/js/_droptables.js");
/******/ 	__webpack_require__("./site/assets/js/_functions.js");
/******/ 	__webpack_require__("./site/assets/js/_handsontable.js");
/******/ 	var __webpack_exports__ = __webpack_require__("./site/assets/js/_toolbarOptions.js");
/******/ 	
/******/ })()
;
//# sourceMappingURL=droptables_main.js.map